/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2016, PgPool Global Development Group
 * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/* This is a configuration parameter since PostgreSQL 9.5.
 * We set this false in pgpool-II. This is default in PostgreSQL.
 */
bool operator_precedence_warning = false;


/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

static DefElem *defWithOids(bool value);
/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


/* Line 371 of yacc.c  */
#line 293 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_Y_TAB_H_INCLUDED
# define YY_BASE_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     EQUALS_GREATER = 269,
     LESS_EQUALS = 270,
     GREATER_EQUALS = 271,
     NOT_EQUALS = 272,
     ABORT_P = 273,
     ABSOLUTE_P = 274,
     ACCESS = 275,
     ACTION = 276,
     ADD_P = 277,
     ADMIN = 278,
     AFTER = 279,
     AGGREGATE = 280,
     ALL = 281,
     ALSO = 282,
     ALTER = 283,
     ALWAYS = 284,
     ANALYSE = 285,
     ANALYZE = 286,
     AND = 287,
     ANY = 288,
     ARRAY = 289,
     AS = 290,
     ASC = 291,
     ASSERTION = 292,
     ASSIGNMENT = 293,
     ASYMMETRIC = 294,
     AT = 295,
     ATTRIBUTE = 296,
     AUTHORIZATION = 297,
     BACKWARD = 298,
     BEFORE = 299,
     BEGIN_P = 300,
     BETWEEN = 301,
     BIGINT = 302,
     BINARY = 303,
     BIT = 304,
     BOOLEAN_P = 305,
     BOTH = 306,
     BY = 307,
     CACHE = 308,
     CALLED = 309,
     CASCADE = 310,
     CASCADED = 311,
     CASE = 312,
     CAST = 313,
     CATALOG_P = 314,
     CHAIN = 315,
     CHAR_P = 316,
     CHARACTER = 317,
     CHARACTERISTICS = 318,
     CHECK = 319,
     CHECKPOINT = 320,
     CLASS = 321,
     CLOSE = 322,
     CLUSTER = 323,
     COALESCE = 324,
     COLLATE = 325,
     COLLATION = 326,
     COLUMN = 327,
     COMMENT = 328,
     COMMENTS = 329,
     COMMIT = 330,
     COMMITTED = 331,
     CONCURRENTLY = 332,
     CONFIGURATION = 333,
     CONFLICT = 334,
     CONNECTION = 335,
     CONSTRAINT = 336,
     CONSTRAINTS = 337,
     CONTENT_P = 338,
     CONTINUE_P = 339,
     CONVERSION_P = 340,
     COPY = 341,
     COST = 342,
     CREATE = 343,
     CROSS = 344,
     CSV = 345,
     CUBE = 346,
     CURRENT_P = 347,
     CURRENT_CATALOG = 348,
     CURRENT_DATE = 349,
     CURRENT_ROLE = 350,
     CURRENT_SCHEMA = 351,
     CURRENT_TIME = 352,
     CURRENT_TIMESTAMP = 353,
     CURRENT_USER = 354,
     CURSOR = 355,
     CYCLE = 356,
     DATA_P = 357,
     DATABASE = 358,
     DAY_P = 359,
     DEALLOCATE = 360,
     DEC = 361,
     DECIMAL_P = 362,
     DECLARE = 363,
     DEFAULT = 364,
     DEFAULTS = 365,
     DEFERRABLE = 366,
     DEFERRED = 367,
     DEFINER = 368,
     DELETE_P = 369,
     DELIMITER = 370,
     DELIMITERS = 371,
     DEPENDS = 372,
     DESC = 373,
     DICTIONARY = 374,
     DISABLE_P = 375,
     DISCARD = 376,
     DISTINCT = 377,
     DO = 378,
     DOCUMENT_P = 379,
     DOMAIN_P = 380,
     DOUBLE_P = 381,
     DROP = 382,
     EACH = 383,
     ELSE = 384,
     ENABLE_P = 385,
     ENCODING = 386,
     ENCRYPTED = 387,
     END_P = 388,
     ENUM_P = 389,
     ESCAPE = 390,
     EVENT = 391,
     EXCEPT = 392,
     EXCLUDE = 393,
     EXCLUDING = 394,
     EXCLUSIVE = 395,
     EXECUTE = 396,
     EXISTS = 397,
     EXPLAIN = 398,
     EXTENSION = 399,
     EXTERNAL = 400,
     EXTRACT = 401,
     FALSE_P = 402,
     FAMILY = 403,
     FETCH = 404,
     FILTER = 405,
     FIRST_P = 406,
     FLOAT_P = 407,
     FOLLOWING = 408,
     FOR = 409,
     FORCE = 410,
     FOREIGN = 411,
     FORWARD = 412,
     FREEZE = 413,
     FROM = 414,
     FULL = 415,
     FUNCTION = 416,
     FUNCTIONS = 417,
     GLOBAL = 418,
     GRANT = 419,
     GRANTED = 420,
     GREATEST = 421,
     GROUP_P = 422,
     GROUPING = 423,
     HANDLER = 424,
     HAVING = 425,
     HEADER_P = 426,
     HOLD = 427,
     HOUR_P = 428,
     IDENTITY_P = 429,
     IF_P = 430,
     ILIKE = 431,
     IMMEDIATE = 432,
     IMMUTABLE = 433,
     IMPLICIT_P = 434,
     IMPORT_P = 435,
     IN_P = 436,
     INCLUDING = 437,
     INCREMENT = 438,
     INDEX = 439,
     INDEXES = 440,
     INHERIT = 441,
     INHERITS = 442,
     INITIALLY = 443,
     INLINE_P = 444,
     INNER_P = 445,
     INOUT = 446,
     INPUT_P = 447,
     INSENSITIVE = 448,
     INSERT = 449,
     INSTEAD = 450,
     INT_P = 451,
     INTEGER = 452,
     INTERSECT = 453,
     INTERVAL = 454,
     INTO = 455,
     INVOKER = 456,
     IS = 457,
     ISNULL = 458,
     ISOLATION = 459,
     JOIN = 460,
     KEY = 461,
     LABEL = 462,
     LANGUAGE = 463,
     LARGE_P = 464,
     LAST_P = 465,
     LATERAL_P = 466,
     LEADING = 467,
     LEAKPROOF = 468,
     LEAST = 469,
     LEFT = 470,
     LEVEL = 471,
     LIKE = 472,
     LIMIT = 473,
     LISTEN = 474,
     LOAD = 475,
     LOCAL = 476,
     LOCALTIME = 477,
     LOCALTIMESTAMP = 478,
     LOCATION = 479,
     LOCK_P = 480,
     LOCKED = 481,
     LOGGED = 482,
     MAPPING = 483,
     MATCH = 484,
     MATERIALIZED = 485,
     MAXVALUE = 486,
     METHOD = 487,
     MINUTE_P = 488,
     MINVALUE = 489,
     MODE = 490,
     MONTH_P = 491,
     MOVE = 492,
     NAME_P = 493,
     NAMES = 494,
     NATIONAL = 495,
     NATURAL = 496,
     NCHAR = 497,
     NEXT = 498,
     NO = 499,
     NONE = 500,
     NOT = 501,
     NOTHING = 502,
     NOTIFY = 503,
     NOTNULL = 504,
     NOWAIT = 505,
     NULL_P = 506,
     NULLIF = 507,
     NULLS_P = 508,
     NUMERIC = 509,
     OBJECT_P = 510,
     OF = 511,
     OFF = 512,
     OFFSET = 513,
     OIDS = 514,
     ON = 515,
     ONLY = 516,
     OPERATOR = 517,
     OPTION = 518,
     OPTIONS = 519,
     OR = 520,
     ORDER = 521,
     ORDINALITY = 522,
     OUT_P = 523,
     OUTER_P = 524,
     OVER = 525,
     OVERLAPS = 526,
     OVERLAY = 527,
     OWNED = 528,
     OWNER = 529,
     PARALLEL = 530,
     PARSER = 531,
     PARTIAL = 532,
     PARTITION = 533,
     PASSING = 534,
     PASSWORD = 535,
     PGPOOL = 536,
     PLACING = 537,
     PLANS = 538,
     POLICY = 539,
     POSITION = 540,
     PRECEDING = 541,
     PRECISION = 542,
     PRESERVE = 543,
     PREPARE = 544,
     PREPARED = 545,
     PRIMARY = 546,
     PRIOR = 547,
     PRIVILEGES = 548,
     PROCEDURAL = 549,
     PROCEDURE = 550,
     PROGRAM = 551,
     QUOTE = 552,
     RANGE = 553,
     READ = 554,
     REAL = 555,
     REASSIGN = 556,
     RECHECK = 557,
     RECURSIVE = 558,
     REF = 559,
     REFERENCES = 560,
     REFRESH = 561,
     REINDEX = 562,
     RELATIVE_P = 563,
     RELEASE = 564,
     RENAME = 565,
     REPEATABLE = 566,
     REPLACE = 567,
     REPLICA = 568,
     RESET = 569,
     RESTART = 570,
     RESTRICT = 571,
     RETURNING = 572,
     RETURNS = 573,
     REVOKE = 574,
     RIGHT = 575,
     ROLE = 576,
     ROLLBACK = 577,
     ROLLUP = 578,
     ROW = 579,
     ROWS = 580,
     RULE = 581,
     SAVEPOINT = 582,
     SCHEMA = 583,
     SCROLL = 584,
     SEARCH = 585,
     SECOND_P = 586,
     SECURITY = 587,
     SELECT = 588,
     SEQUENCE = 589,
     SEQUENCES = 590,
     SERIALIZABLE = 591,
     SERVER = 592,
     SESSION = 593,
     SESSION_USER = 594,
     SET = 595,
     SETS = 596,
     SETOF = 597,
     SHARE = 598,
     SHOW = 599,
     SIMILAR = 600,
     SIMPLE = 601,
     SKIP = 602,
     SMALLINT = 603,
     SNAPSHOT = 604,
     SOME = 605,
     SQL_P = 606,
     STABLE = 607,
     STANDALONE_P = 608,
     START = 609,
     STATEMENT = 610,
     STATISTICS = 611,
     STDIN = 612,
     STDOUT = 613,
     STORAGE = 614,
     STRICT_P = 615,
     STRIP_P = 616,
     SUBSTRING = 617,
     SYMMETRIC = 618,
     SYSID = 619,
     SYSTEM_P = 620,
     TABLE = 621,
     TABLES = 622,
     TABLESAMPLE = 623,
     TABLESPACE = 624,
     TEMP = 625,
     TEMPLATE = 626,
     TEMPORARY = 627,
     TEXT_P = 628,
     THEN = 629,
     TIME = 630,
     TIMESTAMP = 631,
     TO = 632,
     TRAILING = 633,
     TRANSACTION = 634,
     TRANSFORM = 635,
     TREAT = 636,
     TRIGGER = 637,
     TRIM = 638,
     TRUE_P = 639,
     TRUNCATE = 640,
     TRUSTED = 641,
     TYPE_P = 642,
     TYPES_P = 643,
     UNBOUNDED = 644,
     UNCOMMITTED = 645,
     UNENCRYPTED = 646,
     UNION = 647,
     UNIQUE = 648,
     UNKNOWN = 649,
     UNLISTEN = 650,
     UNLOGGED = 651,
     UNTIL = 652,
     UPDATE = 653,
     USER = 654,
     USING = 655,
     VACUUM = 656,
     VALID = 657,
     VALIDATE = 658,
     VALIDATOR = 659,
     VALUE_P = 660,
     VALUES = 661,
     VARCHAR = 662,
     VARIADIC = 663,
     VARYING = 664,
     VERBOSE = 665,
     VERSION_P = 666,
     VIEW = 667,
     VIEWS = 668,
     VOLATILE = 669,
     WHEN = 670,
     WHERE = 671,
     WHITESPACE_P = 672,
     WINDOW = 673,
     WITH = 674,
     WITHIN = 675,
     WITHOUT = 676,
     WORK = 677,
     WRAPPER = 678,
     WRITE = 679,
     XML_P = 680,
     XMLATTRIBUTES = 681,
     XMLCONCAT = 682,
     XMLELEMENT = 683,
     XMLEXISTS = 684,
     XMLFOREST = 685,
     XMLPARSE = 686,
     XMLPI = 687,
     XMLROOT = 688,
     XMLSERIALIZE = 689,
     YEAR_P = 690,
     YES_P = 691,
     ZONE = 692,
     NOT_LA = 693,
     NULLS_LA = 694,
     WITH_LA = 695,
     POSTFIXOP = 696,
     UMINUS = 697
   };
#endif
/* Tokens.  */
#define IDENT 258
#define FCONST 259
#define SCONST 260
#define BCONST 261
#define XCONST 262
#define Op 263
#define ICONST 264
#define PARAM 265
#define TYPECAST 266
#define DOT_DOT 267
#define COLON_EQUALS 268
#define EQUALS_GREATER 269
#define LESS_EQUALS 270
#define GREATER_EQUALS 271
#define NOT_EQUALS 272
#define ABORT_P 273
#define ABSOLUTE_P 274
#define ACCESS 275
#define ACTION 276
#define ADD_P 277
#define ADMIN 278
#define AFTER 279
#define AGGREGATE 280
#define ALL 281
#define ALSO 282
#define ALTER 283
#define ALWAYS 284
#define ANALYSE 285
#define ANALYZE 286
#define AND 287
#define ANY 288
#define ARRAY 289
#define AS 290
#define ASC 291
#define ASSERTION 292
#define ASSIGNMENT 293
#define ASYMMETRIC 294
#define AT 295
#define ATTRIBUTE 296
#define AUTHORIZATION 297
#define BACKWARD 298
#define BEFORE 299
#define BEGIN_P 300
#define BETWEEN 301
#define BIGINT 302
#define BINARY 303
#define BIT 304
#define BOOLEAN_P 305
#define BOTH 306
#define BY 307
#define CACHE 308
#define CALLED 309
#define CASCADE 310
#define CASCADED 311
#define CASE 312
#define CAST 313
#define CATALOG_P 314
#define CHAIN 315
#define CHAR_P 316
#define CHARACTER 317
#define CHARACTERISTICS 318
#define CHECK 319
#define CHECKPOINT 320
#define CLASS 321
#define CLOSE 322
#define CLUSTER 323
#define COALESCE 324
#define COLLATE 325
#define COLLATION 326
#define COLUMN 327
#define COMMENT 328
#define COMMENTS 329
#define COMMIT 330
#define COMMITTED 331
#define CONCURRENTLY 332
#define CONFIGURATION 333
#define CONFLICT 334
#define CONNECTION 335
#define CONSTRAINT 336
#define CONSTRAINTS 337
#define CONTENT_P 338
#define CONTINUE_P 339
#define CONVERSION_P 340
#define COPY 341
#define COST 342
#define CREATE 343
#define CROSS 344
#define CSV 345
#define CUBE 346
#define CURRENT_P 347
#define CURRENT_CATALOG 348
#define CURRENT_DATE 349
#define CURRENT_ROLE 350
#define CURRENT_SCHEMA 351
#define CURRENT_TIME 352
#define CURRENT_TIMESTAMP 353
#define CURRENT_USER 354
#define CURSOR 355
#define CYCLE 356
#define DATA_P 357
#define DATABASE 358
#define DAY_P 359
#define DEALLOCATE 360
#define DEC 361
#define DECIMAL_P 362
#define DECLARE 363
#define DEFAULT 364
#define DEFAULTS 365
#define DEFERRABLE 366
#define DEFERRED 367
#define DEFINER 368
#define DELETE_P 369
#define DELIMITER 370
#define DELIMITERS 371
#define DEPENDS 372
#define DESC 373
#define DICTIONARY 374
#define DISABLE_P 375
#define DISCARD 376
#define DISTINCT 377
#define DO 378
#define DOCUMENT_P 379
#define DOMAIN_P 380
#define DOUBLE_P 381
#define DROP 382
#define EACH 383
#define ELSE 384
#define ENABLE_P 385
#define ENCODING 386
#define ENCRYPTED 387
#define END_P 388
#define ENUM_P 389
#define ESCAPE 390
#define EVENT 391
#define EXCEPT 392
#define EXCLUDE 393
#define EXCLUDING 394
#define EXCLUSIVE 395
#define EXECUTE 396
#define EXISTS 397
#define EXPLAIN 398
#define EXTENSION 399
#define EXTERNAL 400
#define EXTRACT 401
#define FALSE_P 402
#define FAMILY 403
#define FETCH 404
#define FILTER 405
#define FIRST_P 406
#define FLOAT_P 407
#define FOLLOWING 408
#define FOR 409
#define FORCE 410
#define FOREIGN 411
#define FORWARD 412
#define FREEZE 413
#define FROM 414
#define FULL 415
#define FUNCTION 416
#define FUNCTIONS 417
#define GLOBAL 418
#define GRANT 419
#define GRANTED 420
#define GREATEST 421
#define GROUP_P 422
#define GROUPING 423
#define HANDLER 424
#define HAVING 425
#define HEADER_P 426
#define HOLD 427
#define HOUR_P 428
#define IDENTITY_P 429
#define IF_P 430
#define ILIKE 431
#define IMMEDIATE 432
#define IMMUTABLE 433
#define IMPLICIT_P 434
#define IMPORT_P 435
#define IN_P 436
#define INCLUDING 437
#define INCREMENT 438
#define INDEX 439
#define INDEXES 440
#define INHERIT 441
#define INHERITS 442
#define INITIALLY 443
#define INLINE_P 444
#define INNER_P 445
#define INOUT 446
#define INPUT_P 447
#define INSENSITIVE 448
#define INSERT 449
#define INSTEAD 450
#define INT_P 451
#define INTEGER 452
#define INTERSECT 453
#define INTERVAL 454
#define INTO 455
#define INVOKER 456
#define IS 457
#define ISNULL 458
#define ISOLATION 459
#define JOIN 460
#define KEY 461
#define LABEL 462
#define LANGUAGE 463
#define LARGE_P 464
#define LAST_P 465
#define LATERAL_P 466
#define LEADING 467
#define LEAKPROOF 468
#define LEAST 469
#define LEFT 470
#define LEVEL 471
#define LIKE 472
#define LIMIT 473
#define LISTEN 474
#define LOAD 475
#define LOCAL 476
#define LOCALTIME 477
#define LOCALTIMESTAMP 478
#define LOCATION 479
#define LOCK_P 480
#define LOCKED 481
#define LOGGED 482
#define MAPPING 483
#define MATCH 484
#define MATERIALIZED 485
#define MAXVALUE 486
#define METHOD 487
#define MINUTE_P 488
#define MINVALUE 489
#define MODE 490
#define MONTH_P 491
#define MOVE 492
#define NAME_P 493
#define NAMES 494
#define NATIONAL 495
#define NATURAL 496
#define NCHAR 497
#define NEXT 498
#define NO 499
#define NONE 500
#define NOT 501
#define NOTHING 502
#define NOTIFY 503
#define NOTNULL 504
#define NOWAIT 505
#define NULL_P 506
#define NULLIF 507
#define NULLS_P 508
#define NUMERIC 509
#define OBJECT_P 510
#define OF 511
#define OFF 512
#define OFFSET 513
#define OIDS 514
#define ON 515
#define ONLY 516
#define OPERATOR 517
#define OPTION 518
#define OPTIONS 519
#define OR 520
#define ORDER 521
#define ORDINALITY 522
#define OUT_P 523
#define OUTER_P 524
#define OVER 525
#define OVERLAPS 526
#define OVERLAY 527
#define OWNED 528
#define OWNER 529
#define PARALLEL 530
#define PARSER 531
#define PARTIAL 532
#define PARTITION 533
#define PASSING 534
#define PASSWORD 535
#define PGPOOL 536
#define PLACING 537
#define PLANS 538
#define POLICY 539
#define POSITION 540
#define PRECEDING 541
#define PRECISION 542
#define PRESERVE 543
#define PREPARE 544
#define PREPARED 545
#define PRIMARY 546
#define PRIOR 547
#define PRIVILEGES 548
#define PROCEDURAL 549
#define PROCEDURE 550
#define PROGRAM 551
#define QUOTE 552
#define RANGE 553
#define READ 554
#define REAL 555
#define REASSIGN 556
#define RECHECK 557
#define RECURSIVE 558
#define REF 559
#define REFERENCES 560
#define REFRESH 561
#define REINDEX 562
#define RELATIVE_P 563
#define RELEASE 564
#define RENAME 565
#define REPEATABLE 566
#define REPLACE 567
#define REPLICA 568
#define RESET 569
#define RESTART 570
#define RESTRICT 571
#define RETURNING 572
#define RETURNS 573
#define REVOKE 574
#define RIGHT 575
#define ROLE 576
#define ROLLBACK 577
#define ROLLUP 578
#define ROW 579
#define ROWS 580
#define RULE 581
#define SAVEPOINT 582
#define SCHEMA 583
#define SCROLL 584
#define SEARCH 585
#define SECOND_P 586
#define SECURITY 587
#define SELECT 588
#define SEQUENCE 589
#define SEQUENCES 590
#define SERIALIZABLE 591
#define SERVER 592
#define SESSION 593
#define SESSION_USER 594
#define SET 595
#define SETS 596
#define SETOF 597
#define SHARE 598
#define SHOW 599
#define SIMILAR 600
#define SIMPLE 601
#define SKIP 602
#define SMALLINT 603
#define SNAPSHOT 604
#define SOME 605
#define SQL_P 606
#define STABLE 607
#define STANDALONE_P 608
#define START 609
#define STATEMENT 610
#define STATISTICS 611
#define STDIN 612
#define STDOUT 613
#define STORAGE 614
#define STRICT_P 615
#define STRIP_P 616
#define SUBSTRING 617
#define SYMMETRIC 618
#define SYSID 619
#define SYSTEM_P 620
#define TABLE 621
#define TABLES 622
#define TABLESAMPLE 623
#define TABLESPACE 624
#define TEMP 625
#define TEMPLATE 626
#define TEMPORARY 627
#define TEXT_P 628
#define THEN 629
#define TIME 630
#define TIMESTAMP 631
#define TO 632
#define TRAILING 633
#define TRANSACTION 634
#define TRANSFORM 635
#define TREAT 636
#define TRIGGER 637
#define TRIM 638
#define TRUE_P 639
#define TRUNCATE 640
#define TRUSTED 641
#define TYPE_P 642
#define TYPES_P 643
#define UNBOUNDED 644
#define UNCOMMITTED 645
#define UNENCRYPTED 646
#define UNION 647
#define UNIQUE 648
#define UNKNOWN 649
#define UNLISTEN 650
#define UNLOGGED 651
#define UNTIL 652
#define UPDATE 653
#define USER 654
#define USING 655
#define VACUUM 656
#define VALID 657
#define VALIDATE 658
#define VALIDATOR 659
#define VALUE_P 660
#define VALUES 661
#define VARCHAR 662
#define VARIADIC 663
#define VARYING 664
#define VERBOSE 665
#define VERSION_P 666
#define VIEW 667
#define VIEWS 668
#define VOLATILE 669
#define WHEN 670
#define WHERE 671
#define WHITESPACE_P 672
#define WINDOW 673
#define WITH 674
#define WITHIN 675
#define WITHOUT 676
#define WORK 677
#define WRAPPER 678
#define WRITE 679
#define XML_P 680
#define XMLATTRIBUTES 681
#define XMLCONCAT 682
#define XMLELEMENT 683
#define XMLEXISTS 684
#define XMLFOREST 685
#define XMLPARSE 686
#define XMLPI 687
#define XMLROOT 688
#define XMLSERIALIZE 689
#define YEAR_P 690
#define YES_P 691
#define ZONE 692
#define NOT_LA 693
#define NULLS_LA 694
#define WITH_LA 695
#define POSTFIXOP 696
#define UMINUS 697



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 227 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;


/* Line 387 of yacc.c  */
#line 1261 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int base_yyparse (void *YYPARSE_PARAM);
#else
int base_yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int base_yyparse (core_yyscan_t yyscanner);
#else
int base_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1301 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  767
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   92941

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  460
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  618
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2513
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4991

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   697

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   449,     2,     2,
     454,   455,   447,   445,   458,   446,   456,   448,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   459,   457,
     441,   443,   442,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   452,     2,   453,   450,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   444,   451
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     241,   243,   245,   247,   249,   251,   253,   255,   257,   259,
     261,   262,   268,   270,   272,   273,   276,   277,   280,   281,
     284,   287,   291,   295,   297,   301,   305,   308,   310,   312,
     315,   318,   321,   325,   329,   335,   341,   342,   346,   352,
     358,   364,   369,   373,   379,   383,   389,   395,   402,   404,
     406,   410,   416,   423,   428,   438,   446,   448,   449,   452,
     453,   455,   457,   459,   461,   463,   465,   469,   472,   476,
     480,   483,   489,   491,   495,   499,   503,   507,   509,   513,
     517,   520,   523,   526,   529,   533,   537,   541,   545,   547,
     551,   553,   557,   559,   561,   564,   567,   570,   572,   574,
     576,   578,   580,   582,   584,   588,   594,   596,   598,   600,
     602,   604,   605,   607,   609,   612,   616,   618,   621,   625,
     628,   630,   632,   635,   637,   640,   642,   646,   650,   653,
     657,   662,   666,   669,   674,   676,   678,   680,   682,   684,
     687,   690,   693,   696,   699,   704,   711,   722,   736,   741,
     748,   759,   773,   778,   785,   790,   797,   803,   811,   823,
     838,   840,   844,   847,   853,   857,   864,   869,   876,   883,
     890,   896,   902,   909,   916,   921,   930,   935,   938,   943,
     947,   954,   959,   963,   967,   971,   975,   978,   981,   985,
     990,   995,   999,  1003,  1007,  1011,  1015,  1019,  1024,  1029,
    1033,  1036,  1040,  1043,  1046,  1050,  1054,  1057,  1060,  1064,
    1069,  1074,  1079,  1085,  1087,  1091,  1094,  1096,  1098,  1099,
    1102,  1103,  1106,  1107,  1109,  1111,  1113,  1117,  1121,  1124,
    1125,  1127,  1131,  1135,  1137,  1143,  1147,  1152,  1154,  1158,
    1163,  1170,  1175,  1184,  1187,  1190,  1202,  1212,  1214,  1216,
    1218,  1219,  1221,  1223,  1225,  1227,  1231,  1234,  1235,  1237,
    1239,  1241,  1245,  1249,  1251,  1253,  1257,  1261,  1265,  1269,
    1274,  1278,  1281,  1283,  1284,  1287,  1288,  1292,  1293,  1295,
    1296,  1298,  1302,  1305,  1307,  1309,  1311,  1315,  1316,  1318,
    1322,  1324,  1336,  1351,  1362,  1376,  1378,  1380,  1383,  1386,
    1389,  1392,  1394,  1395,  1397,  1398,  1402,  1403,  1405,  1409,
    1411,  1415,  1417,  1419,  1421,  1423,  1425,  1430,  1435,  1438,
    1439,  1443,  1445,  1447,  1450,  1453,  1455,  1459,  1464,  1470,
    1473,  1479,  1481,  1484,  1487,  1490,  1494,  1498,  1502,  1503,
    1505,  1507,  1509,  1511,  1513,  1515,  1519,  1521,  1527,  1535,
    1539,  1548,  1553,  1563,  1575,  1578,  1579,  1583,  1584,  1586,
    1590,  1592,  1595,  1598,  1601,  1602,  1604,  1608,  1612,  1619,
    1624,  1625,  1627,  1629,  1632,  1635,  1636,  1640,  1644,  1647,
    1649,  1651,  1654,  1657,  1662,  1663,  1666,  1669,  1672,  1673,
    1677,  1682,  1687,  1688,  1691,  1692,  1697,  1698,  1702,  1710,
    1721,  1727,  1730,  1734,  1735,  1744,  1756,  1761,  1763,  1764,
    1771,  1777,  1786,  1791,  1798,  1800,  1801,  1803,  1806,  1809,
    1811,  1814,  1818,  1821,  1824,  1827,  1830,  1834,  1838,  1840,
    1844,  1846,  1847,  1849,  1852,  1854,  1856,  1860,  1867,  1878,
    1880,  1881,  1883,  1886,  1889,  1890,  1893,  1896,  1898,  1899,
    1905,  1913,  1915,  1916,  1924,  1927,  1928,  1932,  1938,  1944,
    1953,  1956,  1957,  1960,  1963,  1966,  1968,  1974,  1977,  1978,
    1981,  1989,  2000,  2007,  2014,  2021,  2028,  2036,  2044,  2054,
    2064,  2071,  2079,  2086,  2095,  2104,  2113,  2122,  2129,  2136,
    2144,  2152,  2161,  2168,  2178,  2185,  2193,  2196,  2199,  2202,
    2205,  2207,  2210,  2212,  2213,  2220,  2229,  2237,  2244,  2249,
    2250,  2252,  2256,  2261,  2263,  2267,  2269,  2272,  2275,  2278,
    2281,  2283,  2285,  2296,  2299,  2300,  2303,  2306,  2308,  2309,
    2314,  2321,  2327,  2332,  2337,  2349,  2364,  2370,  2378,  2390,
    2393,  2395,  2400,  2401,  2410,  2412,  2414,  2422,  2432,  2441,
    2451,  2460,  2467,  2476,  2481,  2482,  2488,  2489,  2492,  2493,
    2496,  2497,  2500,  2501,  2503,  2505,  2507,  2509,  2511,  2520,
    2536,  2557,  2559,  2561,  2564,  2566,  2570,  2572,  2574,  2576,
    2580,  2582,  2586,  2587,  2589,  2590,  2592,  2594,  2599,  2600,
    2602,  2606,  2607,  2609,  2611,  2613,  2615,  2618,  2619,  2620,
    2623,  2626,  2628,  2631,  2634,  2637,  2640,  2647,  2656,  2668,
    2682,  2684,  2688,  2694,  2696,  2700,  2706,  2708,  2711,  2714,
    2716,  2725,  2730,  2736,  2741,  2746,  2751,  2755,  2763,  2772,
    2779,  2786,  2793,  2800,  2807,  2812,  2818,  2822,  2824,  2828,
    2832,  2834,  2836,  2838,  2840,  2842,  2844,  2848,  2850,  2854,
    2858,  2860,  2861,  2863,  2867,  2875,  2885,  2895,  2899,  2900,
    2914,  2916,  2920,  2926,  2933,  2938,  2946,  2949,  2951,  2952,
    2955,  2956,  2959,  2964,  2965,  2967,  2968,  2975,  2984,  2993,
    2995,  2999,  3005,  3011,  3019,  3029,  3037,  3047,  3053,  3060,
    3067,  3072,  3077,  3084,  3089,  3096,  3102,  3110,  3112,  3114,
    3116,  3119,  3121,  3124,  3127,  3130,  3132,  3134,  3136,  3138,
    3142,  3146,  3150,  3154,  3156,  3160,  3162,  3165,  3168,  3172,
    3174,  3178,  3184,  3187,  3190,  3191,  3198,  3205,  3212,  3220,
    3228,  3236,  3245,  3255,  3264,  3273,  3280,  3290,  3299,  3309,
    3319,  3327,  3338,  3346,  3349,  3351,  3353,  3355,  3357,  3359,
    3361,  3363,  3366,  3368,  3370,  3372,  3374,  3376,  3379,  3381,
    3385,  3388,  3392,  3396,  3400,  3404,  3406,  3408,  3417,  3426,
    3435,  3445,  3455,  3465,  3475,  3478,  3479,  3481,  3483,  3486,
    3489,  3491,  3493,  3495,  3497,  3499,  3501,  3504,  3506,  3508,
    3511,  3514,  3516,  3519,  3523,  3527,  3531,  3535,  3540,  3545,
    3549,  3553,  3557,  3562,  3567,  3571,  3576,  3581,  3583,  3585,
    3587,  3588,  3596,  3604,  3615,  3617,  3619,  3622,  3627,  3633,
    3635,  3639,  3642,  3645,  3648,  3651,  3653,  3656,  3659,  3664,
    3668,  3671,  3674,  3677,  3680,  3684,  3687,  3690,  3693,  3699,
    3705,  3711,  3713,  3717,  3719,  3722,  3726,  3727,  3729,  3733,
    3736,  3743,  3750,  3760,  3764,  3765,  3769,  3770,  3776,  3779,
    3780,  3784,  3788,  3792,  3800,  3808,  3819,  3821,  3823,  3825,
    3827,  3842,  3860,  3862,  3863,  3865,  3866,  3868,  3869,  3872,
    3873,  3875,  3879,  3885,  3891,  3899,  3902,  3903,  3905,  3906,
    3908,  3910,  3911,  3914,  3917,  3918,  3928,  3941,  3949,  3952,
    3953,  3957,  3960,  3962,  3966,  3970,  3973,  3975,  3979,  3983,
    3987,  3990,  3993,  3995,  3997,  3999,  4001,  4004,  4006,  4008,
    4010,  4012,  4017,  4023,  4025,  4029,  4033,  4035,  4039,  4043,
    4049,  4056,  4058,  4062,  4064,  4067,  4072,  4078,  4080,  4082,
    4084,  4086,  4090,  4094,  4097,  4100,  4102,  4105,  4108,  4111,
    4113,  4116,  4119,  4122,  4125,  4127,  4129,  4131,  4135,  4139,
    4145,  4148,  4149,  4152,  4154,  4158,  4164,  4166,  4169,  4171,
    4172,  4178,  4186,  4192,  4200,  4206,  4214,  4218,  4224,  4230,
    4236,  4238,  4242,  4245,  4247,  4250,  4252,  4255,  4267,  4278,
    4289,  4292,  4295,  4296,  4306,  4309,  4310,  4321,  4333,  4345,
    4351,  4357,  4366,  4370,  4374,  4381,  4388,  4390,  4392,  4394,
    4396,  4398,  4400,  4404,  4406,  4412,  4418,  4426,  4433,  4440,
    4447,  4454,  4463,  4472,  4479,  4486,  4494,  4504,  4514,  4523,
    4534,  4541,  4548,  4555,  4564,  4571,  4580,  4587,  4596,  4604,
    4614,  4621,  4630,  4638,  4648,  4657,  4668,  4678,  4690,  4699,
    4710,  4720,  4732,  4741,  4750,  4758,  4765,  4772,  4779,  4788,
    4797,  4806,  4815,  4822,  4832,  4834,  4835,  4838,  4839,  4847,
    4857,  4866,  4874,  4882,  4889,  4896,  4903,  4910,  4917,  4925,
    4935,  4945,  4952,  4961,  4970,  4979,  4988,  4997,  5004,  5013,
    5020,  5029,  5037,  5047,  5055,  5065,  5072,  5081,  5083,  5087,
    5091,  5095,  5103,  5110,  5117,  5124,  5131,  5138,  5146,  5154,
    5162,  5172,  5182,  5189,  5196,  5203,  5212,  5221,  5230,  5237,
    5245,  5259,  5261,  5263,  5267,  5271,  5273,  5275,  5277,  5279,
    5281,  5283,  5285,  5286,  5288,  5290,  5292,  5294,  5296,  5298,
    5299,  5306,  5315,  5319,  5322,  5323,  5326,  5329,  5332,  5335,
    5339,  5343,  5346,  5349,  5352,  5355,  5359,  5362,  5368,  5373,
    5377,  5381,  5385,  5387,  5389,  5390,  5394,  5397,  5400,  5402,
    5405,  5407,  5411,  5414,  5416,  5417,  5427,  5439,  5452,  5467,
    5471,  5476,  5481,  5482,  5485,  5491,  5493,  5494,  5496,  5499,
    5503,  5507,  5511,  5513,  5516,  5518,  5520,  5522,  5524,  5526,
    5528,  5529,  5535,  5540,  5547,  5552,  5556,  5562,  5567,  5572,
    5579,  5584,  5591,  5598,  5604,  5612,  5622,  5629,  5631,  5632,
    5639,  5651,  5663,  5675,  5689,  5699,  5711,  5713,  5715,  5726,
    5731,  5734,  5740,  5743,  5744,  5749,  5755,  5761,  5766,  5773,
    5775,  5779,  5781,  5783,  5785,  5787,  5789,  5792,  5797,  5799,
    5801,  5803,  5804,  5806,  5807,  5809,  5810,  5814,  5815,  5818,
    5823,  5827,  5833,  5835,  5837,  5839,  5841,  5843,  5845,  5847,
    5849,  5851,  5853,  5857,  5860,  5862,  5864,  5866,  5868,  5869,
    5875,  5879,  5880,  5882,  5884,  5886,  5888,  5892,  5902,  5906,
    5907,  5910,  5914,  5917,  5921,  5929,  5931,  5935,  5937,  5942,
    5945,  5947,  5951,  5954,  5963,  5969,  5970,  5975,  5979,  5980,
    5983,  5984,  5992,  5995,  5996,  6002,  6006,  6007,  6010,  6013,
    6016,  6020,  6022,  6026,  6028,  6031,  6033,  6034,  6036,  6039,
    6040,  6049,  6051,  6055,  6057,  6059,  6063,  6069,  6075,  6078,
    6080,  6084,  6092,  6094,  6095,  6099,  6102,  6105,  6108,  6109,
    6112,  6115,  6117,  6119,  6123,  6127,  6129,  6132,  6137,  6142,
    6145,  6149,  6155,  6161,  6163,  6165,  6175,  6185,  6187,  6190,
    6195,  6200,  6205,  6208,  6211,  6215,  6217,  6221,  6228,  6230,
    6231,  6234,  6235,  6239,  6243,  6248,  6253,  6258,  6263,  6267,
    6270,  6272,  6274,  6275,  6277,  6279,  6280,  6282,  6288,  6290,
    6291,  6293,  6294,  6298,  6300,  6304,  6309,  6313,  6316,  6319,
    6321,  6323,  6325,  6326,  6329,  6334,  6340,  6343,  6347,  6349,
    6351,  6353,  6355,  6359,  6360,  6362,  6364,  6366,  6368,  6370,
    6374,  6375,  6377,  6381,  6383,  6385,  6387,  6389,  6391,  6394,
    6399,  6404,  6410,  6413,  6414,  6416,  6420,  6422,  6423,  6425,
    6428,  6432,  6435,  6440,  6443,  6447,  6450,  6451,  6454,  6458,
    6461,  6462,  6464,  6468,  6471,  6475,  6478,  6482,  6485,  6489,
    6491,  6496,  6500,  6505,  6511,  6516,  6522,  6527,  6533,  6536,
    6541,  6543,  6545,  6546,  6548,  6553,  6559,  6564,  6565,  6568,
    6571,  6574,  6576,  6578,  6579,  6584,  6587,  6589,  6592,  6595,
    6600,  6602,  6606,  6608,  6611,  6615,  6622,  6627,  6628,  6631,
    6638,  6641,  6643,  6647,  6652,  6653,  6656,  6657,  6660,  6661,
    6664,  6669,  6670,  6672,  6673,  6675,  6679,  6683,  6686,  6690,
    6696,  6703,  6706,  6710,  6714,  6719,  6720,  6722,  6724,  6726,
    6728,  6730,  6733,  6738,  6740,  6742,  6744,  6746,  6749,  6753,
    6757,  6758,  6760,  6762,  6764,  6766,  6768,  6771,  6774,  6777,
    6780,  6783,  6785,  6789,  6790,  6792,  6794,  6796,  6798,  6804,
    6807,  6809,  6811,  6813,  6815,  6821,  6824,  6827,  6830,  6832,
    6836,  6840,  6843,  6845,  6846,  6850,  6851,  6857,  6860,  6866,
    6869,  6871,  6875,  6879,  6880,  6882,  6884,  6886,  6888,  6890,
    6892,  6896,  6900,  6904,  6908,  6912,  6916,  6920,  6921,  6923,
    6928,  6930,  6934,  6938,  6944,  6947,  6950,  6954,  6958,  6962,
    6966,  6970,  6974,  6978,  6982,  6986,  6990,  6994,  6998,  7002,
    7005,  7008,  7012,  7016,  7019,  7022,  7026,  7032,  7037,  7044,
    7048,  7054,  7059,  7066,  7071,  7078,  7084,  7092,  7096,  7099,
    7104,  7107,  7111,  7115,  7120,  7124,  7129,  7133,  7138,  7144,
    7151,  7158,  7166,  7173,  7181,  7188,  7196,  7200,  7205,  7210,
    7217,  7220,  7224,  7229,  7231,  7235,  7238,  7241,  7245,  7249,
    7253,  7257,  7261,  7265,  7269,  7273,  7277,  7281,  7285,  7289,
    7293,  7296,  7299,  7305,  7312,  7319,  7327,  7331,  7336,  7338,
    7340,  7343,  7348,  7350,  7352,  7354,  7357,  7360,  7363,  7366,
    7368,  7370,  7375,  7379,  7385,  7392,  7401,  7408,  7415,  7420,
    7425,  7427,  7429,  7431,  7437,  7439,  7441,  7446,  7448,  7453,
    7455,  7460,  7462,  7467,  7469,  7471,  7473,  7475,  7477,  7479,
    7486,  7491,  7496,  7501,  7506,  7513,  7519,  7525,  7531,  7536,
    7543,  7548,  7553,  7558,  7563,  7569,  7577,  7585,  7595,  7601,
    7606,  7613,  7619,  7627,  7635,  7643,  7646,  7650,  7654,  7658,
    7663,  7664,  7669,  7671,  7675,  7679,  7681,  7683,  7685,  7688,
    7691,  7692,  7695,  7700,  7705,  7712,  7718,  7719,  7725,  7726,
    7729,  7730,  7732,  7736,  7740,  7743,  7746,  7747,  7754,  7756,
    7757,  7761,  7762,  7765,  7768,  7769,  7771,  7776,  7779,  7782,
    7785,  7788,  7791,  7796,  7800,  7806,  7811,  7815,  7821,  7823,
    7825,  7827,  7829,  7831,  7833,  7835,  7837,  7839,  7841,  7843,
    7845,  7847,  7849,  7851,  7853,  7855,  7857,  7862,  7864,  7869,
    7871,  7876,  7878,  7881,  7883,  7886,  7888,  7892,  7894,  7898,
    7900,  7904,  7908,  7910,  7914,  7918,  7922,  7925,  7927,  7931,
    7935,  7936,  7938,  7940,  7942,  7944,  7946,  7948,  7950,  7952,
    7957,  7961,  7964,  7968,  7969,  7973,  7977,  7980,  7983,  7985,
    7986,  7989,  7992,  7996,  7999,  8001,  8003,  8007,  8013,  8015,
    8018,  8023,  8026,  8027,  8029,  8030,  8032,  8035,  8038,  8041,
    8045,  8051,  8053,  8054,  8056,  8059,  8060,  8063,  8065,  8066,
    8068,  8070,  8072,  8076,  8080,  8082,  8083,  8085,  8089,  8093,
    8096,  8098,  8100,  8102,  8106,  8108,  8111,  8113,  8117,  8119,
    8121,  8123,  8125,  8127,  8129,  8131,  8134,  8136,  8138,  8140,
    8142,  8144,  8147,  8154,  8157,  8161,  8167,  8169,  8171,  8173,
    8175,  8177,  8179,  8182,  8185,  8187,  8189,  8191,  8193,  8195,
    8199,  8201,  8203,  8205,  8207,  8209,  8211,  8213,  8215,  8217,
    8219,  8221,  8223,  8225,  8227,  8229,  8231,  8233,  8235,  8237,
    8239,  8241,  8243,  8245,  8247,  8249,  8251,  8253,  8255,  8257,
    8259,  8261,  8263,  8265,  8267,  8269,  8271,  8273,  8275,  8277,
    8279,  8281,  8283,  8285,  8287,  8289,  8291,  8293,  8295,  8297,
    8299,  8301,  8303,  8305,  8307,  8309,  8311,  8313,  8315,  8317,
    8319,  8321,  8323,  8325,  8327,  8329,  8331,  8333,  8335,  8337,
    8339,  8341,  8343,  8345,  8347,  8349,  8351,  8353,  8355,  8357,
    8359,  8361,  8363,  8365,  8367,  8369,  8371,  8373,  8375,  8377,
    8379,  8381,  8383,  8385,  8387,  8389,  8391,  8393,  8395,  8397,
    8399,  8401,  8403,  8405,  8407,  8409,  8411,  8413,  8415,  8417,
    8419,  8421,  8423,  8425,  8427,  8429,  8431,  8433,  8435,  8437,
    8439,  8441,  8443,  8445,  8447,  8449,  8451,  8453,  8455,  8457,
    8459,  8461,  8463,  8465,  8467,  8469,  8471,  8473,  8475,  8477,
    8479,  8481,  8483,  8485,  8487,  8489,  8491,  8493,  8495,  8497,
    8499,  8501,  8503,  8505,  8507,  8509,  8511,  8513,  8515,  8517,
    8519,  8521,  8523,  8525,  8527,  8529,  8531,  8533,  8535,  8537,
    8539,  8541,  8543,  8545,  8547,  8549,  8551,  8553,  8555,  8557,
    8559,  8561,  8563,  8565,  8567,  8569,  8571,  8573,  8575,  8577,
    8579,  8581,  8583,  8585,  8587,  8589,  8591,  8593,  8595,  8597,
    8599,  8601,  8603,  8605,  8607,  8609,  8611,  8613,  8615,  8617,
    8619,  8621,  8623,  8625,  8627,  8629,  8631,  8633,  8635,  8637,
    8639,  8641,  8643,  8645,  8647,  8649,  8651,  8653,  8655,  8657,
    8659,  8661,  8663,  8665,  8667,  8669,  8671,  8673,  8675,  8677,
    8679,  8681,  8683,  8685,  8687,  8689,  8691,  8693,  8695,  8697,
    8699,  8701,  8703,  8705,  8707,  8709,  8711,  8713,  8715,  8717,
    8719,  8721,  8723,  8725,  8727,  8729,  8731,  8733,  8735,  8737,
    8739,  8741,  8743,  8745,  8747,  8749,  8751,  8753,  8755,  8757,
    8759,  8761,  8763,  8765,  8767,  8769,  8771,  8773,  8775,  8777,
    8779,  8781,  8783,  8785,  8787,  8789,  8791,  8793,  8795,  8797,
    8799,  8801,  8803,  8805,  8807,  8809,  8811,  8813,  8815,  8817,
    8819,  8821,  8823,  8825,  8827,  8829,  8831,  8833,  8835,  8837,
    8839,  8841,  8843,  8845,  8847,  8849,  8851,  8853,  8855,  8857,
    8859,  8861,  8863,  8865,  8867,  8869,  8871,  8873,  8875,  8877,
    8879,  8881,  8883,  8885,  8887,  8889,  8891,  8893,  8895,  8897,
    8899,  8901,  8903,  8905,  8907,  8909,  8911,  8913,  8915,  8917,
    8919,  8921,  8923,  8925,  8927,  8929,  8931,  8933,  8935,  8937,
    8939,  8941,  8943,  8945,  8947,  8949,  8951,  8953,  8955,  8957,
    8959,  8961,  8963,  8965,  8967,  8969,  8971,  8973,  8975,  8977,
    8979,  8981,  8983,  8985,  8987,  8989,  8991,  8993,  8995,  8997,
    8999,  9001,  9003,  9005,  9007,  9009,  9011,  9013,  9015,  9017,
    9019,  9021,  9023,  9025,  9027,  9029,  9031,  9033,  9035,  9037,
    9039,  9041,  9043,  9045,  9047,  9049,  9051,  9053,  9055,  9057,
    9059,  9061,  9063,  9065
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     461,     0,    -1,   462,    -1,   462,   457,   463,    -1,   463,
      -1,   668,    -1,   831,    -1,   832,    -1,   733,    -1,   836,
      -1,   682,    -1,   607,    -1,   610,    -1,   616,    -1,   630,
      -1,   632,    -1,   772,    -1,   479,    -1,   799,    -1,   800,
      -1,   804,    -1,   801,    -1,   641,    -1,   586,    -1,   834,
      -1,   509,    -1,   795,    -1,   521,    -1,   473,    -1,   471,
      -1,   839,    -1,   838,    -1,   639,    -1,   475,    -1,   474,
      -1,   847,    -1,   507,    -1,   524,    -1,   842,    -1,   707,
      -1,   504,    -1,   525,    -1,   649,    -1,   578,    -1,   670,
      -1,   783,    -1,   841,    -1,   835,    -1,   604,    -1,   611,
      -1,   625,    -1,   631,    -1,   749,    -1,   478,    -1,   581,
      -1,   684,    -1,   691,    -1,   692,    -1,   640,    -1,   593,
      -1,   482,    -1,   585,    -1,   541,    -1,   601,    -1,   787,
      -1,   650,    -1,   664,    -1,   464,    -1,   470,    -1,   636,
      -1,   825,    -1,   864,    -1,   887,    -1,   672,    -1,   873,
      -1,   508,    -1,   780,    -1,   671,    -1,   785,    -1,   615,
      -1,   629,    -1,   481,    -1,   695,    -1,   696,    -1,   697,
      -1,   642,    -1,   599,    -1,   812,    -1,   699,    -1,   603,
      -1,   789,    -1,   663,    -1,   476,    -1,   477,    -1,   638,
      -1,   833,    -1,   862,    -1,   853,    -1,   714,    -1,   718,
      -1,   729,    -1,   633,    -1,   738,    -1,   865,    -1,   815,
      -1,   584,    -1,   824,    -1,   875,    -1,   813,    -1,   859,
      -1,   698,    -1,   790,    -1,   776,    -1,   775,    -1,   777,
      -1,   796,    -1,   719,    -1,   730,    -1,   805,    -1,   710,
      -1,   891,    -1,   817,    -1,   705,    -1,   816,    -1,   880,
      -1,   844,    -1,   498,    -1,   486,    -1,   503,    -1,   822,
      -1,    -1,    88,   321,  1067,   465,   466,    -1,   419,    -1,
     440,    -1,    -1,   466,   469,    -1,    -1,   467,   468,    -1,
      -1,   280,  1065,    -1,   280,   251,    -1,   132,   280,  1065,
      -1,   391,   280,  1065,    -1,   186,    -1,    80,   218,  1066,
      -1,   402,   397,  1065,    -1,   399,  1069,    -1,     3,    -1,
     468,    -1,   364,  1064,    -1,    23,  1069,    -1,   321,  1069,
      -1,   181,   321,  1069,    -1,   181,   167,  1069,    -1,    88,
     399,  1067,   465,   466,    -1,    28,   321,  1068,   465,   467,
      -1,    -1,   181,   103,  1057,    -1,    28,   321,  1068,   472,
     501,    -1,    28,   321,    26,   472,   501,    -1,    28,   399,
    1068,   465,   467,    -1,    28,   399,  1068,   501,    -1,   127,
     321,  1069,    -1,   127,   321,   175,   142,  1069,    -1,   127,
     399,  1069,    -1,   127,   399,   175,   142,  1069,    -1,    88,
     167,  1067,   465,   466,    -1,    28,   167,  1068,   480,   399,
    1069,    -1,    22,    -1,   127,    -1,   127,   167,  1069,    -1,
     127,   167,   175,   142,  1069,    -1,    88,   328,   483,    42,
    1068,   484,    -1,    88,   328,  1070,   484,    -1,    88,   328,
     175,   246,   142,   483,    42,  1068,   484,    -1,    88,   328,
     175,   246,   142,  1070,   484,    -1,  1070,    -1,    -1,   484,
     485,    -1,    -1,   541,    -1,   738,    -1,   585,    -1,   650,
      -1,   718,    -1,   822,    -1,   281,   340,   488,    -1,   340,
     487,    -1,   340,   221,   487,    -1,   340,   338,   487,    -1,
     379,   820,    -1,   338,    63,    35,   379,   820,    -1,   489,
      -1,   490,   377,   491,    -1,   490,   443,   491,    -1,   490,
     377,   109,    -1,   490,   443,   109,    -1,   488,    -1,   490,
     159,    92,    -1,   375,   437,   495,    -1,    59,  1065,    -1,
     328,  1065,    -1,   239,   496,    -1,   321,   497,    -1,   338,
      42,   497,    -1,   338,    42,   109,    -1,   425,   263,   996,
      -1,   379,   349,  1065,    -1,  1070,    -1,   490,   456,  1070,
      -1,   492,    -1,   491,   458,   492,    -1,   494,    -1,   591,
      -1,   299,   390,    -1,   299,    76,    -1,   311,   299,    -1,
     336,    -1,   384,    -1,   147,    -1,   260,    -1,   497,    -1,
    1065,    -1,     3,    -1,   980,  1065,   982,    -1,   980,   454,
    1064,   455,  1065,    -1,   591,    -1,   109,    -1,   221,    -1,
    1065,    -1,   109,    -1,    -1,  1072,    -1,  1065,    -1,   314,
     499,    -1,   281,   314,   500,    -1,   500,    -1,   375,   437,
      -1,   379,   204,   216,    -1,   338,    42,    -1,   490,    -1,
      26,    -1,   340,   487,    -1,   498,    -1,   340,   489,    -1,
     498,    -1,   281,   344,   490,    -1,   281,   344,    26,    -1,
     344,   490,    -1,   344,   375,   437,    -1,   344,   379,   204,
     216,    -1,   344,   338,    42,    -1,   344,    26,    -1,   340,
      82,   505,   506,    -1,    26,    -1,  1053,    -1,   112,    -1,
     177,    -1,    65,    -1,   121,    26,    -1,   121,   370,    -1,
     121,   372,    -1,   121,   283,    -1,   121,   335,    -1,    28,
     366,   945,   510,    -1,    28,   366,   175,   142,   945,   510,
      -1,    28,   366,    26,   181,   369,  1056,   340,   369,  1056,
     878,    -1,    28,   366,    26,   181,   369,  1056,   273,    52,
    1069,   340,   369,  1056,   878,    -1,    28,   184,  1054,   510,
      -1,    28,   184,   175,   142,  1054,   510,    -1,    28,   184,
      26,   181,   369,  1056,   340,   369,  1056,   878,    -1,    28,
     184,    26,   181,   369,  1056,   273,    52,  1069,   340,   369,
    1056,   878,    -1,    28,   334,  1054,   510,    -1,    28,   334,
     175,   142,  1054,   510,    -1,    28,   412,  1054,   510,    -1,
      28,   412,   175,   142,  1054,   510,    -1,    28,   230,   412,
    1054,   510,    -1,    28,   230,   412,   175,   142,  1054,   510,
      -1,    28,   230,   412,    26,   181,   369,  1056,   340,   369,
    1056,   878,    -1,    28,   230,   412,    26,   181,   369,  1056,
     273,    52,  1069,   340,   369,  1056,   878,    -1,   511,    -1,
     510,   458,   511,    -1,    22,   549,    -1,    22,   175,   246,
     142,   549,    -1,    22,    72,   549,    -1,    22,    72,   175,
     246,   142,   549,    -1,    28,   797,  1070,   512,    -1,    28,
     797,  1070,   127,   246,   251,    -1,    28,   797,  1070,   340,
     246,   251,    -1,    28,   797,  1070,   340,   356,  1066,    -1,
      28,   797,  1070,   340,   517,    -1,    28,   797,  1070,   314,
     517,    -1,    28,   797,  1070,   340,   359,  1070,    -1,   127,
     797,   175,   142,  1070,   513,    -1,   127,   797,  1070,   513,
      -1,    28,   797,  1070,   798,   387,   960,   514,   515,    -1,
      28,   797,  1070,   619,    -1,    22,   558,    -1,    28,    81,
    1056,   661,    -1,   403,    81,  1056,    -1,   127,    81,   175,
     142,  1056,   513,    -1,   127,    81,  1056,   513,    -1,   340,
     419,   259,    -1,   340,   421,   259,    -1,    68,   260,  1056,
      -1,   340,   421,    68,    -1,   340,   227,    -1,   340,   396,
      -1,   130,   382,  1056,    -1,   130,    29,   382,  1056,    -1,
     130,   313,   382,  1056,    -1,   130,   382,    26,    -1,   130,
     382,   399,    -1,   120,   382,  1056,    -1,   120,   382,    26,
      -1,   120,   382,   399,    -1,   130,   326,  1056,    -1,   130,
      29,   326,  1056,    -1,   130,   313,   326,  1056,    -1,   120,
     326,  1056,    -1,   186,  1054,    -1,   244,   186,  1054,    -1,
     256,   702,    -1,   246,   256,    -1,   274,   377,  1068,    -1,
     340,   369,  1056,    -1,   340,   517,    -1,   314,   517,    -1,
     313,   174,   516,    -1,   130,   324,   216,   332,    -1,   120,
     324,   216,   332,    -1,   155,   324,   216,   332,    -1,   244,
     155,   324,   216,   332,    -1,   619,    -1,   340,   109,   984,
      -1,   127,   109,    -1,    55,    -1,   316,    -1,    -1,    70,
     702,    -1,    -1,   400,   984,    -1,    -1,   247,    -1,   160,
      -1,   109,    -1,   400,   184,  1056,    -1,   454,   519,   455,
      -1,   419,   517,    -1,    -1,   520,    -1,   519,   458,   520,
      -1,  1073,   443,   676,    -1,  1073,    -1,  1073,   456,  1073,
     443,   676,    -1,  1073,   456,  1073,    -1,    28,   387,   702,
     522,    -1,   523,    -1,   522,   458,   523,    -1,    22,    41,
     959,   513,    -1,   127,    41,   175,   142,  1070,   513,    -1,
     127,    41,  1070,   513,    -1,    28,    41,  1070,   798,   387,
     960,   514,   513,    -1,    67,   888,    -1,    67,    26,    -1,
      86,   532,  1054,   561,   533,   526,   527,   528,   534,   465,
     529,    -1,    86,   454,   861,   455,   377,   527,   528,   465,
     529,    -1,   159,    -1,   377,    -1,   296,    -1,    -1,  1065,
      -1,   357,    -1,   358,    -1,   530,    -1,   454,   536,   455,
      -1,   530,   531,    -1,    -1,    48,    -1,   259,    -1,   158,
      -1,   115,   837,  1065,    -1,   251,   837,  1065,    -1,    90,
      -1,   171,    -1,   297,   837,  1065,    -1,   135,   837,  1065,
      -1,   155,   297,   562,    -1,   155,   297,   447,    -1,   155,
     246,   251,   562,    -1,   155,   251,   562,    -1,   131,  1065,
      -1,    48,    -1,    -1,   419,   259,    -1,    -1,   535,   116,
    1065,    -1,    -1,   400,    -1,    -1,   537,    -1,   536,   458,
     537,    -1,  1073,   538,    -1,   494,    -1,   591,    -1,   447,
      -1,   454,   539,   455,    -1,    -1,   540,    -1,   539,   458,
     540,    -1,   494,    -1,    88,   542,   366,  1054,   454,   543,
     455,   572,   573,   574,   575,    -1,    88,   542,   366,   175,
     246,   142,  1054,   454,   543,   455,   572,   573,   574,   575,
      -1,    88,   542,   366,  1054,   256,   702,   544,   573,   574,
     575,    -1,    88,   542,   366,   175,   246,   142,  1054,   256,
     702,   544,   573,   574,   575,    -1,   372,    -1,   370,    -1,
     221,   372,    -1,   221,   370,    -1,   163,   372,    -1,   163,
     370,    -1,   396,    -1,    -1,   545,    -1,    -1,   454,   546,
     455,    -1,    -1,   547,    -1,   545,   458,   547,    -1,   548,
      -1,   546,   458,   548,    -1,   549,    -1,   555,    -1,   558,
      -1,   550,    -1,   558,    -1,  1070,   960,   617,   551,    -1,
    1070,   419,   264,   551,    -1,   551,   552,    -1,    -1,    81,
    1056,   553,    -1,   553,    -1,   554,    -1,    70,   702,    -1,
     246,   251,    -1,   251,    -1,   393,   769,   576,    -1,   291,
     206,   769,   576,    -1,    64,   454,   984,   455,   560,    -1,
     109,   985,    -1,   305,  1054,   561,   564,   568,    -1,   111,
      -1,   246,   111,    -1,   188,   112,    -1,   188,   177,    -1,
     217,  1054,   556,    -1,   556,   182,   557,    -1,   556,   139,
     557,    -1,    -1,   110,    -1,    82,    -1,   185,    -1,   359,
      -1,    74,    -1,    26,    -1,    81,  1056,   559,    -1,   559,
      -1,    64,   454,   984,   455,   661,    -1,   393,   454,   562,
     455,   769,   576,   661,    -1,   393,   577,   661,    -1,   291,
     206,   454,   562,   455,   769,   576,   661,    -1,   291,   206,
     577,   661,    -1,   138,   742,   454,   565,   455,   769,   576,
     567,   661,    -1,   156,   206,   454,   562,   455,   305,  1054,
     561,   564,   568,   661,    -1,   244,   186,    -1,    -1,   454,
     562,   455,    -1,    -1,   563,    -1,   562,   458,   563,    -1,
    1070,    -1,   229,   160,    -1,   229,   277,    -1,   229,   346,
      -1,    -1,   566,    -1,   565,   458,   566,    -1,   744,   419,
     779,    -1,   744,   419,   262,   454,   779,   455,    -1,   416,
     454,   984,   455,    -1,    -1,   569,    -1,   570,    -1,   569,
     570,    -1,   570,   569,    -1,    -1,   260,   398,   571,    -1,
     260,   114,   571,    -1,   244,    21,    -1,   316,    -1,    55,
      -1,   340,   251,    -1,   340,   109,    -1,   187,   454,  1053,
     455,    -1,    -1,   419,   517,    -1,   419,   259,    -1,   421,
     259,    -1,    -1,   260,    75,   127,    -1,   260,    75,   114,
     325,    -1,   260,    75,   288,   325,    -1,    -1,   369,  1056,
      -1,    -1,   400,   184,   369,  1056,    -1,    -1,   400,   184,
    1060,    -1,    88,   542,   366,   579,    35,   891,   580,    -1,
      88,   542,   366,   175,   246,   142,   579,    35,   891,   580,
      -1,  1054,   561,   573,   574,   575,    -1,   419,   102,    -1,
     419,   244,   102,    -1,    -1,    88,   583,   230,   412,   582,
      35,   891,   580,    -1,    88,   583,   230,   412,   175,   246,
     142,   582,    35,   891,   580,    -1,  1054,   561,   518,   575,
      -1,   396,    -1,    -1,   306,   230,   412,   740,  1054,   580,
      -1,    88,   542,   334,  1054,   587,    -1,    88,   542,   334,
     175,   246,   142,  1054,   587,    -1,    28,   334,  1054,   588,
      -1,    28,   334,   175,   142,  1054,   588,    -1,   588,    -1,
      -1,   589,    -1,   588,   589,    -1,    53,   591,    -1,   101,
      -1,   244,   101,    -1,   183,   590,   591,    -1,   231,   591,
      -1,   234,   591,    -1,   244,   231,    -1,   244,   234,    -1,
     273,    52,   702,    -1,   354,   465,   591,    -1,   315,    -1,
     315,   465,   591,    -1,    52,    -1,    -1,     4,    -1,   446,
       4,    -1,  1066,    -1,   591,    -1,   592,   458,   591,    -1,
      88,   750,   594,   600,   208,   497,    -1,    88,   750,   594,
     600,   208,   497,   169,   595,   596,   598,    -1,   386,    -1,
      -1,  1056,    -1,  1056,   703,    -1,   189,   595,    -1,    -1,
     404,   595,    -1,   244,   404,    -1,   597,    -1,    -1,   127,
     600,   208,   497,   513,    -1,   127,   600,   208,   175,   142,
     497,   513,    -1,   294,    -1,    -1,    88,   369,  1056,   602,
     224,  1065,   518,    -1,   274,  1068,    -1,    -1,   127,   369,
    1056,    -1,   127,   369,   175,   142,  1056,    -1,    88,   144,
    1056,   465,   605,    -1,    88,   144,   175,   246,   142,  1056,
     465,   605,    -1,   605,   606,    -1,    -1,   328,  1056,    -1,
     411,   497,    -1,   159,   497,    -1,    55,    -1,    28,   144,
    1056,   398,   608,    -1,   608,   609,    -1,    -1,   377,   497,
      -1,    28,   144,  1056,   480,    25,  1062,   762,    -1,    28,
     144,  1056,   480,    58,   454,   960,    35,   960,   455,    -1,
      28,   144,  1056,   480,    71,   702,    -1,    28,   144,  1056,
     480,    85,   702,    -1,    28,   144,  1056,   480,   125,   960,
      -1,    28,   144,  1056,   480,   161,   728,    -1,    28,   144,
    1056,   480,   600,   208,  1056,    -1,    28,   144,  1056,   480,
     262,   779,   778,    -1,    28,   144,  1056,   480,   262,    66,
     702,   400,  1058,    -1,    28,   144,  1056,   480,   262,   148,
     702,   400,  1058,    -1,    28,   144,  1056,   480,   328,  1056,
      -1,    28,   144,  1056,   480,   136,   382,  1056,    -1,    28,
     144,  1056,   480,   366,   702,    -1,    28,   144,  1056,   480,
     373,   330,   276,   702,    -1,    28,   144,  1056,   480,   373,
     330,   119,   702,    -1,    28,   144,  1056,   480,   373,   330,
     371,   702,    -1,    28,   144,  1056,   480,   373,   330,    78,
     702,    -1,    28,   144,  1056,   480,   334,   702,    -1,    28,
     144,  1056,   480,   412,   702,    -1,    28,   144,  1056,   480,
     230,   412,   702,    -1,    28,   144,  1056,   480,   156,   366,
     702,    -1,    28,   144,  1056,   480,   156,   102,   423,  1056,
      -1,    28,   144,  1056,   480,   337,  1056,    -1,    28,   144,
    1056,   480,   380,   154,   960,   208,  1056,    -1,    28,   144,
    1056,   480,   387,   960,    -1,    88,   156,   102,   423,  1056,
     614,   617,    -1,   169,   595,    -1,   244,   169,    -1,   404,
     595,    -1,   244,   404,    -1,   612,    -1,   613,   612,    -1,
     613,    -1,    -1,   127,   156,   102,   423,  1056,   513,    -1,
     127,   156,   102,   423,   175,   142,  1056,   513,    -1,    28,
     156,   102,   423,  1056,   614,   619,    -1,    28,   156,   102,
     423,  1056,   613,    -1,   264,   454,   618,   455,    -1,    -1,
     622,    -1,   618,   458,   622,    -1,   264,   454,   620,   455,
      -1,   621,    -1,   620,   458,   621,    -1,   622,    -1,   340,
     622,    -1,    22,   622,    -1,   127,   623,    -1,   623,   624,
      -1,  1073,    -1,  1065,    -1,    88,   337,  1056,   626,   628,
     156,   102,   423,  1056,   617,    -1,   387,  1065,    -1,    -1,
     411,  1065,    -1,   411,   251,    -1,   627,    -1,    -1,   127,
     337,  1056,   513,    -1,   127,   337,   175,   142,  1056,   513,
      -1,    28,   337,  1056,   627,   619,    -1,    28,   337,  1056,
     627,    -1,    28,   337,  1056,   619,    -1,    88,   156,   366,
    1054,   454,   543,   455,   572,   337,  1056,   617,    -1,    88,
     156,   366,   175,   246,   142,  1054,   454,   543,   455,   572,
     337,  1056,   617,    -1,    28,   156,   366,   945,   510,    -1,
      28,   156,   366,   175,   142,   945,   510,    -1,   180,   156,
     328,  1056,   635,   159,   337,  1056,   200,  1056,   617,    -1,
     218,   377,    -1,   137,    -1,   634,   454,   946,   455,    -1,
      -1,    88,   399,   228,   154,   637,   337,  1056,   617,    -1,
    1068,    -1,   399,    -1,   127,   399,   228,   154,   637,   337,
    1056,    -1,   127,   399,   228,   175,   142,   154,   637,   337,
    1056,    -1,    28,   399,   228,   154,   637,   337,  1056,   619,
      -1,    88,   284,  1056,   260,  1054,   647,   645,   643,   644,
      -1,    28,   284,  1056,   260,  1054,   646,   643,   644,    -1,
     127,   284,  1056,   260,   702,   513,    -1,   127,   284,   175,
     142,  1056,   260,   702,   513,    -1,   400,   454,   984,   455,
      -1,    -1,   419,    64,   454,   984,   455,    -1,    -1,   377,
    1069,    -1,    -1,   377,  1069,    -1,    -1,   154,   648,    -1,
      -1,    26,    -1,   333,    -1,   194,    -1,   398,    -1,   114,
      -1,    88,    20,   232,  1056,   387,   184,   169,   595,    -1,
      88,   382,  1056,   651,   652,   260,  1054,   654,   657,   141,
     295,  1062,   454,   658,   455,    -1,    88,    81,   382,  1056,
      24,   652,   260,  1054,   660,   661,   154,   128,   324,   657,
     141,   295,  1062,   454,   658,   455,    -1,    44,    -1,    24,
      -1,   195,   256,    -1,   653,    -1,   652,   265,   653,    -1,
     194,    -1,   114,    -1,   398,    -1,   398,   256,   562,    -1,
     385,    -1,   154,   655,   656,    -1,    -1,   128,    -1,    -1,
     324,    -1,   355,    -1,   415,   454,   984,   455,    -1,    -1,
     659,    -1,   658,   458,   659,    -1,    -1,  1064,    -1,     4,
      -1,  1065,    -1,  1073,    -1,   159,  1054,    -1,    -1,    -1,
     661,   662,    -1,   246,   111,    -1,   111,    -1,   188,   177,
      -1,   188,   112,    -1,   246,   402,    -1,   244,   186,    -1,
     127,   382,  1056,   260,   702,   513,    -1,   127,   382,   175,
     142,  1056,   260,   702,   513,    -1,    88,   136,   382,  1056,
     260,  1073,   141,   295,  1062,   454,   455,    -1,    88,   136,
     382,  1056,   260,  1073,   415,   665,   141,   295,  1062,   454,
     455,    -1,   666,    -1,   665,    32,   666,    -1,  1070,   181,
     454,   667,   455,    -1,     5,    -1,   667,   458,     5,    -1,
      28,   136,   382,  1056,   669,    -1,   130,    -1,   130,   313,
      -1,   130,    29,    -1,   120,    -1,    88,    37,  1056,    64,
     454,   984,   455,   661,    -1,   127,    37,  1056,   513,    -1,
      88,    25,  1062,   762,   673,    -1,    88,    25,  1062,   677,
      -1,    88,   262,   779,   673,    -1,    88,   387,   702,   673,
      -1,    88,   387,   702,    -1,    88,   387,   702,    35,   454,
     957,   455,    -1,    88,   387,   702,    35,   134,   454,   680,
     455,    -1,    88,   387,   702,    35,   298,   673,    -1,    88,
     373,   330,   276,   702,   673,    -1,    88,   373,   330,   119,
     702,   673,    -1,    88,   373,   330,   371,   702,   673,    -1,
      88,   373,   330,    78,   702,   673,    -1,    88,    71,   702,
     673,    -1,    88,    71,   702,   159,   702,    -1,   454,   674,
     455,    -1,   675,    -1,   674,   458,   675,    -1,  1073,   443,
     676,    -1,  1073,    -1,   759,    -1,  1077,    -1,  1018,    -1,
     591,    -1,  1065,    -1,   454,   678,   455,    -1,   679,    -1,
     678,   458,   679,    -1,     3,   443,   676,    -1,   681,    -1,
      -1,  1065,    -1,   681,   458,  1065,    -1,    28,   387,   702,
      22,   405,   683,  1065,    -1,    28,   387,   702,    22,   405,
     683,  1065,    44,  1065,    -1,    28,   387,   702,    22,   405,
     683,  1065,    24,  1065,    -1,   175,   246,   142,    -1,    -1,
      88,   262,    66,   702,   687,   154,   387,   960,   400,  1058,
     688,    35,   685,    -1,   686,    -1,   685,   458,   686,    -1,
     262,  1064,   779,   689,   690,    -1,   262,  1064,   779,   778,
     689,   690,    -1,   161,  1064,  1062,   751,    -1,   161,  1064,
     454,  1023,   455,  1062,   751,    -1,   359,   960,    -1,   109,
      -1,    -1,   148,   702,    -1,    -1,   154,   330,    -1,   154,
     266,    52,   702,    -1,    -1,   302,    -1,    -1,    88,   262,
     148,   702,   400,  1058,    -1,    28,   262,   148,   702,   400,
    1058,    22,   685,    -1,    28,   262,   148,   702,   400,  1058,
     127,   693,    -1,   694,    -1,   693,   458,   694,    -1,   262,
    1064,   454,  1023,   455,    -1,   161,  1064,   454,  1023,   455,
      -1,   127,   262,    66,   702,   400,  1058,   513,    -1,   127,
     262,    66,   175,   142,   702,   400,  1058,   513,    -1,   127,
     262,   148,   702,   400,  1058,   513,    -1,   127,   262,   148,
     175,   142,   702,   400,  1058,   513,    -1,   127,   273,    52,
    1069,   513,    -1,   301,   273,    52,  1069,   377,  1068,    -1,
     127,   700,   175,   142,   701,   513,    -1,   127,   700,   701,
     513,    -1,   127,   387,   704,   513,    -1,   127,   387,   175,
     142,   704,   513,    -1,   127,   125,   704,   513,    -1,   127,
     125,   175,   142,   704,   513,    -1,   127,   184,    77,   701,
     513,    -1,   127,   184,    77,   175,   142,   701,   513,    -1,
     366,    -1,   334,    -1,   412,    -1,   230,   412,    -1,   184,
      -1,   156,   366,    -1,    20,   232,    -1,   136,   382,    -1,
      71,    -1,    85,    -1,   328,    -1,   144,    -1,   373,   330,
     276,    -1,   373,   330,   119,    -1,   373,   330,   371,    -1,
     373,   330,    78,    -1,   702,    -1,   701,   458,   702,    -1,
    1070,    -1,  1070,   703,    -1,   456,  1059,    -1,   703,   456,
    1059,    -1,   960,    -1,   704,   458,   960,    -1,   385,   902,
     946,   706,   513,    -1,    84,   174,    -1,   315,   174,    -1,
      -1,    73,   260,   708,   702,   202,   709,    -1,    73,   260,
     387,   960,   202,   709,    -1,    73,   260,   125,   960,   202,
     709,    -1,    73,   260,    25,  1062,   762,   202,   709,    -1,
      73,   260,   161,  1062,   751,   202,   709,    -1,    73,   260,
     262,   779,   778,   202,   709,    -1,    73,   260,    81,  1056,
     260,   702,   202,   709,    -1,    73,   260,    81,  1056,   260,
     125,   702,   202,   709,    -1,    73,   260,   284,  1056,   260,
     702,   202,   709,    -1,    73,   260,   326,  1056,   260,   702,
     202,   709,    -1,    73,   260,   326,  1056,   202,   709,    -1,
      73,   260,   380,   154,   960,   208,  1056,   202,   709,    -1,
      73,   260,   382,  1056,   260,   702,   202,   709,    -1,    73,
     260,   262,    66,   702,   400,  1058,   202,   709,    -1,    73,
     260,   262,   148,   702,   400,  1058,   202,   709,    -1,    73,
     260,   209,   255,   591,   202,   709,    -1,    73,   260,    58,
     454,   960,    35,   960,   455,   202,   709,    -1,    73,   260,
     600,   208,   702,   202,   709,    -1,    20,   232,    -1,    72,
      -1,   103,    -1,   328,    -1,   184,    -1,   334,    -1,   366,
      -1,   412,    -1,   230,   412,    -1,    71,    -1,    85,    -1,
     369,    -1,   144,    -1,   321,    -1,   156,   366,    -1,   337,
      -1,   156,   102,   423,    -1,   136,   382,    -1,   373,   330,
      78,    -1,   373,   330,   119,    -1,   373,   330,   276,    -1,
     373,   330,   371,    -1,  1065,    -1,   251,    -1,   332,   207,
     711,   260,   712,   702,   202,   713,    -1,   332,   207,   711,
     260,   387,   960,   202,   713,    -1,   332,   207,   711,   260,
     125,   960,   202,   713,    -1,   332,   207,   711,   260,    25,
    1062,   762,   202,   713,    -1,   332,   207,   711,   260,   161,
    1062,   751,   202,   713,    -1,   332,   207,   711,   260,   209,
     255,   591,   202,   713,    -1,   332,   207,   711,   260,   600,
     208,   702,   202,   713,    -1,   154,   497,    -1,    -1,    72,
      -1,   103,    -1,   136,   382,    -1,   156,   366,    -1,   328,
      -1,   334,    -1,   366,    -1,   321,    -1,   369,    -1,   412,
      -1,   230,   412,    -1,  1065,    -1,   251,    -1,   149,   715,
      -1,   237,   715,    -1,   888,    -1,   716,   888,    -1,   243,
     717,   888,    -1,   292,   717,   888,    -1,   151,   717,   888,
      -1,   210,   717,   888,    -1,    19,  1066,   717,   888,    -1,
     308,  1066,   717,   888,    -1,  1066,   717,   888,    -1,    26,
     717,   888,    -1,   157,   717,   888,    -1,   157,  1066,   717,
     888,    -1,   157,    26,   717,   888,    -1,    43,   717,   888,
      -1,    43,  1066,   717,   888,    -1,    43,    26,   717,   888,
      -1,   159,    -1,   181,    -1,   716,    -1,    -1,   164,   720,
     260,   723,   377,   724,   726,    -1,   319,   720,   260,   723,
     159,   724,   513,    -1,   319,   164,   263,   154,   720,   260,
     723,   159,   724,   513,    -1,   721,    -1,    26,    -1,    26,
     293,    -1,    26,   454,   562,   455,    -1,    26,   293,   454,
     562,   455,    -1,   722,    -1,   721,   458,   722,    -1,   333,
     561,    -1,   305,   561,    -1,    88,   561,    -1,  1070,   561,
      -1,  1053,    -1,   366,  1053,    -1,   334,  1053,    -1,   156,
     102,   423,  1055,    -1,   156,   337,  1055,    -1,   161,   727,
      -1,   103,  1055,    -1,   125,   701,    -1,   208,  1055,    -1,
     209,   255,   592,    -1,   328,  1055,    -1,   369,  1055,    -1,
     387,   701,    -1,    26,   367,   181,   328,  1055,    -1,    26,
     335,   181,   328,  1055,    -1,    26,   162,   181,   328,  1055,
      -1,   725,    -1,   724,   458,   725,    -1,  1068,    -1,   167,
    1068,    -1,   419,   164,   263,    -1,    -1,   728,    -1,   727,
     458,   728,    -1,  1062,   751,    -1,   164,   721,   377,  1069,
     731,   732,    -1,   319,   721,   159,  1069,   732,   513,    -1,
     319,    23,   263,   154,   721,   159,  1069,   732,   513,    -1,
     419,    23,   263,    -1,    -1,   165,    52,  1068,    -1,    -1,
      28,   109,   293,   734,   736,    -1,   734,   735,    -1,    -1,
     181,   328,  1055,    -1,   154,   321,  1069,    -1,   154,   399,
    1069,    -1,   164,   720,   260,   737,   377,   724,   726,    -1,
     319,   720,   260,   737,   159,   724,   513,    -1,   319,   164,
     263,   154,   720,   260,   737,   159,   724,   513,    -1,   367,
      -1,   162,    -1,   335,    -1,   388,    -1,    88,   739,   184,
     740,   741,   260,  1054,   742,   454,   743,   455,   518,   575,
     955,    -1,    88,   739,   184,   740,   175,   246,   142,  1060,
     260,  1054,   742,   454,   743,   455,   518,   575,   955,    -1,
     393,    -1,    -1,    77,    -1,    -1,  1060,    -1,    -1,   400,
    1058,    -1,    -1,   744,    -1,   743,   458,   744,    -1,  1070,
     745,   746,   747,   748,    -1,   989,   745,   746,   747,   748,
      -1,   454,   984,   455,   745,   746,   747,   748,    -1,    70,
     702,    -1,    -1,   702,    -1,    -1,    36,    -1,   118,    -1,
      -1,   439,   151,    -1,   439,   210,    -1,    -1,    88,   750,
     161,  1062,   753,   318,   758,   764,   769,    -1,    88,   750,
     161,  1062,   753,   318,   366,   454,   771,   455,   764,   769,
      -1,    88,   750,   161,  1062,   753,   764,   769,    -1,   265,
     312,    -1,    -1,   454,   752,   455,    -1,   454,   455,    -1,
     755,    -1,   752,   458,   755,    -1,   454,   754,   455,    -1,
     454,   455,    -1,   760,    -1,   754,   458,   760,    -1,   756,
     757,   759,    -1,   757,   756,   759,    -1,   757,   759,    -1,
     756,   759,    -1,   759,    -1,   181,    -1,   268,    -1,   191,
      -1,   181,   268,    -1,   408,    -1,  1071,    -1,   759,    -1,
     960,    -1,  1071,   703,   449,   387,    -1,   342,  1071,   703,
     449,   387,    -1,   755,    -1,   755,   109,   984,    -1,   755,
     443,   984,    -1,   755,    -1,   454,   447,   455,    -1,   454,
     763,   455,    -1,   454,   266,    52,   763,   455,    -1,   454,
     763,   266,    52,   763,   455,    -1,   761,    -1,   763,   458,
     761,    -1,   766,    -1,   764,   766,    -1,    54,   260,   251,
     192,    -1,   318,   251,   260,   251,   192,    -1,   360,    -1,
     178,    -1,   352,    -1,   414,    -1,   145,   332,   113,    -1,
     145,   332,   201,    -1,   332,   113,    -1,   332,   201,    -1,
     213,    -1,   246,   213,    -1,    87,   591,    -1,   325,   591,
      -1,   502,    -1,   275,  1070,    -1,    35,   767,    -1,   208,
     497,    -1,   380,   768,    -1,   418,    -1,   765,    -1,  1065,
      -1,  1065,   458,  1065,    -1,   154,   387,   960,    -1,   768,
     458,   154,   387,   960,    -1,   419,   673,    -1,    -1,   757,
     759,    -1,   770,    -1,   771,   458,   770,    -1,    28,   161,
     728,   773,   774,    -1,   765,    -1,   773,   765,    -1,   316,
      -1,    -1,   127,   161,  1062,   751,   513,    -1,   127,   161,
     175,   142,  1062,   751,   513,    -1,   127,    25,  1062,   762,
     513,    -1,   127,    25,   175,   142,  1062,   762,   513,    -1,
     127,   262,   779,   778,   513,    -1,   127,   262,   175,   142,
     779,   778,   513,    -1,   454,   960,   455,    -1,   454,   960,
     458,   960,   455,    -1,   454,   245,   458,   960,   455,    -1,
     454,   960,   458,   245,   455,    -1,  1015,    -1,  1070,   456,
     779,    -1,   123,   781,    -1,   782,    -1,   781,   782,    -1,
    1065,    -1,   208,   497,    -1,    88,    58,   454,   960,    35,
     960,   455,   419,   161,   728,   784,    -1,    88,    58,   454,
     960,    35,   960,   455,   421,   161,   784,    -1,    88,    58,
     454,   960,    35,   960,   455,   419,   191,   784,    -1,    35,
     179,    -1,    35,    38,    -1,    -1,   127,    58,   786,   454,
     960,    35,   960,   455,   513,    -1,   175,   142,    -1,    -1,
      88,   750,   380,   154,   960,   208,  1056,   454,   788,   455,
      -1,   159,   351,   419,   161,   728,   458,   377,   351,   419,
     161,   728,    -1,   377,   351,   419,   161,   728,   458,   159,
     351,   419,   161,   728,    -1,   159,   351,   419,   161,   728,
      -1,   377,   351,   419,   161,   728,    -1,   127,   380,   786,
     154,   960,   208,  1056,   513,    -1,   307,   791,  1054,    -1,
     307,   792,  1056,    -1,   307,   454,   793,   455,   791,  1054,
      -1,   307,   454,   793,   455,   792,  1056,    -1,   184,    -1,
     366,    -1,   328,    -1,   365,    -1,   103,    -1,   794,    -1,
     793,   458,   794,    -1,   410,    -1,    28,   369,  1056,   340,
     517,    -1,    28,   369,  1056,   314,   517,    -1,    28,    25,
    1062,   762,   310,   377,  1056,    -1,    28,    71,   702,   310,
     377,  1056,    -1,    28,    85,   702,   310,   377,  1056,    -1,
      28,   103,  1057,   310,   377,  1057,    -1,    28,   125,   702,
     310,   377,  1056,    -1,    28,   125,   702,   310,    81,  1056,
     377,  1056,    -1,    28,   156,   102,   423,  1056,   310,   377,
    1056,    -1,    28,   161,   728,   310,   377,  1056,    -1,    28,
     167,  1067,   310,   377,  1067,    -1,    28,   600,   208,  1056,
     310,   377,  1056,    -1,    28,   262,    66,   702,   400,  1058,
     310,   377,  1056,    -1,    28,   262,   148,   702,   400,  1058,
     310,   377,  1056,    -1,    28,   284,  1056,   260,  1054,   310,
     377,  1056,    -1,    28,   284,   175,   142,  1056,   260,  1054,
     310,   377,  1056,    -1,    28,   328,  1056,   310,   377,  1056,
      -1,    28,   337,  1056,   310,   377,  1056,    -1,    28,   366,
     945,   310,   377,  1056,    -1,    28,   366,   175,   142,   945,
     310,   377,  1056,    -1,    28,   334,  1054,   310,   377,  1056,
      -1,    28,   334,   175,   142,  1054,   310,   377,  1056,    -1,
      28,   412,  1054,   310,   377,  1056,    -1,    28,   412,   175,
     142,  1054,   310,   377,  1056,    -1,    28,   230,   412,  1054,
     310,   377,  1056,    -1,    28,   230,   412,   175,   142,  1054,
     310,   377,  1056,    -1,    28,   184,  1054,   310,   377,  1056,
      -1,    28,   184,   175,   142,  1054,   310,   377,  1056,    -1,
      28,   156,   366,   945,   310,   377,  1056,    -1,    28,   156,
     366,   175,   142,   945,   310,   377,  1056,    -1,    28,   366,
     945,   310,   797,  1056,   377,  1056,    -1,    28,   366,   175,
     142,   945,   310,   797,  1056,   377,  1056,    -1,    28,   230,
     412,  1054,   310,   797,  1056,   377,  1056,    -1,    28,   230,
     412,   175,   142,  1054,   310,   797,  1056,   377,  1056,    -1,
      28,   366,   945,   310,    81,  1056,   377,  1056,    -1,    28,
     366,   175,   142,   945,   310,    81,  1056,   377,  1056,    -1,
      28,   156,   366,   945,   310,   797,  1056,   377,  1056,    -1,
      28,   156,   366,   175,   142,   945,   310,   797,  1056,   377,
    1056,    -1,    28,   326,  1056,   260,  1054,   310,   377,  1056,
      -1,    28,   382,  1056,   260,  1054,   310,   377,  1056,    -1,
      28,   136,   382,  1056,   310,   377,  1056,    -1,    28,   321,
    1067,   310,   377,  1067,    -1,    28,   399,  1067,   310,   377,
    1067,    -1,    28,   369,  1056,   310,   377,  1056,    -1,    28,
     373,   330,   276,   702,   310,   377,  1056,    -1,    28,   373,
     330,   119,   702,   310,   377,  1056,    -1,    28,   373,   330,
     371,   702,   310,   377,  1056,    -1,    28,   373,   330,    78,
     702,   310,   377,  1056,    -1,    28,   387,   702,   310,   377,
    1056,    -1,    28,   387,   702,   310,    41,  1056,   377,  1056,
     513,    -1,    72,    -1,    -1,   340,   102,    -1,    -1,    28,
     161,   728,   117,   260,   144,  1056,    -1,    28,   382,  1056,
     260,  1054,   117,   260,   144,  1056,    -1,    28,   230,   412,
    1054,   117,   260,   144,  1056,    -1,    28,   184,  1054,   117,
     260,   144,  1056,    -1,    28,    25,  1062,   762,   340,   328,
    1056,    -1,    28,    71,   702,   340,   328,  1056,    -1,    28,
      85,   702,   340,   328,  1056,    -1,    28,   125,   702,   340,
     328,  1056,    -1,    28,   144,   702,   340,   328,  1056,    -1,
      28,   161,   728,   340,   328,  1056,    -1,    28,   262,   779,
     778,   340,   328,  1056,    -1,    28,   262,    66,   702,   400,
    1058,   340,   328,  1056,    -1,    28,   262,   148,   702,   400,
    1058,   340,   328,  1056,    -1,    28,   366,   945,   340,   328,
    1056,    -1,    28,   366,   175,   142,   945,   340,   328,  1056,
      -1,    28,   373,   330,   276,   702,   340,   328,  1056,    -1,
      28,   373,   330,   119,   702,   340,   328,  1056,    -1,    28,
     373,   330,   371,   702,   340,   328,  1056,    -1,    28,   373,
     330,    78,   702,   340,   328,  1056,    -1,    28,   334,  1054,
     340,   328,  1056,    -1,    28,   334,   175,   142,  1054,   340,
     328,  1056,    -1,    28,   412,  1054,   340,   328,  1056,    -1,
      28,   412,   175,   142,  1054,   340,   328,  1056,    -1,    28,
     230,   412,  1054,   340,   328,  1056,    -1,    28,   230,   412,
     175,   142,  1054,   340,   328,  1056,    -1,    28,   156,   366,
     945,   340,   328,  1056,    -1,    28,   156,   366,   175,   142,
     945,   340,   328,  1056,    -1,    28,   387,   702,   340,   328,
    1056,    -1,    28,   262,   779,   778,   340,   454,   802,   455,
      -1,   803,    -1,   802,   458,   803,    -1,  1073,   443,   245,
      -1,  1073,   443,   676,    -1,    28,    25,  1062,   762,   274,
     377,  1068,    -1,    28,    71,   702,   274,   377,  1068,    -1,
      28,    85,   702,   274,   377,  1068,    -1,    28,   103,  1057,
     274,   377,  1068,    -1,    28,   125,   702,   274,   377,  1068,
      -1,    28,   161,   728,   274,   377,  1068,    -1,    28,   600,
     208,  1056,   274,   377,  1068,    -1,    28,   209,   255,   591,
     274,   377,  1068,    -1,    28,   262,   779,   778,   274,   377,
    1068,    -1,    28,   262,    66,   702,   400,  1058,   274,   377,
    1068,    -1,    28,   262,   148,   702,   400,  1058,   274,   377,
    1068,    -1,    28,   328,  1056,   274,   377,  1068,    -1,    28,
     387,   702,   274,   377,  1068,    -1,    28,   369,  1056,   274,
     377,  1068,    -1,    28,   373,   330,   119,   702,   274,   377,
    1068,    -1,    28,   373,   330,    78,   702,   274,   377,  1068,
      -1,    28,   156,   102,   423,  1056,   274,   377,  1068,    -1,
      28,   337,  1056,   274,   377,  1068,    -1,    28,   136,   382,
    1056,   274,   377,  1068,    -1,    88,   750,   326,  1056,    35,
     260,   810,   377,  1054,   955,   123,   811,   806,    -1,   247,
      -1,   808,    -1,   454,   807,   455,    -1,   807,   457,   809,
      -1,   809,    -1,   891,    -1,   865,    -1,   880,    -1,   873,
      -1,   813,    -1,   808,    -1,    -1,   333,    -1,   398,    -1,
     114,    -1,   194,    -1,   195,    -1,    27,    -1,    -1,   127,
     326,  1056,   260,   702,   513,    -1,   127,   326,   175,   142,
    1056,   260,   702,   513,    -1,   248,  1070,   814,    -1,   458,
    1065,    -1,    -1,   219,  1070,    -1,   395,  1070,    -1,   395,
     447,    -1,    18,   818,    -1,    45,   818,   821,    -1,   354,
     379,   821,    -1,    75,   818,    -1,   133,   818,    -1,   322,
     818,    -1,   327,  1070,    -1,   309,   327,  1070,    -1,   309,
    1070,    -1,   322,   818,   377,   327,  1070,    -1,   322,   818,
     377,  1070,    -1,   289,   379,  1065,    -1,    75,   290,  1065,
      -1,   322,   290,  1065,    -1,   422,    -1,   379,    -1,    -1,
     204,   216,   493,    -1,   299,   261,    -1,   299,   424,    -1,
     111,    -1,   246,   111,    -1,   819,    -1,   820,   458,   819,
      -1,   820,   819,    -1,   820,    -1,    -1,    88,   542,   412,
    1054,   561,   518,    35,   891,   823,    -1,    88,   265,   312,
     542,   412,  1054,   561,   518,    35,   891,   823,    -1,    88,
     542,   303,   412,  1054,   454,   562,   455,   518,    35,   891,
     823,    -1,    88,   265,   312,   542,   303,   412,  1054,   454,
     562,   455,   518,    35,   891,   823,    -1,   419,    64,   263,
      -1,   419,    56,    64,   263,    -1,   419,   221,    64,   263,
      -1,    -1,   220,  1061,    -1,    88,   103,  1057,   465,   826,
      -1,   827,    -1,    -1,   828,    -1,   827,   828,    -1,   829,
     830,  1066,    -1,   829,   830,   494,    -1,   829,   830,   109,
      -1,     3,    -1,    80,   218,    -1,   131,    -1,   224,    -1,
     274,    -1,   369,    -1,   371,    -1,   443,    -1,    -1,    28,
     103,  1057,   419,   826,    -1,    28,   103,  1057,   826,    -1,
      28,   103,  1057,   340,   369,  1056,    -1,    28,   103,  1057,
     501,    -1,   127,   103,  1057,    -1,   127,   103,   175,   142,
    1057,    -1,    28,   365,   340,   488,    -1,    28,   365,   314,
     500,    -1,    88,   125,   702,   837,   960,   551,    -1,    28,
     125,   702,   512,    -1,    28,   125,   702,   127,   246,   251,
      -1,    28,   125,   702,   340,   246,   251,    -1,    28,   125,
     702,    22,   558,    -1,    28,   125,   702,   127,    81,  1056,
     513,    -1,    28,   125,   702,   127,    81,   175,   142,  1056,
     513,    -1,    28,   125,   702,   403,    81,  1056,    -1,    35,
      -1,    -1,    28,   373,   330,   119,   702,   673,    -1,    28,
     373,   330,    78,   702,    22,   228,   154,  1055,   840,   701,
      -1,    28,   373,   330,    78,   702,    28,   228,   154,  1055,
     840,   701,    -1,    28,   373,   330,    78,   702,    28,   228,
     312,   702,   840,   702,    -1,    28,   373,   330,    78,   702,
      28,   228,   154,  1055,   312,   702,   840,   702,    -1,    28,
     373,   330,    78,   702,   127,   228,   154,  1055,    -1,    28,
     373,   330,    78,   702,   127,   228,   175,   142,   154,  1055,
      -1,   419,    -1,   440,    -1,    88,   687,    85,   702,   154,
    1065,   377,  1065,   159,   702,    -1,    68,   849,  1054,   843,
      -1,    68,   849,    -1,    68,   849,  1060,   260,  1054,    -1,
     400,  1060,    -1,    -1,   401,   850,   851,   849,    -1,   401,
     850,   851,   849,  1054,    -1,   401,   850,   851,   849,   847,
      -1,   401,   454,   845,   455,    -1,   401,   454,   845,   455,
    1054,   852,    -1,   846,    -1,   845,   458,   846,    -1,   848,
      -1,   410,    -1,   158,    -1,   160,    -1,     3,    -1,   848,
     849,    -1,   848,   849,  1054,   852,    -1,    31,    -1,    30,
      -1,   410,    -1,    -1,   160,    -1,    -1,   158,    -1,    -1,
     454,  1055,   455,    -1,    -1,   143,   854,    -1,   143,   848,
     849,   854,    -1,   143,   410,   854,    -1,   143,   454,   855,
     455,   854,    -1,   891,    -1,   865,    -1,   880,    -1,   873,
      -1,   887,    -1,   578,    -1,   581,    -1,   584,    -1,   862,
      -1,   856,    -1,   855,   458,   856,    -1,   857,   858,    -1,
    1072,    -1,   848,    -1,   494,    -1,   591,    -1,    -1,   289,
    1056,   860,    35,   861,    -1,   454,  1023,   455,    -1,    -1,
     891,    -1,   865,    -1,   880,    -1,   873,    -1,   141,  1056,
     863,    -1,    88,   542,   366,   579,    35,   141,  1056,   863,
     580,    -1,   454,  1020,   455,    -1,    -1,   105,  1056,    -1,
     105,   289,  1056,    -1,   105,    26,    -1,   105,   289,    26,
      -1,   899,   194,   200,   866,   867,   870,   872,    -1,  1054,
      -1,  1054,    35,  1070,    -1,   891,    -1,   454,   868,   455,
     891,    -1,   109,   406,    -1,   869,    -1,   868,   458,   869,
      -1,  1070,  1045,    -1,   260,    79,   871,   123,   398,   340,
     881,   955,    -1,   260,    79,   871,   123,   247,    -1,    -1,
     454,   743,   455,   955,    -1,   260,    81,  1056,    -1,    -1,
     317,  1051,    -1,    -1,   899,   114,   159,   947,   874,   956,
     872,    -1,   400,   936,    -1,    -1,   225,   902,   946,   876,
     878,    -1,   181,   877,   235,    -1,    -1,    20,   343,    -1,
     324,   343,    -1,   324,   140,    -1,   343,   398,   140,    -1,
     343,    -1,   343,   324,   140,    -1,   140,    -1,    20,   140,
      -1,   250,    -1,    -1,   250,    -1,   347,   226,    -1,    -1,
     899,   398,   947,   340,   881,   935,   956,   872,    -1,   882,
      -1,   881,   458,   882,    -1,   883,    -1,   884,    -1,   885,
     443,  1047,    -1,   454,   886,   455,   443,  1049,    -1,   454,
     886,   455,   443,   892,    -1,  1070,  1045,    -1,   885,    -1,
     886,   458,   885,    -1,   108,   888,   889,   100,   890,   154,
     891,    -1,  1056,    -1,    -1,   889,   244,   329,    -1,   889,
     329,    -1,   889,    48,    -1,   889,   193,    -1,    -1,   419,
     172,    -1,   421,   172,    -1,   893,    -1,   892,    -1,   454,
     893,   455,    -1,   454,   892,   455,    -1,   895,    -1,   894,
     907,    -1,   894,   906,   928,   911,    -1,   894,   906,   910,
     929,    -1,   896,   894,    -1,   896,   894,   907,    -1,   896,
     894,   906,   928,   911,    -1,   896,   894,   906,   910,   929,
      -1,   895,    -1,   892,    -1,   333,   905,  1050,   900,   935,
     955,   920,   927,  1001,    -1,   333,   904,  1051,   900,   935,
     955,   920,   927,  1001,    -1,   934,    -1,   366,   945,    -1,
     894,   392,   903,   894,    -1,   894,   198,   903,   894,    -1,
     894,   137,   903,   894,    -1,   419,   897,    -1,   440,   897,
      -1,   419,   303,   897,    -1,   898,    -1,   897,   458,   898,
      -1,  1056,   852,    35,   454,   861,   455,    -1,   896,    -1,
      -1,   200,   901,    -1,    -1,   372,   902,  1054,    -1,   370,
     902,  1054,    -1,   221,   372,   902,  1054,    -1,   221,   370,
     902,  1054,    -1,   163,   372,   902,  1054,    -1,   163,   370,
     902,  1054,    -1,   396,   902,  1054,    -1,   366,  1054,    -1,
    1054,    -1,   366,    -1,    -1,    26,    -1,   122,    -1,    -1,
     122,    -1,   122,   260,   454,  1020,   455,    -1,    26,    -1,
      -1,   907,    -1,    -1,   266,    52,   908,    -1,   909,    -1,
     908,   458,   909,    -1,   984,   400,  1018,   748,    -1,   984,
     747,   748,    -1,   912,   913,    -1,   913,   912,    -1,   912,
      -1,   913,    -1,   910,    -1,    -1,   218,   914,    -1,   218,
     914,   458,   915,    -1,   149,   919,   916,   918,   261,    -1,
     258,   915,    -1,   258,   917,   918,    -1,   984,    -1,    26,
      -1,   984,    -1,  1066,    -1,   454,   984,   455,    -1,    -1,
     986,    -1,   324,    -1,   325,    -1,   151,    -1,   243,    -1,
     167,    52,   921,    -1,    -1,   922,    -1,   921,   458,   922,
      -1,   984,    -1,   923,    -1,   925,    -1,   924,    -1,   926,
      -1,   454,   455,    -1,   323,   454,  1020,   455,    -1,    91,
     454,  1020,   455,    -1,   168,   341,   454,   921,   455,    -1,
     170,   984,    -1,    -1,   930,    -1,   154,   299,   261,    -1,
     928,    -1,    -1,   931,    -1,   930,   931,    -1,   932,   933,
     879,    -1,   154,   398,    -1,   154,   244,   206,   398,    -1,
     154,   343,    -1,   154,   206,   343,    -1,   256,  1053,    -1,
      -1,   406,  1049,    -1,   934,   458,  1049,    -1,   159,   936,
      -1,    -1,   937,    -1,   936,   458,   937,    -1,   945,   940,
      -1,   945,   940,   948,    -1,   950,   941,    -1,   211,   950,
     941,    -1,   892,   940,    -1,   211,   892,   940,    -1,   938,
      -1,   454,   938,   455,   939,    -1,   454,   938,   455,    -1,
     937,    89,   205,   937,    -1,   937,   942,   205,   937,   944,
      -1,   937,   205,   937,   944,    -1,   937,   241,   942,   205,
     937,    -1,   937,   241,   205,   937,    -1,    35,  1070,   454,
    1055,   455,    -1,    35,  1070,    -1,  1070,   454,  1055,   455,
      -1,  1070,    -1,   939,    -1,    -1,   939,    -1,    35,   454,
     958,   455,    -1,    35,  1070,   454,   958,   455,    -1,  1070,
     454,   958,   455,    -1,    -1,   160,   943,    -1,   215,   943,
      -1,   320,   943,    -1,   190,    -1,   269,    -1,    -1,   400,
     454,  1055,   455,    -1,   260,   984,    -1,  1054,    -1,  1054,
     447,    -1,   261,  1054,    -1,   261,   454,  1054,   455,    -1,
     945,    -1,   946,   458,   945,    -1,   945,    -1,   945,  1070,
      -1,   945,    35,  1070,    -1,   368,  1062,   454,  1020,   455,
     949,    -1,   311,   454,   984,   455,    -1,    -1,   989,   954,
      -1,   325,   159,   454,   952,   455,   954,    -1,   989,   953,
      -1,   951,    -1,   952,   458,   951,    -1,    35,   454,   958,
     455,    -1,    -1,   440,   267,    -1,    -1,   416,   984,    -1,
      -1,   416,   984,    -1,   416,    92,   256,   888,    -1,    -1,
     958,    -1,    -1,   959,    -1,   958,   458,   959,    -1,  1070,
     960,   514,    -1,   962,   961,    -1,   342,   962,   961,    -1,
     962,    34,   452,  1064,   453,    -1,   342,   962,    34,   452,
    1064,   453,    -1,   962,    34,    -1,   342,   962,    34,    -1,
     961,   452,   453,    -1,   961,   452,  1064,   453,    -1,    -1,
     964,    -1,   966,    -1,   968,    -1,   972,    -1,   979,    -1,
     980,   982,    -1,   980,   454,  1064,   455,    -1,   966,    -1,
     969,    -1,   973,    -1,   979,    -1,  1071,   965,    -1,  1071,
     703,   965,    -1,   454,  1020,   455,    -1,    -1,   196,    -1,
     197,    -1,   348,    -1,    47,    -1,   300,    -1,   152,   967,
      -1,   126,   287,    -1,   107,   965,    -1,   106,   965,    -1,
     254,   965,    -1,    50,    -1,   454,  1064,   455,    -1,    -1,
     970,    -1,   971,    -1,   970,    -1,   971,    -1,    49,   977,
     454,  1020,   455,    -1,    49,   977,    -1,   974,    -1,   975,
      -1,   974,    -1,   975,    -1,   976,   454,  1064,   455,   978,
      -1,   976,   978,    -1,    62,   977,    -1,    61,   977,    -1,
     407,    -1,   240,    62,   977,    -1,   240,    61,   977,    -1,
     242,   977,    -1,   409,    -1,    -1,    62,   340,  1070,    -1,
      -1,   376,   454,  1064,   455,   981,    -1,   376,   981,    -1,
     375,   454,  1064,   455,   981,    -1,   375,   981,    -1,   199,
      -1,   440,   375,   437,    -1,   421,   375,   437,    -1,    -1,
     435,    -1,   236,    -1,   104,    -1,   173,    -1,   233,    -1,
     983,    -1,   435,   377,   236,    -1,   104,   377,   173,    -1,
     104,   377,   233,    -1,   104,   377,   983,    -1,   173,   377,
     233,    -1,   173,   377,   983,    -1,   233,   377,   983,    -1,
      -1,   331,    -1,   331,   454,  1064,   455,    -1,   986,    -1,
     984,    11,   960,    -1,   984,    70,   702,    -1,   984,    40,
     375,   437,   984,    -1,   445,   984,    -1,   446,   984,    -1,
     984,   445,   984,    -1,   984,   446,   984,    -1,   984,   447,
     984,    -1,   984,   448,   984,    -1,   984,   449,   984,    -1,
     984,   450,   984,    -1,   984,   441,   984,    -1,   984,   442,
     984,    -1,   984,   443,   984,    -1,   984,    15,   984,    -1,
     984,    16,   984,    -1,   984,    17,   984,    -1,   984,  1017,
     984,    -1,  1017,   984,    -1,   984,  1017,    -1,   984,    32,
     984,    -1,   984,   265,   984,    -1,   246,   984,    -1,   438,
     984,    -1,   984,   217,   984,    -1,   984,   217,   984,   135,
     984,    -1,   984,   438,   217,   984,    -1,   984,   438,   217,
     984,   135,   984,    -1,   984,   176,   984,    -1,   984,   176,
     984,   135,   984,    -1,   984,   438,   176,   984,    -1,   984,
     438,   176,   984,   135,   984,    -1,   984,   345,   377,   984,
      -1,   984,   345,   377,   984,   135,   984,    -1,   984,   438,
     345,   377,   984,    -1,   984,   438,   345,   377,   984,   135,
     984,    -1,   984,   202,   251,    -1,   984,   203,    -1,   984,
     202,   246,   251,    -1,   984,   249,    -1,  1011,   271,  1011,
      -1,   984,   202,   384,    -1,   984,   202,   246,   384,    -1,
     984,   202,   147,    -1,   984,   202,   246,   147,    -1,   984,
     202,   394,    -1,   984,   202,   246,   394,    -1,   984,   202,
     122,   159,   984,    -1,   984,   202,   246,   122,   159,   984,
      -1,   984,   202,   256,   454,  1023,   455,    -1,   984,   202,
     246,   256,   454,  1023,   455,    -1,   984,    46,  1046,   985,
      32,   984,    -1,   984,   438,    46,  1046,   985,    32,   984,
      -1,   984,    46,   363,   985,    32,   984,    -1,   984,   438,
      46,   363,   985,    32,   984,    -1,   984,   181,  1035,    -1,
     984,   438,   181,  1035,    -1,   984,  1019,  1014,   892,    -1,
     984,  1019,  1014,   454,   984,   455,    -1,   393,   892,    -1,
     984,   202,   124,    -1,   984,   202,   246,   124,    -1,   986,
      -1,   985,    11,   960,    -1,   445,   985,    -1,   446,   985,
      -1,   985,   445,   985,    -1,   985,   446,   985,    -1,   985,
     447,   985,    -1,   985,   448,   985,    -1,   985,   449,   985,
      -1,   985,   450,   985,    -1,   985,   441,   985,    -1,   985,
     442,   985,    -1,   985,   443,   985,    -1,   985,    15,   985,
      -1,   985,    16,   985,    -1,   985,    17,   985,    -1,   985,
    1017,   985,    -1,  1017,   985,    -1,   985,  1017,    -1,   985,
     202,   122,   159,   985,    -1,   985,   202,   246,   122,   159,
     985,    -1,   985,   202,   256,   454,  1023,   455,    -1,   985,
     202,   246,   256,   454,  1023,   455,    -1,   985,   202,   124,
      -1,   985,   202,   246,   124,    -1,  1041,    -1,  1063,    -1,
      10,  1045,    -1,   454,   984,   455,  1045,    -1,  1036,    -1,
     988,    -1,   892,    -1,   892,  1044,    -1,   142,   892,    -1,
      34,   892,    -1,    34,  1024,    -1,  1012,    -1,  1013,    -1,
     168,   454,  1020,   455,    -1,  1062,   454,   455,    -1,  1062,
     454,  1021,   906,   455,    -1,  1062,   454,   408,  1022,   906,
     455,    -1,  1062,   454,  1021,   458,   408,  1022,   906,   455,
      -1,  1062,   454,    26,  1021,   906,   455,    -1,  1062,   454,
     122,  1021,   906,   455,    -1,  1062,   454,   447,   455,    -1,
     987,   999,  1000,  1004,    -1,   990,    -1,   987,    -1,   990,
      -1,    71,   154,   454,   984,   455,    -1,    94,    -1,    97,
      -1,    97,   454,  1064,   455,    -1,    98,    -1,    98,   454,
    1064,   455,    -1,   222,    -1,   222,   454,  1064,   455,    -1,
     223,    -1,   223,   454,  1064,   455,    -1,    95,    -1,    99,
      -1,   339,    -1,   399,    -1,    93,    -1,    96,    -1,    58,
     454,   984,    35,   960,   455,    -1,   146,   454,  1026,   455,
      -1,   272,   454,  1028,   455,    -1,   285,   454,  1030,   455,
      -1,   362,   454,  1031,   455,    -1,   381,   454,   984,    35,
     960,   455,    -1,   383,   454,    51,  1034,   455,    -1,   383,
     454,   212,  1034,   455,    -1,   383,   454,   378,  1034,   455,
      -1,   383,   454,  1034,   455,    -1,   252,   454,   984,   458,
     984,   455,    -1,    69,   454,  1020,   455,    -1,   166,   454,
    1020,   455,    -1,   214,   454,  1020,   455,    -1,   427,   454,
    1020,   455,    -1,   428,   454,   238,  1073,   455,    -1,   428,
     454,   238,  1073,   458,   993,   455,    -1,   428,   454,   238,
    1073,   458,  1020,   455,    -1,   428,   454,   238,  1073,   458,
     993,   458,  1020,   455,    -1,   429,   454,   986,   998,   455,
      -1,   430,   454,   994,   455,    -1,   431,   454,   996,   984,
     997,   455,    -1,   432,   454,   238,  1073,   455,    -1,   432,
     454,   238,  1073,   458,   984,   455,    -1,   433,   454,   984,
     458,   991,   992,   455,    -1,   434,   454,   996,   984,    35,
     962,   455,    -1,   411,   984,    -1,   411,   244,   405,    -1,
     458,   353,   436,    -1,   458,   353,   244,    -1,   458,   353,
     244,   405,    -1,    -1,   426,   454,   994,   455,    -1,   995,
      -1,   994,   458,   995,    -1,   984,    35,  1073,    -1,   984,
      -1,   124,    -1,    83,    -1,   288,   417,    -1,   361,   417,
      -1,    -1,   279,   986,    -1,   279,   986,    52,   304,    -1,
     279,    52,   304,   986,    -1,   279,    52,   304,   986,    52,
     304,    -1,   420,   167,   454,   907,   455,    -1,    -1,   150,
     454,   416,   984,   455,    -1,    -1,   418,  1002,    -1,    -1,
    1003,    -1,  1002,   458,  1003,    -1,  1070,    35,  1005,    -1,
     270,  1005,    -1,   270,  1070,    -1,    -1,   454,  1006,  1007,
     906,  1008,   455,    -1,  1070,    -1,    -1,   278,    52,  1020,
      -1,    -1,   298,  1009,    -1,   325,  1009,    -1,    -1,  1010,
      -1,    46,  1010,    32,  1010,    -1,   389,   286,    -1,   389,
     153,    -1,    92,   324,    -1,   984,   286,    -1,   984,   153,
      -1,   324,   454,  1020,   455,    -1,   324,   454,   455,    -1,
     454,  1020,   458,   984,   455,    -1,   324,   454,  1020,   455,
      -1,   324,   454,   455,    -1,   454,  1020,   458,   984,   455,
      -1,    33,    -1,   350,    -1,    26,    -1,     8,    -1,  1016,
      -1,   445,    -1,   446,    -1,   447,    -1,   448,    -1,   449,
      -1,   450,    -1,   441,    -1,   442,    -1,   443,    -1,    15,
      -1,    16,    -1,    17,    -1,     8,    -1,   262,   454,   779,
     455,    -1,  1015,    -1,   262,   454,   779,   455,    -1,  1015,
      -1,   262,   454,   779,   455,    -1,   217,    -1,   438,   217,
      -1,   176,    -1,   438,   176,    -1,   984,    -1,  1020,   458,
     984,    -1,  1022,    -1,  1021,   458,  1022,    -1,   984,    -1,
     757,    13,   984,    -1,   757,    14,   984,    -1,   960,    -1,
    1023,   458,   960,    -1,   452,  1020,   453,    -1,   452,  1025,
     453,    -1,   452,   453,    -1,  1024,    -1,  1025,   458,  1024,
      -1,  1027,   159,   984,    -1,    -1,     3,    -1,   435,    -1,
     236,    -1,   104,    -1,   173,    -1,   233,    -1,   331,    -1,
    1065,    -1,   984,  1029,  1032,  1033,    -1,   984,  1029,  1032,
      -1,   282,   984,    -1,   985,   181,   985,    -1,    -1,   984,
    1032,  1033,    -1,   984,  1033,  1032,    -1,   984,  1032,    -1,
     984,  1033,    -1,  1020,    -1,    -1,   159,   984,    -1,   154,
     984,    -1,   984,   159,  1020,    -1,   159,  1020,    -1,  1020,
      -1,   892,    -1,   454,  1020,   455,    -1,    57,  1040,  1037,
    1039,   133,    -1,  1038,    -1,  1037,  1038,    -1,   415,   984,
     374,   984,    -1,   129,   984,    -1,    -1,   984,    -1,    -1,
    1070,    -1,  1070,  1044,    -1,   456,  1059,    -1,   456,   447,
      -1,   452,   984,   453,    -1,   452,  1043,   459,  1043,   453,
      -1,   984,    -1,    -1,  1042,    -1,  1044,  1042,    -1,    -1,
    1045,  1042,    -1,    39,    -1,    -1,   984,    -1,   109,    -1,
    1047,    -1,  1048,   458,  1047,    -1,   454,  1048,   455,    -1,
    1051,    -1,    -1,  1052,    -1,  1051,   458,  1052,    -1,   984,
      35,  1073,    -1,   984,     3,    -1,   984,    -1,   447,    -1,
    1054,    -1,  1053,   458,  1054,    -1,  1070,    -1,  1070,  1044,
      -1,  1056,    -1,  1055,   458,  1056,    -1,  1070,    -1,  1070,
      -1,  1070,    -1,  1073,    -1,  1070,    -1,  1065,    -1,  1071,
      -1,  1070,  1044,    -1,  1064,    -1,     4,    -1,  1065,    -1,
       6,    -1,     7,    -1,  1062,  1065,    -1,  1062,   454,  1021,
     906,   455,  1065,    -1,   963,  1065,    -1,   980,  1065,   982,
      -1,   980,   454,  1064,   455,  1065,    -1,   384,    -1,   147,
      -1,   251,    -1,     9,    -1,     5,    -1,  1064,    -1,   445,
    1064,    -1,   446,  1064,    -1,  1068,    -1,  1072,    -1,    99,
      -1,   339,    -1,  1068,    -1,  1069,   458,  1068,    -1,     3,
      -1,  1074,    -1,  1075,    -1,     3,    -1,  1074,    -1,  1076,
      -1,     3,    -1,  1074,    -1,  1075,    -1,  1076,    -1,     3,
      -1,  1074,    -1,  1075,    -1,  1076,    -1,  1077,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,    23,
      -1,    24,    -1,    25,    -1,    27,    -1,    28,    -1,    29,
      -1,    37,    -1,    38,    -1,    40,    -1,    41,    -1,    43,
      -1,    44,    -1,    45,    -1,    52,    -1,    53,    -1,    54,
      -1,    55,    -1,    56,    -1,    59,    -1,    60,    -1,    63,
      -1,    65,    -1,    66,    -1,    67,    -1,    68,    -1,    73,
      -1,    74,    -1,    75,    -1,    76,    -1,    78,    -1,    79,
      -1,    80,    -1,    82,    -1,    83,    -1,    84,    -1,    85,
      -1,    86,    -1,    87,    -1,    90,    -1,    91,    -1,    92,
      -1,   100,    -1,   101,    -1,   102,    -1,   103,    -1,   104,
      -1,   105,    -1,   108,    -1,   110,    -1,   112,    -1,   113,
      -1,   114,    -1,   115,    -1,   116,    -1,   117,    -1,   119,
      -1,   120,    -1,   121,    -1,   124,    -1,   125,    -1,   126,
      -1,   127,    -1,   128,    -1,   130,    -1,   131,    -1,   132,
      -1,   134,    -1,   135,    -1,   136,    -1,   138,    -1,   139,
      -1,   140,    -1,   141,    -1,   143,    -1,   144,    -1,   145,
      -1,   148,    -1,   150,    -1,   151,    -1,   153,    -1,   155,
      -1,   157,    -1,   161,    -1,   162,    -1,   163,    -1,   165,
      -1,   169,    -1,   171,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   177,    -1,   178,    -1,   179,    -1,   180,
      -1,   182,    -1,   183,    -1,   184,    -1,   185,    -1,   186,
      -1,   187,    -1,   189,    -1,   192,    -1,   193,    -1,   194,
      -1,   195,    -1,   201,    -1,   204,    -1,   206,    -1,   207,
      -1,   208,    -1,   209,    -1,   210,    -1,   213,    -1,   216,
      -1,   219,    -1,   220,    -1,   221,    -1,   224,    -1,   225,
      -1,   226,    -1,   227,    -1,   228,    -1,   229,    -1,   230,
      -1,   231,    -1,   232,    -1,   233,    -1,   234,    -1,   235,
      -1,   236,    -1,   237,    -1,   238,    -1,   239,    -1,   243,
      -1,   244,    -1,   247,    -1,   248,    -1,   250,    -1,   253,
      -1,   255,    -1,   256,    -1,   257,    -1,   259,    -1,   262,
      -1,   263,    -1,   264,    -1,   267,    -1,   270,    -1,   273,
      -1,   274,    -1,   275,    -1,   276,    -1,   277,    -1,   278,
      -1,   279,    -1,   280,    -1,   283,    -1,   284,    -1,   286,
      -1,   289,    -1,   290,    -1,   288,    -1,   292,    -1,   293,
      -1,   294,    -1,   295,    -1,   296,    -1,   297,    -1,   298,
      -1,   299,    -1,   301,    -1,   302,    -1,   303,    -1,   304,
      -1,   306,    -1,   307,    -1,   308,    -1,   309,    -1,   310,
      -1,   311,    -1,   312,    -1,   313,    -1,   314,    -1,   315,
      -1,   316,    -1,   318,    -1,   319,    -1,   321,    -1,   322,
      -1,   323,    -1,   325,    -1,   326,    -1,   327,    -1,   328,
      -1,   329,    -1,   330,    -1,   331,    -1,   332,    -1,   334,
      -1,   335,    -1,   336,    -1,   337,    -1,   338,    -1,   340,
      -1,   341,    -1,   343,    -1,   344,    -1,   346,    -1,   347,
      -1,   349,    -1,   351,    -1,   352,    -1,   353,    -1,   354,
      -1,   355,    -1,   356,    -1,   357,    -1,   358,    -1,   359,
      -1,   360,    -1,   361,    -1,   364,    -1,   365,    -1,   367,
      -1,   369,    -1,   370,    -1,   371,    -1,   372,    -1,   373,
      -1,   379,    -1,   380,    -1,   382,    -1,   385,    -1,   386,
      -1,   387,    -1,   388,    -1,   389,    -1,   390,    -1,   391,
      -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,   398,
      -1,   401,    -1,   402,    -1,   403,    -1,   404,    -1,   405,
      -1,   409,    -1,   411,    -1,   412,    -1,   413,    -1,   414,
      -1,   417,    -1,   420,    -1,   421,    -1,   422,    -1,   423,
      -1,   424,    -1,   425,    -1,   435,    -1,   436,    -1,   437,
      -1,    46,    -1,    47,    -1,    49,    -1,    50,    -1,    61,
      -1,    62,    -1,    69,    -1,   106,    -1,   107,    -1,   142,
      -1,   146,    -1,   152,    -1,   166,    -1,   168,    -1,   191,
      -1,   196,    -1,   197,    -1,   199,    -1,   214,    -1,   240,
      -1,   242,    -1,   245,    -1,   252,    -1,   254,    -1,   268,
      -1,   272,    -1,   285,    -1,   287,    -1,   300,    -1,   324,
      -1,   342,    -1,   348,    -1,   362,    -1,   375,    -1,   376,
      -1,   381,    -1,   383,    -1,   406,    -1,   407,    -1,   426,
      -1,   427,    -1,   428,    -1,   429,    -1,   430,    -1,   431,
      -1,   432,    -1,   433,    -1,   434,    -1,    42,    -1,    48,
      -1,    71,    -1,    77,    -1,    89,    -1,    96,    -1,   158,
      -1,   160,    -1,   176,    -1,   190,    -1,   202,    -1,   203,
      -1,   205,    -1,   215,    -1,   217,    -1,   241,    -1,   249,
      -1,   269,    -1,   271,    -1,   320,    -1,   345,    -1,   368,
      -1,   410,    -1,    26,    -1,    30,    -1,    31,    -1,    32,
      -1,    33,    -1,    34,    -1,    35,    -1,    36,    -1,    39,
      -1,    51,    -1,    57,    -1,    58,    -1,    64,    -1,    70,
      -1,    72,    -1,    81,    -1,    88,    -1,    93,    -1,    94,
      -1,    95,    -1,    97,    -1,    98,    -1,    99,    -1,   109,
      -1,   111,    -1,   118,    -1,   122,    -1,   123,    -1,   129,
      -1,   133,    -1,   137,    -1,   147,    -1,   149,    -1,   154,
      -1,   156,    -1,   159,    -1,   164,    -1,   167,    -1,   170,
      -1,   181,    -1,   188,    -1,   198,    -1,   200,    -1,   211,
      -1,   212,    -1,   218,    -1,   222,    -1,   223,    -1,   246,
      -1,   251,    -1,   258,    -1,   260,    -1,   261,    -1,   265,
      -1,   266,    -1,   282,    -1,   291,    -1,   305,    -1,   317,
      -1,   333,    -1,   339,    -1,   350,    -1,   363,    -1,   366,
      -1,   374,    -1,   377,    -1,   378,    -1,   384,    -1,   392,
      -1,   393,    -1,   399,    -1,   400,    -1,   408,    -1,   415,
      -1,   416,    -1,   418,    -1,   419,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   769,   769,   776,   783,   793,   794,   795,   796,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,   865,   866,   867,
     868,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,   881,   882,   883,   884,   885,   886,   887,
     888,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,   899,   900,   901,   902,   903,   904,   905,   906,   907,
     908,   909,   910,   911,   912,   913,   914,   915,   916,   917,
     919,   929,   940,   941,   942,   951,   952,   956,   957,   961,
     966,   970,   975,   980,   984,   988,   993,   997,  1045,  1047,
    1051,  1055,  1059,  1063,  1077,  1095,  1106,  1107,  1111,  1119,
    1137,  1149,  1170,  1177,  1196,  1203,  1220,  1238,  1249,  1250,
    1262,  1269,  1286,  1296,  1306,  1321,  1339,  1340,  1344,  1351,
    1359,  1360,  1361,  1362,  1363,  1364,  1378,  1385,  1391,  1397,
    1406,  1414,  1422,  1426,  1434,  1442,  1449,  1458,  1459,  1467,
    1478,  1486,  1494,  1505,  1513,  1521,  1528,  1537,  1547,  1548,
    1552,  1553,  1556,  1558,  1562,  1563,  1564,  1565,  1569,  1570,
    1571,  1577,  1589,  1593,  1597,  1612,  1619,  1620,  1621,  1625,
    1626,  1627,  1631,  1632,  1636,  1637,  1646,  1647,  1654,  1661,
    1671,  1678,  1688,  1689,  1694,  1695,  1701,  1707,  1713,  1719,
    1725,  1731,  1737,  1747,  1757,  1758,  1762,  1763,  1771,  1786,
    1792,  1798,  1804,  1810,  1829,  1838,  1847,  1858,  1869,  1878,
    1887,  1898,  1909,  1918,  1927,  1936,  1945,  1954,  1963,  1974,
    1988,  1989,  1994,  2003,  2012,  2021,  2030,  2039,  2047,  2055,
    2064,  2073,  2082,  2091,  2101,  2114,  2129,  2138,  2147,  2162,
    2170,  2180,  2190,  2197,  2204,  2212,  2220,  2227,  2234,  2242,
    2250,  2258,  2265,  2272,  2280,  2287,  2294,  2302,  2310,  2318,
    2326,  2334,  2342,  2352,  2359,  2367,  2375,  2383,  2391,  2399,
    2406,  2413,  2420,  2426,  2436,  2437,  2441,  2442,  2443,  2447,
    2455,  2459,  2460,  2464,  2471,  2478,  2485,  2495,  2498,  2499,
    2503,  2504,  2509,  2513,  2517,  2522,  2537,  2550,  2551,  2556,
    2565,  2575,  2585,  2611,  2617,  2650,  2679,  2701,  2702,  2706,
    2707,  2716,  2717,  2718,  2721,  2722,  2727,  2728,  2732,  2736,
    2740,  2744,  2748,  2752,  2756,  2760,  2764,  2768,  2772,  2776,
    2780,  2784,  2793,  2797,  2801,  2805,  2809,  2813,  2817,  2818,
    2823,  2827,  2834,  2841,  2842,  2843,  2844,  2845,  2849,  2853,
    2861,  2872,  2888,  2905,  2922,  2952,  2953,  2954,  2955,  2956,
    2963,  2970,  2971,  2975,  2976,  2980,  2981,  2985,  2989,  2996,
    3000,  3007,  3008,  3009,  3013,  3014,  3017,  3038,  3059,  3060,
    3064,  3072,  3073,  3074,  3105,  3112,  3119,  3130,  3141,  3153,
    3164,  3197,  3204,  3211,  3218,  3229,  3239,  3240,  3241,  3245,
    3246,  3247,  3248,  3249,  3250,  3259,  3267,  3271,  3284,  3299,
    3313,  3328,  3342,  3360,  3381,  3382,  3386,  3387,  3391,  3392,
    3395,  3401,  3405,  3413,  3418,  3424,  3425,  3429,  3434,  3441,
    3442,  3452,  3454,  3456,  3458,  3461,  3464,  3467,  3471,  3472,
    3473,  3474,  3475,  3478,  3479,  3484,  3485,  3486,  3487,  3490,
    3491,  3492,  3493,  3496,  3497,  3500,  3501,  3504,  3519,  3532,
    3548,  3562,  3563,  3564,  3576,  3589,  3605,  3618,  3619,  3631,
    3651,  3661,  3674,  3682,  3693,  3694,  3697,  3698,  3701,  3705,
    3709,  3713,  3717,  3721,  3725,  3729,  3733,  3737,  3741,  3745,
    3751,  3752,  3756,  3757,  3762,  3765,  3766,  3778,  3790,  3805,
    3806,  3814,  3815,  3819,  3820,  3824,  3825,  3829,  3830,  3834,
    3845,  3858,  3859,  3869,  3880,  3881,  3894,  3901,  3918,  3926,
    3937,  3940,  3944,  3948,  3952,  3956,  3968,  3978,  3981,  3985,
    3998,  4008,  4018,  4027,  4036,  4045,  4055,  4064,  4074,  4083,
    4092,  4101,  4110,  4119,  4128,  4137,  4146,  4155,  4164,  4173,
    4182,  4191,  4200,  4209,  4219,  4237,  4248,  4249,  4250,  4251,
    4255,  4256,  4260,  4261,  4271,  4282,  4302,  4310,  4322,  4323,
    4327,  4331,  4339,  4343,  4347,  4354,  4358,  4363,  4368,  4375,
    4382,  4387,  4397,  4411,  4412,  4417,  4418,  4422,  4423,  4433,
    4444,  4464,  4473,  4481,  4498,  4518,  4548,  4557,  4578,  4593,
    4594,  4598,  4606,  4621,  4632,  4633,  4643,  4651,  4668,  4690,
    4706,  4720,  4731,  4745,  4746,  4750,  4751,  4755,  4756,  4760,
    4761,  4765,  4766,  4770,  4771,  4772,  4773,  4774,  4784,  4803,
    4823,  4848,  4849,  4850,  4854,  4856,  4878,  4880,  4882,  4884,
    4886,  4891,  4896,  4906,  4907,  4911,  4912,  4916,  4917,  4921,
    4922,  4923,  4927,  4931,  4932,  4933,  4937,  4938,  4943,  4944,
    4971,  4972,  4973,  4974,  4975,  4976,  4981,  4992,  5015,  5025,
    5039,  5041,  5046,  5051,  5053,  5058,  5068,  5069,  5070,  5071,
    5083,  5103,  5126,  5136,  5147,  5157,  5167,  5178,  5187,  5194,
    5201,  5210,  5219,  5228,  5237,  5246,  5257,  5260,  5261,  5264,
    5268,  5275,  5276,  5277,  5278,  5279,  5282,  5285,  5286,  5294,
    5301,  5302,  5305,  5307,  5318,  5328,  5338,  5350,  5351,  5367,
    5382,  5383,  5387,  5397,  5408,  5417,  5427,  5436,  5437,  5440,
    5441,  5444,  5445,  5446,  5449,  5463,  5468,  5478,  5487,  5499,
    5500,  5504,  5512,  5524,  5534,  5547,  5557,  5579,  5589,  5607,
    5618,  5629,  5639,  5649,  5659,  5669,  5680,  5694,  5695,  5696,
    5697,  5698,  5699,  5700,  5701,  5702,  5703,  5704,  5705,  5706,
    5707,  5708,  5709,  5713,  5714,  5717,  5718,  5721,  5723,  5728,
    5729,  5739,  5750,  5751,  5752,  5786,  5795,  5804,  5813,  5822,
    5831,  5840,  5849,  5863,  5872,  5881,  5891,  5900,  5909,  5917,
    5926,  5935,  5944,  5956,  5957,  5958,  5959,  5960,  5961,  5962,
    5963,  5964,  5965,  5966,  5967,  5968,  5969,  5970,  5971,  5972,
    5973,  5974,  5975,  5976,  5977,  5981,  5982,  5996,  6007,  6018,
    6029,  6040,  6051,  6062,  6075,  6076,  6080,  6081,  6082,  6083,
    6084,  6085,  6086,  6087,  6088,  6089,  6090,  6093,  6094,  6104,
    6110,  6118,  6126,  6134,  6142,  6150,  6158,  6166,  6174,  6182,
    6190,  6198,  6206,  6214,  6222,  6230,  6238,  6248,  6249,  6252,
    6253,  6263,  6279,  6293,  6319,  6321,  6323,  6325,  6332,  6341,
    6342,  6345,  6352,  6359,  6366,  6380,  6388,  6396,  6404,  6412,
    6420,  6428,  6436,  6444,  6452,  6460,  6468,  6476,  6484,  6492,
    6500,  6512,  6513,  6517,  6518,  6523,  6524,  6528,  6529,  6534,
    6550,  6563,  6573,  6585,  6586,  6589,  6590,  6600,  6610,  6611,
    6615,  6619,  6623,  6634,  6647,  6661,  6678,  6679,  6680,  6681,
    6693,  6719,  6748,  6749,  6753,  6754,  6758,  6759,  6763,  6764,
    6767,  6768,  6776,  6787,  6798,  6811,  6812,  6815,  6816,  6819,
    6820,  6821,  6824,  6825,  6826,  6842,  6854,  6867,  6882,  6883,
    6886,  6887,  6891,  6892,  6900,  6901,  6905,  6906,  6921,  6930,
    6939,  6948,  6957,  6969,  6970,  6971,  6972,  6973,  6979,  6983,
    6998,  6999,  7005,  7015,  7019,  7024,  7032,  7073,  7077,  7081,
    7085,  7093,  7094,  7099,  7100,  7107,  7111,  7115,  7119,  7123,
    7127,  7131,  7135,  7139,  7143,  7147,  7151,  7155,  7159,  7163,
    7168,  7175,  7179,  7183,  7187,  7191,  7197,  7198,  7205,  7206,
    7210,  7211,  7214,  7226,  7230,  7245,  7256,  7257,  7262,  7263,
    7278,  7289,  7303,  7314,  7328,  7339,  7353,  7361,  7363,  7365,
    7370,  7372,  7385,  7394,  7395,  7399,  7403,  7415,  7426,  7437,
    7450,  7451,  7452,  7456,  7469,  7470,  7480,  7492,  7496,  7500,
    7504,  7511,  7532,  7541,  7550,  7559,  7570,  7571,  7574,  7575,
    7576,  7579,  7580,  7583,  7593,  7602,  7619,  7629,  7638,  7647,
    7656,  7665,  7674,  7683,  7693,  7702,  7711,  7720,  7729,  7739,
    7749,  7758,  7767,  7777,  7787,  7797,  7807,  7817,  7827,  7837,
    7847,  7857,  7867,  7877,  7887,  7898,  7909,  7920,  7931,  7941,
    7951,  7962,  7973,  7983,  7993,  8001,  8010,  8019,  8028,  8037,
    8046,  8055,  8064,  8073,  8087,  8088,  8091,  8092,  8102,  8112,
    8122,  8132,  8151,  8161,  8170,  8179,  8188,  8197,  8207,  8217,
    8226,  8235,  8244,  8253,  8262,  8271,  8280,  8289,  8298,  8307,
    8316,  8325,  8334,  8343,  8352,  8361,  8379,  8389,  8390,  8393,
    8395,  8405,  8414,  8422,  8430,  8438,  8446,  8455,  8463,  8471,
    8480,  8488,  8496,  8504,  8512,  8520,  8528,  8536,  8544,  8552,
    8569,  8586,  8587,  8588,  8593,  8599,  8608,  8609,  8610,  8611,
    8612,  8616,  8617,  8620,  8621,  8622,  8623,  8627,  8628,  8629,
    8634,  8645,  8667,  8677,  8678,  8681,  8690,  8696,  8715,  8722,
    8729,  8736,  8743,  8750,  8757,  8765,  8773,  8781,  8789,  8797,
    8804,  8811,  8820,  8821,  8822,  8826,  8829,  8832,  8835,  8838,
    8845,  8847,  8849,  8854,  8856,  8868,  8881,  8894,  8912,  8933,
    8934,  8935,  8936,  8946,  8962,  8972,  8973,  8977,  8978,  8982,
    8986,  8990,  9008,  9009,  9010,  9011,  9012,  9013,  9014,  9021,
    9022,  9033,  9040,  9047,  9058,  9075,  9082,  9100,  9106,  9122,
    9135,  9144,  9152,  9160,  9169,  9180,  9191,  9201,  9202,  9213,
    9223,  9234,  9245,  9256,  9267,  9276,  9288,  9289,  9303,  9326,
    9334,  9343,  9354,  9355,  9367,  9381,  9395,  9407,  9415,  9428,
    9429,  9433,  9434,  9435,  9436,  9437,  9450,  9460,  9473,  9474,
    9478,  9479,  9482,  9483,  9486,  9487,  9491,  9492,  9505,  9512,
    9522,  9529,  9539,  9540,  9541,  9542,  9543,  9544,  9545,  9546,
    9547,  9551,  9555,  9562,  9569,  9570,  9574,  9575,  9576,  9586,
    9596,  9597,  9601,  9602,  9603,  9604,  9614,  9621,  9639,  9640,
    9650,  9656,  9662,  9668,  9684,  9702,  9706,  9714,  9720,  9726,
    9735,  9737,  9742,  9753,  9763,  9773,  9779,  9788,  9797,  9803,
    9804,  9815,  9829,  9830,  9841,  9852,  9853,  9856,  9857,  9858,
    9859,  9860,  9861,  9862,  9863,  9866,  9867,  9871,  9872,  9873,
    9884,  9902,  9903,  9907,  9908,  9912,  9928,  9954,  9987,  9998,
    9999, 10009, 10020, 10023, 10024, 10025, 10026, 10027, 10030, 10031,
   10032, 10080, 10081, 10085, 10086, 10101, 10102, 10109, 10117, 10125,
   10133, 10141, 10149, 10160, 10161, 10188, 10202, 10217, 10218, 10237,
   10241, 10245, 10262, 10269, 10276, 10286, 10287, 10290, 10302, 10303,
   10307, 10319, 10327, 10332, 10337, 10342, 10347, 10355, 10363, 10368,
   10373, 10380, 10381, 10385, 10386, 10387, 10394, 10395, 10399, 10400,
   10404, 10405, 10409, 10413, 10414, 10417, 10426, 10439, 10440, 10441,
   10442, 10446, 10447, 10451, 10453, 10463, 10468, 10471, 10476, 10477,
   10485, 10495, 10496, 10497, 10505, 10509, 10510, 10513, 10514, 10539,
   10540, 10544, 10545, 10549, 10550, 10551, 10552, 10553, 10557, 10570,
   10577, 10584, 10591, 10592, 10596, 10597, 10601, 10602, 10606, 10607,
   10611, 10622, 10623, 10624, 10625, 10629, 10630, 10635, 10641, 10659,
   10660, 10664, 10665, 10671, 10676, 10684, 10691, 10699, 10734, 10759,
   10763, 10789, 10793, 10805, 10818, 10832, 10843, 10858, 10864, 10869,
   10875, 10882, 10883, 10891, 10895, 10899, 10905, 10912, 10917, 10918,
   10919, 10920, 10924, 10925, 10937, 10938, 10943, 10950, 10957, 10964,
   10975, 10976, 10989, 10993, 11000, 11013, 11026, 11027, 11042, 11052,
   11064, 11069, 11070, 11073, 11074, 11077, 11078, 11083, 11084, 11089,
   11090, 11098, 11103, 11104, 11108, 11112, 11118, 11148, 11153, 11160,
   11165, 11171, 11176, 11185, 11187, 11190, 11194, 11195, 11196, 11197,
   11198, 11199, 11204, 11224, 11225, 11226, 11227, 11238, 11244, 11252,
   11253, 11259, 11264, 11269, 11274, 11279, 11284, 11289, 11294, 11300,
   11306, 11312, 11319, 11341, 11350, 11354, 11362, 11366, 11374, 11386,
   11407, 11411, 11417, 11421, 11434, 11445, 11460, 11462, 11464, 11466,
   11468, 11470, 11475, 11476, 11480, 11481, 11488, 11497, 11505, 11514,
   11525, 11533, 11534, 11535, 11539, 11541, 11543, 11545, 11547, 11549,
   11551, 11556, 11561, 11567, 11575, 11580, 11587, 11594, 11598, 11602,
   11638, 11639, 11641, 11649, 11664, 11666, 11668, 11670, 11672, 11674,
   11676, 11678, 11680, 11682, 11684, 11686, 11688, 11690, 11693, 11695,
   11697, 11700, 11702, 11704, 11706, 11709, 11714, 11722, 11727, 11735,
   11740, 11748, 11753, 11762, 11770, 11778, 11786, 11804, 11812, 11820,
   11828, 11836, 11852, 11860, 11868, 11876, 11884, 11892, 11900, 11904,
   11910, 11914, 11918, 11926, 11934, 11942, 11950, 11970, 11992, 12003,
   12010, 12026, 12031, 12048, 12050, 12052, 12054, 12056, 12058, 12060,
   12062, 12064, 12066, 12068, 12070, 12072, 12074, 12076, 12078, 12080,
   12082, 12084, 12086, 12090, 12096, 12100, 12104, 12109, 12125, 12126,
   12127, 12142, 12172, 12174, 12176, 12187, 12211, 12222, 12233, 12241,
   12251, 12261, 12270, 12274, 12280, 12287, 12294, 12304, 12311, 12339,
   12374, 12385, 12386, 12393, 12399, 12425, 12435, 12448, 12456, 12469,
   12479, 12492, 12502, 12515, 12519, 12523, 12527, 12531, 12535, 12539,
   12541, 12545, 12554, 12559, 12566, 12581, 12588, 12592, 12596, 12600,
   12604, 12611, 12619, 12627, 12631, 12635, 12639, 12643, 12647, 12653,
   12657, 12666, 12670, 12674, 12679, 12693, 12695, 12699, 12701, 12703,
   12706, 12709, 12712, 12713, 12716, 12724, 12734, 12735, 12738, 12739,
   12740, 12745, 12749, 12753, 12757, 12768, 12769, 12773, 12774, 12782,
   12783, 12787, 12788, 12793, 12801, 12803, 12817, 12820, 12847, 12848,
   12851, 12852, 12863, 12881, 12888, 12897, 12914, 12959, 12967, 12975,
   12983, 12991, 13012, 13013, 13014, 13017, 13018, 13021, 13024, 13025,
   13026, 13029, 13030, 13033, 13034, 13035, 13036, 13037, 13038, 13039,
   13040, 13041, 13042, 13043, 13044, 13047, 13049, 13054, 13056, 13061,
   13063, 13065, 13067, 13069, 13071, 13083, 13087, 13094, 13098, 13104,
   13108, 13117, 13128, 13129, 13132, 13136, 13140, 13146, 13147, 13152,
   13156, 13163, 13164, 13165, 13166, 13167, 13168, 13169, 13170, 13180,
   13184, 13191, 13198, 13199, 13215, 13219, 13224, 13228, 13243, 13248,
   13252, 13255, 13258, 13259, 13260, 13263, 13270, 13280, 13294, 13295,
   13299, 13310, 13311, 13314, 13315, 13318, 13322, 13329, 13333, 13337,
   13345, 13356, 13357, 13361, 13362, 13366, 13367, 13370, 13371, 13382,
   13383, 13392, 13393, 13401, 13411, 13412, 13416, 13417, 13420, 13436,
   13444, 13452, 13474, 13475, 13486, 13490, 13517, 13519, 13524, 13527,
   13530, 13532, 13534, 13536, 13546, 13548, 13559, 13563, 13567, 13571,
   13575, 13584, 13591, 13623, 13627, 13633, 13640, 13644, 13648, 13654,
   13655, 13657, 13658, 13659, 13663, 13693, 13720, 13724, 13730, 13732,
   13749, 13750, 13751, 13756, 13757, 13758, 13763, 13764, 13765, 13766,
   13772, 13773, 13774, 13775, 13776, 13796, 13797, 13798, 13799, 13800,
   13801, 13802, 13803, 13804, 13805, 13806, 13807, 13808, 13809, 13810,
   13811, 13812, 13813, 13814, 13815, 13816, 13817, 13818, 13819, 13820,
   13821, 13822, 13823, 13824, 13825, 13826, 13827, 13828, 13829, 13830,
   13831, 13832, 13833, 13834, 13835, 13836, 13837, 13838, 13839, 13840,
   13841, 13842, 13843, 13844, 13845, 13846, 13847, 13848, 13849, 13850,
   13851, 13852, 13853, 13854, 13855, 13856, 13857, 13858, 13859, 13860,
   13861, 13862, 13863, 13864, 13865, 13866, 13867, 13868, 13869, 13870,
   13871, 13872, 13873, 13874, 13875, 13876, 13877, 13878, 13879, 13880,
   13881, 13882, 13883, 13884, 13885, 13886, 13887, 13888, 13889, 13890,
   13891, 13892, 13893, 13894, 13895, 13896, 13897, 13898, 13899, 13900,
   13901, 13902, 13903, 13904, 13905, 13906, 13907, 13908, 13909, 13910,
   13911, 13912, 13913, 13914, 13915, 13916, 13917, 13918, 13919, 13920,
   13921, 13922, 13923, 13924, 13925, 13926, 13927, 13928, 13929, 13930,
   13931, 13932, 13933, 13934, 13935, 13936, 13937, 13938, 13939, 13940,
   13941, 13942, 13943, 13944, 13945, 13946, 13947, 13948, 13949, 13950,
   13951, 13952, 13953, 13954, 13955, 13956, 13957, 13958, 13959, 13960,
   13961, 13962, 13963, 13964, 13965, 13966, 13967, 13968, 13969, 13970,
   13971, 13972, 13973, 13974, 13975, 13976, 13977, 13978, 13979, 13980,
   13981, 13982, 13983, 13984, 13985, 13986, 13987, 13988, 13989, 13990,
   13991, 13992, 13993, 13994, 13995, 13996, 13997, 13998, 13999, 14000,
   14001, 14002, 14003, 14004, 14005, 14006, 14007, 14008, 14009, 14010,
   14011, 14012, 14013, 14014, 14015, 14016, 14017, 14018, 14019, 14020,
   14021, 14022, 14023, 14024, 14025, 14026, 14027, 14028, 14029, 14030,
   14031, 14032, 14033, 14034, 14035, 14036, 14037, 14038, 14039, 14040,
   14041, 14042, 14043, 14044, 14045, 14046, 14047, 14048, 14049, 14050,
   14051, 14052, 14053, 14054, 14055, 14056, 14057, 14058, 14059, 14060,
   14061, 14062, 14063, 14064, 14065, 14066, 14080, 14081, 14082, 14083,
   14084, 14085, 14086, 14087, 14088, 14089, 14090, 14091, 14092, 14093,
   14094, 14095, 14096, 14097, 14098, 14099, 14100, 14101, 14102, 14103,
   14104, 14105, 14106, 14107, 14108, 14109, 14110, 14111, 14112, 14113,
   14114, 14115, 14116, 14117, 14118, 14119, 14120, 14121, 14122, 14123,
   14124, 14125, 14126, 14127, 14141, 14142, 14143, 14144, 14145, 14146,
   14147, 14148, 14149, 14150, 14151, 14152, 14153, 14154, 14155, 14156,
   14157, 14158, 14159, 14160, 14161, 14162, 14163, 14173, 14174, 14175,
   14176, 14177, 14178, 14179, 14180, 14181, 14182, 14183, 14184, 14185,
   14186, 14187, 14188, 14189, 14190, 14191, 14192, 14193, 14194, 14195,
   14196, 14197, 14198, 14199, 14200, 14201, 14202, 14203, 14204, 14205,
   14206, 14207, 14208, 14209, 14210, 14211, 14212, 14213, 14214, 14215,
   14216, 14217, 14218, 14219, 14220, 14221, 14222, 14223, 14224, 14225,
   14226, 14227, 14228, 14229, 14230, 14231, 14232, 14233, 14234, 14235,
   14236, 14237, 14238, 14239, 14240, 14241, 14242, 14243, 14244, 14245,
   14246, 14247, 14248, 14249
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM",
  "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "GROUPING", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS",
  "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PGPOOL", "PLACING", "PLANS",
  "POLICY", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'",
  "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "DropPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "type_name_list",
  "TruncateStmt", "opt_restart_seqs", "CommentStmt", "comment_type",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label_type",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "CreateTransformStmt", "transform_element_list",
  "DropTransformStmt", "ReindexStmt", "reindex_target_type",
  "reindex_target_multitable", "reindex_option_list",
  "reindex_option_elem", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "AlterObjectSchemaStmt",
  "AlterOperatorStmt", "operator_def_list", "operator_def_elem",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "all_or_distinct", "distinct_clause",
  "opt_all_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst", "Sconst",
  "SignedIconst", "RoleId", "RoleSpec", "role_list", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,    60,    62,    61,   696,    43,    45,    42,    47,    37,
      94,   697,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   460,   461,   462,   462,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     463,   464,   465,   465,   465,   466,   466,   467,   467,   468,
     468,   468,   468,   468,   468,   468,   468,   468,   469,   469,
     469,   469,   469,   469,   470,   471,   472,   472,   473,   473,
     474,   475,   476,   476,   477,   477,   478,   479,   480,   480,
     481,   481,   482,   482,   482,   482,   483,   483,   484,   484,
     485,   485,   485,   485,   485,   485,   486,   486,   486,   486,
     487,   487,   487,   488,   488,   488,   488,   489,   489,   489,
     489,   489,   489,   489,   489,   489,   489,   489,   490,   490,
     491,   491,   492,   492,   493,   493,   493,   493,   494,   494,
     494,   494,   495,   495,   495,   495,   495,   495,   495,   496,
     496,   496,   497,   497,   498,   498,   499,   499,   499,   499,
     500,   500,   501,   501,   502,   502,   503,   503,   503,   503,
     503,   503,   503,   504,   505,   505,   506,   506,   507,   508,
     508,   508,   508,   508,   509,   509,   509,   509,   509,   509,
     509,   509,   509,   509,   509,   509,   509,   509,   509,   509,
     510,   510,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   512,   512,   513,   513,   513,   514,
     514,   515,   515,   516,   516,   516,   516,   517,   518,   518,
     519,   519,   520,   520,   520,   520,   521,   522,   522,   523,
     523,   523,   523,   524,   524,   525,   525,   526,   526,   527,
     527,   528,   528,   528,   529,   529,   530,   530,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   532,   532,   533,   533,   534,   534,   535,   535,
     536,   536,   537,   538,   538,   538,   538,   538,   539,   539,
     540,   541,   541,   541,   541,   542,   542,   542,   542,   542,
     542,   542,   542,   543,   543,   544,   544,   545,   545,   546,
     546,   547,   547,   547,   548,   548,   549,   550,   551,   551,
     552,   552,   552,   552,   553,   553,   553,   553,   553,   553,
     553,   554,   554,   554,   554,   555,   556,   556,   556,   557,
     557,   557,   557,   557,   557,   558,   558,   559,   559,   559,
     559,   559,   559,   559,   560,   560,   561,   561,   562,   562,
     563,   564,   564,   564,   564,   565,   565,   566,   566,   567,
     567,   568,   568,   568,   568,   568,   569,   570,   571,   571,
     571,   571,   571,   572,   572,   573,   573,   573,   573,   574,
     574,   574,   574,   575,   575,   576,   576,   577,   578,   578,
     579,   580,   580,   580,   581,   581,   582,   583,   583,   584,
     585,   585,   586,   586,   587,   587,   588,   588,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     590,   590,   591,   591,   591,   592,   592,   593,   593,   594,
     594,   595,   595,   596,   596,   597,   597,   598,   598,   599,
     599,   600,   600,   601,   602,   602,   603,   603,   604,   604,
     605,   605,   606,   606,   606,   606,   607,   608,   608,   609,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   611,   612,   612,   612,   612,
     613,   613,   614,   614,   615,   615,   616,   616,   617,   617,
     618,   618,   619,   620,   620,   621,   621,   621,   621,   622,
     623,   624,   625,   626,   626,   627,   627,   628,   628,   629,
     629,   630,   630,   630,   631,   631,   632,   632,   633,   634,
     634,   635,   635,   636,   637,   637,   638,   638,   639,   640,
     641,   642,   642,   643,   643,   644,   644,   645,   645,   646,
     646,   647,   647,   648,   648,   648,   648,   648,   649,   650,
     650,   651,   651,   651,   652,   652,   653,   653,   653,   653,
     653,   654,   654,   655,   655,   656,   656,   657,   657,   658,
     658,   658,   659,   659,   659,   659,   660,   660,   661,   661,
     662,   662,   662,   662,   662,   662,   663,   663,   664,   664,
     665,   665,   666,   667,   667,   668,   669,   669,   669,   669,
     670,   671,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   673,   674,   674,   675,
     675,   676,   676,   676,   676,   676,   677,   678,   678,   679,
     680,   680,   681,   681,   682,   682,   682,   683,   683,   684,
     685,   685,   686,   686,   686,   686,   686,   687,   687,   688,
     688,   689,   689,   689,   690,   690,   691,   692,   692,   693,
     693,   694,   694,   695,   695,   696,   696,   697,   698,   699,
     699,   699,   699,   699,   699,   699,   699,   700,   700,   700,
     700,   700,   700,   700,   700,   700,   700,   700,   700,   700,
     700,   700,   700,   701,   701,   702,   702,   703,   703,   704,
     704,   705,   706,   706,   706,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   709,   709,   710,   710,   710,
     710,   710,   710,   710,   711,   711,   712,   712,   712,   712,
     712,   712,   712,   712,   712,   712,   712,   713,   713,   714,
     714,   715,   715,   715,   715,   715,   715,   715,   715,   715,
     715,   715,   715,   715,   715,   715,   715,   716,   716,   717,
     717,   718,   719,   719,   720,   720,   720,   720,   720,   721,
     721,   722,   722,   722,   722,   723,   723,   723,   723,   723,
     723,   723,   723,   723,   723,   723,   723,   723,   723,   723,
     723,   724,   724,   725,   725,   726,   726,   727,   727,   728,
     729,   730,   730,   731,   731,   732,   732,   733,   734,   734,
     735,   735,   735,   736,   736,   736,   737,   737,   737,   737,
     738,   738,   739,   739,   740,   740,   741,   741,   742,   742,
     743,   743,   744,   744,   744,   745,   745,   746,   746,   747,
     747,   747,   748,   748,   748,   749,   749,   749,   750,   750,
     751,   751,   752,   752,   753,   753,   754,   754,   755,   755,
     755,   755,   755,   756,   756,   756,   756,   756,   757,   758,
     759,   759,   759,   760,   760,   760,   761,   762,   762,   762,
     762,   763,   763,   764,   764,   765,   765,   765,   765,   765,
     765,   765,   765,   765,   765,   765,   765,   765,   765,   765,
     765,   766,   766,   766,   766,   766,   767,   767,   768,   768,
     769,   769,   770,   771,   771,   772,   773,   773,   774,   774,
     775,   775,   776,   776,   777,   777,   778,   778,   778,   778,
     779,   779,   780,   781,   781,   782,   782,   783,   783,   783,
     784,   784,   784,   785,   786,   786,   787,   788,   788,   788,
     788,   789,   790,   790,   790,   790,   791,   791,   792,   792,
     792,   793,   793,   794,   795,   795,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   796,   796,   796,   796,   796,   796,
     796,   796,   796,   796,   797,   797,   798,   798,   799,   799,
     799,   799,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   801,   802,   802,   803,
     803,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     805,   806,   806,   806,   807,   807,   808,   808,   808,   808,
     808,   809,   809,   810,   810,   810,   810,   811,   811,   811,
     812,   812,   813,   814,   814,   815,   816,   816,   817,   817,
     817,   817,   817,   817,   817,   817,   817,   817,   817,   817,
     817,   817,   818,   818,   818,   819,   819,   819,   819,   819,
     820,   820,   820,   821,   821,   822,   822,   822,   822,   823,
     823,   823,   823,   824,   825,   826,   826,   827,   827,   828,
     828,   828,   829,   829,   829,   829,   829,   829,   829,   830,
     830,   831,   831,   831,   832,   833,   833,   834,   834,   835,
     836,   836,   836,   836,   836,   836,   836,   837,   837,   838,
     839,   839,   839,   839,   839,   839,   840,   840,   841,   842,
     842,   842,   843,   843,   844,   844,   844,   844,   844,   845,
     845,   846,   846,   846,   846,   846,   847,   847,   848,   848,
     849,   849,   850,   850,   851,   851,   852,   852,   853,   853,
     853,   853,   854,   854,   854,   854,   854,   854,   854,   854,
     854,   855,   855,   856,   857,   857,   858,   858,   858,   859,
     860,   860,   861,   861,   861,   861,   862,   862,   863,   863,
     864,   864,   864,   864,   865,   866,   866,   867,   867,   867,
     868,   868,   869,   870,   870,   870,   871,   871,   871,   872,
     872,   873,   874,   874,   875,   876,   876,   877,   877,   877,
     877,   877,   877,   877,   877,   878,   878,   879,   879,   879,
     880,   881,   881,   882,   882,   883,   884,   884,   885,   886,
     886,   887,   888,   889,   889,   889,   889,   889,   890,   890,
     890,   891,   891,   892,   892,   893,   893,   893,   893,   893,
     893,   893,   893,   894,   894,   895,   895,   895,   895,   895,
     895,   895,   896,   896,   896,   897,   897,   898,   899,   899,
     900,   900,   901,   901,   901,   901,   901,   901,   901,   901,
     901,   902,   902,   903,   903,   903,   904,   904,   905,   905,
     906,   906,   907,   908,   908,   909,   909,   910,   910,   910,
     910,   911,   911,   912,   912,   912,   913,   913,   914,   914,
     915,   916,   916,   916,   917,   918,   918,   919,   919,   920,
     920,   921,   921,   922,   922,   922,   922,   922,   923,   924,
     925,   926,   927,   927,   928,   928,   929,   929,   930,   930,
     931,   932,   932,   932,   932,   933,   933,   934,   934,   935,
     935,   936,   936,   937,   937,   937,   937,   937,   937,   937,
     937,   938,   938,   938,   938,   938,   938,   939,   939,   939,
     939,   940,   940,   941,   941,   941,   941,   941,   942,   942,
     942,   942,   943,   943,   944,   944,   945,   945,   945,   945,
     946,   946,   947,   947,   947,   948,   949,   949,   950,   950,
     951,   952,   952,   953,   953,   954,   954,   955,   955,   956,
     956,   956,   957,   957,   958,   958,   959,   960,   960,   960,
     960,   960,   960,   961,   961,   961,   962,   962,   962,   962,
     962,   962,   962,   963,   963,   963,   963,   964,   964,   965,
     965,   966,   966,   966,   966,   966,   966,   966,   966,   966,
     966,   966,   967,   967,   968,   968,   969,   969,   970,   971,
     972,   972,   973,   973,   974,   975,   976,   976,   976,   976,
     976,   976,   977,   977,   978,   978,   979,   979,   979,   979,
     980,   981,   981,   981,   982,   982,   982,   982,   982,   982,
     982,   982,   982,   982,   982,   982,   982,   982,   983,   983,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   985,   985,   985,   985,   985,   985,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   986,   986,
     986,   986,   986,   986,   986,   986,   986,   986,   986,   986,
     986,   986,   987,   987,   987,   987,   987,   987,   987,   988,
     988,   989,   989,   990,   990,   990,   990,   990,   990,   990,
     990,   990,   990,   990,   990,   990,   990,   990,   990,   990,
     990,   990,   990,   990,   990,   990,   990,   990,   990,   990,
     990,   990,   990,   990,   990,   990,   990,   990,   990,   990,
     990,   990,   990,   990,   990,   991,   991,   992,   992,   992,
     992,   993,   994,   994,   995,   995,   996,   996,   997,   997,
     997,   998,   998,   998,   998,   999,   999,  1000,  1000,  1001,
    1001,  1002,  1002,  1003,  1004,  1004,  1004,  1005,  1006,  1006,
    1007,  1007,  1008,  1008,  1008,  1009,  1009,  1010,  1010,  1010,
    1010,  1010,  1011,  1011,  1011,  1012,  1012,  1013,  1014,  1014,
    1014,  1015,  1015,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1017,  1017,  1018,  1018,  1019,
    1019,  1019,  1019,  1019,  1019,  1020,  1020,  1021,  1021,  1022,
    1022,  1022,  1023,  1023,  1024,  1024,  1024,  1025,  1025,  1026,
    1026,  1027,  1027,  1027,  1027,  1027,  1027,  1027,  1027,  1028,
    1028,  1029,  1030,  1030,  1031,  1031,  1031,  1031,  1031,  1031,
    1032,  1033,  1034,  1034,  1034,  1035,  1035,  1036,  1037,  1037,
    1038,  1039,  1039,  1040,  1040,  1041,  1041,  1042,  1042,  1042,
    1042,  1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,  1047,
    1047,  1048,  1048,  1049,  1050,  1050,  1051,  1051,  1052,  1052,
    1052,  1052,  1053,  1053,  1054,  1054,  1055,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1062,  1063,  1063,  1063,  1063,
    1063,  1063,  1063,  1063,  1063,  1063,  1063,  1063,  1063,  1064,
    1065,  1066,  1066,  1066,  1067,  1068,  1068,  1068,  1069,  1069,
    1070,  1070,  1070,  1071,  1071,  1071,  1072,  1072,  1072,  1072,
    1073,  1073,  1073,  1073,  1073,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1077,  1077,  1077
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     4,     3,     5,     3,     5,     5,     6,     1,     1,
       3,     5,     6,     4,     9,     7,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     3,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     5,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     3,     1,     2,     3,     2,
       1,     1,     2,     1,     2,     1,     3,     3,     2,     3,
       4,     3,     2,     4,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     4,     6,    10,    13,     4,     6,
      10,    13,     4,     6,     4,     6,     5,     7,    11,    14,
       1,     3,     2,     5,     3,     6,     4,     6,     6,     6,
       5,     5,     6,     6,     4,     8,     4,     2,     4,     3,
       6,     4,     3,     3,     3,     3,     2,     2,     3,     4,
       4,     3,     3,     3,     3,     3,     3,     4,     4,     3,
       2,     3,     2,     2,     3,     3,     2,     2,     3,     4,
       4,     4,     5,     1,     3,     2,     1,     1,     0,     2,
       0,     2,     0,     1,     1,     1,     3,     3,     2,     0,
       1,     3,     3,     1,     5,     3,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    11,     9,     1,     1,     1,
       0,     1,     1,     1,     1,     3,     2,     0,     1,     1,
       1,     3,     3,     1,     1,     3,     3,     3,     3,     4,
       3,     2,     1,     0,     2,     0,     3,     0,     1,     0,
       1,     3,     2,     1,     1,     1,     3,     0,     1,     3,
       1,    11,    14,    10,    13,     1,     1,     2,     2,     2,
       2,     1,     0,     1,     0,     3,     0,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     4,     4,     2,     0,
       3,     1,     1,     2,     2,     1,     3,     4,     5,     2,
       5,     1,     2,     2,     2,     3,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     3,     1,     5,     7,     3,
       8,     4,     9,    11,     2,     0,     3,     0,     1,     3,
       1,     2,     2,     2,     0,     1,     3,     3,     6,     4,
       0,     1,     1,     2,     2,     0,     3,     3,     2,     1,
       1,     2,     2,     4,     0,     2,     2,     2,     0,     3,
       4,     4,     0,     2,     0,     4,     0,     3,     7,    10,
       5,     2,     3,     0,     8,    11,     4,     1,     0,     6,
       5,     8,     4,     6,     1,     0,     1,     2,     2,     1,
       2,     3,     2,     2,     2,     2,     3,     3,     1,     3,
       1,     0,     1,     2,     1,     1,     3,     6,    10,     1,
       0,     1,     2,     2,     0,     2,     2,     1,     0,     5,
       7,     1,     0,     7,     2,     0,     3,     5,     5,     8,
       2,     0,     2,     2,     2,     1,     5,     2,     0,     2,
       7,    10,     6,     6,     6,     6,     7,     7,     9,     9,
       6,     7,     6,     8,     8,     8,     8,     6,     6,     7,
       7,     8,     6,     9,     6,     7,     2,     2,     2,     2,
       1,     2,     1,     0,     6,     8,     7,     6,     4,     0,
       1,     3,     4,     1,     3,     1,     2,     2,     2,     2,
       1,     1,    10,     2,     0,     2,     2,     1,     0,     4,
       6,     5,     4,     4,    11,    14,     5,     7,    11,     2,
       1,     4,     0,     8,     1,     1,     7,     9,     8,     9,
       8,     6,     8,     4,     0,     5,     0,     2,     0,     2,
       0,     2,     0,     1,     1,     1,     1,     1,     8,    15,
      20,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       3,     0,     1,     1,     1,     1,     2,     0,     0,     2,
       2,     1,     2,     2,     2,     2,     6,     8,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     4,     5,     4,     4,     4,     3,     7,     8,     6,
       6,     6,     6,     6,     4,     5,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     3,
       1,     0,     1,     3,     7,     9,     9,     3,     0,    13,
       1,     3,     5,     6,     4,     7,     2,     1,     0,     2,
       0,     2,     4,     0,     1,     0,     6,     8,     8,     1,
       3,     5,     5,     7,     9,     7,     9,     5,     6,     6,
       4,     4,     6,     4,     6,     5,     7,     1,     1,     1,
       2,     1,     2,     2,     2,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     3,     1,     2,     2,     3,     1,
       3,     5,     2,     2,     0,     6,     6,     6,     7,     7,
       7,     8,     9,     8,     8,     6,     9,     8,     9,     9,
       7,    10,     7,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     3,
       2,     3,     3,     3,     3,     1,     1,     8,     8,     8,
       9,     9,     9,     9,     2,     0,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     2,     3,     2,     2,     2,     5,     5,
       5,     1,     3,     1,     2,     3,     0,     1,     3,     2,
       6,     6,     9,     3,     0,     3,     0,     5,     2,     0,
       3,     3,     3,     7,     7,    10,     1,     1,     1,     1,
      14,    17,     1,     0,     1,     0,     1,     0,     2,     0,
       1,     3,     5,     5,     7,     2,     0,     1,     0,     1,
       1,     0,     2,     2,     0,     9,    12,     7,     2,     0,
       3,     2,     1,     3,     3,     2,     1,     3,     3,     3,
       2,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     4,     5,     1,     3,     3,     1,     3,     3,     5,
       6,     1,     3,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     2,     2,     1,
       2,     2,     2,     2,     1,     1,     1,     3,     3,     5,
       2,     0,     2,     1,     3,     5,     1,     2,     1,     0,
       5,     7,     5,     7,     5,     7,     3,     5,     5,     5,
       1,     3,     2,     1,     2,     1,     2,    11,    10,    10,
       2,     2,     0,     9,     2,     0,    10,    11,    11,     5,
       5,     8,     3,     3,     6,     6,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     5,     7,     6,     6,     6,
       6,     8,     8,     6,     6,     7,     9,     9,     8,    10,
       6,     6,     6,     8,     6,     8,     6,     8,     7,     9,
       6,     8,     7,     9,     8,    10,     9,    11,     8,    10,
       9,    11,     8,     8,     7,     6,     6,     6,     8,     8,
       8,     8,     6,     9,     1,     0,     2,     0,     7,     9,
       8,     7,     7,     6,     6,     6,     6,     6,     7,     9,
       9,     6,     8,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     8,     1,     3,     3,
       3,     7,     6,     6,     6,     6,     6,     7,     7,     7,
       9,     9,     6,     6,     6,     8,     8,     8,     6,     7,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       6,     8,     3,     2,     0,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     2,     5,     4,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     9,    11,    12,    14,     3,
       4,     4,     0,     2,     5,     1,     0,     1,     2,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     5,     4,     6,     4,     3,     5,     4,     4,     6,
       4,     6,     6,     5,     7,     9,     6,     1,     0,     6,
      11,    11,    11,    13,     9,    11,     1,     1,    10,     4,
       2,     5,     2,     0,     4,     5,     5,     4,     6,     1,
       3,     1,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     0,     1,     0,     1,     0,     3,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,     3,     0,
       2,     3,     2,     3,     7,     1,     3,     1,     4,     2,
       1,     3,     2,     8,     5,     0,     4,     3,     0,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     1,     2,     0,
       8,     1,     3,     1,     1,     3,     5,     5,     2,     1,
       3,     7,     1,     0,     3,     2,     2,     2,     0,     2,
       2,     1,     1,     3,     3,     1,     2,     4,     4,     2,
       3,     5,     5,     1,     1,     9,     9,     1,     2,     4,
       4,     4,     2,     2,     3,     1,     3,     6,     1,     0,
       2,     0,     3,     3,     4,     4,     4,     4,     3,     2,
       1,     1,     0,     1,     1,     0,     1,     5,     1,     0,
       1,     0,     3,     1,     3,     4,     3,     2,     2,     1,
       1,     1,     0,     2,     4,     5,     2,     3,     1,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     1,     3,
       0,     1,     3,     1,     1,     1,     1,     1,     2,     4,
       4,     5,     2,     0,     1,     3,     1,     0,     1,     2,
       3,     2,     4,     2,     3,     2,     0,     2,     3,     2,
       0,     1,     3,     2,     3,     2,     3,     2,     3,     1,
       4,     3,     4,     5,     4,     5,     4,     5,     2,     4,
       1,     1,     0,     1,     4,     5,     4,     0,     2,     2,
       2,     1,     1,     0,     4,     2,     1,     2,     2,     4,
       1,     3,     1,     2,     3,     6,     4,     0,     2,     6,
       2,     1,     3,     4,     0,     2,     0,     2,     0,     2,
       4,     0,     1,     0,     1,     3,     3,     2,     3,     5,
       6,     2,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     1,     2,     3,     3,
       0,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     1,     3,     0,     1,     1,     1,     1,     5,     2,
       1,     1,     1,     1,     5,     2,     2,     2,     1,     3,
       3,     2,     1,     0,     3,     0,     5,     2,     5,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     0,     1,     4,
       1,     3,     3,     5,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     3,     3,     2,     2,     3,     5,     4,     6,     3,
       5,     4,     6,     4,     6,     5,     7,     3,     2,     4,
       2,     3,     3,     4,     3,     4,     3,     4,     5,     6,
       6,     7,     6,     7,     6,     7,     3,     4,     4,     6,
       2,     3,     4,     1,     3,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     5,     6,     6,     7,     3,     4,     1,     1,
       2,     4,     1,     1,     1,     2,     2,     2,     2,     1,
       1,     4,     3,     5,     6,     8,     6,     6,     4,     4,
       1,     1,     1,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     7,     2,     3,     3,     3,     4,
       0,     4,     1,     3,     3,     1,     1,     1,     2,     2,
       0,     2,     4,     4,     6,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     2,     2,     0,     1,     4,     2,     2,     2,
       2,     2,     4,     3,     5,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     4,     1,
       4,     1,     2,     1,     2,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     2,     3,     0,     3,     3,     2,     2,     1,     0,
       2,     2,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     0,     1,     2,     0,     2,     1,     0,     1,
       1,     1,     3,     3,     1,     0,     1,     3,     3,     2,
       1,     1,     1,     3,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     6,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1499,  1284,   572,  1369,  1368,  1284,   258,     0,  1371,     0,
    1284,   393,  1019,     0,     0,     0,     0,   572,  1284,     0,
    1499,     0,     0,     0,     0,     0,  1512,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1284,     0,     0,
    1519,     0,     0,     0,     0,  1512,     0,  1373,     0,     0,
       0,     0,     0,     2,     4,    67,    68,    29,    28,    34,
      33,    92,    93,    53,    17,    81,    60,   127,   126,   128,
      40,    36,    75,    25,    27,    37,    41,    62,    43,    54,
     105,    61,    23,    59,    86,    63,    89,    48,    11,    12,
      49,    79,    13,    50,    80,    14,    51,    15,   101,    69,
      94,    32,    58,    22,    85,    42,    65,    91,    66,     5,
      44,    77,    73,    10,    55,    56,    57,    82,    83,    84,
     110,    88,   122,    39,   119,    98,    99,   116,   100,   117,
       8,   102,    52,    16,   113,   112,   114,    76,    45,    78,
      64,    90,   111,    26,   115,    18,    19,    21,    20,   118,
      87,   108,   104,   123,   121,   129,   106,    70,     6,     7,
      95,    24,    47,     9,    31,    30,    46,    38,   125,    35,
    1371,    97,   109,    96,    71,   103,    74,   107,   124,    72,
     120,  1472,  1471,  1521,  1475,  1498,     0,  1487,  1283,  1282,
    1268,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   571,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1294,  2080,  2095,  2096,  2097,  2098,  2099,  2100,
    2101,  2102,   364,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2366,  2367,  2368,  2369,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2370,  2371,  2120,  2121,  2122,  2123,
    2124,  2372,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,
    2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,
    2143,  2144,  2145,  2146,  2373,  2374,  2147,  2148,  2149,  2150,
    2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,
    2171,  2172,  2375,  2173,  2174,  2175,  2376,  2176,  2177,  2178,
    2377,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2378,  2379,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,  2200,  2201,  2202,  2380,  2203,  2204,
    2205,  2206,  2381,  2382,  2383,  2207,  2208,  2209,  2210,  2211,
    2212,  2213,  2214,  2384,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,
    2231,  2232,  2233,  2234,  2385,  2386,  2235,  2236,  2387,  2237,
    2238,  2239,  2388,  2240,  2389,  2241,  2242,  2243,  2244,  2245,
    2246,  2247,  2248,  2390,  2249,  2391,  2250,  2251,  2252,  2253,
    2254,  2255,  2256,  2257,  2258,  2259,  2392,  2260,  2393,  2263,
    2261,  2262,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,
    2394,  2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,  2280,
    2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,
    2291,  2395,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,
    2300,  2301,  2302,  2303,  2304,  2305,  2306,  2396,  2307,  2308,
    2309,  2310,  2397,  2311,  2312,  2313,  2314,  2315,  2316,  2317,
    2318,  2319,  2320,  2321,  2322,  2398,  2323,  2324,  2325,  2326,
    2327,  2328,  2329,  2330,  2399,  2400,  2331,  2332,  2401,  2333,
    2402,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,  2403,  2404,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2413,  2363,  2364,  2365,   363,  1462,  2048,  2081,  2082,  1370,
    1350,   572,     0,  1271,   392,  1499,     0,     0,     0,     0,
       0,     0,     0,     0,   787,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   177,     0,     0,   416,
     415,     0,     0,     0,   992,   421,     0,     0,     0,     0,
       0,   560,  1412,  2261,  1410,  1463,   259,   262,   263,   260,
     261,  2070,     0,  1102,  1103,  1105,     0,     0,     0,  1115,
     825,   826,     0,     0,     0,   828,     0,     0,     0,   821,
       0,     0,     0,     0,     0,     0,   827,   818,     0,   817,
       0,     0,  1115,     0,     0,     0,   819,     0,     0,  1272,
    1409,   422,  1499,     0,  1387,  1388,  1389,  1371,  1378,  1390,
    1383,  1385,  1384,  1386,  1382,  2069,  2096,   930,   930,   930,
     930,   927,   928,   930,   930,   930,  2278,     0,     0,   909,
       0,   911,  2071,   930,   935,   477,   477,   477,     0,   934,
     939,   477,     0,  1265,  1303,  2053,  1511,     0,   910,  1264,
       0,     0,     0,  2331,  1401,     0,     0,  1130,  1126,  1128,
    1129,  1127,     0,     0,     0,  2294,  1276,   241,  2304,  2399,
    2331,   240,   234,   236,   208,  2100,     0,     0,   934,     0,
    1273,  1274,   895,  1518,  1516,     0,  2035,  2118,  2132,  2218,
     231,  2289,  2295,  2304,  2399,  2331,  2362,   187,   197,   192,
       0,   252,  2304,  2399,  2331,   248,  1294,     0,  1488,  1616,
    2044,     0,  1267,  1266,  1372,     0,  1375,     0,  1577,  2274,
    1492,  1495,  1377,  1493,  1484,     0,     0,     1,  1499,  1366,
    1515,  1515,     0,  1515,     0,  1476,  1484,  1479,  1483,     0,
       0,     0,     0,  2080,  2414,  2415,  2416,  2417,  2418,  2419,
    2420,  2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,
    2430,  2431,  2432,  2433,  2434,  2435,  2436,     0,     0,  2054,
    2081,  2085,     0,   835,     0,  1306,  2049,   979,     0,     0,
       0,     0,  2048,     0,     0,     0,     0,  2086,  2076,  2077,
       0,  2074,  2075,  2087,  2088,  2089,     0,  2191,     0,     0,
       0,  1941,  1952,  1953,  1954,  2122,  2176,  1949,  1950,  1951,
    1943,  1944,  1945,  1946,  1947,  1948,     0,  1100,  1942,     0,
    2191,     0,   156,     0,   134,     0,     0,  2191,     0,     0,
       0,     0,     0,  2191,     0,     0,     0,     0,     0,  2223,
       0,   134,  2191,     0,     0,  1288,     0,     0,     0,  1290,
    1293,  1269,  1353,     0,  2044,     0,     0,     0,   872,   864,
       0,   873,   865,     0,     0,   875,     0,     0,   867,     0,
       0,     0,     0,   876,     0,   866,   868,   878,   869,   874,
       0,     0,     0,     0,   870,     0,     0,  1280,     0,  1403,
    1405,  1404,  1402,   477,     0,     0,     0,     0,     0,     0,
     134,  1338,     0,  2191,   134,     0,     0,   420,   419,   134,
    2074,   418,   417,  2122,  2176,     0,  1018,     0,   134,  2191,
       0,   179,   644,   575,     0,     0,   746,  2223,   134,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,   559,
     572,  1413,  1411,     0,  1106,   233,   232,  1104,   823,  2191,
       0,   338,     0,     0,  2191,  1325,  2083,  1674,  1703,  1681,
    1703,  1703,  1670,  1670,  2160,  1683,  2191,  1671,  1672,  1710,
       0,  1703,  1670,  1675,     0,  1673,  1713,  1713,  1698,   338,
     839,  1655,  1656,  1657,  1658,  1684,  1685,  1659,  1690,  1691,
    1705,  1660,  1727,  1670,  2084,   824,     0,   822,  2191,     0,
    2191,  2078,   170,     0,   820,  2122,  2176,  2191,     0,     0,
    2191,     0,  2191,   162,  2191,     0,  2191,   338,  2191,   576,
       0,     0,  2191,     0,  2191,   338,  2191,  2223,   164,     0,
    2191,   338,   833,     0,  1406,     0,  1380,  2403,  1395,     0,
    1391,  1398,  1394,  1499,   930,   929,     0,   930,     0,   930,
       0,   930,     0,   930,     0,     0,     0,   930,  2072,  2073,
     912,     0,   936,     0,     0,   943,   942,   941,     0,     0,
       0,   944,     0,  1620,  1436,     0,  1262,   235,   186,     0,
     247,   246,  1279,     0,     0,     0,   995,  1133,     0,  1131,
    1122,  1123,  1275,   239,   237,     0,     0,     0,     0,     0,
       0,  1281,     0,     0,     0,     0,  2057,  2059,  2060,  1955,
    2025,     0,  2367,  2368,  2369,  2014,     0,  2370,  2371,  2372,
    2416,  1857,  1844,  1853,  1858,  1845,  1847,  1854,  2373,  2374,
    2375,  2376,  2067,  2377,  2378,  2379,  2381,  2382,  2383,  2384,
    1849,  1851,  2385,  2386,     0,  2068,  2388,  2389,  2245,  2391,
    2392,  2394,  2395,  1855,  2397,  2398,  2399,  2400,  2401,  2402,
    2066,     0,  1856,  2404,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,  2413,     0,     0,     0,  2041,     0,  1824,     0,  1663,
    1664,  1686,  1687,  1665,  1692,  1693,  1666,     0,  2040,  1730,
    1906,  1823,  1840,     0,  1829,  1830,     0,  1822,  1818,  1501,
    2036,     0,  1819,  2056,  2058,  2015,  1501,  2034,   200,   254,
       0,   255,  2042,  2304,   188,   230,   202,   229,   203,   201,
       0,  2120,   189,     0,     0,   190,     0,     0,     0,     0,
     251,   249,     0,  1270,     0,  1618,  1617,  2022,     0,  2023,
    2045,   844,  1365,  1363,  1364,  1362,     0,  1359,  1361,  1374,
    1371,  2030,  2029,  2031,     0,  1494,     0,     0,     0,  1474,
    1473,     3,  1377,  1513,  1514,     0,     0,     0,     0,     0,
       0,     0,     0,  1567,  1529,  1530,  1532,  1564,  1568,  1576,
       0,  1480,     0,     0,  1622,     0,  1578,     0,     0,  2055,
       0,     0,     0,     0,   836,     0,     0,     0,  1312,     0,
    1314,  1315,  1316,     0,     0,     0,  1317,  1318,  1306,   243,
    1324,  1322,  1305,  1307,  1320,     0,     0,     0,     0,     0,
       0,     0,  1330,     0,     0,   168,   169,   588,   572,     0,
    2191,     0,     0,     0,     0,     0,  1058,  1065,     0,     0,
       0,     0,     0,     0,     0,     0,  1059,  1057,  1060,   245,
    1069,  1086,  1089,     0,   969,     0,     0,     0,     0,     0,
    1185,     0,     0,     0,  1185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   268,   280,
     333,   552,     0,     0,   554,     0,  2191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   132,   133,
     138,     0,     0,     0,     0,     0,     0,   539,   551,     0,
       0,     0,     0,     0,   548,     0,   134,   272,   532,   536,
       0,     0,     0,   653,   652,  1328,  1327,     0,     0,  1185,
       0,   264,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   356,   357,     0,
       0,     0,   138,   161,     0,     0,     0,   274,     0,     0,
    1289,  1286,  1287,     0,  1292,     0,  1349,     0,   863,     0,
       0,     0,     0,   880,     0,   877,     0,     0,   871,  2122,
    2176,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   395,     0,     0,   743,     0,     0,     0,     0,     0,
     754,     0,  1306,  1337,     0,     0,     0,   581,     0,  2191,
       0,   136,   788,     0,   744,   421,     0,     0,   136,     0,
       0,   173,     0,   648,     0,     0,     0,     0,     0,     0,
     692,   691,     0,     0,     0,   745,     0,   136,     0,  2191,
     535,  2191,     0,   477,   477,     0,     0,   994,   997,     0,
       0,     0,     0,  1466,  1468,  1467,     0,  1465,     0,   338,
     336,   337,   741,  1114,     0,     0,  1702,  1689,  1697,  1696,
       0,  1679,  1678,  1677,     0,  1676,     0,  1703,  1703,  1701,
    1680,  1655,     0,     0,     0,  1709,     0,  1707,     0,   813,
    1651,  1647,     0,     0,  1695,  1716,  1717,  1718,  1715,  1728,
    1714,     0,  1661,  1719,  1670,  1667,     0,     0,   338,     0,
       0,  2191,   338,  2191,     0,  2191,     0,     0,   338,   338,
       0,     0,     0,     0,     0,     0,   649,     0,   832,   830,
     829,   831,     0,     0,     0,     0,   811,     0,     0,     0,
    2191,   338,     0,     0,   810,  1965,     0,     0,  1499,     0,
     219,   220,   218,  1396,   221,  1397,  1393,  1379,     0,   920,
       0,   924,     0,   915,     0,   921,     0,   916,   913,   914,
       0,   919,     0,     0,   478,   480,     0,     0,  2144,  2159,
       0,  2182,  2211,  2212,  2295,  2300,     0,  2326,  2336,     0,
     945,   974,   940,   662,     0,     0,  1446,  1263,  1972,     0,
    1499,     0,     0,     0,     0,   238,   209,     0,     0,     0,
     976,  2294,  1278,   894,   572,     0,  1820,     0,  1827,  1828,
    2013,     0,     0,     0,     0,     0,     0,  1826,  1980,     0,
       0,     0,     0,     0,  1753,     0,     0,     0,  1993,     0,
    1999,     0,     0,  1790,     0,     0,     0,     0,     0,     0,
       0,     0,  1754,  1734,  1735,  1824,  1965,     0,  1825,  2063,
       0,  1727,  2039,  1955,     0,  1952,  1953,  1954,     0,     0,
       0,  2028,     0,  1963,     0,     0,  1768,  1961,  1770,     0,
       0,     0,     0,  1949,  1950,  1951,  1943,  1944,  1945,  1946,
    1947,  1948,  1959,  1750,     0,     0,  1908,     0,  1749,     0,
       0,  1580,     0,  2061,  2016,  1580,   256,   257,   253,     0,
       0,   205,   204,     0,   223,   227,   228,   199,   226,     0,
     222,   207,  1897,  1896,   206,   198,   195,   193,   210,   212,
     213,   196,   194,   250,     0,  2021,     0,  2090,  2437,  2438,
    2439,  2440,  2441,  2442,  2443,  2444,  2445,  2446,  2447,  2448,
    2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,
    2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,
    2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,  2018,  2017,  2051,  2091,  2092,
    2093,  2094,  2024,     0,     0,   338,  1357,     0,  1354,  2033,
       0,  1496,     0,  2046,     0,  1367,  1491,  1490,  1522,  1523,
    1011,  1489,  1547,  1548,  1543,     0,     0,     0,  1573,  1571,
    1539,  1533,  1538,  1536,     0,  1540,  1730,  1566,  1478,  1527,
    1528,  1531,  1477,     0,  1569,     0,  1449,  1567,  1532,  1433,
       0,  1415,     0,  1623,     0,  1033,  1035,     0,  1034,     0,
    1037,     0,  1046,     0,     0,  1032,  1051,     0,  1040,  1038,
       0,     0,     0,     0,     0,     0,   837,     0,     0,     0,
       0,  1313,     0,     0,  2326,   242,  1316,  1321,  1308,  1319,
       0,     0,     0,     0,     0,   978,   977,     0,     0,   999,
       0,     0,     0,  1333,   466,     0,   335,     0,     0,     0,
       0,     0,     0,     0,     0,   739,   736,     0,     0,   735,
       0,   586,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   623,     0,  1185,     0,   656,     0,  1067,     0,     0,
    1066,     0,  1070,     0,     0,  1068,  1063,  1064,  2295,  2304,
    2331,   244,  1088,     0,  1087,  1085,  1021,     0,  1022,     0,
       0,     0,     0,     0,  2169,  2191,   282,   297,     0,  1184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   320,     0,     0,   323,   322,
       0,     0,     0,     0,     0,   327,   306,     0,   307,     0,
       0,   326,     0,     0,   553,     0,     0,     0,     0,  1185,
       0,   276,     0,     0,     0,     0,     0,     0,  1101,     0,
     680,     0,   159,     0,   155,   158,     0,     0,     0,     0,
     538,   550,     0,   542,   543,   540,   544,   545,     0,     0,
       0,     0,     0,     0,   537,     0,     0,   646,   645,   651,
       0,     0,     0,     0,     0,     0,     0,     0,  1135,  1134,
       0,     0,     0,     0,     0,     0,   778,     0,     0,     0,
       0,     0,     0,     0,   665,     0,   664,     0,   160,     0,
       0,     0,     0,     0,     0,     0,   217,  1285,  1291,  1352,
    2052,  1351,     0,     0,     0,     0,   879,     0,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,     0,
       0,     0,     0,     0,   370,     0,     0,     0,  2083,     0,
     767,   742,     0,     0,   755,     0,   757,   760,     0,  1304,
     439,     0,     0,   578,   623,     0,   424,   166,     0,     0,
       0,     0,   682,   131,   177,   179,   422,     0,   178,   180,
     182,   183,   184,   181,   185,   643,   647,     0,   574,     0,
       0,     0,     0,     0,   693,   697,   696,   700,   698,     0,
     694,     0,     0,  1643,     0,   154,     0,     0,   530,   534,
       0,     0,     0,   424,   508,   349,  2191,     0,   477,     0,
    2191,     0,   996,     0,     0,     0,     0,     0,     0,     0,
       0,  1464,     0,  1092,     0,  1326,     0,     0,     0,   338,
    1700,  1699,  1652,  1648,     0,     0,     0,     0,   840,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1668,
    2191,   338,     0,  1090,   171,  2079,     0,   815,     0,     0,
       0,     0,     0,  1094,   807,     0,   338,   163,     0,   338,
     338,   577,     0,     0,   338,   338,   165,     0,     0,     0,
     569,   338,   834,  1408,     0,  2191,   477,  1381,  1392,   917,
     926,   925,   923,   922,   918,     0,   937,     0,   476,     0,
       0,     0,   951,   952,     0,     0,   950,   967,   953,     0,
     955,   947,   946,   956,   957,     0,     0,   976,   660,     0,
       0,     0,     0,  1443,     0,  1441,     0,  1621,  1445,  1434,
    1400,     0,  1399,     0,   523,     0,     0,  1132,     0,     0,
     934,     0,     0,   338,  1277,     0,   896,   897,     0,     0,
       0,     0,     0,     0,   903,   900,   901,   902,   904,     0,
     905,     0,     0,     0,  2026,  1976,     0,  1977,     0,     0,
    2012,  2008,     0,     0,     0,     0,     0,  1981,  1984,  1985,
    1986,  1983,  1987,  1982,     0,     0,  1988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2395,     0,     0,     0,
       0,  1793,     0,     0,  1936,     0,  1965,  1998,     0,     0,
       0,     0,     0,     0,  1965,  2004,     0,     0,     0,     0,
    1895,     0,  1892,     0,     0,     0,     0,  2025,     0,     0,
    2064,  1731,  1745,  1746,  1747,  1751,  2038,     0,  2027,     0,
       0,  1732,  1759,     0,  2005,  1786,     0,  1791,  1774,     0,
    1767,     0,  1772,  1776,  1755,     0,  1752,     0,  2028,  1964,
       0,  1962,     0,  1742,  1743,  1744,  1736,  1737,  1738,  1739,
    1740,  1741,  1748,  1940,  1938,  1939,     0,     0,     0,  1916,
       0,     0,  1771,  2184,  2218,     0,  1512,  1512,  1512,  1500,
    1510,  2037,     0,  1638,     0,     0,     0,     0,  1832,     0,
    1969,  1521,  1967,  1038,  1638,  2043,     0,     0,  1727,     0,
    1619,  2019,  2022,   842,   843,   841,  1377,  1360,  1356,  1355,
    2032,  1376,     0,  1499,     0,  1009,  1010,     0,  1014,     0,
       0,  1541,  1574,     0,  1565,     0,  1545,  1546,  1537,  1575,
    1447,     0,  1570,  1482,  1481,     0,  1641,     0,     0,  1425,
    1417,     0,  1624,     0,  1580,  1451,  1453,  1454,     0,  2025,
    1036,     0,  1670,  1047,     0,  1031,     0,  1030,  1670,     0,
    1048,     0,  1670,     0,     0,     0,  1222,  1137,  1193,   838,
    1223,  1138,  1194,  1224,  1139,  1323,  1311,  1310,  1309,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   718,  2191,   338,  1331,  1225,     0,  1140,
     334,  1332,  1195,  1336,   738,   737,     0,     0,  1196,     0,
     587,     0,     0,   592,   593,   594,     0,     0,     0,   595,
       0,  2122,  2176,     0,   600,   607,   612,   602,     0,     0,
     614,   608,     0,     0,     0,     0,     0,     0,   620,   627,
       0,     0,     0,     0,     0,     0,     0,  1061,  1062,  1226,
    1143,     0,  1197,  1020,     0,  1144,   167,     0,     0,   269,
    2191,   284,     0,   629,   718,  1187,   304,     0,     0,   319,
     314,   315,   313,  2191,   338,  2191,   338,     0,     0,     0,
       0,     0,   316,   311,   312,   308,     0,     0,   321,  2099,
    2161,  2305,     0,   633,   635,     0,   640,   324,  1160,   345,
     344,   343,     0,   328,     0,   350,   353,   325,   302,   305,
     303,   299,   281,     0,     0,     0,     0,     0,     0,     0,
       0,  2050,     0,     0,  1096,     0,     0,     0,     0,     0,
       0,     0,   674,   157,  1175,   147,     0,     0,   143,     0,
       0,     0,     0,   137,     0,  1232,  1150,     0,     0,   273,
     533,   541,   546,  1154,   549,  1207,   547,  1238,  1151,     0,
    1185,     0,   265,     0,  1152,     0,  1201,  1234,  1177,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1339,     0,
       0,     0,     0,     0,     0,   338,     0,     0,     0,  1187,
    2191,   338,  1233,     0,  1182,  1215,     0,   358,     0,  1176,
       0,     0,   275,  1156,  1209,     0,     0,   215,   214,   216,
       0,     0,  2159,     0,   886,   847,   885,     0,     0,     0,
       0,     0,     0,   855,     0,     0,     0,   846,     0,   845,
     369,     0,   394,   367,   368,   370,     0,     0,   766,     0,
       0,     0,   756,     0,     0,     0,  1329,     0,   134,   585,
       0,     0,     0,   580,   622,   629,     0,     0,     0,   423,
     427,   431,   432,   433,     0,     0,     0,     0,   148,   135,
       0,   796,     0,   477,     0,   678,     0,   179,   172,     0,
       0,     0,   349,   753,   751,   750,   752,     0,     0,     0,
     771,   749,     0,  1642,  1644,     0,     0,     0,     0,     0,
     523,   426,     0,   480,     0,     0,   512,     0,     0,     0,
       0,   349,     0,     0,     0,  1025,     0,  1043,  1026,     0,
       0,     0,     0,  1074,  1081,  1075,  1053,     0,     0,   557,
    1469,  1470,     0,   338,     0,     0,  1669,  1682,   814,     0,
    1712,  1711,  1713,  1713,     0,  1653,     0,  1704,  1705,  1721,
    1722,  1723,  1724,  1725,  1726,     0,  1720,  1662,     0,   624,
     338,   338,     0,   338,     0,   338,   338,     0,   671,     0,
    1260,   650,     0,     0,   726,   812,     0,     0,   338,   809,
    1966,     0,   938,   479,     0,     0,     0,     0,   949,     0,
     555,   954,     0,   966,   961,   963,     0,   970,   659,     0,
       0,  1444,  1437,  1439,  1438,     0,     0,  1435,  1973,   808,
       0,   529,  1124,  1125,     0,     0,   338,     0,   971,     0,
       0,   898,   899,     0,     0,   906,     0,     0,     0,  1517,
    1974,  1975,     0,     0,     0,  2009,     0,     0,  1870,     0,
    1846,  1848,  1860,     0,  1871,  1831,  1872,  1850,  1852,     0,
    1956,     0,     0,  1861,     0,  1795,  1796,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,  1810,  1862,  1935,     0,     0,
    1996,  1997,  1863,     0,     0,  2003,     0,     0,     0,  1868,
    1873,     0,     0,     0,     0,  1879,     0,  1900,     0,     0,
       0,  1821,  1966,     0,     0,     0,     0,     0,     0,     0,
       0,  1792,  1775,  1769,     0,  1773,  1777,     0,     0,     0,
    1763,     0,     0,  1761,  1787,  1757,     0,     0,  1788,     0,
       0,     0,  1839,     0,     0,  1512,  1512,  1512,  1512,  1509,
       0,     0,     0,     0,  2292,     0,  1602,  1579,  1581,  1589,
    1602,  1607,  1841,  1636,  1842,     0,  2044,     0,  1550,  1521,
    1521,  1521,  1838,     0,     0,     0,     0,  1520,  1550,   191,
       0,   224,   211,  2021,     0,  1358,  2047,     0,  1524,     0,
    1957,  1014,     0,  1526,     0,     0,  1572,  1534,  1448,  1432,
       0,  1430,  1419,     0,  1420,  2025,     0,  1430,  1416,  1459,
       0,     0,  1641,     0,  1458,     0,  1670,  1028,  1029,     0,
    1052,     0,  1221,  1136,  1192,   981,   982,     0,   980,     0,
       0,     0,   465,   998,     0,     0,     0,   718,     0,     0,
     469,     0,  1334,     0,  1239,  1174,   589,   590,     0,   601,
       0,   610,   609,     0,     0,   597,     0,     0,     0,     0,
       0,   596,   616,   561,   617,   619,     0,     0,   618,   621,
     626,  1185,     0,   657,  1162,     0,  1213,  1055,  1188,     0,
    1023,     0,     0,     0,     0,     0,     0,   439,   298,     0,
       0,     0,   286,   296,     0,  1191,   330,     0,   301,     0,
     294,   317,   309,   318,   310,   329,   331,     0,   637,   638,
     636,   632,     0,   639,   641,     0,   347,     0,     0,     0,
    1228,     0,  1185,     0,   277,     0,  1158,     0,  1211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,  1198,     0,  1217,     0,     0,     0,   679,     0,   676,
       0,     0,   140,   139,     0,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   359,   340,     0,   774,     0,     0,     0,
     361,     0,     0,     0,     0,  1227,  1145,   848,     0,     0,
       0,   849,   860,     0,     0,   850,     0,     0,     0,     0,
     862,   372,   373,   134,   371,     0,     0,  2245,  1943,  1944,
     764,   769,   761,   763,   765,   762,     0,   768,   718,     0,
     758,   759,     0,     0,     0,     0,     0,   451,     0,     0,
     445,     0,     0,  1081,   438,   441,   442,     0,     0,   581,
     584,   582,   583,   615,     0,   458,   504,     0,   150,     0,
       0,   151,   149,     0,     0,   349,   683,   687,   685,   684,
     686,   681,     0,   674,     0,   175,   422,     0,     0,   573,
     699,   702,   695,     0,   770,   772,   747,     0,   629,     0,
     535,     0,   477,  1409,   518,     0,   508,   504,   506,   505,
     507,     0,   514,   348,     0,     0,   523,   514,     0,     0,
     999,  1024,     0,     0,     0,  1071,  1076,  1072,     0,     0,
    1039,     0,  1073,     0,  1054,  1017,  1255,  1256,  1253,  1254,
       0,     0,     0,  1461,  1093,     0,  1688,     0,  1708,  1706,
    1649,  1654,  1694,  1729,   338,  1091,   816,     0,   803,     0,
     805,  1095,   338,   338,   338,   338,   666,     0,   570,     0,
       0,     0,     0,   948,   968,     0,   964,     0,     0,   931,
     973,     0,     0,  1442,  1440,   521,     0,   976,     0,   932,
     975,     0,     0,     0,     0,     0,     0,     0,  1978,     0,
    2011,  2007,     0,  1843,  1979,     0,  1991,  1990,  1936,     0,
       0,  1794,  1806,  1807,  1808,  1992,     0,  1816,     0,     0,
    1803,  1804,  1805,  1797,  1798,  1799,  1800,  1801,  1802,  1809,
    2001,  2000,  1994,  1995,     0,  1865,  1866,  1867,  2002,  1874,
       0,  2113,  1901,  1878,  1894,  1893,     0,     0,     0,  1881,
       0,     0,  1890,     0,  1937,  2065,  1733,     0,     0,  1760,
    2006,  1778,     0,     0,     0,  1756,  1956,     0,     0,     0,
       0,     0,  1765,     0,     0,     0,  1919,  1914,  1915,  1933,
       0,     0,     0,     0,     0,     0,  1503,  1502,  1508,  1602,
    1607,     0,  1484,     0,  1589,     0,  1601,  1587,  1600,     0,
       0,  1613,  1611,     0,  1613,     0,  1613,     0,  1583,     0,
    1603,  1585,  1600,     0,  1628,     0,  2045,  1637,     0,  1563,
       0,     0,     0,     0,  1970,  1971,     0,  1968,  1833,  1563,
       0,  2020,  1497,     0,  1525,  1012,  1013,  1542,  1535,  2140,
    1639,     0,  1431,     0,     0,  1422,  1428,  1414,     0,     0,
    1452,  1430,  1455,  1049,     0,     0,  1041,   987,   988,   986,
     989,     0,     0,     0,   718,     0,     0,   485,     0,  1006,
    1006,     0,     0,   471,   517,  1081,   721,     0,     0,     0,
     719,   338,  1141,     0,   611,     0,     0,   606,   604,   603,
     605,     0,   562,  1237,  1142,     0,     0,     0,     0,  1056,
       0,     0,  1161,     0,   283,     0,   436,     0,   291,  1186,
       0,     0,     0,   290,     0,   338,   338,   332,   634,   346,
     351,   352,   355,     0,     0,     0,     0,     0,  1190,     0,
       0,     0,     0,     0,     0,     0,   797,   780,     0,     0,
     798,   799,     0,     0,     0,  1098,  1099,  1097,  1216,     0,
       0,     0,  1148,     0,     0,   670,   144,   141,   142,   145,
    1172,  1155,  1208,     0,     0,     0,  1153,     0,  1202,  1168,
    1164,     0,     0,     0,     0,     0,  1236,  1181,  1206,  1235,
    1179,  1204,  1178,  1203,  1180,  1205,     0,  1173,     0,  1646,
     777,     0,     0,     0,   338,   338,   668,  1157,  1210,     0,
       0,   851,     0,     0,   853,   854,     0,   857,   377,   397,
     688,   740,     0,     0,   717,     0,   443,     0,   449,   453,
     454,   452,   444,  1081,   477,   516,     0,     0,   730,     0,
     579,   424,   455,     0,     0,   428,   153,   152,     0,     0,
       0,   677,   676,   179,  2191,     0,     0,   704,   708,   748,
       0,  1645,   663,   349,   531,     0,     0,   424,   523,     0,
     429,   434,   435,     0,   512,   508,     0,     0,   520,  1302,
       0,   524,   526,     0,     0,     0,  1027,  1044,  1045,     0,
       0,  1081,     0,     0,  1080,     0,     0,   564,   338,  1650,
     625,   338,   338,   672,  1261,  1121,   727,     0,   960,   959,
     958,   556,     0,   962,   661,     0,   522,   338,     0,     0,
     908,   889,   907,     0,     0,   888,     0,   887,  2010,  1859,
    1869,  1989,  1935,  1966,     0,     0,  1817,     0,     0,  1864,
    2405,     0,     0,     0,     0,  1898,  1899,  1880,     0,  2236,
    1885,     0,     0,     0,  1784,  1782,  1779,     0,  1780,  1764,
       0,     0,  1762,  1758,     0,  1789,  1905,     0,  1921,  1918,
    1932,  1966,  1507,  1506,  1505,  1504,  1588,  1586,     0,  1591,
    1598,     0,  1582,     0,  1612,  1608,     0,  1609,     0,     0,
    1610,     0,     0,  1584,     0,  1598,     0,  1635,  1521,     0,
       0,  1910,  1836,  1837,  1834,  1521,  2062,  1910,   225,     0,
       0,  1429,  1418,  1421,     0,     0,     0,     0,  1460,  1450,
    1042,  1050,     0,     0,     0,   467,     0,  1081,     0,     0,
       0,  1008,  1008,     0,  1081,   516,   723,   722,   725,   720,
     724,  1335,     0,   598,   599,   613,  1163,     0,  1214,  1170,
       0,  1446,   285,     0,   630,   287,   288,   289,   292,   340,
     300,   293,     0,     0,     0,  1159,     0,  1212,  1166,  1230,
    1146,  1199,     0,     0,   786,     0,     0,     0,     0,  1231,
    1147,  1200,  1218,  1219,  1220,     0,     0,     0,     0,  1446,
       0,     0,     0,     0,     0,  1344,     0,  1189,   339,   776,
     775,   340,   360,  1183,     0,   852,   858,   859,   856,     0,
     366,   374,   398,   134,     0,     0,  1112,  1112,     0,   718,
       0,     0,   440,   516,   484,     0,   446,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   669,
     174,     0,   424,   629,   703,     0,     0,     0,   773,     0,
     523,   426,     0,  1407,   425,     0,     0,   514,   512,     0,
     509,     0,   513,     0,  1295,     0,     0,     0,     0,  1077,
       0,  1083,     0,  1038,  1015,  1078,     0,  1638,     0,     0,
       0,     0,   568,  1113,   804,   806,   667,   965,     0,   972,
     338,   890,   891,   892,   893,  1937,  1812,     0,     0,     0,
       0,  1875,     0,  1876,  1903,  1902,  1882,  1886,     0,  1883,
    1884,  1781,  1785,  1783,  1766,  1907,     0,  1521,  1934,  1631,
       0,  1634,  1590,     0,     0,  1592,     0,     0,  1594,  1596,
       0,     0,     0,     0,     0,     0,  2048,     0,  2139,  2379,
    2291,     0,  1549,  1551,  1554,  1556,  1555,  1557,  1553,  1562,
       0,  1486,     0,  1485,  1958,  1640,     0,     0,  1000,     0,
       0,  1457,  1456,   966,     0,   338,  1006,   516,   486,  2245,
     487,  1005,  1007,  1011,  1011,     0,   516,   718,   591,     0,
       0,   270,   628,     0,   342,   354,     0,  1446,     0,     0,
       0,   793,   781,     0,     0,   800,  1149,   673,     0,     0,
     266,  1169,  1165,  1346,  1347,     0,     0,     0,     0,     0,
     338,   861,     0,   400,   407,   378,   383,  1338,     0,  1338,
       0,   380,   384,  1338,   379,  1338,   376,   377,     0,  1112,
       0,  1109,  1108,   716,     0,   475,   447,     0,   495,     0,
       0,   731,     0,     0,   504,   464,   463,   460,   459,   461,
     462,   457,   456,     0,   629,   790,   349,  1302,     0,   642,
     705,   706,   701,     0,     0,     0,   519,   508,   504,   430,
     439,   413,   514,   510,   511,     0,     0,     0,   523,  1348,
     999,     0,  1082,     0,     0,     0,     0,     0,     0,  1116,
     563,     0,     0,   567,   558,   629,   933,  1813,     0,  1814,
       0,     0,     0,  1888,  1887,     0,  1924,  1636,     0,     0,
    1630,     0,  1599,  1615,     0,  1595,  1593,     0,  1604,     0,
    1606,  1833,     0,     0,     0,  1558,     0,  1909,  1911,     0,
    1835,  1427,  1638,     0,  1424,     0,   983,     0,   984,  1008,
     490,     0,  1014,  1014,   477,   718,   468,  1171,     0,   631,
       0,   295,     0,   278,  1167,     0,   784,     0,   795,   793,
       0,     0,     0,     0,  1340,     0,  1341,  1342,  1345,   362,
     375,     0,   405,     0,   403,   402,   404,     0,   391,     0,
       0,     0,     0,     0,     0,   365,   396,  1107,  1111,  1110,
       0,     0,   448,   481,   482,   483,     0,   450,   491,   492,
       0,   728,     0,   733,     0,     0,   503,   654,     0,     0,
       0,  1296,     0,     0,     0,  1302,   512,   508,   437,   411,
       0,  1299,     0,   525,     0,   349,  1081,  1084,  1079,  1259,
       0,     0,   566,   565,   658,  1815,  1891,  1877,  1904,  1889,
    1920,     0,     0,     0,  1629,  1632,     0,  1597,     0,     0,
    1605,     0,     0,     0,  1552,     0,     0,  1426,  1001,     0,
       0,  1011,     0,   718,     0,  1003,  1002,   484,   470,  1446,
     341,     0,     0,     0,   791,   794,   782,   795,   802,   801,
     675,  1446,     0,   401,   410,     0,   408,   381,   386,     0,
     390,   388,   387,   382,   385,     0,   474,     0,     0,     0,
     493,     0,   494,   515,     0,   732,     0,     0,   789,     0,
       0,   424,   707,     0,  1297,   514,   512,  1300,  1301,     0,
     514,  1016,  1258,  1257,  1499,     0,     0,  2366,  2140,  2338,
       0,  1922,  1925,  1923,  1917,     0,  1614,  1627,  1560,     0,
    1559,  1912,  1913,  1638,   338,  1014,     0,   472,   488,   495,
     271,  1446,     0,     0,   783,   267,  1343,   406,     0,   389,
     708,   500,     0,   499,     0,   497,   496,   729,   734,   629,
     779,  1302,   711,   414,   514,     0,  1638,  1241,  1499,  1240,
    1242,  1250,  1247,  1249,  1248,  1246,  1119,  1120,     0,  1929,
    1928,  1927,  1931,  1930,  1633,     0,  1625,  1561,  1423,   985,
    1004,     0,   718,   279,   785,   792,   409,     0,   498,   502,
     501,   655,  1298,   713,     0,   709,   712,   714,   715,   412,
     349,   990,     0,  1251,  1245,  1484,  1471,     0,     0,     0,
       0,   489,   473,     0,   689,     0,   514,  1243,  1499,     0,
       0,  1926,     0,     0,   710,  1638,  1244,     0,     0,  1626,
       0,   991,     0,     0,   711,     0,     0,     0,  1117,  1118,
     690
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    52,    53,    54,    55,  1440,  2307,  2194,  3028,  3029,
      56,    57,  1436,    58,    59,    60,    61,    62,    63,    64,
    1368,    65,    66,   960,  1561,  2318,    67,  2045,   738,   739,
     740,  1867,  1868,  2257,  1869,  1857,  1256,  1694,  1389,   712,
     713,  1350,  1390,    69,    70,  1250,  1848,    71,    72,    73,
    1418,  1419,  1362,  1602,  4029,  4681,  2863,  2171,  3068,  2864,
    2865,    74,  1487,  1488,    75,    76,  2995,  2991,  3563,  4340,
    4341,  4556,   556,  2286,  4343,  4344,  4542,  4543,  4705,  4815,
    4816,  2319,  1556,  3062,  3646,  3019,  4099,  3020,  4100,  3021,
    4101,  3006,  3594,  3595,  3596,  3022,  4072,  4581,  3023,  2064,
    4722,  2354,  1716,  1714,  4568,  3906,  3907,  4793,  4727,  4728,
    4729,  4895,  4074,  3066,  3652,  4108,  4356,  2753,   644,  1582,
    3171,   645,  2357,   588,   646,  2320,    82,  2348,  2349,  1459,
    2202,  3570,  3151,    83,   980,  3412,  4412,  4623,  4624,    84,
     221,    85,  1565,    86,    87,  2303,  3013,    88,  2081,  2770,
      89,    90,  2798,  2799,  2800,    91,    92,  3437,  4283,  1420,
    2852,  2853,  2854,  2855,  3463,    93,  1563,  1464,  2327,    94,
      95,    96,    97,    98,  2470,  2471,    99,  2245,   100,   101,
     102,   103,   104,  3499,  3995,  3623,  2892,  3035,  3621,   105,
    2321,  1573,  2339,  2340,  4088,  4375,  4592,  4377,  4944,  4945,
    4349,  3390,  3920,   107,   108,  4067,  4068,  4734,   109,  2079,
     110,   111,   112,  1540,  2295,  2296,  3571,  1534,  2289,  2290,
    3633,  3634,   113,  2948,   114,  3976,  3977,   589,  4739,  4688,
    4806,   115,   116,  3980,  3981,   117,   118,   119,   120,   121,
     638,  1071,  1072,  1334,  1019,   122,  1965,   123,   926,  2975,
     124,  1144,  2512,  4151,   125,   669,  1085,  1086,  2322,   127,
     678,  2490,   680,  1729,  3153,  3154,  3719,  2456,   825,   128,
     129,  2467,  2493,   130,  1355,  2055,  2056,  3901,  2323,   590,
    1588,  2361,  2748,  4487,  4488,  4261,  4503,  2678,  3343,   132,
     591,  1394,  2127,  2364,  3076,  2022,  2023,  2024,  3669,  2025,
    3078,  2026,  1328,  2027,  3084,  3085,  3086,  3665,  3672,  3675,
    4401,  4402,   133,  1392,  2125,   134,   135,   136,  1431,   856,
     137,   603,   604,   138,  4561,   139,   993,   140,  4410,   141,
     142,   703,   704,  1128,  1129,   143,   144,  2141,  3444,   145,
     146,   147,  3492,  3493,   148,   149,  4909,  4952,  4953,  4954,
    3680,  4854,   150,  4911,  1116,   152,   153,   154,   190,   889,
     890,   891,  2324,  4394,   156,   157,  1351,  1352,  1353,  1354,
    2050,   158,   159,   160,   161,   162,   163,  1544,   164,   165,
    4535,   166,   167,  1506,   168,  1286,  1287,   169,   170,   550,
     756,  1290,  1298,   171,   648,  1079,  1080,  1081,  1696,   172,
    1124,   928,   649,  1074,   174,   650,  2010,  2699,  3353,  3354,
    3357,  4246,  3882,   651,  2696,   177,  1736,  2476,  2479,  2692,
     652,  2704,  2705,  2706,  2707,  2708,  3360,   653,   671,   983,
    2370,   654,  1217,   182,   183,   184,   766,   760,   761,   186,
    1841,  2639,   687,  1305,   725,   726,   774,  3327,  1978,  1979,
    2001,  2002,  1314,  1315,  1991,  1993,  2680,  1994,  2688,  1984,
    3859,  4472,  4473,  4474,  4475,  4476,  4477,  4231,  1997,  1998,
    1317,  1318,  1319,  2006,   187,  2643,  3307,  3308,  3309,  3836,
    3837,  3851,  3847,  4215,  4458,  3310,  1114,  1325,  4223,  4926,
    3311,  4449,  4450,  4640,  3854,  3318,  3351,  3052,  3053,  3054,
    2028,  1631,  1021,  1218,  1022,  1645,  1219,  1615,  1024,  1220,
    1221,  1222,  1027,  1223,  1224,  1225,  1030,  1607,  1634,  1226,
    1227,  1625,  1642,  1643,  1685,  2550,  1229,  1230,  1231,  3313,
    1232,  3792,  4182,  4171,  2571,  2572,  1864,  3788,  3253,  1836,
    2629,  4481,  4657,  4658,  3292,  3817,  4198,  4447,  4773,  4861,
    4862,  1233,  1234,  1235,  2626,  1832,   858,  1236,  3573,  1834,
    2565,  2651,  2652,  1739,  1759,  2518,  2534,  2535,  2545,  3212,
    2553,  2558,  3240,  3241,  2566,  2595,  1237,  2520,  2521,  3196,
    1761,  1238,  1279,  1876,  1280,  1756,  2590,  1293,  1294,   758,
    1246,  1239,  1240,  1730,   749,  4454,   545,   815,  2880,  1956,
     893,   684,  1241,  1242,  1243,  1244,  1424,   830,  1041,  1042,
     546,   809,   832,  2856,   547,   548,   811,  1961
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -4498
static const int yypact[] =
{
    3868,     9, 11062, -4498, -4498,     9, -4498, 63467,   -12,   154,
    1019,   161, 11885, 63902, 70862,   199,   366, 12007,     9, 70862,
    1190, 48677, 60422,   272, 70862,   849,   498, 48677, 70862,  1463,
   71297,   778,   758,   129, 71732, 64337, 59117,  1071, 70862,   993,
    1242, 72167, 64772,   734, 65207,   498, 45207,    91,   823, 72602,
   70862,  1807,  1352,   968, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
     -12, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498,  1723, -4498,   841,  1782,  1273,   884,  1128, -4498, -4498,
   -4498, 56942, 70862, 70862, 70862,  1354, 70862,  1272, 70862,   386,
   56942, 52592, 65642,  1442,  1362, 41721, 73037, -4498, 51287, 70862,
   70862, 73472, 70862,  1516, 61727, 70862,  1382, 70862, 70862, 53027,
   73907,  1581,   915, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   70862, 12498,   849, -4498, -4498,  1807, 70862,  1580, 56942, 70862,
    1344, 70862,  1477, 70862, -4498, 70862,  1501, 74342,   415,  1300,
   52592,  1729, 42157,  1614, 70862, 52592, 74777, 70862, 70862, -4498,
   -4498,  1630, 70862, 70862, -4498,  1707, 53462,  1405,  1743,  1912,
    1821,   964, -4498, 66077, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, 56072,   366, -4498, -4498,  1781, 57377, 70862,  1864,
   -4498, -4498, 75212, 90389,  1669, -4498,   416, 57812, 53897,  1980,
    1651, 42593,  2032, 75647, 54332, 76082, -4498, -4498, 76517, -4498,
   76952,  1758,  1864, 77387, 90812, 54767, -4498,  1884, 77822, -4498,
    1652,  1286,  1052, 37773, -4498, -4498, -4498,   -12, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498,   309,  1353,   248,   205,
     252, -4498, -4498,   208,   210,   213,   309,  2128,  2128, -4498,
   70862, -4498, -4498,  1353,    37,  1666,  1666,  1666,  1881,  1030,
   -4498,  1666,  1819, -4498, -4498, -4498, -4498, 65207, -4498,  1693,
   66512, 70862, 66947,   849,  1701,  2104,  1760, -4498, -4498, -4498,
   -4498, -4498,  1755, 70862, 70862, 70862, -4498, -4498,  2129,  1747,
    1979,  1756, -4498, -4498, -4498,  1934,  1944,  1942,   133,   849,
    1858, -4498,  2064, -4498,  1985, 27502, 27502,   849, 67382, 78257,
     240, 56072,   849, 67817,  1839,  1155,  1990, -4498, -4498, -4498,
     681, -4498,  2212,  1851,  2055,  1756,   915, 39086, -4498,  1842,
    1401, 65207, -4498, -4498, -4498,   353,  2148, 27954, -4498, 70862,
    1852, -4498,  1874,  1852,  1891,  1906,  1273, -4498,  3868, 70862,
    1257,  1257,  2259,  1257,  1716,  1732, -4498,  1877, -4498,  2173,
    2139, 65207,   823,   201, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,  1914,  1401, -4498,
     241, -4498,  1174,  1913,  1258,  3041, -4498, -4498,   761, 70862,
    2046,   197,    25,  1955, 68252,  6313,  1954, -4498, -4498, -4498,
    2108,   978, -4498, -4498, -4498, -4498,  2248,  2288,  5603,   303,
   68687, -4498, -4498, -4498, -4498, 70862, 70862, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498,  1996, -4498, -4498,  1988,
    2309,  2196,  2280,  2152,  1205,  2216,   694,  2338,  6386,   913,
   66512, 70862,  2305,  2358,  5912,  1389,   247,  2249,   872,  2356,
    2217,  1566,  2401,  7004, 70862, -4498,  2343,  2468,    78, -4498,
     244, -4498,  2184,  2325,   689,  2357, 56942,  2137, -4498, -4498,
   70862, -4498, -4498, 91235,  2211, -4498,   440, 56942, -4498,  2339,
    2189, 43029, 70862, -4498, 70862, -4498, -4498, -4498, -4498, -4498,
    2266,  2448, 70862, 91235, -4498,  2399, 70862, -4498,  2153, -4498,
   -4498, -4498, -4498,  1666, 70862,  2155,  2546, 91235,   145, 70862,
     -10,  2578, 70862,  2368,   -10,  2195, 78692, -4498, -4498,   -10,
   -4498, -4498, -4498, 70862, 70862,  2172,  1560,  2370,   -10,  2391,
    2596,  2600,  2258,  2373,   788,  1393,   182,  2494,   -10,  2237,
   79127, 79562, 70862,  2241, 70862,  2579, 56942, 70862,  2503, -4498,
    2364, -4498, -4498,   300, -4498, -4498, -4498, -4498, -4498,  2517,
    1914,   225,  2519,  2210,  2523, -4498, -4498, -4498,  2257, -4498,
    2257,  2257,  2214,  2214,  2382,  2218,  2529, -4498, -4498, -4498,
    1541,  2257,  2214, -4498, 92081, -4498,  1281,  1315, -4498,   163,
   -4498,  2646, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
     150, -4498,  1018,  1662, -4498, -4498,  2260, -4498,  2539,  1954,
    2540, -4498,  2226, 79997, -4498, 80432, 80867,  2543,  1996, 52592,
    2544,  2427,  2547,  2226,  2552,  2428,  2553,   225,  2554, -4498,
     800,  2549,  2559,  2444,  2563,   163,  2564,  1643,  2226, 56507,
    2565,   167, -4498, 29762, -4498,  2345, -4498,   823, -4498,  1459,
   -4498, 47807, -4498,  1052,  1353, -4498, 70862,  1353, 70862,  1353,
   70862,  1353, 70862,  1353, 70862, 70862, 70862,  1353, -4498, -4498,
   -4498, 70862,  2265, 70862, 70862, -4498, -4498, -4498, 60857, 52592,
   61292, -4498, 70862, -4498,    89,   849, -4498, -4498, -4498,     0,
   -4498,  1756, -4498, 91235,  2679, 52592,  2579, -4498,  1524, -4498,
   -4498, -4498, -4498, -4498, -4498,  2507, 70862,  2570,  2573, 60857,
   52592, -4498, 81302, 56072,  2469,  2274, -4498, -4498, -4498, -4498,
   -4498,  1677,  2725,   324,  2726, 29762,  2281,   312,   312,  2282,
    2580, -4498, -4498, -4498,   285,  2283,  2284, -4498,   237,   237,
    2285,  2286, -4498,   270,  2289,  2290,  2737,  2740,   274,  2292,
    2294,  2295,  1541,   312, 29762, -4498,  2298,   237,  2306,  2307,
    2311,  2754,  2312, -4498,  2758,  2313,   335,   340,  2314,  2315,
   -4498,  2285, -4498,   238,  2316,  2318,  2319,  2320,  2321,  2322,
    2323,  2324, 29762, 29762, 29762, -4498, 26146,  1401,   849, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,   276,  4980, -4498,
    2359, -4498, -4498,  2509, -4498, -4498, 29762, -4498, -4498,    62,
   -4498,   277, -4498, -4498, -4498,  1401,  2582,  2326, -4498, -4498,
    1283,  2327, -4498,  1808, -4498, -4498, -4498, -4498, -4498, -4498,
   55202,  2748, -4498,   781,   849,   244,  1121,  2694, 46937, 47372,
   -4498, -4498,  2571, -4498, 70862, -4498, -4498, 29762, 44772, -4498,
    1401,   120, -4498, -4498, -4498, -4498,  1562, -4498, -4498, -4498,
     -12, -4498, 11322, -4498,  1564,  1852, 70862, 70862,  2753, -4498,
   -4498, -4498,  1874, -4498, -4498,  1273,  1273, 29762,  1273,  1028,
    1267, 28406, 29762,  2635,  2532,  1193,  1120,  2637, -4498,  2536,
    1716,  1732, 65207, 70862, 81737,  2453, -4498, 45642,  1317,  1401,
    2417,  2418,  2470, 49547,  2340,  2424,  2425,  2476, -4498,  2588,
   -4498, -4498,  2430,  2501,  2439, 82172, -4498, -4498,   961, -4498,
   -4498, -4498,   961, -4498,  2375,  1014,   906,   266,  2442,   239,
     212,  2739, -4498,  1325,  2493, -4498, -4498, -4498,  5972, 70862,
    2687,  8039,  2572,   303,  2575,  2504, -4498, -4498,  2624,  2463,
   70862,  2464,  2591,   303,   308, 82607, -4498, -4498, -4498, -4498,
   -4498, -4498,  5490, 24848, -4498,  2467,  2446,  2477, 70862, 58247,
     776,  2587,  2590,  1251,  1703,   202,  2524, 70862,  1369,  2597,
   70862,  2400,  2478,  2479,  2683,  2404,  1725,  2778,  2402, -4498,
   -4498, -4498,  1900,  2592, -4498,  2681,  2723,  7433,  2480,  2484,
   89543,   896, 43465, 70862, 70862,  2764,  1367,  2491, -4498, -4498,
   -4498,  1367, 70862,  2499,  2510, 70862,   303, -4498,  2818,   303,
     303,  1374,  2826,  2514,   464,  1309,   -10,  2402,  1579, -4498,
    2515,  2518,   259, -4498,  2622, -4498, -4498,  2525, 65207,   250,
    1588,  2402,  2522,  2531,  2404,  2404, 70862, 70862, 70862, 70862,
   70862,   170,  2855,  2859,  2533,   200,  2581,  2454, -4498, 51722,
    2534, 78257, -4498, -4498, 70862,  2537,  1825,  2402,  1458,  1402,
   -4498, -4498, -4498,   915, -4498, 70862, -4498, 70862, -4498,  1914,
   91235,  2653,  2713, -4498,  2497, -4498,  1954,   303, -4498, 70862,
   70862,  1996,  2656,  1416,   904, 91235,  2659,  2720, 70862,  2724,
    2548,  2508,  2541, 46072, -4498,  2172,  2481,  2895, 70862, 49547,
   -4498,  2907,   961, -4498, 91235,  2673,  2792, -4498, 70862,  2690,
    2486, -4498,  2838,  2551, -4498, -4498,    59, 70862, -4498,  2806,
   52592,   325,   849,  2538, 52592,  2728, 70862, 70862, 70862, 70862,
   -4498, -4498,  2697,   809,   224, -4498, 51722, -4498, 70862,  2709,
    1579,  2710,  2922,    70,  1666, 83042,  2805, -4498, 83477,  2513,
    2929, 91235,  2760, -4498,  1803, -4498,  2640, -4498, 56942,   225,
   -4498, -4498, -4498, -4498, 91235, 70862, -4498,  2516, -4498, -4498,
   29762, -4498, -4498, -4498,  2128, -4498, 91235,  2257,  2257, -4498,
   -4498,  2937,  2598,  2599,  2128, -4498,  2128, -4498, 91235, -4498,
    2526,  2527,  2636,  2128, -4498,  2605,  2606,  2607, -4498,  2535,
    2608,  2128, -4498, -4498,  1787, -4498, 83912, 56942,   225, 52592,
   52592,  2844,   167,  2845,  2593,  2853,  2601, 43465,   225,   181,
   70862, 70862, 52592, 70862, 70862, 70862, -4498, 70862, -4498, -4498,
   -4498, -4498, 91235, 70862, 70862, 91235, -4498, 52592, 51722,  2856,
    2858,   225, 70862, 70862, -4498, 11322,  1569, 84347,  1052, 55637,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, 70862, -4498,
   70862, -4498, 70862, -4498, 70862, -4498, 70862, -4498, -4498, -4498,
   70862, -4498, 70862,  1583, -4498, -4498,  1589,   134, 70862, 70862,
     693, 56942, 70862,  2747, 70862, 70862, 70862, 70862, 70862,  2626,
    2327,   560, -4498,  1322,   203, 65207,  2756, -4498, -4498,  1607,
    1807,  1085, 70862,   931,  1755, -4498, -4498, 61292, 60422,  2851,
      79, 70862, -4498, -4498,  3877, 29762,  1401, 27050, -4498, -4498,
   11322,  2603, 29762, 29762,  2557,  2128,  2128, -4498,   858, 29762,
   29762, 29762,  2128,  2128,  2997, 29762, 43465, 29762, 32926, 23066,
   29762, 29762, 26598, -4498, 29762,  2777, 34276, 29762,  1121,  2781,
   29762,  1121,  2997,  3005,  3005,  1233,  4294,  2566,  1401, -4498,
    2128,   844, -4498,   223, 91235, 29762, 29762, 29762, 29762, 49547,
    2647,   185, 70862, 29762,  2569,  1697, -4498, 29762, -4498,  2574,
   29762,  2648,   221, 29762, 29762, 29762, 29762, 29762, 29762, 29762,
   29762, 29762, -4498, 35150,   232,  2860,  2880,    22,   379, 69122,
   27502,  2873, 22160, -4498,   288,  2873, -4498, -4498, -4498, 70862,
    2748, -4498, -4498,  2654, -4498, -4498, -4498, -4498, -4498,   289,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,  2577, -4498, -4498,
   -4498, -4498,  2577, -4498,  2583,  7203,  2586, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498,  2867,  2874,   225, 70862,   353, 62162, -4498,
   27954, -4498,  1618, -4498,  2595, -4498,  2849, -4498,  2594, -4498,
    8992,  2849, -4498, -4498,   189,  2707,  2847,  2790, -4498, -4498,
   -4498,  2602, 11322, -4498,  1577, 11322,  1786, -4498, -4498, -4498,
   -4498, -4498, -4498,  1139, -4498, 70862,   893,  2635,  1120,  2657,
     851,  3019, 70862, -4498, 39523,  2788, -4498,  3006, -4498, 92081,
   -4498,  2604, -4498, 91658, 88262, -4498, -4498,   550, -4498,  1022,
    2684,  2685,  2741, 52592, 70862, 70862, -4498, 49547, 52592, 70862,
   70862, -4498, 52592, 70862, 70862, -4498, -4498, -4498, -4498, -4498,
   48242,    47, 60422,  2745, 59552, -4498, -4498,  2614, 70862,  2674,
    2869,  2870,   -15, -4498, -4498, 84782, -4498,  2827, 52592, 70862,
   70862, 29762,  2832, 70862, 70862, -4498,   437,  2700,  2714, -4498,
   70862,  2719, 56942,  2630, 70862, 70862, 91235,  2704,   656, 56942,
    2686, 43901, 70862, 70862, 70862, 70862,  2767,  2945, 91235, 70862,
    2893,  1239, 65207,   345,  1829,  2402,  2852, -4498,  2958,   704,
   -4498, 52592, -4498, 70862,  2854, -4498, -4498, -4498, 69557,  3062,
    2768, -4498, -4498, 85217, -4498, -4498, -4498,  1628, -4498, 52592,
   52592, 70862,  9340, 85652,   729,  2877, -4498, -4498, 91235, -4498,
   70862, 70862, 70862,  2969,  2900, 70862, 62597, 86087, 86522,  1196,
    1268,  2908, 70862, 63032,  2909, -4498,  2802, 70862, -4498, -4498,
   49982, 52592, 70862,   284, 49547, -4498, -4498, 70862, -4498,  2868,
     273, -4498, 70862,  8868, -4498,  2751,  2762, 70862,  2875,   346,
    1841,  2402, 70862, 70862,  2671,  1638,  2757,    53, -4498,  2876,
      63, 70862, -4498, 52592,   471, -4498,  2831, 52592, 70862,  9905,
   -4498, -4498,   303, -4498, -4498, -4498, -4498, -4498, 70862, 70862,
     303, 70862,   303,  1380, -4498, 52592, 70862, -4498, -4498, -4498,
   70862,  9385, 70862, 70862, 70862, 70862, 52592, 70862, -4498, -4498,
    1264,   975,  1489,  1515,   735, 70862,  2962, 70862, 86957, 52592,
   70862, 70862, 70862,  1573, -4498,  2816, -4498, 52592,   471,  9600,
   70862, 70862,  2783,  2784,   195,  2863, -4498, -4498, -4498, -4498,
   -4498, -4498,  2952,  3120, 87392,   263, -4498,  2956,  2961,  2765,
    2766,  2965, 70862,   263, 70862, -4498, -4498, -4498, -4498,  2966,
   70862,   263,  2973,   263,  2883,  2905,   142,  2992,  2738,  1672,
   -4498, -4498, 29762, 91235, -4498,  1684, -4498,  2744,   809, -4498,
   -4498, 49547, 70862,   178,   126,  3038, 58682,   963,  3028, 70862,
    2771, 70862,  3030,   963, 70862, -4498,  1452, 60422, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,  3032, -4498,   849,
    2172,  2172,  2172,  2172, -4498, -4498, -4498, -4498,  2934,  1711,
   -4498,  2743,  2172, 70862,  2857,   963,  2749,  3049, -4498,  1579,
    3050,   897, 70862, 58682,  1863,  2774,  2949,  3163,  1666,   849,
    2955,  2942, -4498, 25271,  8433,  2944,  2998, 56072,  3033,  3036,
    3055, -4498,  1914, -4498,  3175, -4498, 29762,  1690,  2761,   163,
   -4498, -4498,  2759,  2527,  2775,  2776,  2763,  2769, -4498,  2128,
     184, 70862,  2770,  1223,   696,  2884,  2128,  2981,  2772, -4498,
    3077,   225,  1954, -4498,  2226, -4498, 70862, -4498, 70862, 70862,
   70862, 70862,  1996, -4498, -4498,  2963,   225,  2226,  2968,   225,
     225, -4498,  3013,  2970,   225,   163,  2226,  2892,  3078, 56072,
   -4498,   167, -4498, -4498, 29762,  2985,  1666, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498,  1706, -4498, 70862, -4498,  3052,
    3053,  3054,  2779,  2782,  2813, 70862,  2785, -4498,  2779,   303,
    2779,  2327,  2327,  2779,  2782, 52157,  3216,  3076, -4498,  2865,
    2791,  3089,   697, -4498,   699,   834,  3015, -4498, -4498, -4498,
   -4498, 91235, -4498, 52592,  2833, 70862, 70862, -4498,   143,  2993,
    2796, 52157,  3203,   225, -4498, 56942, -4498, -4498, 91235,  2878,
    2891, 56942,  3003,  2864, -4498, -4498, -4498, -4498, -4498, 91235,
   -4498,  3058, 70862,  1708, -4498, -4498,  1530, -4498,  1540, 29762,
     207, -4498,  9880,  1712, 29762,  2808,  2812, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498,  2820,  3118, -4498,  1741,  1746,  1751,
    2824,  2828,  2701,  2829,  9945,  2830,  2843, 32926, 32926, 26146,
    2174, -4498, 32926,  2837,  3007,  1753,  9315,  2840,  2848, 10266,
   28858, 29762, 28858, 28858, 10473,  2840,  2861,  1759, 49547,  3002,
   10863,  1761, -4498, 29762, 49547,  3357, 29762, -4498, 29762,  2862,
   -4498, -4498,  5433,  5433,  5433,  2997, -4498,  2850, -4498, 32926,
   32926, -4498,  1517, 26146, -4498, -4498,  3127, -4498, -4498,  1544,
   -4498,  2866, -4498, -4498,  2092, 43465,  4331, 29762,   227, 29762,
    2569, 29762,  2925,  5433,  5433,  5433,   352,   352,   190,   190,
     190,  1762,   379, -4498, -4498, -4498,  2871,  2887,  2889,  3029,
    2894, 29762, -4498,  1930,  2040, 70862,  2433,  2663,  2872, -4498,
   -4498, -4498, 36025,  2888, 29762, 29762, 29762,  2897, -4498,  1855,
   11322,   114, -4498,   292,  2888, -4498,   915,  2128,   844, 47807,
   -4498, -4498, 29762, -4498, -4498, -4498,  1874, -4498, -4498, -4498,
   -4498, -4498, 70862,  1807, 29762, -4498, -4498,  3072,  2879, 29762,
    1577, -4498, -4498,  2910, -4498, 29762, -4498, -4498, -4498,  2327,
   -4498,  3080, -4498, -4498, -4498, 36025,  2896,  2903, 38648,  3051,
   -4498, 70862, -4498, 70862,   151, -4498, -4498, -4498,  2901, -4498,
   -4498, 88262,  1662, -4498, 91658, -4498, 91658, -4498,  1662,  3258,
   -4498, 88262,  1466, 52592, 70862, 70862, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498, 52592,
   52592,  3059, 70862,  3060,  3061, 29762,   835, 70862,  2899,  2902,
    1067,  3130, 70862, -4498,  3184,   225, -4498, -4498,  2972, -4498,
   11322, -4498, -4498, -4498, -4498, -4498, 52592, 70862, -4498, 56072,
   -4498,  1914, 91235, -4498, -4498, -4498, 70862,  2923, 70862, -4498,
   70862, 70862, 70862,  1996, -4498, -4498, -4498, -4498,  1004, 91235,
   -4498, -4498, 70862, 70862,   628,  2977,  2980, 70862, -4498,  1062,
    2622, 10164, 70862, 70862, 70862,  3153, 70862, -4498, -4498, -4498,
   -4498,  3096, -4498, -4498, 88262, -4498,  2226,   861,  2982,  2402,
    3104, -4498,  3218,  3094, -4498,  1079, -4498, 70862,  3031, -4498,
   -4498, -4498, -4498,  3220,   225,  3224,   225, 70862, 70862, 70862,
   70862,  3035, -4498, -4498, -4498, -4498,  3037,  3154, -4498, 49547,
   49547, 49547,  1774, -4498, -4498,   849, -4498, -4498, -4498, -4498,
   -4498, -4498,  3187, -4498,  1775, -4498,  1046, -4498, -4498, -4498,
   -4498, -4498, -4498, 52592, 70862, 10496,  3231, 70862, 70862, 70862,
    1400, -4498,  1015, 91235, -4498, 89966, 52592, 70862, 49547, 70862,
    2999, 52592,  2978, -4498, -4498, -4498,  3159,  3099, -4498,   278,
    3100, 52592,  2986, -4498,  3008, -4498, -4498,  3009,  1895,  2402,
    1579, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,   901,
     383,  1923,  2402,  3011, -4498,  3017, -4498, -4498, -4498,  3156,
    3167,  3170,  3022,  3023,  3073,  3027,  3039,  3079, -4498,  3040,
    3081,  3042,  3086,  3145,  3043,   225, 91235,  3160,   849,  3068,
    3280,   225, -4498,  3046, -4498, -4498,  3383, -4498, 70862, -4498,
    3048,  1966,  2402, -4498, -4498, 52592, 70862, -4498, -4498, -4498,
     263, 91235, 70862,  3226, -4498, -4498, -4498,   263,   263, 70862,
   70862,   263,  3228, -4498,  3229, 70862,  3230, -4498,   263, -4498,
   -4498,   222, -4498, -4498, -4498,  2883,  3257, 41285, -4498,  3430,
    5155,  2979, -4498, 49547, 41285,  1734,  1724,   118,   -10, -4498,
   56072, 70862, 56072, -4498,   126,  3094, 70862, 70862,  2994,  2983,
   -4498, -4498, -4498, -4498, 52592,   715, 52592,  2128, -4498, -4498,
    3064, -4498, 70862,  1666,   394,  3071,  3394,  2600,   325,  3125,
    1620,  3351,  2774, -4498, -4498, -4498, -4498, 70862, 70862,   809,
     849, -4498,  3000,  2996, -4498, 70862, 70862, 70862, 70862, 70862,
    2833,  3004,  3010, 91235,    46,  3198,  3199,  2404,  3427,  3321,
    1807,  2774,  3090,  3324, 70862, -4498,  1784,   125, -4498,   849,
   56072, 88685,  3316, -4498,  8225, -4498, -4498,   677, 70862,  3303,
   -4498, -4498,  1807,   225, 91235,  1800, -4498, -4498, -4498,  2128,
   -4498, -4498,  1343,  1343,  3020, -4498,  3021, -4498,  3413, -4498,
   -4498, -4498, -4498, -4498, -4498,  3026, -4498, -4498, 70862, -4498,
     225,   167,  3082,   225,  3083,   225,   225, 70862, -4498, 70862,
   -4498, -4498, 70862, 70862, -4498, -4498, 70862, 51722,   225, -4498,
   11322,  3335, -4498, -4498,  3150,  3158,  3161, 70862,  2779, 56942,
   -4498,  3034, 52592,   771, -4498, -4498,  3234, -4498, -4498, 65207,
    3157, -4498, -4498, -4498, -4498,  3363,  3364, -4498, -4498, -4498,
     255, -4498, -4498, -4498, 52592, 60857,   254, 52592, -4498,  1914,
    3304, -4498, -4498,  1954,   303, -4498,  3308, 70862,  3309, -4498,
   -4498, -4498,  3075, 10976, 29762, -4498,  3372, 91235, -4498,  5567,
   -4498, -4498, -4498, 29762, -4498, -4498, -4498, -4498, -4498, 29762,
   -4498, 29762,  3365, -4498, 23519,  3512,  3512,  3067, 91235, 32926,
   32926, 32926, 32926,  1306,  2306, 32926, 32926, 32926, 32926, 32926,
   32926, 32926, 32926, 32926, 33830,   466, -4498,  3259, 29762, 29762,
    3375,  3365, -4498, 91235,  3087,  2840,  3091,  3092, 29762, -4498,
   -4498,  1816, 34713,  3093, 49547, -4498, 29762,  9333,  1817,  3121,
   11067,  1401,  5637,   849, 29762,  2496,  4557, 29762,  1822, 29762,
    3376, -4498, -4498, -4498,  3097, -4498, -4498, 91235, 29762,  3098,
    2662, 32926, 32926,  2823, -4498,  3410, 29762, 26146, -4498,  3265,
    3128, 39960, -4498, 23972,  3105,   498,   498,   498,   498, -4498,
   70862, 70862, 70862, 36462,  3378, 35587, 69992,  3106,  1856, -4498,
   69992, 70427, -4498,  3115, -4498,  3102,  1401, 29762,  3390,   709,
     709,  3265, -4498, 29762, 29762, 29310,  3110, -4498,  3390,   244,
    3111, -4498, -4498, 11322,  3114, -4498, -4498,  3113, -4498,  3117,
   -4498,  2879,   231, -4498,  5689,  3311, -4498, -4498, -4498,  3106,
   30214,  3252, -4498,  1823, -4498, -4498,  3494,  3252, -4498, -4498,
    1835, 39523,  2896, 27954,  1401,  1857,  1486, -4498, -4498, 88262,
   -4498,  3188, -4498, -4498, -4498,  2226,  2226,   986,  2779,  3422,
     986,  5979, -4498, -4498, 36899, 70862, 70862, -4498, 70862,  1862,
    1440, 70862, -4498, 70862, -4498, -4498, -4498, -4498,  3542, -4498,
   70862, -4498, -4498,  3178,  3179, -4498, 70862, 70862, 70862, 70862,
    3373, -4498, -4498,  1913, -4498, -4498, 52592, 70862, -4498, -4498,
   -4498,   380,  2208,  2402, -4498,  3205, -4498, -4498, -4498,  3388,
   -4498,  3531,  3215, 70862,  3443, 70862,  3133, -4498,  1440,   775,
    2404,   863, -4498, -4498,  3201, -4498, -4498, 70862, -4498, 70862,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,  3260, -4498, -4498,
   -4498, -4498, 49982, -4498, -4498, 70862, -4498, 49547, 41285, 49547,
   -4498,  1117,   387,  2271,  2402, 70862, -4498,  3212, -4498,  3213,
    3217,  3268,   953,   937,  3221,  3222,  3269,  3146,  3147,  3148,
   -4498, -4498,  1866, -4498,  3162,  3290, 70862,  2226,  3164,  3185,
     309,   849, -4498, -4498,   849,  2226,   849, 70862, 70862, 70862,
    3555,  3239, 70862, 70862, 70862, 70862, 70862, 70862,  3456,   721,
    1700, 52592, 70862, 70862, 52592, 70862, 70862, 70862, 70862, 70862,
   70862,  3467, 70862, -4498,  3543,  3470,  1680,  3513,  3227, 70862,
   -4498, 70862,  2622, 70862, 70862, -4498, -4498, -4498,  3165,  3414,
     263, -4498, -4498,  3415,  3419, -4498,   263,   263,  3423,   263,
   -4498, -4498, -4498,   -10, -4498,   222, 70862,  3117,  2128,  1900,
   -4498, -4498, -4498, -4498, -4498, -4498,  2738, -4498, -4498,  2114,
   -4498, -4498, 70862,  3172, 70862, 70862, 32926, -4498,  1340,   265,
   -4498,  3424, 70862,  3209, -4498, -4498, -4498,  3334, 70862, -4498,
   -4498, -4498, -4498, -4498,  3177, -4498,  3446, 58682,  2226, 52592,
   52592,  2226, -4498, 91235,  3180,  2774, -4498, -4498, -4498, -4498,
   -4498, -4498, 52592,  2978, 52592,   325,   838, 87827,  3214, -4498,
    3181,  3481, -4498,  3186,  3189, -4498, -4498, 70862,  3094,  1867,
    1579,  3601,   600,  1652, -4498, 59987,  1863,  3446, -4498, -4498,
   -4498,  3570,  3277, -4498,  1807, 70862,  2833,  3277,   849, 70862,
    2674, -4498, 88262, 29762, 29762, -4498,  3190, -4498,  3195,  8746,
   -4498,  3263,  3193,  2172, -4498, -4498, -4498, -4498, -4498, -4498,
    3275,  3200, 70862, -4498, -4498,  3202, -4498,  3206, -4498, -4498,
   -4498, -4498, -4498, -4498,   225, -4498, -4498, 70862, -4498, 70862,
   -4498, -4498,   225,   225,   225,   225, -4498,  3323, -4498, 70862,
   70862, 70862, 70862,  2779, -4498,   303, -4498,  3497, 52157, -4498,
   -4498,  1875, 70862, -4498, -4498, -4498,  3556,    79,  3503, -4498,
   -4498,  3461,   311,  3462,  3464,   311,  3465,   311, -4498, 29762,
   11322, -4498,  3219, -4498, 11322,  6030, 11322,  3375, -4498,  1882,
   29762, -4498,  2890,  2890,  2890,  4364,  3509, -4498,  1064,  3232,
    2890,  2890,  2890,   397,   397,   191,   191,   191,  3512,   466,
   11322, 11322, -4498, -4498,  3225, -4498, -4498, -4498,  2840, -4498,
   30666,  3366,  3619, -4498, -4498, -4498,  3256,  3264,  3235, -4498,
   29762, 31118,  3233, 92081,  3404, -4498,  1605, 29762, 29762,  4444,
   -4498,  5304, 29762, 91235,  1883,  4444,   243, 29762,  4635,  5243,
   29762, 29762,  3698,  6333,  3237, 29762, 89108, -4498, -4498, -4498,
    1890, 29762, 70862, 70862, 70862, 70862, -4498, -4498, -4498, 69992,
   70427,  3240, 24410,  1856,  3238, 70862, -4498, -4498,  3241, 36025,
    3471,  3416, -4498, 36025,  3416,  1375,  3416,  3477,  3315, 40397,
   -4498, -4498,  3242,  3417, -4498, 22160,  1473, 11322,  3637,  3527,
   29762,  3243,  3245,  3246, 11322, 11322, 29762, -4498,   849,  3527,
     849, -4498, -4498, 43465, -4498, -4498, -4498, -4498, -4498,  3447,
   11322, 27502, -4498,  1807, 70862,  1401,    67, -4498,  3261, 70862,
   -4498,  3252, -4498, -4498,  3318,  1892, -4498, -4498, -4498, -4498,
   -4498,  3330, 60422,  3551, -4498, 29762,  1901, -4498,  3292,  3642,
     146,  1905,  1933,  1440, -4498,  3209, -4498,  1396,  3528,   192,
   -4498,   225, -4498, 91235, -4498, 70862, 70862, -4498, -4498, -4498,
   -4498, 70862,  2340, -4498, -4498, 70862, 70862, 70862, 70862, -4498,
   52592, 70862, -4498, 70862, -4498, 49547,  1724,  3466, -4498, -4498,
    3469,   309, 70862, -4498, 91235,   225,   225, -4498, -4498, -4498,
   -4498, -4498,  3270,  3663,  3355, 70862, 70862, 70862, -4498, 70862,
   52592, 70862, 70862,  2128,  2128, 91235,  3267, -4498,  2128,  2128,
    3271, -4498, 52592, 70862, 70862, -4498, -4498, -4498, -4498, 49547,
   40837,  3350, -4498, 29762,  3664, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, 52592, 70862,  3353, -4498,  3356, -4498, -4498,
   -4498, 70862, 70862, 70862, 70862,  3593, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, 70862, -4498, 70862, -4498,
   -4498,   849,   849, 91235,   225,   225, -4498, -4498, -4498,  3535,
     263, -4498,   263,   263, -4498, -4498,   263, -4498,  3285,   362,
   -4498,  1440,  1670,  3580,  3583, 29762, -4498,  1009,  4364, -4498,
   -4498, -4498, -4498,  3209,  1666,  3345, 56942,   855, -4498,  3568,
     178, 58682,  1238,  3298,  3425, -4498,  2226,  2226,  3359, 70862,
    3725,  2226,  3185, -4498,  3515,   612, 70862,  3635,  3349, -4498,
     849, -4498, -4498,  2774, -4498,  1807, 70862, 58682,  2833,  1935,
   -4498, -4498, -4498,  3346,  3199,  1863,   847, 70862, -4498,  3347,
    3732, -4498, -4498,  3611,  3511,  3319, -4498, 11322, 11322,   849,
   92504,  8225, 91235,  3618, -4498, 70862,   228,  3586,   225, -4498,
   -4498,   225,   225, -4498, -4498, -4498, -4498, 70862,  2779,  2779,
    2779, -4498,  3514, -4498, -4498,  3578, -4498,   225, 52157,   311,
   -4498, -4498, -4498,   311,   311, -4498,   311, -4498, 11322, -4498,
   -4498, -4498, -4498,  6353, 32926,  3620, -4498,  3326, 91235, -4498,
    3327,  1939,  1940, 34276,  3478, -4498, -4498, -4498,  6707,  3379,
   11322,  3433,  3328,  3332,  4444,  4444,  5304,  1941, -4498,  4444,
   29762, 29762,  4444,  4444, 29762, -4498, -4498,  6993,  3510, -4498,
   -4498,  7315, -4498, -4498, -4498, -4498, -4498, -4498, 50417, 69992,
    3336, 70862,  1856, 36025, -4498, -4498,  1698, -4498, 36025,  3587,
   -4498, 36025, 56942, -4498, 70862,  3337, 70862, -4498,   114, 31570,
   29762,  3391, -4498, -4498, -4498,  3265, -4498,  3391, -4498,  3338,
   70862,  2326, -4498, -4498,  3713, 36899,  3674,  3354, -4498, -4498,
   -4498, -4498, 52157,  3541, 52157,  1440,  7788,  3209, 36899, 44337,
   70862, 70862, 70862,  3506,  3209,  3345, -4498, -4498, -4498, -4498,
   -4498, -4498,  3358, -4498, -4498, -4498, -4498,  3435, -4498, -4498,
     555,  2756, -4498,  1945, -4498, -4498, -4498, -4498, -4498,  3543,
   -4498, -4498, 41285, 52592, 70862, -4498,  3437, -4498, -4498, -4498,
   -4498, -4498, 38211, 43465, -4498,   953,  3370,  3371,   937, -4498,
   -4498, -4498, -4498, -4498, -4498, 70862,  7878,  3374,   865,  2756,
   70862, 70862,   -24,  1101,  1445,  2779,  3672, -4498, -4498, -4498,
   -4498,  3543, -4498, -4498,   263, -4498, -4498, -4498, -4498, 49547,
   -4498,  3381, -4498,   -10,  3701, 56942,  3783,  3783, 70862, -4498,
    8182,  3576, -4498,  3345,  3600,  3646, -4498,  3377, 70862,  3537,
    3380,  3382,   807,   807, 70862, 70862, 70862,  1946,  1807, -4498,
     325,  3694, 58682,  3094, -4498,  1370,  3384,  3702, -4498,  3804,
    2833,  3004,  3389, -4498, -4498, 59987,  3582,  3277,  3199,  3522,
   -4498,  3524, -4498,  1098, -4498,  1807, 70862, 70862, 36899, -4498,
   91658, -4498,  1947, -4498, -4498, -4498,  3463,  2888,  3500,  3518,
    3406, 70862,   653, -4498, -4498, -4498, -4498, -4498, 70862, -4498,
     254, -4498, -4498, -4498, -4498, -4498,  4625, 32926, 91235,  1959,
   29762, -4498, 29762, -4498,  3810, -4498, -4498, -4498,   740, -4498,
   -4498, -4498,  4444,  4444,  4444, -4498,  3811,  3265, -4498, -4498,
    1961,  3829, -4498, 70862,  1967, -4498, 29762,  3411, -4498, -4498,
   36025,  1698,  3412,  1969, 70862,  1976, 91235,  3420,  3418,    18,
    3426, 22613,  3429, -4498, -4498, -4498, -4498, -4498, 11322, 11322,
   70862, -4498,  3421, -4498, -4498, -4498, 70862,  1991, -4498,    88,
   25694, -4498, -4498,   771,   986,   254,  3642,  3345, -4498,  3428,
   -4498, -4498, -4498,  1177,  1177, 70862,  3345, -4498, -4498, 70862,
    3501, -4498, -4498, 49547,  3483, -4498,   902,  2756, 70862, 91235,
    1954,    85, -4498, 91235, 91235, -4498, -4498, -4498, 29762,  3502,
   -4498, -4498, -4498, -4498, -4498, 70862, 70862, 70862, 70862, 70862,
     225, -4498,  2019, -4498, 37336, -4498, -4498,  2578,   849,  2578,
    1545, -4498, -4498,  2578, -4498,  2578, -4498,  3285,   849,  3783,
     306, -4498, -4498, -4498,  1376,  3633, -4498,   159,  3621,  3519,
    3434, -4498, 56942,  3873,  3446, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -4498,  2020,  3094,  3742,  2774,  3347, 70862, -4498,
   -4498, -4498, -4498, 29762,  3596,  1807, -4498,  1863,  3446, -4498,
   -4498, -4498,  3277, -4498, -4498,  3828,  3630,  3830,  2833, -4498,
    2674,  2029, -4498,  8746, 92504, 91235,  3772,  3488,  3490, -4498,
   -4498,  3493, 70862, -4498, -4498,  3094, -4498,  4625,  2030, -4498,
    2037,  2038,  3607,  3495, -4498, 29762,   107,  3115, 50417,  3468,
   -4498,  2039, -4498, 11322, 70862, -4498, -4498, 29762, -4498,  2044,
   -4498, -4498, 29762,  3473, 29762, -4498, 31570,  3458, -4498,  3883,
   -4498, -4498,  2888, 36899, -4498,  3579, -4498,  3761, -4498, 70862,
    3505, 43465,  2879,  2879,  1666, -4498,  1440, -4498, 70862, -4498,
   29762, -4498,  3559, -4498, -4498,  2050, -4498,  1140,  3622,  3771,
    2059,  2068,  8464, 70862,  2782,  1445,  2782, -4498,  2779, -4498,
   -4498, 49547, -4498, 50852, -4498, -4498, -4498,   849, -4498,   849,
    3678, 70862, 46502,   849,   849, -4498, -4498, -4498, -4498, -4498,
    3803,  3748, -4498, -4498, -4498, -4498,   389, -4498,  3677,  3679,
   70862, -4498,  3484, -4498,  2074,  3603, -4498, -4498, 70862,  3907,
    3910, -4498,   630,  8501, 56942,  3347,  3199,  1863,  1724, -4498,
    3683, -4498,  3684, -4498,  3496,  2774,  8225, -4498, -4498,   301,
    3787,  3790, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
    2840, 32022, 32022,  3498, -4498, -4498, 70862, -4498,  2076,  2089,
   -4498,  2090, 31570,  2097, -4498, 70862,  3504, -4498, -4498, 39523,
   52157,  1177,  3507, -4498,  3508, -4498, -4498,  3600,  1440,  2756,
   11322, 70862, 56942,  3900, -4498, -4498, -4498,  3622, -4498, -4498,
   -4498,  2756, 70862, -4498, -4498,  2098, -4498, -4498, -4498, 70862,
    3181, -4498,  3181, -4498, -4498,  3638, -4498,   753,   753,  3843,
   -4498,  3566, -4498, -4498,  3520, -4498,  3960, 70862, -4498,   953,
    1807, 58682, -4498,  3516, -4498,  3277,  3199, -4498, -4498, 36899,
    3277, -4498, -4498, -4498,  2192, 56942, 56942, 33378,  3644,   842,
    9793, -4498, -4498, -4498, -4498,  2099, -4498,  3658, -4498,  2109,
   -4498, -4498, -4498,   941,   254,  2879, 29762,  1440, -4498,  3621,
   -4498,  2756,  1954, 70862, -4498, -4498, -4498, -4498, 50852,  3181,
    3349, -4498,  3956, -4498,   233, -4498, -4498, -4498, -4498,  3094,
    3267,  3347, 49112, -4498,  3277,  2110,  2888, -4498,  1952, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498,  3521,  3523,  3946, -4498,
   -4498, -4498, -4498, -4498, -4498,  3530, -4498, -4498, -4498, -4498,
   -4498,  8853, -4498, -4498, -4498, -4498, -4498,  3841, -4498, -4498,
   -4498, -4498, -4498, -4498,  2111, -4498, -4498, -4498, -4498, -4498,
    2774, -4498,  2061, -4498, -4498,  2119,  1906,  3608,  3827, 32474,
   29762, -4498,  1440,  3692, -4498, 49112,  3277, -4498,  1952,  3639,
    3641, -4498,  8974, 56942, -4498,  2888, -4498,  3574,  3575, -4498,
    3544, -4498,  3835,  3836, 49112, 56942, 56942,  2117, -4498, -4498,
   -4498
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4498, -4498, -4498,  3236, -4498,  -848,   333,  2511,  -597, -4498,
   -4498, -4498,  3135, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
    3169, -4498, -4498,  1691, -2234, -4498, -4498,   136,   158, -1220,
     119,  2750,  1347, -4498, -1065, -4498, -4498,  -531,   112, -4498,
     218,  -700, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -4498,
    -752,  1834,  1183,  -312, -2620, -4498, -4498, -1316, -2963, -4498,
     543, -4498, -4498,  1771, -4498, -4498, -4498,  1023,   455,  -536,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498,  -679, -4498, -4498,
    -865,   156,    48, -2251,  -353, -4498, -4498,   422,  -354, -1357,
   -4498, -3319, -4498,   -23, -4498, -4498, -4498,  -328, -1319,  1290,
   -4498,  -649, -1088,  1590,  -758, -4498,  -218, -4498,  -838,  -687,
    -684,  -783, -3502, -3508, -3928, -3532, -3486,  1296,   157, -2874,
   -2966,   160,   392, -4498,   162,   164, -4498,   409,  -755, -1368,
   -4498,  -818, -4498, -4498, -4498, -2715, -4498, -4498, -4498, -4498,
      72, -4498, -4498, -4498, -4498,   451, -4498, -4498, -4498, -4498,
   -4498, -4498, -2465,  1748,  1749, -4498, -4498, -2938, -4498,  -822,
   -4498,   589, -2764,  1204, -4498, -4498, -4498,  2492, -4498, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -1488, -4498, -4498,
   -4498, -4498, -4498,   433,   -25, -4498, -4498, -4498, -4498, -4498,
     166, -4498,  1763,  1010, -4498, -4498, -4498,  -832,  -924,  -903,
   -4498, -2757, -4498, -4498, -4498, -4498,  -295, -4498, -4498, -4498,
   -4498, -4498, -4498,  -909, -4498,  1061, -2887, -4498, -4498,  1068,
   -4498, -4498, -4498, -4498, -4498,  -773,  -237,  2520, -4498,  -620,
    -737, -4498, -4498, -4498,  -235, -4498, -4498, -4498, -4498, -4498,
   -4498, -1009,    93,  -981,  -483, -4498, -4498, -4498, -4498, -2147,
   -4498, -4498, -4498, -3334, -4498,  4044,   385,   492,   168, -4498,
     -29,    61,  2967, -1070, -2415,   357,  -417, -4498, -1685, -4498,
   -4498, -4498, -2356, -4498, -4498, -4498, -4498, -3248,   169, -4498,
    2953, -4498, -3520, -4199, -3275, -3731, -4059, -4171, -3246, -4498,
   -4498, -1029, -4498, -4498, -4498, -1335,  2054, -1786, -4498, -1918,
     418,  1360,  -871, -2533, -3530,  -645, -3000, -4498, -4498, -3452,
    -532, -4498, -4498, -4498, -4498, -4498, -4498, -4498, -1023,  -560,
   -4498, -4498,  3480, -4498, -4024, -4498,  3452, -4498, -4498, -4498,
   -4498,  2342,  2346, -4498,  2347, -4498, -4498, -1336,  1141, -4498,
   -4498, -4498, -4498,   106, -4498, -4498, -4498, -4498,  -754,  -869,
   -4498, -4498, -4498,   172, -4498, -4498, -4498, -4498,  2072,  -840,
    -661,  3367,   173, -4349, -4498, -4498,  -894, -4498,  2752, -4498,
   -4498, -4498, -4498, -4498, -4498, -4498, -4498, -2545, -4498, -4498,
   -4103, -4498, -4498, -4498, -4498, -4498,  2134,  2142,    83,   -40,
   -4498, -4498, -1198, -4498,  -519, -4498,  2413, -4498, -4498, -4498,
   -4498, -1592,   174,   469, -4498,     3, -4498, -4498, -4498,   234,
   -4498, -4498, -3171,     5, -4498, -4498, -4498, -4498, -4093, -4498,
       6,  -674,   756, -4498, -4498, -2588, -4498,   175,    16, -4498,
   -4498,     1,     2,   -43,   -41,   -32,     4,   117,  2834, -4498,
    2881, -4498,    -2,  1810, -4498, -4498,  -759,  -144, -4498,  1446,
    -583,  2115,  2804,  2810, -4498,  1437, -4498, -4498,  1448, -4498,
     797,  -656,  -527, -4498, -4498, -4498, -4498,   262,  -582,  2125,
   -4498,  2817, -4498, -4498, -4498, -1710,  1444, -3158,   830, -3148,
   -3121,   320,   296, -1266,  -319,    26,  -686,  2836, -4498, -4498,
     848,  -486, -4498, -4498,  -484, -2603,   793, -4498, -4041, -2142,
     624,  2542,  -970, -4498, -4498,  -940, 14299, -4498, -4498, -4498,
   14936, 15038, -4498, -4498, 15300, 16352, -4498,  -804,  1048, 16536,
    7166,  -944, -1649,   -14, 13548, -2275,  -762, -2407, -4498, -3282,
   -2334, -4498, -4498, -4498,  -270,   905,   475, -4498, -4498, -4498,
   -4498,   -75, -4498,  -619, -4498,  -621, -4498, -4498, -4498,  -602,
   -4497,  2335, -4498, -4498, -4498,  -194, -4498, 17317,  1496, -4498,
    -878, -2516, -2532, -3156, -1666, -4498, -4498, -4498, -4498, -4498,
   -4498, -4498, -1432, -3046,  -616,  1568, -4498, -4498,  1656, -4498,
   -4498, -4498, -1231,  1518,  -770, -2422,  1571, -1863, -4498,  -763,
   -4498,  -695,  2341,  -711,  6432, -1257,  7065,  -485, -2059, -1163,
   -1439, -4498,   -54, -4498,    -7,   -16,     8,  -133,  -160,  -453,
    3712, 12813,  -589, -1233, 10067, 12405, 13518, -2854
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2420
static const yytype_int16 yytable[] =
{
     605,   180,   181,   175,   185,   176,   178,   717,   765,   685,
    1648,   857,   955,   986,   672,  1713,  1693,  1251,  1320,  1326,
     672,  1423,   181,   544,   185,  1658,  1105,  1106,  1107,   673,
     595,  1247,  1111,  1492,  1652,   673,  2457,  2063,  1329,   775,
    1972,   831,  2136,   751,  1621,  1957,  1554,  1463,   864,  1962,
    1504,  3328,  1644,   764,  1082,  3018,  2649,  1575,  2128,   881,
     587,  1048,  1611,  1612,  1535,  1281,  2259,  3438,  2148,  1749,
     748,   984,  1620,  1627,  1265,   863,  3176,  3603,   940,  3629,
    2137,  3038,  3418,   679,  3674,  3458,   880,  3460,  2344,   637,
    2214,  2517,  1542,  2945,  3644,  3874,  1547,   718,  1962,  2165,
    1957,  1551,  3909,   647,  1975,  2715,  2717,  2670,  3657,  3908,
    1558,  3157,    68,  1458,  3321,  3359,  1457,  3581,  3946,  1599,
    1577,  3804,  1471,  1076,  2882,  4112,  2983,   995,  3319,  3320,
     769,  1497,  3903,  2224,  2987,  2654,  2989,   807,  4104,  4121,
    4115,  4065,   986,  3575,   777,  4105,   826,  3833,  2482,  2362,
    3575,  1065,  2580,   778,   711,  3261,    77,    78,  2228,  2229,
      79,   745,    80,  3850,    81,  2121,   106,   763,   126,   131,
    2036,  1053,   151,   155,   173,   179,  4387,   737,  3365,  4262,
    1391,  1493,  1068,  4463,  3641,  4465,  3887,   776,  4511,  3848,
    2427,  1313,  1316,   655,  3772,  1686,  1608,  1609,   655,  4611,
    1258,  1804,  3218,  4504,  1963, -2178, -2083,  1619, -2213,   554,
   -2235,  2235,  1632, -2264, -2083, -2083,  4260,  1574,  1600,  1365,
    4537,  4538,  1600,  2472,  2588,   596,  4530,   601,  1611,  1612,
    1810,  2149,   697,  3009,  3663,  3312,  1600,  2714,  4741,  4687,
     874,  2240, -1670, -1698,  2492,   601, -2084,  1620, -2110, -1941,
    3031,   754, -2181,  1627, -2084, -2084, -1941,   655,  2623,  3597,
    1812,   655,  1839,  1695,   601,  2624,  2588,  2608,   601, -1960,
    1734,  2967,  3215,  3216,  1087, -1683, -1960,  3235,  1091, -1710,
    1600,   601,   601,   601,  1531,   812,   814,  3364,  3312,   818,
   -2419,   820,  1140, -2055,   601,  2793,  2449, -2054, -2419, -2419,
   -1698,  2993,  3174,  4269,  1538,  3648,  2297,  1421,  3314,  1600,
    2642,   878,   655,   698,  3265,  3266,   601, -1703,   655,  4723,
    2069,  2071,  2139,  4562,  1366,  1476,  2352,  4244,  4852, -1703,
    1102,  2222,  4672,  4673,  3419,  4664,  3194,  3010,  1797,  1501,
   -1713,  2869,  4939,  2473,  4718, -1713,  2630,  2065,  1593,  1255,
    3123,  1521,  3125,  1608,  1609,   885,  1282,  3725,  2341,  4653,
    4918,  3314,  2310,  1804,   661,  -835,  1477,   661,  2739,   661,
    2794,   601,   661,  2890, -1703,  2066,  4061,  1268,   857,  1619,
     772,  2887,  3875,     3,     4,  2751,   662,  4408,   188,   662,
    1804,   662,  1810,  2859,   662,  4533,  4844,  2609,   549, -2234,
    1594,  4155,  2610,  4157,  2779,  4771,   670,   661,  3218,  1438,
     950,   661,   670,  2316,   551,   950,  4534,  2139,  2139,  1810,
    3616,  2116,  1812,  4649,  4683,  1504,   950,   857,   682,   662,
    1439,   189,  4772,   662,  2672,  1964,  4724,   949,  2611,  2752,
    2891,  3876,   958,  1269,  2860,  1858,  2740,  1798,   886,  1812,
    1870,  1870,  2139,   968,  2047,  2139,  1136,   699,  2072,  2139,
    4602,  2452,  4971,  4265,  3512,  2458,  2764,  2460,  -134,  2450,
    2463,  2311,  1770,  -134,  2895,  1844,  2631,  3218,  -399,  1601,
     986,  1333,   597,  1601,  4940,  4719,  4665,  2267,   823,  2317,
     887,  1103,   986,  1595,   700,   701,  4853,  1601,  2271,  3726,
    2164,  2451,  1502,  4827,   935,  4725,  3011,  2888,  3617,  2117,
    2217,  1283,  2067,  1284,  2974,  2150,  4062,   945,  1036,  2994,
    1840,  4245,  2342,  1478,  2353,  2514,  2151,  2474,  2152,  3502,
    2797,  2861,  2870,  3598,   598,  4717,   927,  1650,  1681,  1430,
    2073,  1601,  1514,   888,  1596,   755,  2475,  1735,  2589,  3419,
    1996,  2896,  4942,   990,   986,  2107,   932,   181,   929,   185,
     930,   931,  4150,  1039,  1697,  2115,  2612,  1962,  3664,   599,
    1601,   600,  3325, -1941,   602,  2236,  2586,  2241,  1735,  3561,
    3562,  3961,  2625,   702,  2153,  2968,   985,   605,  3618,  3012,
    3281,  1110,  4812, -1960,  4270,  1367,  1659,  4388,  1277,  1539,
     765,  1110,  1278,  2897,  1633,  4409,  2210,  1083,  2212,  3361,
    4791,  4353,  1753,  1962,  3575,   555,  2070, -2234,  1479,  2105,
    4875,  1628,  2519,   925,  2445,  1683,  2291,  2223,  2200,  1597,
    3913,  2203,  2204,  1321,   667,   668,  1539,  3105,  2262,  1650,
    1831,  3233,  2219,  2679,   181,   764,   185,  4187,  2299,   672,
    4905,   672,  4080,   672,   938, -2083,  1731,  2898,   941,   672,
    1098,  1099, -2178,  2258,  1084, -2213,  1089, -2235,  1093,  4404,
   -2264,   986,  1741,  2431,  1097,  2181,   966,  1122,  2343,   986,
     986,  4212,  3850, -2234,  2862,  4216,  1100,  1750,  3383,  1075,
    4111,  1610, -1698,   667,   668, -2084, -2234,   667,   668,  2268,
    4092,  4161,  1503,  1141,  2399, -2110,  4880,  1629,  4206, -2181,
    2453,  1248,  3718,  1113,  1257,   985,  1259,   857,  4885,  2464,
    4249,  1606,  2802,  2877,  1614,   777,  1078,  3619, -1710,  1852,
    1800,  1842,  2377,  1606,   778,  4865,  2192,  2007,  2008, -2419,
    1277,  2195, -2055,  2657,  1278,  1666, -2054,  2124,   667,  1422,
    2765,  2899,   824,  1676,   667,   668,  1622,  3935,  2777,  1684,
    3513,  1622,  4342,  1285,  3965,  4669, -1703,  2803,   776,   180,
     181,   175,   185,   176,   178,  1623,  2821,  1113, -1703,  4507,
    1623,   946,  1037,  1356,  1854,  1421,   601,  4828,  4933,  1624,
     655,  3676,  3620,  3867,  1626,  2454,  3367,  3414,  3368,  1828,
    1829,  1830,  1831,  3625,  1957,  4497,  1515,  1324,  4891,   711,
    1119,  1121,  4506,  2380,  2381,  4421,  2719,  2807,  4845,  4422,
    4423,  4051,  4424,  3547,  1826,  1827,  1828,  1829,  1830,  1831,
    3551,  3552,   672,  4575,  3555,  3641,  3895,  3161,  1288,  3163,
    1267,  3560,  1509,  2878,  3230,  3231,  3232,  3233,  2139,  1118,
    1371,  4050,  2943,  1516,   601,  4601,  4096,  2140,  2649,  2649,
    2649,  2527,  2900,   601,   686,  1254,  1566,  4566,  2352,  1262,
    2901,  3677,  2188,  2902,  2729,  4012,  1295,  2513,  1668,  2516,
      68,  4576,  3609,  1438,  2066,  2523,  4096,  4358,  1357,  4577,
    1855,  2537,  2538,  2539,  1481,  4510,  3312,  4621,  3312,  2057,
    1482,  2555,  2557,  2121,  1439,  2808,  2567,  1567,  1117,  -134,
    -134,  3228,  3229,  3230,  3231,  3232,  3233,  4578,  4904,  1669,
    3553,  3554,  1589,  2335,    77,    78,  4451,  1349,    79,  3112,
      80,  2866,    81,  3885,   106,  2355,   126,   131,  1428,  1429,
     151,   155,   173,   179,  3752,  3753,  3754,  3755,  1635, -2052,
    3760,  3761,  3762,  3763,  3764,  3765,  3766,  3767,  3768,  3769,
    2697,  4389,  2528,  3909,  1338,  3949,  2895,  4127,  1443,  3314,
    2057,  3314,  2071,  2059,  4390,   772,  3909,  3312,   770,  2466,
    1009,  2214,  2275,  3908,  4633,  2737,  3024,  2058,   696,   711,
    1119,  2060,  4579,  1349,  3362,  4920,  4359,  4892,   779,  1483,
    1365,   569,  1856,  2336,  1444,  2720,  3808,  3809,  2721,  3331,
    3678,  4670,  4429,  1650,  2461,  2462,  2551,  1636,  1650,  1529,
    4675,  3947,  2778,  2276,  2569,  1798,   885,  1639,  3077,  1466,
    2455,  2529,  3415,  4013,   697,  1358,  3610,  3482,  3059,   771,
    3162,  1339,  3164,  2896,  2059,  2944,  1552,  1553,  2722,  1621,
    3314,   695,  1592,   985,  4097,  4455, -1670,  4622,  1268,   571,
    4459,  4452,  2060,  4461,  1568,   985,  4372,  1586,  3007,  4893,
    4749,  1359,  4735,  3583,   672,  3679,  1670,  1637,   780,  3572,
    1638,  3337,  3406,  4756,  4841,   181,  3572,   185,  1465,  4746,
    4754,  2530,  1340,  4894,  2531,  2897,  4747,  2412,  3978,  1737,
    1082,  1360,  1699,  4314,  1701,  1366,  1703,   772,  1705,  3950,
    1707,  1708,  1709,   746,  3973,   698,  3909,  1711,  3586,   886,
    2375,  3674,  1635,  3407,  1269,   976,  2061,   985,  4921,  2747,
    4379, -1670,  4383,  2379,  3431,  4391,  3575,  1136,  1654,  1656,
     641,  1277,  3483,  2690,  3025,  1278,  1484,  4255,  3897,  2898,
    1088,  1090,  1092,  1758,  4605,  1094,  1095,  1096,  3165,  1569,
      14,   887,  4606,  3670,  1361,  1101,  4580,  3860,  2051,  2437,
    2186,  1671,  1767,   765,  3510,  1639,  4634,  1411,  2052,  1982,
    2277,  4284,  1485,  -999,    40,  1341,  4165,  1460,  4166,  2532,
    3717,  1636,  2425,    19,  2337,  2053,  2404,  2061,  3148,  3979,
     722,  3432,  1799,  1783,  1862,  4529,  3439,  2338,   579,  2417,
     580,  1801,  1486,  2675,   888,  3974,  2543,    44,  1795,  3951,
       3,     4,  3952,  1461,  2426,  1843,   667,  1422,  2062,  3718,
      40,  2793,  3166,   773,  1555,  2046,  2187,  1020,   857,  4846,
    2691,  3511,  4682,  2899,   985,  1863,  4667,  1860,  1861,  2935,
    1968,  1637,   985,   985,  1638,  4351,   672,    48,  1020,   699,
    3590,   672,   672,    44,  1976,  1977,   885,  1981,   723,  1309,
      49,  1983,  4628,   778,   778,  2278,   778,   757,   641,  1640,
    3408,  4748,   781,  1303,  3026,  2936,  2929,  2373, -1670,  3484,
     977,    50,  2930,  2533,  2689,  2676,   700,   701,    14,  2062,
    3591,  4248,  4645,    48,  4851,  2698,  2794,   776,   776,   552,
     776,  4058,  3975,  4903,  3592,  2937,    49,  2164,  4906,  4607,
    4167,  3898,  2938,  1650,  1462,  3485,  -622,  3027,  3867,  2246,
    1346,    19,  1347,  2054,  4235,  3251,  2403,    50,  1311,  4228,
    2407,  3258,  1309,  1411,   978,  1985,  2413,  2414,  1324,  1639,
     979,    51,   767,  3899,  2900,  3486,  4451,  3317,    32,   886,
    1650,   719,  2901,  4685,   724,  2902,   672,  4690,  4691,  2430,
   -1484,  4147,  4949,  3120,  3900,  3409,   672,  4362,  1312,  1304,
    2819,  3909, -1484,  1986,  2911,    40,  1435, -1484,  4788,  3126,
    3963,  2931,  2914,  3440,  2916,  1846,  3109,  3121,   188,  3361,
    2315,   887,  3593,  4041,  2328,  4515,  4803,  1109,  2793,  4044,
    4045,  1311,  4047,  4536,  4596,  1099,  2246,  1570,    44,  3441,
    4363,  3043,  3044,  3045,  3046,   768,  4795,  4796,  3756,  1539,
    3757, -1484,  3312,  3051,  4975,  4589,  3312,  1571,  3575,   672,
    2100,   189,   672,   672,  2910,  2075,  2218,  2909,  1330,   569,
     188, -1484,  4059,  1640,   888,  2076,  3110,  3964,    48,  2468,
    1847,   986,  2483,   857,  3714, -1670,  2797,  2751,  3335,  2922,
    4804,    49,  1641,  1985, -1670,  2205,  1610, -1670,  1333,  3430,
   -1670,  2205,  1988,  2794,  1331,  3378,  -156,  3916,  1110,  3468,
    2405, -1484,    50,   189,  2221,  4091,    32,  2962,  3095, -1484,
    3892,  3093,  3469,  2159,  1264,  3314,    51,   571,  4266,  3314,
     672,  1986,   661,  2795,  1332, -2074,  -528,  4060,  2246,  -156,
    4533,  3386,  2837,    40,  2156,  1803,  3738,  1512,  1804,  2156,
    4720,  2783,  1335,   562,   662,  3841,  2166,  1989,  2932,  2649,
    2469,  4534,  2214,  1650,  2372,  -156,  2325,  1527,  1349,  2796,
    3572,  3916,  3758,  1349,  1639,  2157,    44,  1810,  2734,  2672,
    2157,  1537,  3759, -2420,  3917,  3842,  1987,  3909,  1336,  2230,
    2231,  2232,  2233,  4267,  2933,  2144,  1698,  2145,  2838,  1700,
    4218,  1702,   857,  1704,  3514,  1706,   782,  1812,  1572,  1710,
    3844,  2030,  4564,  2402,  2839,  2956,    48,  2903,  1337,  2077,
     642,  1482,  1617,  1618,  2934,  2206,    40,  2378,  2207,    49,
    1988,  2206,  2269,  2270,  2207,   569,  1804,  2386,  2273,  2387,
    3918,  2282,  3919,  4740,  1438, -1484,  2392,  2031,  3917,  4930,
      50,  2294,  1446,  2146,  2398,  2078,  -993,  2211,  4131,    44,
    4132,  3150,  4753,  2797,   643,  1439,  4737,   817,  1343,  3707,
    2840,  2903,  3267,  2665,   819,  3494,   579,  2032,   580,  2330,
    2331,  2332,  2333,  1472,  3389,  1989,  3270,   826,  3271,  4514,
     947,  3217,   948,   571,  3479,  1812,  2274,  2816,  2167,    48,
    1447,    35,   585,  3245,  3918,  1277,  3919,  4764,  1299,  1278,
     181,  3272,   185, -2420,  4590,  3846,  4620,   839, -2420,  1473,
    1483,  2254,  1622,  1474,  4031,  2168,  2893,  1491,   969,  3071,
    3480,  4540,   876,  2255,  2439,  3268,  2440,  3039,  2441,  2489,
    2442,  1623,  2443,   569,  4032,  4591,  2444,    51,  2169,  1475,
    2170,  3366,  2252,  4420, -2420,  1624,  1622,  2722,  2256,   970,
    3481,   932,   181,   929,   185,   930,   931,  1738,  3649,  4679,
    4676,  3653,  2536,  3294,  2416,  1623,  3674,  2419,  2525,  2526,
    3405,  2477,  1448,  2164,  1622,  2540,  2541,  2424,  2253,  1626,
    2297,   971,  1078,  1804,   840,  2139,  2432,   690,   986,  1819,
    3747,   571,  2399,  1623,  2147,  2551,  2551,  3840,  3583,   884,
    2551,  4710,  4850,  2579,  3584,  3273,  4711,  1678,   937,  2939,
    3274,  3312,  1810,   691,  4616,  3585,  3312,   692,  2488,  3773,
    1449,  3312,   934,  1450,  3312,  2166,  2594,   972,  1679,  2596,
    4361,  2597,   579,  2213,   580,  2941,  2511,  2551,  2551,  2940,
     870,  4345,  1812,  3586,   582,  3587,  3089,  4493,  3312,  4495,
     986,  1870,  4712,  2658,  2598,   584,  4382,  1343,  1555,  4370,
    1260,  3312,  1452,  1277,  4014,  2942,   871,  1278,  3841,   939,
   -1484,  4346, -2420,  -422,  4533,  1309,  4273,  4274,  3323,  3324,
    1310,  1850, -1484,  2726,  3314,  4015, -2074, -1484,  2730,  3314,
      35, -1520,  2733,   942,  3314,  4534, -1520,  3314,  3842,  4426,
    3713,  2313,  3326,  4335,  1454,  4336,  4337,   857,  3138,  4338,
    3397,  2686,  2687,  3843,  2174,  2591,  1491,  4763,  2757,   655,
    2345,  3314,  3588,  3844,  1688,  3371,  2225,  1689,  4798, -1483,
    1610, -1484,  2037,   969,  3314,  1277,   956, -2055,  3275,  1278,
     579, -1483,   580,  1456,  1311,  3894, -1483,  -527,  3276,  3845,
    1610, -1484,  2037,  2599,  3244,  3840,  3246,  3247,  2600,  3914,
   -1520,  2809,  2166,  2601,   970, -2420,  1555,  2167,  4456,  3630,
     964,  4941,  1826,  1827,  1828,  1829,  1830,  1831,  3639,   950,
    3589,  3048,  -422,   973,  1312,  3590,  3049,   672,  3420,  1743,
   -1483, -1484,  1744,  3190,  2168,  1438,  3627,  4966,  2434, -1484,
   -1520,  3312,  2681,  3191,  3582,  3329,  2815,   974,  3192,  3049,
   -1483,  2857,  4707,  3443,  4709,   975,  1439,  2169,  4713,  2170,
    4714,  2700,   181,   988,   770,  3591,  3841,  1966,  3846,  1969,
    1967,  3784,  1970,  2741,  2433,  2744, -1521,  2434,  2771,  3592,
    2514, -1521,   972,   950,   985,   826,  4877,  2905,  2446,   992,
   -1483,  2447,  2164,   672,  2448,  3279,  3842,  2447, -1483,  3423,
    1288,  1035,  2166,  3312,  2185,  2917,  2166,  1043,  2738,  4787,
    2894,  3843,  2480,  1044,  3314,  2481,  2927,  3098,  2166,  2649,
     986,  3844,  3572,  2671,  2649,   771,  2672,   222,  3944,  2952,
    2649,  2602,   553,  2813,  1049,  3936,  2814,   950,  1060,  3119,
     639,  2603,  1069,  2884,  2167, -1521,  2885,  3845,  4457,   951,
    1803,   952,  1259,  1804,  3128,  3728,  1073,  3130,  3131,   720,
   -1544, -1544,  3134,  3135,  2959, -1484,  1610,  3593,  1333,  3139,
    1104,  2168,  2166,  3474,  3948,  3953,  3314,  2998,  2801,  1757,
    2999,    51,  1810,  2514,  2263, -1521,  3966,   655, -2420,  3002,
      40,  1108,  3003,   772,  2169,  3096,  2170,  1112,  2434,  2279,
    2166,  1115,  4627,  2251,  3733,  1123,  1125,  2804,  3688,  3689,
    3599,  3142,  1812,  3189,  2447,  1127,  2434,  3198,  2300,  2879,
    2434,  1133,  1126,    44, -1483,  4962,  3846,  2773,  2774,  2164,
     986,  3178,  1149,  1135,  1134,  3218,  2785,  4541,  2787,  3219,
    3220,  3221,  2791,  2166,  2167,   672,  3204,  1137,  2167,  2434,
      28,  3205,  1139,   672,  2434,   672,  3206,  1138,  3237,  2434,
    2167,  2434,  1136,    48,  3250,  2366,  3255,  2434,  1143,  3256,
    4114,  2168,  2368,  3509,  2369,  2168,    49,  3278,  2374,  3461,
    3466,  3312,  3462,  3467,  2866,  1142,  3962,  2168,  3396,  3661,
    1020,  1610,  3662,  2037,  2169,  1145,  2170,    50,  2169,  2976,
    2170,  3515,  2388,  1266,  1270,  3686,  3312,  2976,  2434,  1272,
    2169,    51,  2170,  2573,  2167,  2976,  2576,  2976, -2420,   773,
    4928,  3779,  3789, -2420,  3780,  3790,  1263,  3800,  3883,  2164,
    2434,  3884,  3064,  2164,  3065,    40,  3375,  3376,  1271,  1276,
    3888,  2168,  2167,  3889,  3544,  2164,  2422,  3911,  3912,  1020,
    3295,  2912,  3296,  4951,  3314,  3155,  1289,  4585,  3731, -2420,
    1296,  1307,  3893,  3042,  2169,  2721,  2170,  3915,    44,  2168,
    2447,  3988,  4093,  3169,  3989,  2447,  4102,  3077,  1297,  3314,
    4144,  3155,  1322,  1735,  4400,  2167,  3749,  4162,  4188,  1323,
    2434,  2481,  2169,  3072,  2170,  4200,  1299,  4251,  2434,  2164,
    2721,   985,  3060,   181,  1819,  3222,  4257,  2973,    48,  4258,
    4263,  1300,  2168,  2447,  3040,  2982,  3734,  2984,  1327,  1333,
    3778,    49,  4981,  2986,  3572,  4874,  3223,  2164,  1369,  3111,
    3113,  3114,  3104,  3106,  3615,  2169,  1364,  2170,  4264,  3115,
    4384,  2447,    50,  4385,  4431,  4433,  4441,  4432,  2434,  2481,
    4512,  4586,  4613,  4513,  2447,  4614,    51, -1252,  1393, -1252,
    3297,   857,  3298,   985,  4629,  3820,  4637,  2481,  1395,  4638,
    2164,   986,  4642,   986,  4648,  2672,  2399,  3637,  2581,  1397,
    1398,  4650,  3932, -2327,  3637,  2166,  3224, -2420,  3497,  4907,
      28,  3179,  3312,  3392,  1432,  3061,  4662,  3183,  3505,  4663,
    1430,  1433,   672,  4138,  4139,  4140,  1434,  2551,  2551,  2551,
    2551,  1435,  1437,  2551,  2551,  2551,  2551,  2551,  2551,  2551,
    2551,  2551,  2551,  3721,  4700,  4736,  1442,  4701,  1849,  3600,
    1445,  3602,  4612,  3340,  4755,  4765,  1467,  4663,  2481,  1504,
    3782,   986,  4766,  4767,  4777,  3256,  2434,  2672,  2166,  4780,
    1468,  3122,  3637,  3124,  1149,  4802,   765,  3218,  2481,  1480,
    1489,  3219,  3220,  3221,  4808,  3314,  4967,  2481,  4968,  2551,
    2551, -2327,  3448,  4809,  3450,    40,  2481,  1490,  3797,  4835,
   -2420,  4866,  4836,  4052,  2672,  4053,  3937,  1826,  1827,  1828,
    1829,  1830,  1831,  1494,  4867,  4868,  3856,  2434,  2434,  3667,
     765,  1795,  4870,  4887,  4924,  2434,  4888,  3637,    44,  1499,
    3861,  3862,  3863,  3372,  4927,  4950,  4964,  4656,  4663,  4965,
   -2327,  3608,  4990,  3611,  1299,  4965, -1472,  2167,  4217,  1500,
    4220,  1306, -2327,  1308,  1505,  1507,  4282, -2327,  3315,  1508,
    4382,  1510, -2327,  1513,  1517,  1795,  1524, -2327,    48,  3967,
   -2327,  1518,  1525, -2327,  2168,  3188,  3394,  1528,  1530,  1533,
    1536,    49,  2594,  1543,  1546,  3225,  3226,  3227,  1548,  3228,
    3229,  3230,  3231,  3232,  3233,  1962,  1539,  2169,  3288,  2170,
    1557, -2327,    50,  3533,  3300,  3301,  3302,  1559,  1560,  3540,
    2167,  3315,  -176,   985,  3306,  1562,  4908,  1564,  1576,  1578,
    3330, -2327,   672,  1585,  2514,   765,  1587,  1591,   207,  1598,
    4559,  1603,  2164, -2329,  1604,  1605,  1606,  2168,  1610,  1613,
    1803,  1616,  1614,  1804,   932,   181,   929,   185,   930,   931,
    1630,  1647,  1649,  1646,  1650,  1657,  1660,  1661,  1664,  1662,
    2169, -2327,  2170, -2327,  1663,  1665,  1667,  3306,  3223, -2327,
     764,  1673,  1810,  1672,  1674,  1675,  1677,  1682, -2420,  1803,
    2775,  1687,  1804,  3470,  1740,  4048,  1805,  1806,  1807,  1712,
    4036,  3727,  2790,  1745,  1747,  2164,  3490,  1748,  1755,  1754,
   -1674, -1681,  1812,  1808,  1764,  1762,  1763,  1765,  1766,    51,
    1768,  1810, -1671,  1769,  1770, -1672,  1771,  1811,  1772,  1773,
   -2327, -2329,  1775,   985,  4322,  4323,  3494,  4325,  3224, -1675,
    1776,  1777,  2823, -1673,  4124,  1778,  1779,  1780,  1781,  1782,
    1784,  1812,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1835,
    1837,  3684,  1839,  1853,  1840,  1849,  1865,  1873,  1974,  1310,
    1312,  2003,  2005,  2014,  2033,  2034,  2037,  3807,  2035,   686,
   -2329,  2038,  2039,  3340,  2040,  3545,  2041,  2042,  3695,  3696,
    3340,  3698, -2329,  3700,  3701,   690,  2043, -2329,  2049,  2068,
    2074,  2080, -2329,  4183,  2551, -2327,  3708, -2329,  4400,  2102,
   -2329,  1803,  2106, -2329,  1804,  2108,  2109,  2110, -2420,  3464,
    2111,  2113,  2114, -2420,  2129,  2130,  2131,  2142,  2154, -2327,
    2143, -2327, -2327,  2158,  2160,  2161,  2162,  2163,  2164,  2172,
    2173, -2329,  2176,  1810,  3729,  2177,  2175,  2191,  2193, -2420,
    2201,  3401, -2343,  3402,  3403,  3404,  2197,  1813,  2208, -2420,
    2182, -2329,  1814,  3503,  2183, -2327,  1411,  2198, -2327, -2327,
   -2327,  2209,  2215,  1812,  2220,  2216,  2237,  4141,  1149,  2226,
    2238,  3218,  4172,  1815,  1816, -2420, -2420, -2420,  2227,  2242,
    2239,  2247,  2243,  2264,  2250,  2265,  2272,  3001,  1817,  2280,
    2266, -2329,  2281, -2329,  1819,  2284,  2283,  2285,  2287, -2329,
    2293,  2298,  3536,  2301,  2302,  2292,  2305,  3225,  3226,  3227,
    2306,  3228,  3229,  3230,  3231,  3232,  3233,   564,  2314,  1462,
    1818,  2309,  2329,  2334,  2976,  2347,  2350,  2351,  3810,  2359,
   -2343,  2976,  2976,  1819,  2365,  2976,  1820,  2363,  2367,  2371,
    2376,  2382,  2976,  2384,  2385,  3564,  2391,  2246,  2389,  2390,
   -2329,  3574,  2393,  2394,  2395,  2397,  2406,  2408,  3574,  2396,
     672,  4367,  3716,  2409,   985,  2410,   985,   672,  2428, -2420,
    2429,  2411,  2459,  2465, -2420,  1803,  2478, -2420,  1804, -2343,
    2491,  2524,  1805,  1806,  1807,  2568,  1804,  3730,  2519,  2574,
    3612, -2343,  2587,  2593,  2578,  2607, -2343,  2627,  2605,   686,
    2628, -2343,  2642,  2656,  3635,  2659, -2343,  1810,  2660, -2343,
   -2420,  2663, -2343,  1811,  1338,  2662,  1821,   771,  2664,  2673,
    2682,  2684,  2674,  2683,  2701, -2329,  2710,  2695,  2711,  2713,
    2685,  2723,  2724,  3666,   985,  3549,  4102,  1812,  2745,  2725,
   -2343,  3656,   181,  2742,  2747,  2749,  2750,  2766,  2756, -2329,
     841, -2329, -2329,  2761,  2772,  1819,  2776,   842,   843,   844,
   -2343,  2767,  3687,  3683,   181,   826,  2769,  2788,  2780,  2789,
   -2420,  2792,  2806,  2805,  1260,  3168,  4544,  1826,  1827,  1828,
    1829,  1830,  1831,  2827,  2811, -2329,  2828,  1264, -2329, -2329,
   -2329,  1339,  3180,  2822,  2841,  2846,  2847,  2868,  2873,  2883,
   -2343,  2874, -2343,  3186,  2886,  2876,  2889,  2947, -2343,  1822,
    1329,  2904,  1823,  1824,  1825,  3814,  1826,  1827,  1828,  1829,
    1830,  1831,  3224,  2958,  2970,  2971,  4076,  4077,  2977,  3209,
    2965,  2966,  2969,  2978,  2992,  2979,  2980,  2981, -2420,  4081,
    4916,  4917,  1340,  1813,  2985,  2988,  2996,   672,  1814,  2990,
    3016,  2997,  3030,  3032,  3034,  1113,  4241,  3004,  3041, -2343,
    3047,  3057,  3058,  3067,  3055,  3069,  4641,  3050,  3070,  1815,
    1816,  3073,  3074,  3056,  3087,  3090,  3088,  4641,  3091,  3092,
    3094,  3099,  3100,  3101,  1817,  1639,  3097,  3116,  3102,  3118,
    3702,  3132,  3703,  3127,  3103,  3108,  3705,  3117,  3129,  3136,
    3133,  3141,  3137,  3144,  3145,  3146,  3147,  2672,   686,  3156,
    1683,  2492,  3158,  3149,   765,  3159,  1818,  3795,  3160,  3315,
    3167,  3315,  3170,  3175,  1110,  3177,  3933,  3182,  3184,  1819,
    3181, -2420,   765,  3200, -2343,  1341,  3187,  3201,  1826,  1827,
    1828,  1829,  1830,  1831,  3340,  3202,  3185,  3203, -1933,  3207,
    3736,  3252,  4698,  3208,  3210,  3213,  3269,  3264, -2343,  1795,
   -2343, -2343,  3236,  3822,  3823,  3824,  3825,  3214,  2434,  3291,
    4988,  4989,  3286,  3242,  3317,  3829,  3348,  3832,  3346,  3352,
    3369,  3356,  3350,  4239,  3388,  1342,  3249,  3263,  3342,  3377,
    3277,  3380,  1343,  3379, -2343,  3287,  3391, -2343, -2343, -2343,
    3315, -2420, -2420, -2420,  3339,  3228,  3229,  3230,  3231,  3232,
    3233,  3289,  1821,  3290,  3363,  3427,  3400,  3429,  3293,  3393,
    3434,  1344,  3322,  3384,  3416,    35,  3385,  3417,  3436,  3433,
    3435,  4016,  3447,  3446,  4019,  1803,  3449,  3455,  1804,  3456,
    3457,  3465,  1805,  1806,  1807,  3475,  3496,  3500,  3498,  3501,
    3504,  1345,  4130,  3506,  3518,  3507,  3508,  4778,  3516,  1808,
    4133,  4134,  4135,  4136,  3517,  3519,  3398,  1810,  3520,  3521,
    3522,  3523,  2551,  1811,  3524,  3531,  3535,  3526,  3537,  3528,
    1346,  4434,  1347,  3410,  3530,  4354,  3525,  3527,  1803,  3529,
    3532,  1804,  3539,  3541,  2235,  3543,  3566,  1812,  3550,  4545,
    3556,  3557,  3559,  3576,  3579,  1822,  3624,  3626,  1823,  1824,
    1825,  3607,  1826,  1827,  1828,  1829,  1830,  1831,  3622,  3606,
    1810,  3613,  3574,  3628,  3637,  3636, -2420,  3650,  3645,  3651,
    1348,   672,  3654,  3655,  4083,  3647,  3659,  3658,  4544,  4467,
    3671,  4546,  3682,  3690,  3691,  1632,  4482,  3709,  3710,  4704,
    1812,  3693,  3697,  3699,  4492,  3997,  3711,  4280,  3998,  3712,
    3999,  4686,  3715,   672,  3722,  4557,  4547,  3720,  4689,  3927,
    3928,  3929,  3930,  3723,  3724,  3741,  3732,  3487,  3996,  3489,
    3735,  3737,  4548,   847,   848,   849,  4549,   850,   851,   852,
     853,   854,   855,  3218,  3239,  3750,  4694,  1757,  4696,  3238,
   -1932,   772,  3791,  1813,  2976,  3802,  4550,  3831,  1814,  4551,
    2976,  2976,  3775,  2976,  3815,  3811,  3776,  3777,  3783,  3564,
    4318,  3803,  4552,  3806,  4631,  3853,  3855,  3858,  3155,  1815,
    1816,  1098,  1099,  3821,  3839,  3868,  3870,  3871,  3872,  3881,
    3534,  3873,  3878,  3886,  1817,  3896,  3902,  3923,  3925,  3926,
    3939,  3931,  3938,  3940,  3941,  3943, -2420,  3945,  3954,  3969,
    3970, -2420,  3957,  1797,  3971,  3548,  3972,  3984,  3982,  3983,
    3991,  3985,  3986,  3987,  3994,  3990,  1818,  4003,  4004,  4271,
    4011,  4026,  4030,  4028,  4033,  3949,  4040,  4042,  3993,  1819,
    4039,  4043,  1820,  4820,  4822,  4046,  4055, -2420,  3673,  4066,
    4063,  4071,  4553,  4073,  4079,  4087,  4095,  4086,  4814,  2447,
    4554,  4089,  4113,  4290,  4291,  4106,  4107,  4090,  4119,  4120,
    4122,  4123,  4125,  4583,  4126,  4109,   181,  4128,  4146,  4129,
    4137,  4142,  4148,  4149,  4153,  2551,  4154,  4156,  4164,  4948,
    4173,  4174,  1819,  4175,  4159, -1934,  4213,  4056,  4555,   857,
    4169,  4176,  4221,  4222,  4227,  4214,  4168,  2823,  4636,  4229,
    4177,  4181,  4196,  4209,  4208,  4211,  4226,  4230,  4232,  4500,
    4233,  4234,  1821,  4240,  4247,  4250,  1803,  4252,   672,  1804,
    4254,  4259,  4260,  4292,  4268,  4293,  4152,  4285,  3685,  4152,
    4286,  4152,  4332,  4333,  4294,  4305,  4706,  4315,  4317,  4308,
    4320,  4889,  4948,  4321,   681,  4326,   683,  4334,  1810,  4339,
     689,  4347,  4348,  4521, -2420,  4355,   706,   714,   681,  4360,
     721,  4948,  4364,   714,   714, -2420,   750,  4770,   753,  4366,
    4368,  4371,  4365,  4374,  4376,  4386,  4393,  4395,  1812,  4779,
    4396,  4397,  4406,  4398,  4781,  4411,  4783,  4417,  4418,  4427,
    4428,  4430,  4435,  4439,  4437,  3315,  4438,  4440,  4446,  3315,
    4453,  4464,  4460,  4484,  4486,  1822,  3340,  4489,  1823,  1824,
    1825,  4494,  1826,  1827,  1828,  1829,  1830,  1831,  4490,  4480,
    4299,  4505,  4509,  4508,  4518,  3259,  4413,  4558,  4560,  4414,
    4415,  3742,  4309,  4814,  4523,  4524,  4539,  4062,  4528,  4567,
    4569,  4570,  4572,  4194,  4573,  4419,  4588,  4574,  4593,  4595,
    4516,  3306,  3751,  4594,  4598,  3306,  4600,  4603, -2420,  4604,
    4615,  4617,  4236,  4934,  4238,  1826,  1827,  1828,  1829,  1830,
    1831,  4619,  4632,  4635,  4639,  4644,  4647,  3774,  -130,  4618,
    4678,  4693,  4652,  4253, -2420,  4651,  4660,  4721,  4733, -2420,
    4654,  4726,  4671,  4680,  4242,   181,     1,  4656,  4730,  4731,
    4738,  4744,  4750,  4751,  4752,  4759,     2,  4762,     3,     4,
    4769,  1738,  2495,   808,   813,   813,   816,  4760,   813,  4761,
     822,  4768,   808,     5,   750, -2420,  4785,   859,  4786,  4789,
    4790,  4792,  4776,   750,  4805,  4687,   750,  4782,  4801,  4819,
     813,  4825,   750,     6,  4826,     7,     8,  4829,  4834,  4831,
    4837,     9,  4839,    10,   672,  4840,  4847,  4848,  4855,  2496,
    4849,  4856,  4883,  4864,    11,   986,    12,  4827,  3816,  4287,
    1819,  4876,  4890,  4878,  4828,  4898,  4302,  4303,  4919,  4925,
    4902,  4306,  4307,    13,  3574,  4897,    14,  4938,  4959,  4957,
    2497,  4958,  4963,   672,  4960,  4969,  4970,  4973,  3155,    15,
    4977,    16,  4978,  4982,  4983,    17,  4985,  4986,  4984,  1441,
    1396,    18,  2498,  2248,  1301,  3036,  3332,  2872,  3442,    19,
    3960,    20,  4357,  2499,  2957,  4329,  4330,    21,  3565,  1872,
    4049,  4715,  4813,  4936,  2976,  4797,  2976,  2976,  4597,  4075,
    2976,  4599,    22,  2500,  4352,  4582,  3382,  3143,  2501,  4879,
    4498,  4932,  4832, -2420,  4830,  4896,  3387,  4110,    23,  4094,
    4070,  3958,  3014,  3015,  3459,  2326,  4082,  4369,  4937,  3632,
    4987,  3005,  4974,  4571,  3580,   857,  4900,  3577,  4522,  4807,
    4884,   688,  2308,  4525,  4378,  4143,  4666,  1732,  2716,  1742,
    4116,  3370,  4757,   987,  1061,  2485,  2502,    24,    25,  2486,
    3538,  2487,  3155,    26,  3155,  4312,  4380,   181,  3340,  4976,
    4910,  2667,  2438,  4399,  2048,    27,  4324,  2503,  4626,   857,
    2668,  4794,  4098,  1273,   986,  4873,    28,  3890,  4243,  2000,
    3338,  4328,  3347,  2694,  1999,  3869,  4869,  1845,  3345,  4784,
    1971,  4237,  2693,  4152,  2004,  3834, -2420,  4152,  4152,  3349,
    4152,  4219,  4646,  1826,  1827,  1828,  1829,  1830,  1831,    29,
    4207,  3830,  4775,  4774,  3315,  3891,  3692,    30,  2009,  3315,
    4630,  3785,  4483,  2383,  3315,  4872,  4871,  3315,  4462,    31,
    4863,   207,  2632,  3341,    32,    33,  3195,    34,  3284,  3282,
    3334,  2641,    35,  4668,     0,     0,     0,    36,     0,  4381,
      37,  3315,     0,     0,     0,    38,     0,     0,  2504,     0,
      39,    40,     0,     0,  3315,  2505,     0,     0,    41,     0,
       0,  2506,    42,     0,     0,  3306,     0,     0,     0,     0,
    3306,     0,    43,  3306,     0,     0,     0,     0,  4699,     0,
       0,     0,     0,     0,    44,     0,     0,  4078,     0,     0,
       0,     0,     0,  2507,     0,     0,  2508,     0,  4520,  4491,
       0,     0,     0,    45,     0,     0,  4485,     0,     0,     0,
       0,     0,   894,    46,  2509,     0,     0,     0,   750,    47,
     808,     0,     0,   813,    48,   816,  3574,   813,     0,     0,
       0,     0,     0,     0,   859,   672,     0,    49,   961,  2510,
       0,   826,     0,     0,     0,   813,     0,     0,     0,   986,
       0,     0,  1803,     0,     0,  1804,     0,     0,    50,  1805,
    1806,  1807,     0,     0,     0,     0,     0,     0,  2976,   808,
       0,     0,    51,     0,   816,  -130,  1808,     0,     0,   808,
       0,     0,     0,   859,  1810,     0,     0,     0,     0,  1803,
    1811,     0,  1804,     0,  3315,     0,  1805,  1806,  1807,     0,
     813,     0,     0,  4501,  4502,  4502,     0,     0,     0,     0,
       0,     0,     0,  1808,  1812,     0,     0,     0,     0,  4587,
     181,  1810,  1149,     0,     0,  3218,     0,  1811,     0,  3219,
    3220,  3221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4608,   181,     0,   750,
       0,  1812,   714,   714,   714,     0,  3315,     0,     0,     0,
       0,     0,     0,     0,     0,   750,     0,  1132,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1738,   765,     0,
       0,     0,     0,     0,     0,     0,     0,  1245,  1245,     0,
     750,   714,     0,     0,     0,   714,     0,   765,     0,     0,
       0,     0,  1803,     0,     0,  1804,     0,     0,     0,   750,
       0,     0,  3306,   750,     0,     0,     0,     0,     0,  1245,
    1813,     0,     0,  1795,     0,  1814,     0,   857,     0,     0,
       0,   750,     0,     0,  1810,     0,     0,     0,     0,  4609,
   -2420,     0,  1795,   750,     0,     0,  1815,  1816,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1813,     0,     0,
       0,  1817,  1814,     0,  1812,     0,     0,     0,  4732,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   985,     0,
       0,     0,  4708,  1815,  1816,     0,   750,   672,     0,     0,
       0,     0,  4716,  1818,     0,     0,     0,  4272,  1817,     0,
       0,     0,   750,     0,     0,     0,  1819,   813,   813,  1820,
       0,     0,  4929,     0,     0,  1149,  3223,     0,  3218,     0,
       0,     0,  3219,  3220,  3221,     0,     0,     0,  4289,     0,
    1818,     0,   714,   714,  3315,     0,     0,     0,     0,  3798,
       0,     0,     0,  1819,     0,     0,  4745,   181,     0,  4304,
       0,     0,     0,     0,     0,     0,     0,     0,   808,  3315,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   808,
   -2420,     0,     0,   859,     0, -2420,  3224,     0,     0,  4695,
    3155,  4697,     0,  1149,     0,     0,  3218,     0,   813,  1821,
    3219,  3220,  3221,  1149,     0,     0,  3218,     0,     0,     0,
    3219,  3220,  3221,     0,     0,     0,     0,  4331,   750,     0,
       0, -2420,     0,     0,     0,   813,   813,  4190,     0,     0,
       0,     0,     0,     0,     0,     0,  1821,     0,     0,     0,
       0,     0,   750,   750,   750,     0,   813,   985,   808,     0,
    4843,  4817,     0,  4818,     0,     0,     0,  4823,  4824,     0,
       0,     0,     0,     0,     0,     0,  1819,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,
    1827,  1828,  1829,  1830,  1831,     0,  4405,     0,  4882,  2577,
       0,     0,     0,     0,     0,   813,     0,   813,   813,  3223,
       0,     0,  4502,     0,     0,     0,     0,     0,     0,  1822,
       0,     0,  1823,  1824,  1825,     0,  1826,  1827,  1828,  1829,
    1830,  1831,     0,     0,     0,  1245,     0,     0,     0, -2420,
       0,     0,  1738,     0,     0,  3315,     0,     0,     0,     0,
       0,   826,   826,     0,     0,  3225,  3226,  3227,     0,  3228,
    3229,  3230,  3231,  3232,  3233,  1715,  1715,     0,     0,  3224,
     750,     0,   681,     0,     0,     0,     0, -2420,     0,     0,
       0,  4838,     0,     0,     0,     0,     0,  3223,     0,     0,
       0,  4901,   181,     0,     0,     0,     0,     0,  1746,     0,
       0,   750,     0,     0,  1752,  4915,   181,  4912,   185,  4913,
    4914,     0,     0,     0,     0,  4956,     0,  1245,     0,     0,
       0,     0,   985,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2420,     0,     0,     0,  4947,  3224,     0,  1826,
    1827,  1828,  1829,  1830,  1831,  4946,  1245,  3224,     0,     0,
       0,     0,     0,     0,     0,  4886,     0,     0,     0,  4915,
    4955,  4912,   185,  4913,  4914,     0,     0,     0,     0,  4980,
       0,     0,     0,     0,  1245,  1245,  1245,     0,  1245,     0,
       0,   826,   826,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1245,  4947,
       0,     0,     0,     0,     0,     0,     0,     0,  4946,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4947,  4915,
     181,  4912,   185,  4913,  4914,     0,  4935,  4946,     0,     0,
       0,     0,     0,  1802,     0,     0,   750,     0,  1803,  1245,
       0,  1804,     0,     0,     0,  1805,  1806,  1807,  3225,  3226,
    3227,     0,  3228,  3229,  3230,  3231,  3232,  3233,     0,     0,
       0,     0,  1808,     0,     0,  1809,     0,     0,     0,  1245,
    1810,     0,     0,  1245,  1245,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,   750,   750,  2013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1812,     0,  1738,     0,     0,     0,     0,   714,     0,     0,
       0,     0,     0,     0,     0,     0,  3225,  3226,  3227,     0,
    3228,  3229,  3230,  3231,  3232,  3233,  3225,  3226,  3227,     0,
    3228,  3229,  3230,  3231,  3232,  3233,     0,     0,     0,     0,
    3534,     0,  2112,     0,     0,     0,     0,   714,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     750,  2138,     0,     0,     0,     0,     0,     0,     0,   750,
       0,     0,   813,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1738,   859,     0,   750,  1738,  1738,     0,
       0,     0,     0,     0,   750,     0,  1813,   750,     0,     0,
       0,  1814,     0,  1803,     0,     0,  1804,     0,     0,     0,
    1805,  1806,  1807,     0,     0,     0,     0,     0,     0,     0,
     750,     0,  1815,  1816,     0,     0,     0,  1808,   813,   813,
     813,   813,   750,     0,     0,  1810,     0,  1817,     0,     0,
       0,  1811,     0,   714,     0,     0,   750,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2260,     0,   750,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,  1818,
       0,   813,   813,     0,     0,     0,     0,     0,     0,  4758,
     813,     0,  1819,     0,     0,  1820,     0,     0,     0,     0,
     813,  1149,     0,     0,  3218,     0,     0,     0,  3219,  3220,
    3221,     0,     0,     0,     0,     0,     0,     0,     0,   750,
       0,     0,     0,     0,     0,  4191,     0,     0,   813,   813,
     813,   813,     0,     0,     0,     0,     0,     0,     0,     0,
     750,     0,     0,     0,     0,     0,     0,   750,     0,     0,
    2260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     808,     0,  1803,     0,     0,  1804,     0,   816,     0,  1805,
    1806,  1807,  1245,     0,     0,  1821,     0,     0,     0,     0,
       0,  1813,     0,     0,     0,     0,  1814,     0,     0,     0,
       0,     0,     0,     0,  1810,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,  1815,  1816,   808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   859,
       0,     0,  1817,   813,  1812,     0,   813,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   813,     0,     0,     0,
       0,     0,     0,     0,   813,   813,     0,     0,     0,   750,
       0,     0,     0,     0,  1818,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1819,  1822,     0,
    1820,  1823,  1824,  1825,  1715,  1826,  1827,  1828,  1829,  1830,
    1831,   813,     0,   808,     0,     0,     0,   750,   750,     0,
     813,  1803,     0,     0,  1804,  3223,     0,   750, -2420, -2420,
   -2420,     0,     0,     0,   750,     0,     0,     0,     0,   681,
     681,     0,     0,  2494,     0,     0,     0,  1245,     0,  1245,
       0,     0,     0,  1810,  1245,  1245,     0,     0,     0,  1811,
    1813,  1245,  1245,  1245,     0,  1814,     0,  1245,   859,  1245,
    1245,  1245,  1245,  1245,  1245,     0,  1245,     0,  1245,  1245,
    1821,     0,  1245,  1812,     0,  3224, -2420, -2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1245,  1245,  1245,
    1245,  1817,     0,     0,   813,  1245,     0,     0,     0,  1245,
       0,     0,  1245,     0,     0,  1245,  1245,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,  1372,  1245,     0,     0,     0,     0,
       0,   750,  1245, -2420,  1245,     0,     0,     0,     0,     0,
       0,   750,     0,     0,     0,     0,  1819,     0,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,  1373,  1804,     0,
       0,     0,  1805,  1806,  1807,     0,     0,     0,     0,     0,
       0,     0,     0,  1822,     0,     0,  1823,  1824,  1825,  1808,
    1826,  1827,  1828,  1829,  1830,  1831,     0,  1810,     0,  1813,
    3578,     0,     0,  1811,  1814,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1399,     0,     0,     0,     0,
       0,  1400,     0,     0,     0,  1375,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,     0,  1804,  1821,
    1817,     0,  1805,  1806,  1807,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1376,  1808,
       0,  1401,     0,     0,     0,     0,     0,  1810,   750,     0,
     750,     0,  1245,  1811,  3225,  3226,  3227,     0,  3228,  3229,
    3230,  3231,  3232,  3233,     0,  1819,     0,  1803,     0,     0,
    1804,     0,     0,  1377,  1805,  1806,  1807,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   750,     0,     0,
    1402,  1808,     0,  1403,  2702,     0,  2709,     0,     0,  1810,
    1404,     0,     0,  1405,     0,  1811,  1378,     0,     0,     0,
       0,     0,  1822,  1813,     0,  1823,  1824,  1825,  1814,  1826,
    1827,  1828,  1829,  1830,  1831,   816,     0,     0,  1406,  1812,
       0,     0,     0,     0,   681,  1380,   681,     0,     0,  1815,
    1816,  1343,     0,     0,     0,     0,     0,     0,  1821,     0,
       0,     0,     0,  1245,  1817,     0,     0,     0,     0,  1407,
       0,     0,     0,     0,   808,     0,   813,   813,     0,     0,
       0,   808,     0,   859,    35,   813,  2122,   813,  1382,     0,
       0,   813,     0,  1813,   750,  1383,  1818,     0,  1814,     0,
       0,     0,  1384,     0,     0,     0,     0,     0,     0,  1819,
    2123,     0,  1820,     0,     0,   714,     0,     0,     0,  1815,
    1816,     0,  1386,     0,     0,  2138,     0,  1408,     0,  1409,
    1387,     0,     0,  2825,  1817,     0,     0,     0,     0,  1410,
    2836,     0,     0,     0,     0,  1813,     0,  1411,     0,   750,
    1814,  1822,     0,     0, -2420, -2420, -2420,  1412,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,  1818,     0,     0,   750,
       0,  1815,  1816,     0,  2881,  2881,     0,     0,     0,  1819,
       0,     0,  1820,   816,  1388,     0,  1817,     0,     0,     0,
       0,     0,  1821,  1413,     0,     0,  1414,  1415,     0,     0,
     813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,  1818,     0,
    1400,     0,     0,  1416,     0,     0,     0,  2946,     0,  2949,
    2951,  1819,     0,     0,  1820,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   813,     0,     0,     0,
    1401,     0,  1821,     0,   813,     0,   813,  1803,     0,     0,
    1804,     0,   813,     0,  1805,  1806,  1807,  2082,     0,     0,
       0,     0,     0,     0,  1245,  1822,  1417,     0,  1823,  1824,
    1825,  1808,  1826,  1827,  1828,  1829,  1830,  1831,  2138,  1810,
       0,  2881,  3743,   750,     0,  1811,  3037,     0,     0,   681,
    2083,     0,  1403,     0,  1821,     0,     0,     0,  1803,  1404,
       0,  1804,  1405,  2084,     0,  1805,  1806,  1807,     0,  1812,
       0,     0,     0,     0,     0,  2946,     0,  2085,     0,     0,
       0,     0,  1808,     0,   813,  3063,     0,  1406,     0,     0,
    1810,     0,     0,     0,     0,  1822,  1811,     0,  1823,  1824,
    1825,     0,  1826,  1827,  1828,  1829,  1830,  1831,  1245,     0,
       0,     0,  3794,     0,     0,     0,     0,  2086,  1407,     0,
    1812,     0,     0,  3107,     0,     0,     0,     0,  2087,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   813,     0,
     813,  2881,   813,  2881,     0,     0,     0,  1822,  2088,     0,
    1823,  1824,  1825,  2089,  1826,  1827,  1828,  1829,  1830,  1831,
       0,     0,     0,     0,  3877,     0,  1245,     0,     0,     0,
       0,     0,     0,     0,     0,  1813,  1408,     0,  1409,  1715,
    1814,     0,     0,     0,     0,     0,     0,     0,  1410,     0,
       0,     0,     0,     0,     0,     0,  1411,     0,     0,     0,
       0,  1815,  1816,     0,     0,     0,  1412,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1817,   750,     0,     0,
       0,     0,  2090,     0,     0,     0,  1813,   808,     0,     0,
       0,  1814,     0,   808,     0,     0,     0,     0,     0,     0,
       0,     0,  1469,     0,   813,  1414,  1415,     0,  1818,     0,
       0,  1245,  1815,  1816,  2091,     0,  1245,     0,     0,     0,
       0,  1819,     0,     0,  1820,     0,     0,  1817,     0,     0,
       0,     0,  1470,     0,     0,     0,     0,     0,     0,  1245,
    1245,  1245,     0,     0,  1245,     0,   207,     0,     0,     0,
       0,     0,  1245,  1245,  1245,  1245,     0,     0,     0,  1818,
       0,     0,     0,     0,     0,  1245,     0,     0,  1245,     0,
    1245,     0,  1819,     0,     0,  1820,     0,     0,     0,     0,
    2092,  1245,  1245,     0,     0,  1245,  2093,     0,     0,  2094,
       0,     0,     0,     0,     0,  1417,     0,   859,     0,  1245,
       0,  1245,     0,  1245,  1821,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2095,     0,
       0,  1803,     0,  1245,  1804,  2096,     0,   750,  1805,  1806,
    1807,     0,  2097,     0,  3316,     0,  1245,  1245,  1245,  2098,
       0,  1803,     0,     0,  1804,  1808,     0,  1372,  1805,  1806,
    1807,     0,     0,  1810,  1245,  1821,     0,     0,     0,  1811,
       0,     0,     0,     0,  2099,  1808,  1245,     0,     0,     0,
       0,  1245,     0,  1810,     0,     0,     0,  1245,     0,  1811,
    1373,     0,     0,  1812,     0,     0,     0,  3316,  1399,     0,
    3355,     0,     0,  3358,  1400,  2709,     0,  1822,     0,     0,
    1823,  1824,  1825,  1812,  1826,  1827,  1828,  1829,  1830,  1831,
    1374,     0,     0,     0,  3904,     0,     0,     0,     0,  1446,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,  1245,  1375,  2881,
       0,     0,     0,     0,  1715,     0,     0,     0,  1822,     0,
       0,  1823,  1824,  1825,     0,  1826,  1827,  1828,  1829,  1830,
    1831,     0,     0,     0,     0,  4160,     0,  1447,     0,     0,
     813,  1376,   813,   813,   813,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,  1813,
       0,     0,     0,  1404,  1814,     0,  1405,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1377,     0,     0,  1813,
       0,     0,     0,     0,  1814,  1815,  1816,     0,     0,     0,
       0,  1406,     0,     0,     0,     0,     0,     0,     0,     0,
    1817,     0,     0,     0,     0,  1815,  1816,     0,     0,  1378,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1448,
    1817,     0,  1407,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1818,     0,     0,     0,     0,  1379,  1380,     0,
       0,     0,     0,     0,  1343,  1819,     0,     0,  1820,     0,
       0,   750,  1818,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1819,     0,  1449,  1820,     0,
    1450,     0,     0,  1381,     0,     0,     0,    35,     0,     0,
    1451,  1382,  1409,     0,   838,     0,     0,     0,  1383,     0,
       0,     0,  1410,   868,     0,  1384,     0,     0,     0,     0,
    1411,     0,   883,  1385,     0,     0,     0,     0,     0,  1452,
    1412,     0,     0,     0,     0,  1386,     0,     0,     0,     0,
       0,     0,     0,  1387,     0,     0,     0,     0,  1821,     0,
       0,     0,     0,     0,   813,     0,     0,     0,     0,     0,
       0,  2881,  2881,     0,     0,     0,  1453,     0,  1821,  1414,
    1415,  1454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,     0,  1804,     0,
       0,     0,  1805,  1806,  1807,     0,  1455,  1388,   750,   750,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1808,
    1456,     0,     0,     0,   750,     0,     0,  1810,     0,     0,
       0,     0,     0,  1811,     0,     0,     0,     0,     0,  1715,
     750,     0,     0,     0,     0,     0,     0,     0,  1715,   750,
     750,  1822,     0,     0,  1823,  1824,  1825,  1812,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,   750,     0,  4195,  1417,
       0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,     0,     0,  4425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   813,
       0,   813,     0,     0,     0,   813,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   750,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,   750,  1814,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   813,
       0,     0,     0,     0,     0,     0,  1245,     0,     0,  1815,
    1816,     0,     0,     0,     0,  1245,     0,     0,     0,     0,
       0,  1245,     0,  1245,  1817,     0,  1245,     0,     0,     0,
       0,  1245,  1245,  1245,  1245,     0,     0,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,  1245,  1245,  1245,     0,     0,     0,
    1245,  1245,     0,     0,     0,     0,  1818,     0,     0,     0,
    1245,     0,     0,     0,  1245,     0,     0,     0,  1245,  1819,
       0,     0,  1820,     0,     0,     0,  1245,     0,     0,  1245,
       0,  1245,   892,     0,     0,     0,     0,     0,   933,     0,
    1245,     0,     0,  1245,  1245,     0,     0,     0,  1245,  1245,
       0,  1803,     0,  3818,  1804,  1245,     0,     0,  1805,  1806,
    1807,     0,   750,   750,   750,   808,     0,  3316,  3838,     0,
       0,     0,  3838,  3852,     0,  1808,  1399,     0,     0,  1245,
       0,     0,  1400,  1810,     0,  1245,  1245,  1245,     0,  1811,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1821,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1245,  1812,     0,     0,     0,     0,     0,     0,
       0,     0,  1401,  2709,     0,  1245,     0,     0,   594,     0,
       0,     0,     0,     0,   640,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   694,  3910,  1715,  1715,     0,
    2260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   762,   762,     0,     0,   813,   813,
     813,   813,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,  1404,     0,     0,  1405,  1130,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1822,     0,  2138,  1823,  1824,
    1825,     0,  1826,  1827,  1828,  1829,  1830,  1831,     0,  1406,
    1252,  3956,  4436,     0,     0,     0,     0,     0,     0,  1813,
       0,     0,     0,     0,  1814,     0,     0,     0,     0,  1275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1407,     0,     0,     0,     0,  1815,  1816,     0,     0,     0,
       0,  1302,     0,     0,     0,     0,     0,     0,     0,     0,
    1817,  1803,     0,     0,  1804,     0,     0,     0,  1805,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,     0,     0,
       0,     0,  1818,  1810,     0,     0,     0,     0,  1408,  1811,
    1409,  4034,     0,     0,     0,  1819,     0,     0,  1820,     0,
    1410,     0,     0,   821,     0,     0,     0,     0,  1411,     0,
       0,   861,  1427,  1812,   865,   866,     0,   869,  1412,     0,
     875,     0,   877,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   750,     0,   813,     0,  1245,     0,
       0,     0,     0,     0,   750,     0,     0,     0,     0,     0,
    4069,     0,     0,     0,  1495,     0,     0,  1414,  1415,  2138,
       0,     0,     0,  1803,     0,     0,  1804,     0,     0,     0,
    1805,  1806,  1807,     0,     0,     0,     0,     0,  1821,   750,
       0,     0,     0,     0,  1496,     0,     0,  1808,     0,  2946,
       0,     0,     0,     0,     0,  1810,     0,  4103,     0,     0,
       0,  1811,     0,     0,     0,     0,     0,   750,     0,     0,
       0,  2260,     0,     0,     0,  1245,  1245,     0,  1550,  1813,
       0,     0,     0,     0,  1814,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1580,  1583,  1584,  1815,  1816,  1417,     0,  2881,
       0,  2881,     0,     0,     0,     0,     0,     0,     0,     0,
    1817,   750,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,     0,     0,  4445,     0,
       0,  1245,  1818,     0,     0,  1399,     0,     0,     0,     0,
       0,  1400,  1245,     0,     0,  1819,     0,     0,  1820,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,  1245,     0,     0,     0,  1814,     0,     0,     0,
       0,  1401,  1245,  1245,     0,     0,     0,     0,     0,  1245,
    1245,     0,     0,     0,  1245,     0,     0,  1815,  1816,  1245,
       0,     0,  1245,  1245,     0,     0,     0,  1245,  4199,     0,
       0,     0,  1817,  1245,   750,   750,   750,   750,     0,     0,
    1252,  3838,  3852,     0,  3838,     0,     0,  4210,  1821,     0,
    2178,  3316,     0,  1403,     0,  3316,     0,     0,     0,     0,
    1404,  4225,     0,  1405,  1818,     0,     0,  1245,     0,     0,
       0,  1252,  1245,     0,     0,     0,     0,  1819,  1245,     0,
    1820,     0,     0,     0,     0,   859,     0,     0,  1406,     0,
       0,     0,     0,  1245,     0,     0,  3355,     0,     0,     0,
       0,  2709,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   681,     0,     0,  1245,     0,  1407,
       0,     0,     0,     0,   936,     0,     0,     0,     0,     0,
       0,     0,   944,     0,     0,     0,     0,  2881,  2881,   957,
       0,  1822,   962,   963,  1823,  1824,  1825,   965,  1826,  1827,
    1828,  1829,  1830,  1831,     0,  2138,  2661,     0,   982,     0,
    1821,     0,     0,     0,  4288,     0,     0,     0,     0,     0,
       0,     0,     0,   991,     0,     0,     0,  1408,     0,  1409,
       0,     0,     0,     0,     0,     0,     0,     0,  1051,  1410,
    1055,     0,     0,  1057,     0,  1059,     0,  1411,  1063,     0,
       0,     0,     0,     0,     0,  1245,  1874,  1412,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   813,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     813,     0,     0,  2179,     0,     0,  1414,  1415,     0,     0,
       0,     0,     0,  1822,     0,  2011,  1823,  1824,  1825,     0,
    1826,  1827,  1828,  1829,  1830,  1831,     0,  1245,     0,  1131,
    4448,     0,     0,  2180,     0,     0,     0,     0,   808,  1032,
       0,     0,     0,  2138,     0,     0,     0,     0,     0,     0,
       0,  1715,     0,     0,     0,     0,  1803,     0,     0,  1804,
    1032,     0,     0,  1805,  1806,  1807,     0,     0,   813,  3063,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,   762,     0,     0,     0,  1810,     0,
    2132,     0,     0,     0,  1811,     0,  1417,   750,     0,  2155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,     0,  2190,     0,     0,     0,
       0,     0,     0,     0,  2196,     0,  1245,  2199,     0,     0,
       0,     0,     0,     0,  1363,  1245,  1803,     0,     0,  1804,
       0,     0,     0,  1805,  1806,  1807,     0,     0,     0,     0,
       0,     0,  1245,  1245,     0,     0,  1245,     0,     0,     0,
    1808,     0,  2234,     0,     0,     0,     0,     0,  1810,     0,
     808,  3838,     0,     0,  1811,  3316,  2249,     0,     0,     0,
    3316,     0,     0,  3316,   808,     0,  2946,     0,  4466,  2261,
       0,  1245,  1245,     0,     0,     0,     0,     0,  1812,  1498,
       0,     0,     0,     0,     0,     0,     0,  3910,     0,     0,
       0,     0,     0,     0,  1813,  1511,     0,     0,     0,  1814,
    3910,   859,   813,   813,   813,     0,     0,  1522,     0,  1523,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,  2312,
    1815,  1816,     0,     0,     0,     0,     0,     0,     0,  1532,
       0,     0,     0,     0,  1541,  1817,     0,  1545,     0,     0,
    2346,     0,     0,     0,   808,   859,     0,  2358,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,     0,
       0,     0,  1590,     0,     0,     0,     0,     0,     0,     0,
    1819,     0,     0,  1820,  1813,     0,     0,   808,     0,  1814,
     750,  1399,     0,     0,     0,     0,     0,  1400,     0,  1032,
    4069,     0,     0,     0,     0,     0,   750,     0,  2881,     0,
    1815,  1816,     0,     0,  2138,     0,     0,     0,     0,  1032,
       0,     0,     0,     0,     0,  1817,     0,  4103,     0,     0,
       0,     0,     0,  1032,     0,     0,     0,  1401,   813,   750,
    3910,     0,     0,     0,     0,     0,     0,     0,     0,  2436,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,     0,
       0,     0,     0,  1821,     0,     0,     0,     0,     0,  1245,
    1819,     0,  1245,  1820,  1245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1252,  1252,  1403,
       0,     0,     0,     0,     0,     0,  1404,     0,  1245,  1405,
       0,     0,  3316,     0,  2484,     0,  4466,  1733,     0,     0,
    1032,     0,     0,  1245,     0,     0,     0,     0,     0,     0,
    1803,     0,  4659,  1804,  1406,     0,     0,  1805,  1806,  1807,
       0,     0,  1245,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1808,     0,     0,   750,     0,     0,
       0,     0,  1810,  1821,     0,  1407,  1822,     0,  1811,  1823,
    1824,  1825,     0,  1826,  1827,  1828,  1829,  1830,  1831,     0,
    1245,     0,     0,  4496,     0,     0,     0,   813,   813,   813,
     813,     0,  1812,     0,     0,     0,     0,     0,     0,     0,
    3079,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2640,     0,     0,     0,     0,     0,     0,     0,  1372,
       0,  2655,     0,  1408,   808,  1409,     0,     0,     0,  1032,
       0,     0,     0,     0,     0,  1410,     0,     0,     0,     0,
     750,     0,     0,  1411,     0,  1245,     0,     0,     0,     0,
       0,     0,  1373,  1412,     0,     0,  1822,     0,     0,  1823,
    1824,  1825,     0,  1826,  1827,  1828,  1829,  1830,  1831,     0,
       0,     0,     0,  4527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1245,     0,  2103,
     808,     0,  1414,  1415,     0,     0,     0,     0,  1813,  1245,
       0,   762,  1973,  1814,  1245,     0,  1245,     0,  1245,     0,
    1375,     0,     0,     0,     0,  3910,     0,     0,     0,  2104,
       0,   813,     0,   859,  1815,  1816,     0,     0,     0,     0,
       0,     0,  1245,     0,     0,     0,     0,     0,  2666,  1817,
    2669,     0,     0,  1376,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1715,  1715,     0,     0,     0,     0,  1859,
       0,  1818,     0,  3080,  2101,     0,     0,  1252,  1377,     0,
       0,     0,  1417,     0,  1819,     0,     0,  1820,     0,     0,
     813,     0,     0,     0,     0,     0,   808,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3079,     0,
       0,  1378,  1803,     0,     0,  1804,     0,     0,     0,  1805,
    1806,  1807,     0,  1245,  1245,     0,     0,  1372,  2946,     0,
       0,     0,     0,  1032,  1245,     0,  1808,  4659,  2189,     0,
    1380,  2709,     0,     0,  1810,     0,  1343,     0,     0,  1803,
    1811,     0,  1804,     0,   808,     0,  1805,  1806,  1807,     0,
    1373,     0,     0,     0,   813,     0,     0,  1821,     0,     0,
       0,  1715,     0,  1808,  1812,     0,     0,     0,     0,    35,
       0,  1810,     0,  1382,     0,     0,     0,  1811,     0,     0,
    1383,     0,     0,  2138,     0,     0,     0,  1384,     0,  1032,
       0,  3910,     0,     0,     0,  2123,     0,   808,   808,  1245,
       0,  1812,     0,     0,     0,     0,     0,  1386,  1375,     0,
       0,     0,     0,     0,     0,  1387,     0,     0,  1245,  2848,
       0,     0,     0,     0,     0,   813,  1032,     0,     0,     0,
       0,     0,     0,     0,     0,  3082,     0,     0,     0,  2875,
       0,  1376,     0,  2304,     0,     0,     0,     0,     0,     0,
    1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,  1828,
    1829,  1830,  1831,     0,     0,     0,     0,  4565,     0,  1388,
    1813,  3080,     0,  3083,  3673,  1814,  1377,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,  1816,     0,     0,
       0,  1245,  1245,     0,     0,     0,  1032,  1813,     0,  1378,
       0,  1817,  1814,     0,     0,   808,     0,     0,     0,     0,
       0,  1032,     0,     0,     0,     0,     0,   808,   808,  1032,
       0,     0,     0,  1815,  1816,     0,     0,     0,  1380,     0,
    1032,  2401,     0,  1818,  1343,     0,     0,     0,  1817,     0,
       0,     0,     0,     0,     0,  2415,  1819,     0,  2418,  1820,
    2420,     0,  2421,     0,     0,     0,     0,     0,  2423,     0,
       0,     0,     0,  3033,     0,     0,     0,    35,     0,     0,
    1818,  3081,     0,     0,     0,     0,     0,  1032,  1383,     0,
       0,     0,     0,  1819,     0,  1384,  1820,     0,     0,     0,
    1032,     0,     0,  2123,     0,     0,     0,     0,     0,     0,
       0,  3079,  1032,  1973,     0,  1386,     0,  1973,     0,  1973,
       0,     0,  1973,  1387,  1032,     0,     0,     0,     0,     0,
    1372,     0,     0,     0,     0,     0,     0,     0,     0,  1821,
       0,     0,     0,  3082,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1373,     0,     0,     0,     0,  1032,     0,
       0,  1032,     0,     0,     0,     0,  1821,  1388,     0,     0,
       0,  3083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,  1804,     0,     0,     0,  1805,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,     0,     0,
    1399,  1375,     0,  1810,     0,     0,  1400,     0,     0,  1811,
       0,     0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,
    1827,  1828,  1829,  1830,  1831,     0,     0,  3172,     0,  4810,
       0,     0,     0,  1812,  1376,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,  1822,
       0,     0,  1823,  1824,  1825,     0,  1826,  1827,  1828,  1829,
    1830,  1831,     0,     0,  3080,     0,  4842,     0,     0,  1377,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1032,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1803,     0,     0,  1804,     0,     0,  1403,  1805,
    1806,  1807,  1378,     0,     0,  1404,     0,     0,  1405,     0,
    1803,     0,     0,  1804,     0,     0,  1808,  1805,  1806,  1807,
       0,     0,     0,     0,  1810,     0,     0,     0,     0,     0,
    1811,  1380,     0,  1406,  1808,     0,     0,  1343,  2675,  1813,
       0,     0,  1810,     0,  1814,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1407,  1815,  1816,     0,     0,     0,
      35,     0,  1812,     0,  1382,     0,     0,  3299,     0,     0,
    1817,  1383,     0,     0,     0,     0,     0,     0,  1384,     0,
       0,     0,     0,     0,     0,     0,  2123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1386,  2727,
    2728,     0,  1818,     0,  2731,  2732,  1387,     0,     0,  2735,
    2676,     0,  1408,     0,  1409,  1819,     0,     0,  1820,     0,
       0,     0,     0,  2746,  1410,     0,  3082,     0,     0,     0,
    2755,     0,  1411,     0,  2758,  2759,     0,     0,  2762,  2763,
       0,     0,  1412,     0,     0,  2768,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,  1814,     0,  2784,     0,  2786,
    1388,     0,     0,     0,  3083,     0,     0,     0,  1813,     0,
       0,     0,     0,  1814,     0,     0,  1815,  1816,  2810,     0,
       0,  1414,  1415,  2812,     0,  1032,     0,     0,     0,  1032,
    1032,  1817,     0,     0,  1815,  1816,  2817,     0,  1821,     0,
       0,     0,     0,     0,     0,  2824,     0,  2826,  1416,  1817,
    2829,  2832,  2834,     0,     0,     0,     0,  2842,  2845,     0,
       0,     0,     0,  1818,     0,     0,     0,  2858,     0,     0,
       0,     0,  2867,     0,     0,     0,  1819,  2871,     0,  1820,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1032,     0,  1819,     0,     0,  1820,     0,     0,
       0,     0,     0,  2906,  1032,     0,     0,     0,     0,     0,
       0,  1417,     0,     0,  2913,     0,  2915,     0,     0,     0,
       0,  2918,     0,     0,     0,  2919,     0,  2923,  2924,  2925,
    2926,  1822,  2928,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,  1032,  2953,  2954,  2955,  4961,     0,
       0,     0,     0,     0,     0,  2963,  2964,     0,     0,  1821,
       0,  3495,     0,  1803,     0,     0,  1804,     0,     0,     0,
    1805,  1806,  1807,     0,     0,     0,     0,  1821,     0,     0,
       0,  1803,     0,     0,  1804,     0,     0,  1808,  1805,  1806,
    1807,     0,     0,     0,     0,  1810,     0,     0,     0,     0,
       0,  1811,  1399,     0,     0,  1808,     0,  3008,  1400,     0,
       0,     0,     0,  1810,     0,     0,     0,     0,     0,  1811,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,     0,  2677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,     0,  1399,  1401,     0,
       0,     0,  1822,  1400,     0,  1823,  1824,  1825,     0,  1826,
    1827,  1828,  1829,  1830,  1831,     0,     0,     0,     0,  4979,
    1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,  1828,
    1829,  1830,  1831,     0,     0,     0,     0,     0,  3604,  3605,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,  1032,
    1403,     0,     0,     0,  3614,     0,     0,  1404,     0,  3238,
    1405,     0,     0,     0,  3239,     0,     0,     0,     0,     0,
    3631,     0,     0,     0,     0,     0,     0,     0,     0,  3640,
    3642,  1813,     0,     0,     0,  1406,  1814,     0,     0,     0,
       0,     0,     0,     0,     0,  1403,  3660,     0,     0,  1813,
       0,     0,  1404,     0,  1814,  1405,     0,  1815,  1816,     0,
    1973,     0,     0,     0,     0,     0,  1407,     0,     0,  1032,
       0,     0,  1817,     0,     0,  1815,  1816,     0,     0,     0,
    1406,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1817,  3173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1818,     0,     0,     0,     0,     0,
       0,  1407,     0,     0,     0,     0,     0,  1819,     0,     0,
    1820,     0,  1818,     0,  1408,     0,  1409,     0,     0,     0,
       0,     0,     0,     0,     0,  1819,  1410,     0,  1820,     0,
       0,     0,     0,     0,  1411,     0,     0,  1252,     0,     0,
       0,     0,     0,     0,  1412,     0,     0,     0,     0,     0,
       0,  3786,  1399,     0,     0,     0,     0,     0,  1400,  1408,
       0,  1409,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1410,     0,     0,     0,     0,     0,  1032,     0,  1411,
    2818,     0,     0,  1414,  1415,     0,     0,     0,     0,  1412,
    1821,     0,     0,     0,  1032,     0,     0,     0,  1401,     0,
       0,     0,     0,     0,     0,  1032,     0,     0,  1821,     0,
    1416,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3787,  2920,     0,     0,  1414,  1415,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,  2921,     0,  1404,     0,     0,
    1405,     0,  3826,  3827,  3828,     0,     0,  3336,     0,     0,
       0,     0,     0,  1417,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1822,     0,  1406,  1823,  1824,  1825,     0,
    1826,  1827,  1828,  1829,  1830,  1831,     0,     0,     0,     0,
       0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,  1407,     0,  1417,  3373,
    3374,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,  1804,     0,     0,  1973,  1805,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,     0,     0,
       0,     0,  3395,  1810,     0,     0,     0,     0,     0,  1811,
       0,  3399,     0,     0,  1408,     0,  1409,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1410,  3411,  3413,     0,
       0,     0,  3413,  1812,  1411,     0,     0,  3424,  3425,  3426,
       0,  3428,     0,     0,  1412,     0,     0,  1032,     0,     0,
    1032,     0,  1032,     0,     0,     0,     0,  1032,  1803,     0,
       0,  1804,  3445,     0,     0,  1805,  1806,  1807,     0,     0,
       0,     0,  3451,  3452,  3453,  3454,     0,     0,     0,     0,
    2960,     0,  1808,  1414,  1415,  3197,     0,     0,     0,     0,
    1810,     0,     0,     0,     0,     0,  1811,  1399,     0,     0,
       0,     0,     0,  1400,     0,     0,     0,     0,  1032,  3471,
    2961,     0,  3476,  3477,  3478,     0,  4922,     0,     0,     0,
    1812,     0,  3491,  1803,     0,  1032,  1804,     0,  1446,     0,
    1805,  1806,  1807,     0,     0,     0,     0,     0,     0,  1813,
       0,     0,     0,  1401,  1814,     0,     0,  1808,     0,     0,
    1032,     0,     0,     0,     0,  1810,     0,     0,     0,     0,
       0,  1811,     0,     0,     0,  1815,  1816,     0,     0,     0,
       0,     0,     0,  1417,     0,     0,  1447,     0,     0,     0,
    1817,     0,     0,     0,  4054,  1812,     0,     0,     0,     0,
       0,     0,     0,  3542,  4064,  1403,     0,     0,     0,     0,
       0,  3546,  1404,     0,     0,  1405,     0,     0,     0,     0,
       0,     0,  1818,     0,     0,     0,     0,     0,     0,  1032,
    3558,  1032,     0,     0,     0,  1819,  1813,     0,  1820,  4085,
    1406,  1814,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3601,     0,     0,  4923,
       0,     0,  1815,  1816,     0,     0,     0,  2358,  1448,     0,
       0,  1407,     0,     0,     0,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1032,     0,     0,     0,     0,     0,     0,     0,
    3638,  1813,     0,     0,  3643,     0,  1814,     0,     0,  1818,
       0,     0,     0,     0,     0,     0,  1449,  1032,  1821,  1450,
       0,  2436,  1819,     0,     0,  1820,     0,  1815,  1816,  1451,
       0,  1409,     0,  3681,     0,     0,     0,     0,     0,     0,
       0,  1410,  1817,  1032,     0,     0,     0,     0,     0,  1411,
    1032,     0,     0,     0,     0,     0,     0,     0,  1452,  1412,
       0,     0,     0,  3694,     0,     0,  1399,     0,     0,     0,
       0,     0,  1400,     0,  1818,     0,     0,  3704,     0,     0,
       0,  3706,     0,     0,     0,     0,     0,  1819,     0,     0,
    1820,     0,  1973,     0,     0,  2907,     0,     0,  1414,  1415,
    1454,     0,     0,     0,     0,  1821,     0,  3211,     0,  1032,
       0,  1822,  1401,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,  2908,     0,  1032,     0,     0,
       0,     0,     0,     0,  4202,  4203,  4204,  4205,   810,  1456,
    1032,     0,     0,     0,     0,     0,     0,   810,   833,     0,
       0,     0,     0,     0,  1803,   833,     0,  1804,     0,     0,
       0,  1805,  1806,  1807,  1403,     0,   833,     0,     0,     0,
    1821,  1404,     0,     0,  1405,     0,     0,     0,  1808,     0,
       0,  3243,     0,     0,     0,     0,  1810,     0,  1417,     0,
       0,     0,  1811,     0,     0,     0,     0,     0,  1822,  1406,
       0,  1823,  1824,  1825,     0,  1826,  1827,  1828,  1829,  1830,
    1831,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1032,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1822,  1032,     0,  1823,  1824,  1825,     0,
    1826,  1827,  1828,  1829,  1830,  1831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1408,  1032,
    1409,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1410,     0,     0,     0,     0,     0,     0,     0,  1411,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1412,     0,
       0,     0,  1813,  1032,     0,     0,     0,  1814,     0,     0,
       0,     0,     0,     0,     0,     0,  3921,     0,  3922,     0,
       0,     0,     0,     0,     0,  3924,     0,     0,  1815,  1816,
       0,     0,     0,     0,  3421,     0,     0,  1414,  1415,     0,
       0,  1803,  3934,  1817,  1804,     0,     0,     0,  1805,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,  3942,     0,
       0,     0,     0,     0,  3422,  1808,     0,     0,     0,     0,
       0,     0,  3955,  1810,     0,  1818,     0,     0,  1399,  1811,
       0,     0,     0,     0,  1400,     0,     0,     0,  1819,     0,
    3959,  1820,     0,     0,     0,  1032,     0,     0,     0,     0,
    3968,     0,     0,  1812,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4407,     0,     0,
       0,  3992,     0,     0,  1401,     0,     0,  1417,     0,     0,
       0,     0,  4000,  4001,  4002,     0,     0,  4005,  4006,  4007,
    4008,  4009,  4010,     0,     0,     0,     0,  4017,  4018,     0,
    4020,  4021,  4022,  4023,  4024,  4025,     0,  4027,     0,     0,
       0,     0,     0,     0,     0,     0,  4035,     0,  4037,  4038,
       0,  1821,     0,     0,     0,     0,  1403,     0,     0,     0,
       0,     0,     0,  1404,     0,   810,  1405,     0,     0,     0,
       0,  3413,  3248,     0,  1032,     0,     0,   833,     0,     0,
       0,     0,   833,     0,     0,     0,     0,     0,     0,  1813,
    4057,  1406,     0,   833,  1814,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   833,
       0,     0,     0,     0,   810,  1815,  1816,     0,     0,     0,
    1034,     0,  1407,     0,   810,   833,     0,     0,     0,     0,
    1817,   833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1034,   833,     0,  1822,     0,     0,  1823,  1824,  1825,
     833,  1826,  1827,  1828,  1829,  1830,  1831,     0,     0,     0,
       0,     0,  1818,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1819,     0,     0,  1820,     0,
    1408,     0,  1409,     0,     0,     0,     0,  3413,     0,     0,
       0,     0,  1410,     0,     0,     0,     0,     0,     0,     0,
    1411,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1412,     0,     0,     0,     0,  1973,  1973,  1973,     0,  1032,
    4563,     0,     0,     0,     0,     0,     0,  4145,     0,     0,
       0,     0,   810,   810,     0,     0,  1252,     0,   833,     0,
       0,     0,     0,     0,     0,     0,  3472,     0,     0,  1414,
    1415,     0,     0,     0,     0,     0,     0,     0,  1821,     0,
       0,     0,     0,     0,   810,     0,     0,     0,  1032,  4610,
       0,     0,     0,     0,     0,     0,  3473,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,  1804,     0,     0,     0,  1805,  1806,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,  3254,  1417,
       0,     0,     0,  1810,     0,     0,     0,     0,     0,  1811,
       0,  1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,     0,  4674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1032,
       0,     0,     0,   810,     0,     0,     0,     0,     0,  1032,
    1034,     0,     0,     0,   810,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1803,     0,     0,  1804,     0,     0,
    1034,  1805,  1806,  1807,     0,     0,  4275,     0,     0,     0,
    4276,  4277,  4278,  4279,  1034,     0,  4281,     0,  1808,     0,
       0,     0,     0,     0,     0,     0,  1810,     0,     0,     0,
    4742,     0,  1811,     0,     0,     0,     0,     0,     0,     0,
    4295,  4296,  4297,     0,  4298,     0,  4300,  4301,     0,  1813,
       0,     0,     0,   810,  1814,     0,  1812,     0,  4310,  4311,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,  1816,     0,     0,  4319,
       0,     0,     0,     0,     0,  1803,  1973,  1973,  1804,  1973,
    1817,  1034,  1805,  1806,  1807,     0,     0,   191,     0,  1032,
       0,  4327,     0,     0,     0,     0,     0,     0,     0,  1808,
       0,     0,  3793,     0,     0,     0,     0,  1810,     0,     0,
       0,     0,  1818,  1811,     0,     0,   833,     0,     0,     0,
    1032,     0,     0,     0,     0,  1819,     0,     0,  1820,     0,
       0,     0,     0,   192,     0,     0,   833,  1812,     0,     0,
     810,  1032,     0,     0,     0,     0,     0,   193,   833,     0,
       0,  4373,  1813,     0,     0,     0,  1032,  1814,     0,     0,
       0,     0,     0,     0,     0,   194,     0,     0,     0,     0,
       0,   195,  4392,     0,     0,     0,   833,     0,  1815,  1816,
       0,     0,     0,     0,     0,     0,     0,   196,     0,     0,
    1034,     0,   833,  1817,     0,     0,     0,     0,   197,  1032,
       0,     0,  4416,     0,     0,     0,   198,   833,  1821,     0,
     833,     0,     0,     0,     0,     0,     0,     0,   199,     0,
       0,     0,   810,   200,     0,  1818,     0,     0,     0,   201,
       0,     0,     0,     0,     0,     0,     0,     0,  1819,     0,
       0,  1820,     0,  1813,     0,     0,   202,     0,  1814,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
    1816,   203,     0,     0,     0,     0,  1973,     0,     0,   810,
     810,   810,     0,   810,  1817,     0,     0,     0,  1032,     0,
       0,  1973,   204,     0,     0,     0,     0,     0,     0,     0,
       0,  1822,     0,   810,  1823,  1824,  1825,     0,  1826,  1827,
    1828,  1829,  1830,  1831,     0,     0,  1818,     0,     0,     0,
       0,  1821,     0,     0,   205,     0,     0,   833,     0,  1819,
    1803,     0,  1820,  1804,  1032,   833,   833,  1805,  1806,  1807,
       0,     0,     0,     0,   810,  1958,   206,     0,     0,     0,
    3739,     0,     0,     0,  1808,     0,   207,     0,     0,  4517,
       0,     0,  1810,     0,     0,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,   810,     0,     0,     0,   810,   810,
    4526,     0,     0,   208,     0,  4531,  4532,     0,   209,     0,
     210,     0,  1812,     0,  1034,     0,   211,     0,     0,   212,
    1958,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1821,     0,  1822,     0,     0,  1823,  1824,  1825,
       0,  1826,  1827,  1828,  1829,  1830,  1831,   213,   214,     0,
    4584,   215,     0,     0,     0,   216,     0,     0,     0,     0,
       0,     0,     0,     0,   217,     0,     0,     0,     0,   218,
       0,     0,     0,     0,     0,     0,     0,     0,  1032,     0,
    1034,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,     0,  3413,     0,     0,     0,
       0,     0,     0,  4625,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1034,  1813,     0,
       0,     0,     0,  1814,     0,  1822,     0,     0,  1823,  1824,
    1825,     0,  1826,  1827,  1828,  1829,  1830,  1831,  1973,     0,
       0,     0,     0,     0,  1815,  1816,     0,     0,     0,  1973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1817,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4661,     0,     0,     0,     0,   833,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1032,     0,     0,     0,
       0,  1818,     0,     0,  4677,     0,     0,  1034,     0,     0,
       0,     0,     0,  4684,  1819,     0,     0,  1820,     0,     0,
       0,     0,  1034,     0,  1032,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1973,     0,  1958,     0,     0,     0,
       0,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   833,     0,     0,
       0,   833,  1032,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,     0,     0,     0,   810,     0,  1821,     0,     0,
       0,  1034,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,  1034,     0,  1032,     0,  3413,     0,  1032,
    1032,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1973,
       0,     0,     0,     0,   810,     0,   833,   833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1034,
       0,     0,  1034,  4799,   833,   833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   833,     0,  4811,     0,
    1822,     0,     0,  1823,  1824,  1825,     0,  1826,  1827,  1828,
    1829,  1830,  1831,     0,     0,     0,     0,     0,     0,     0,
       0,  1032,     0,     0,     0,     0,     0,     0,   810,     0,
       0,     0,     0,     0,     0,  4833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,     0,   810,     0,     0,     0,     0,   810,
     810,     0,     0,     0,     0,     0,   810,   810,   810,     0,
       0,     0,   810,     0,   810,   810,   810,   810,   810,   810,
       0,   810,     0,   810,   810,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,     0,  4881,     0,     0,     0,
       0,  1034,   810,   810,   810,   810,  1958,     0,     0,     0,
     810,     0,     0,     0,   810,     0,     0,   810,     0,     0,
     810,   810,   810,   810,   810,   810,   810,   810,   810,     0,
     810,     0,  4899,     0,     0,   557,     0,   810,     0,   810,
     558,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   559,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   560,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   561,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   562,     0,     0,     0,
    -788,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   563,     0,
       0,     0,     0,     0,   564,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   566,     0,     0,     0,     0,     0,   606,     0,   567,
       0,     0,   607,     0,     0,     0,     0,   810,     0,     0,
       0,   568,     0,     0,   608,     0,     0,     0,   569,     0,
       0,     0,   570,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   609,     0,     0,     0,  -993,
       0,     0,     0,     0,     0,     0,     0,     0,   610,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1034,  1034,   611,     0,     0,     0,     0,     0,     0,     0,
     833,     0,     0,     0,  1958,   833,   571,     0,     0,   833,
     612,     0,     0,     0,     0,  -528,     0,   833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   613,     0,     0,   833,     0,     0,   810,     0,
       0,     0,     0,   614,     0,     0,     0,   572,     0,   810,
     573,   615,     0,  1034,     0,     0,   810,     0,     0,     0,
       0,     0,     0,   616,     0,  1034,     0,     0,   617,   574,
       0,     0,     0,     0,   618,     0,     0,     0,   833,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -422,     0,
       0,   619,     0,     0,     0,     0,   833,   833,     0,     0,
       0,     0,     0,     0,     0,  1034,   575,     0,     0,     0,
       0,     0,     0,   576,     0,     0,     0,     0,     0,  -422,
       0,     0,   577,     0,     0,     0,     0,  1958,   833,     0,
       0,  1958,     0,     0,     0,     0,     0,   620,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -422,     0,     0,   578,   579,     0,   580,   581,     0,
     833,     0,     0,     0,   833,     0,     0,   582,     0,   621,
       0,     0,   583,     0,     0,     0,     0,     0,   584,     0,
     622,   585,   833,     0,   586,     0,     0,     0,     0,     0,
       0,   623,     0,   833,     0,     0,     0,  -422,     0,     0,
       0,   207,     0,     0,     0,     0,   833,     0,     0,     0,
       0,     0,     0,     0,   833,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   624,     0,
       0,     0,     0,   625,     0,   626,     0,     0,     0,     0,
       0,   627,     0,     0,   628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   810,
    1034,     0,     0,     0,     0,     0,     0,     0,  1958,     0,
       0,     0,     0,   629,     0,     0,   630,     0,     0,     0,
     631,     0,     0,     0,     0,     0,     0,   632,     0,   633,
       0,     0,     0,     0,   634,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   635,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,   833,     0,     0,     0,     0,     0,
       0,     0,     0,   810,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   833,     0,     0,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   895,     0,
       0,     0,     0,   896,     0,     0,     0,     0,     0,     0,
       0,     0,   833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
     833,     0,     0,     0,     0,     0,   897,     0,   833,     0,
       0,     0,   810,     0,     0,  1034,     0,     0,   810,   898,
     899,     0,     0,     0,     0,     0,  1034,     0,     0,   900,
       0,     0,     0,   901,     0,     0,   810,     0,     0,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   902,     0,     0,     0,     0,   834,     0,     0,     0,
       0,     0,     0,   834,   810,   810,   810,     0,     0,   810,
       0,     0,     0,   903,   834,     0,     0,   810,   810,   810,
     810,     0,     0,     0,   904,  1958,     0,     0,     0,     0,
     810,  1958,   905,   810,     0,   810,     0,     0,     0,     0,
       0,     0,     0,     0,   906,     0,   810,   810,     0,   907,
     810,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   810,     0,   810,     0,   810,     0,
       0,     0,   908,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   810,     0,
       0,     0,     0,     0,     0,     0,     0,   909,     0,   810,
       0,   810,   810,   810,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   833,     0,   910,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,     0,     0,   810,     0,     0,     0,
       0,     0,   810,     0,     0,     0,     0,     0,     0,     0,
     911,     0,   810,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,  1034,   912,  1034,     0,     0,     0,     0,  1034,     0,
     833,     0,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   833,   833,     0,     0,
       0,     0,   810,     0,     0,     0,     0,     0,     0,   913,
       0,     0,     0,     0,   914,     0,   915,     0,     0,     0,
       0,     0,   916,   833,     0,   917,   833,     0,     0,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
       0,     0,     0,     0,   918,     0,     0,   919,     0,     0,
       0,   920,     0,     0,     0,     0,     0,     0,   921,     0,
     922,  1034,     0,     0,     0,   923,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     924,     0,     0,     0,     0,     0,  1958,  1958,  1958,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,  1034,   833,     0,  1958,     0,     0,   833,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   833,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
     834,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   834,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   834,     0,     0,
       0,     0,     0,  1034,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   834,     0,     0,     0,     0,     0,   834,
       0,     0,   833,     0,     0,     0,     0,     0,  1034,     0,
     834,     0,     0,     0,     0,     0,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,     0,     0,
    1958,  1034,     0,     0,     0,     0,     0,   833,     0,   833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,   833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,     0,     0,   834,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   833,  1034,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   833,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   810,     0,     0,   833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,     0,   833,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,  1034,     0,     0,     0,     0,     0,
     810,     0,     0,     0,     0,     0,   810,     0,   810,     0,
       0,   810,     0,     0,     0,  1034,   810,   810,   810,   810,
       0,     0,   810,   810,   810,   810,   810,   810,   810,   810,
     810,   810,     0,     0,     0,   810,   810,     0,     0,     0,
    1034,     0,     0,     0,     0,   810,     0,     0,     0,   810,
       0,  1958,     0,   810,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,   810,     0,   810,     0,     0,     0,
       0,     0,     0,     0,  1034,   810,     0,     0,   810,   810,
       0,     0,     0,   810,   810,     0,     0,     0,     0,     0,
     810,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     810,     0,   810,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   810,     0,     0,     0,     0,     0,
     810,   810,   810,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,     0,  1033,     0,     0,     0,
     810,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1033,     0,     0,
       0,   810,     0,     0,   834,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   834,     0,     0,     0,     0,     0,
       0,     0,     0,   833,     0,     0,   834,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   834,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1958,
     834,     0,     0,     0,  1958,  1034,  1958,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   833,     0,
       0,   833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
       0,     0,     0,   834,   834,     0,   833,   833,     0,     0,
    1034,     0,     0,  1959,     0,     0,     0,     0,     0,   833,
       0,   833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1033,     0,     0,   835,
       0,     0,     0,     0,     0,     0,   835,     0,     0,  1034,
     810,   810,     0,     0,     0,     0,  1033,   835,  1959,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1033,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   810,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,   810,     0,
    1034,     0,     0,     0,   810,   810,     0,     0,     0,   810,
    1034,     0,     0,     0,   810,     0,     0,   810,   810,     0,
       0,     0,   810,     0,     0,     0,     0,     0,   810,     0,
       0,     0,     0,     0,   834,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   810,     0,     0,     0,
     810,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,   810,     0,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,  1959,     0,     0,     0,   810,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,   834,
       0,     0,   810,     0,     0,     0,     0,     0,     0,     0,
       0,   834,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   833,     0,     0,
       0,     0,  1958,     0,     0,     0,     0,     0,     0,     0,
       0,  1034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   833,     0,     0,
       0,     0,  1034,     0,     0,     0,     0,     0,     0,   833,
       0,     0,     0,     0,   834,   834,  1958,  1034,     0,     0,
     810,     0,     0,     0,     0,     0,     0,   834,     0,     0,
     833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   834,   834,     0,     0,     0,     0,   835,     0,
       0,     0,     0,   835,   834,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,   835,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     835,     0,   810,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,     0,     0,   835,     0,     0,     0,
    2029,     0,   835,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   835,     0,     0,     0,     0,     0,     0,
       0,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1034,     0,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2029,     0,     0,     0,
       0,     0,     0,     0,  1959,   833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,     0,  1034,     0,     0,     0,     0,
     810,     0,     0,  1033,     0,     0,     0,     0,     0,   835,
       0,     0,     0,     0,     0,     0,     0,   810,   810,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1228,  1228,   810,     0,     0,     0,     0,
     810,     0,     0,     0,     0,   810,     0,     0,   810,   810,
       0,     0,     0,     0,     0,     0,   810,   810,     0,     0,
       0,     0,     0,     0,     0,  1292,     0,     0,     0,     0,
       0,     0,   810,     0,     0,     0,     0,     0,     0,   833,
       0,   833,     0,  1033,     0,   810,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1033,     0,
       0,     0,     0,     0,     0,     0,  2029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1033,     0,  1034,
     833,     0,     0,     0,     0,     0,     0,     0,     0,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1033,     0,  1958,     0,     0,     0,
       0,     0,   810,     0,     0,     0,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,   834,     0,
       0,  1033,  1959,   834,     0,     0,     0,   834,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,     0,  1034,     0,     0,
       0,     0,     0,   834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1033,     0,     0,  1033,     0,
       0,     0,     0,     0,   810,  1034,     0,   810,     0,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   834,     0,     0,     0,
       0,     0,     0,   810,     0,     0,     0,   810,     0,     0,
       0,     0,     0,  1034,   834,   834,     0,     0,   810,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,  1959,   834,   835,     0,  1959,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1958,     0,     0,     0,     0,     0,  1034,   835,     0,     0,
    1034,  1034,     0,     0,     0,   810,     0,     0,   834,   835,
       0,     0,   834,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,     0,     0,     0,     0,  1033,     0,     0,
     834,     0,     0,     0,     0,     0,     0,   835,     0,     0,
       0,   834,     0,     0,     0,     0,     0,     0,     0,   810,
       0,     0,     0,   835,   834,     0,     0,     0,     0,     0,
       0,     0,   834,     0,     0,  2653,     0,     0,   835,     0,
     810,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1034,  1034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,  1760,     0,   810,  1959,     0,     0,     0,
       0,     0,     0,     0,   810,     0,     0,     0,     0,   810,
       0,   810,     0,   810,     0,     0,     0,     0,     0,     0,
     810,     0,  1774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1792,  1793,  1794,     0,  1796,     0,     0,     0,  1958,     0,
     833,     0,   834,     0,     0,     0,     0,     0,   835,     0,
       0,     0,     0,     0,  1838,     0,   835,   835,     0,     0,
       0,     0,     0,     0,     0,     0,  1960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1875,     0,     0,     0,     0,
       0,     0,  2712,     0,   834,     0,  2029,  2718,   810,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   810,
       0,  1960,     0,     0,     0,  1980,     0,   833,     0,  1992,
    1995,     0,     0,     0,     0,     0,     0,     0,     0,   810,
     834,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,   834,     0,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1033,  1023,     0,     0,     0,   810,     0,     0,     0,
       0,     0,   810,   810,   810,     0,     0,     0,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,     0,     0,     0,     0,     0,     0,
       0,  1033,     0,     0,     0,   833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1958,
       0,     0,     0,  1959,     0,     0,     0,     0,     0,  1959,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   810,   810,     0,     0,
       0,     0,  1958,     0,     0,     0,     0,     0,     0,     0,
     810,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1958,   810,   810,     0,     0,     0,  1960,     0,     0,
       0,     0,     0,     0,   834,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   835,     0,
       0,     0,   835,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   835,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   834,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,   835,     0,
       0,   834,     0,     0,   834,     0,  2029,     0,     0,     0,
     835,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   835,   835,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,   835,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1959,  1959,  1959,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   834,     0,  1959,  1033,     0,   834,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   834,     0,     0,     0,
    2522,  1033,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,  1033,  2542,     0,  2544,     0,  1960,  2556,  2559,
    2564,     0,     0,     0,     0,  2570,     0,     0,  2575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2582,  2583,  2584,  2585,     0,     0,     0,
       0,  2592,     0,     0,     0,  2604,     0,     0,  2606,     0,
     834,  2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,
       0,  2622,     0,     0,     0,     0,     0,     0,  1228,     0,
    2650,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1959,     0,
       0,     0,     0,     0,     0,   834,     0,   834,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,   834,
       0,   834,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2653,  2653,  2653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1292,     0,
       0,     0,     0,     0,  2029,     0,     0,  2718,     0,  2718,
       0,     0,     0,     0,  2029,     0,     0,     0,     0,     0,
       0,     0,   834,     0,     0,     0,     0,     0,     0,  1025,
       0,   835,     0,     0,     0,  1960,   835,   834,     0,     0,
     835,     0,     0,     0,     0,     0,     0,     0,   835,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,   834,
       0,     0,   834,     0,     0,  1033,   835,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1033,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2760,
       0,     0,     0,     0,     0,     0,  1023,  2029,     0,   835,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,   835,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,  1959,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,  1960,   835,
       0,     0,  1960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,  1033,     0,  1033,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   835,     0,     0,     0,   835,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1023,
       0,     0,     0,   835,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   835,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,     0,  1033,
       0,     0,     0,     0,     0,   835,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1033,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1023,
    2718,     0,     0,     0,     0,     0,     0,  2718,     0,  1960,
       0,   834,     0,     0,  1023,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,  1025,
    3000,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,  1959,     0,     0,
       0,     0,  1959,  1025,  1959,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,     0,   835,     0,     0,     0,     0,
    1023,     0,     0,     0,  2718,     0,     0,     0,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,  1033,     0,     0,
       0,     0,     0,  1028,     0,  1023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   834,  1023,     0,   834,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,   835,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,     0,  1023,  1026,     0,     0,     0,     0,
       0,     0,  3140,   835,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   835,     0,     0,     0,     0,     0,     0,     0,   835,
    1033,     0,     0,     0,   834,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   834,     0,   834,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,  1033,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,  3193,     0,     0,
       0,     0,  3199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1960,     0,     0,     0,
    1033,     0,  1960,     0,     0,     0,     0,  1796,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,  2564,     0,
    2564,  2564,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3257,     0,   834,  3260,     0,  3262,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3280,     0,  3283,     0,  3285,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,     0,     0,
       0,     0,  2029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2650,  2650,  2650,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
    3333,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1980,  1028,     0,     0,     0,  3344,     0,     0,
       0,     0,     0,  1995,     0,     0,     0,  1028,     0,     0,
       0,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   835,   835,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2718,     0,     0,   835,     0,     0,   835,     0,     0,
       0,     0,     0,  3381,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,  1023,     0,
       0,     0,  1023,  1023,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
    1959,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1026,  1025,  1960,  1960,  1960,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,   834,     0,     0,
       0,   835,     0,     0,  1959,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,   835,     0,  1960,     0,   834,   835,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   835,
       0,     0,     0,  1028,     0,     0,  1033,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,  1026,  1025,
       0,     0,     0,     0,     0,  2029,     0,     0,     0,     0,
    1025,     0,     0,   835,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1960,     0,     0,     0,     0,     0,  1025,   835,     0,
     835,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,   835,     0,   835,     0,     0,     0,  1026,     0,
       0,     0,  1025,   834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,  1025,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,   835,     0,
       0,     0,     0,     0,     0,     0,  1033,     0,  1025,     0,
       0,  1025,     0,     0,     0,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1028,     0,  1026,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1026,   835,     0,   834,     0,   834,
       0,     0,  1023,     0,     0,     0,  1026,     0,  2653,     0,
     835,     0,     0,  2653,     0,     0,     0,     0,     0,  2653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   835,  1028,     0,   835,     0,     0,   834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1026,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,  1033,     0,     0,     0,
    1025,     0,  3740,     0,  1959,     0,     0,     0,     0,     0,
       0,  3744,     0,     0,     0,     0,     0,  3745,     0,  3746,
       0,     0,     0,     0,     0,     0,     0,  1033,     0,     0,
       0,     0,  1960,     0,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,     0,     0,     0,  3770,  3771,  1033,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,  2718,  2570,     0,     0,     0,  1023,     0,
    1028,     0,  3796,     0,     0,  3799,     0,  3801,     0,     0,
       0,     0,     0,     0,     0,  1028,  3805,     0,     0,     0,
       0,     0,     0,  1028,  3812,  3813,     0,     0,     0,     0,
       0,     0,  1026,     0,  1028,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3857,     0,     0,     0,     0,
       0,  3864,  3865,  2650,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,  3880,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,  1292,     0,     0,     0,     0,  1028,     0,  1959,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,  4403,   835,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   834,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,  1025,
    1025,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,  1028,     0,     0,     0,     0,
    1960,  1033,     0,     0,     0,  1960,  1029,  1960,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,  1023,     0,  1023,     0,     0,     0,     0,
    1023,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,     0,     0,   835,
       0,     0,   835,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,  1026,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,     0,  1025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1023,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,  2718,  1959,     0,   834,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1026,     0,     0,   835,   835,     0,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
     835,     0,   835,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,  1023,     0,  1023,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   834,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4117,  4118,  2718,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,   835,     0,     0,     0,
       0,  1033,     0,     0,     0,  1023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,     0,     0,  1029,     0,     0,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,  4158,     0,  1029,
       0,     0,     0,   834,     0,     0,  1023,     0,  4163,  1025,
       0,     0,     0,  1023,     0,     0,     0,  1959,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,  1028,  1028,     0,     0,     0,     0,     0,
       0,  1026,  1033,     0,     0,     0,  1033,  1033,  4178,  4180,
       0,     0,     0,     0,     0,  4184,  4185,     0,     0,     0,
    4186,     0,     0,     0,     0,  4189,     0,     0,  4192,  4193,
       0,     0,  1023,  4197,     0,     0,  1029,     0,     0,  4201,
    1959,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,     0,     0,     0,  1028,     0,     0,  1959,
       0,     0,     0,  1023,     0,     0,     0,     0,  1028,     0,
       0,  1026,     0,  2650,     0,     0,     0,     0,  2650,     0,
       0,     0,     0,     0,  2650,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4403,  1033,  1228,
       0,     0,     0,     0,  1025,     0,     0,     0,  1028,  1031,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,  4256,     0,     0,     0,     0,   835,  1031,
       0,     0,     0,  1960,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1031,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   835,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
     835,     0,     0,     0,     0,     0,     0,  1960,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,  1026,
       0,   835,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,  4316,  1023,     0,     0,     0,     0,  1026,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4350,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
    1025,     0,  1025,     0,     0,     0,     0,  1025,     0,  1031,
       0,     0,     0,  1028,     0,     0,   835,     0,  1023,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4442,  4443,
       0,     0,  4444,     0,     0,  1029,     0,     0,     0,  1026,
    1025,     0,  1026,     0,  1026,     0,     0,     0,     0,  1026,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,     0,
     835,     0,   835,     0,     0,     0,     0,  4478,  4479,     0,
       0,  1028,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
    1026,   835,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,  1025,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,  1960,     0,     0,
       0,     0,  1029,  1031,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,  1025,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,     0,  1026,     0,     0,     0,     0,     0,  1031,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,  1023,     0,     0,     0,     0,  1031,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2570,     0,
    1029,     0,     0,     0,  1026,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,  4643,     0,     0,     0,     0,  1026,
       0,  1028,     0,     0,  1028,     0,  1028,  1025,     0,  1796,
       0,  1028,     0,     0,  1029,     0,     0,  1029,     0,     0,
    1025,  1960,     0,     0,     0,  1026,     0,     0,  1292,     0,
       0,     0,  1026,     0,     0,     0,  1031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1031,   835,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,  1028,     0,     0,     0,  4692,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,  1026,
       0,     0,     0,     0,     0,     0,     0,  1031,     0,     0,
       0,     0,  1026,  1025,     0,     0,     0,     0,     0,     0,
    1031,  4743,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,  1025,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,  1028,     0,  1028,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4478,     0,     0,     0,  1031,     0,
       0,  1031,     0,  1025,     0,     0,     0,     0,     0,  1960,
       0,   835,  1023,     0,     0,     0,     0,     0,  4800,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,  1023,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,  1023,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,  1023,
       0,     0,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,     0,  1028,  1025,     0,     0,   835,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,     0,  4860,
    4860,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4478,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,  1029,  1029,     0,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,  4860,   835,  1026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1960,  1023,     0,     0,  4931,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1960,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,  1960,     0,     0,     0,  1026,  4860,  4972,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,  1833,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,  1031,     0,     0,     0,  1031,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1023,
    1026,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1023,     0,
       0,     0,  1023,  1023,     0,     0,     0,     0,     0,  1031,
       0,  1026,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,  1028,  1023,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,  1028,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,  1029,     0,     0,  1029,     0,  1029,     0,
       0,  1026,     0,  1029,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1833,     0,  1028,     0,  2552,     0,     0,     0,     0,
       0,     0,     0,  1028,  1025,     0,     0,     0,     0,  1833,
    1833,  1833,     0,  1833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1833,     0,     0,     0,     0,
    1026,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,  1029,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1031,     0,     0,
    1031,     0,  1031,     0,  1028,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,     0,  1833,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1031,  1833,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,  1031,     0,     0,     0,     0,
    1026,     0,     0,  1028,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
    1031,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,  1031,
       0,  1031,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,  1025,
    1025,     0,     0,     0,     0,     0,  1026,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1026,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1031,     0,     0,     0,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,  1025,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,  1026,  1026,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,  1029,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,  1031,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1031,     0,     0,     0,     0,     0,  1028,
    1029,     0,     0,  1028,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
       0,  1833,     0,     0,  2552,  2552,     0,  3234,     0,  2552,
       0,     0,     0,  1833,     0,     0,  1833,     0,     0,     0,
       0,  1833,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,  1833,
    1833,  1833,  1833,     0,     0,  1031,  2552,  2552,     0,  1833,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,  1833,     0,  1833,     0,     0,     0,     0,     0,     0,
    1833,  1833,  1833,  1833,  1833,  1833,  1833,  1833,  1833,  1833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1031,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1029,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,  1031,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1833,  1031,     0,     0,     0,     0,  1833,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,  1031,     0,     0,     0,
       0,     0,  3234,  3234,     0,     0,  2552,  2552,  2552,  2552,
       0,     0,  2552,  2552,  2552,  2552,  2552,  2552,  2552,  2552,
    2552,  2552,  3234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1031,
       0,     0,     0,     0,  1833,     0,     0,  1833,     0,  1833,
       0,     0,  3234,  3234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,  2552,  2552,
    1833,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
    1833,     0,     0,     0,     0,     0,     0,     0,  1031,     0,
       0,  1833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1833,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1031,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,  1029,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,     0,  1833,     0,  1031,
    1031,  1833,  1833,  1833,     0,     0,     0,     0,     0,  3234,
    3234,  3234,  3234,     0,     0,     0,     0,  3234,  3234,  3234,
    3234,  3234,  3234,  3234,  3234,  3234,  3234,  1833,  1833,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,     0,     0,  1833,     0,  1833,     0,
       0,     0,  1833,     0,     0,  3234,  3234,     0,     0,  1833,
    1833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1031,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1833,     0,     0,     0,     0,     0,
       0,  1833,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1833,  1833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1833,     0,     0,     0,     0,
    1833,  2552,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1833,     0,  1833,     0,     0,
       0,  1833,  1833,  1833,     0,     0,  1833,     0,     0,  1833,
    1833,     0,     0,     0,  1833,     0,     0,     0,  1833,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3234,  2552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
    1833,  1833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1833,  1833,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,  1833,   224,   225,
     226,   227,   228,   229,   230,   231,  2644,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,   243,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,  1833,   788,
     275,   276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,  2645,     0,   297,   298,  1004,   300,   301,  1833,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  1175,   330,
       0,   331,   332,   333,   334,   335,   792,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,   794,   795,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,   798,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,  1184,   389,   390,   800,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,   450,  1192,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,   804,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,  1201,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,  2646,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,  1212,     0,
       0,     0,     0,     0,     0,  1213,  1214,  2647,     0,     0,
       0,     0,     0,     0,  1216,  2648,   783,  1146,   601,  1147,
    1148,  1149,   655,  1150,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1151,     0,     0,
     236,   237,     0,   238,   239,   784,   240,   241,   242,   243,
    1152,   785,  1153,  1154,     0,   247,   248,   249,   250,   251,
    1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,   258,
     259,   260,  1159,     0,  1160,     0,   262,   263,   264,   265,
     787,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,
    1165,  1166,  1167,   278,   279,   280,   281,   282,   283,  1168,
    1169,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,  1004,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,  1170,   313,   314,   315,  1171,
    1172,   317,     0,   318,   319,  1173,   321,     0,   322,     0,
     323,   790,     0,   791,   324,   325,   326,     0,   327,  1174,
       0,  1175,   330,     0,   331,   332,   333,   334,   335,   792,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,   793,   347,   348,   349,   350,   351,  1176,
    1177,     0,  1178,     0,   355,   794,   795,   356,   796,   357,
     358,   359,   360,   361,     0,     0,   362,  1179,   797,   364,
     798,     0,   365,   366,   367,  1180,  1181,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,  1182,   799,  1183,   386,   387,   388,  1184,
     389,   390,   800,   391,  1185,  1186,   393,  1187,   395,   396,
     397,     0,   398,     0,     0,  1188,   400,   401,     0,     0,
     402,   403,   801,   404,   802,  1189,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,  1190,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,  1191,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,   803,   448,   449,   450,  1192,   452,   453,
     454,   455,   456,   457,   458,   459,    40,   460,   461,   462,
     463,   464,  1193,   465,   466,   467,   468,   469,   804,   470,
     471,  1194,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1195,     0,   486,   487,    44,
     488,   805,   489,   490,   491,   492,   493,     0,  1196,  1197,
       0,     0,   496,   497,  1198,   499,  1199,  1200,   501,   502,
     503,   504,   505,   506,   507,     0,  1201,   508,   509,   510,
     511,   512,  1202,     0,   513,   514,   515,   516,   517,  1077,
    1203,     0,   520,   806,   521,   522,   523,   524,     0,     0,
     525,     0,    49,   526,   527,   528,   529,   530,   531,   532,
    1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,
     543,  1212,     0,    50,     0,     0,     0,     0,  1213,  1214,
       0,     0,     0,     0,     0,     0,     0,  1216,  4655,   783,
    1146,   601,  1147,  1148,  1149,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,  1184,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,  1188,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    1192,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,  1201,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,   518,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,  1212,     0,     0,     0,     0,     0,
       0,  1213,  1214,     0,     0,     0,     0,     0,     0,     0,
    1216,  2554,   783,  1146,   601,  1147,  1148,  1149,   655,  1150,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1151,     0,     0,   236,   237,     0,   238,
     239,   784,   240,   241,   242,   243,  1152,   785,  1153,  1154,
       0,   247,   248,   249,   250,   251,  1155,  1156,   252,   253,
    1157,  1158,   256,     0,   257,   258,   259,   260,  1159,     0,
    1160,     0,   262,   263,   264,   265,   787,   266,   267,   268,
       0,   269,   270,   271,   272,   273,   274,     0,   788,   275,
     276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,
     279,   280,   281,   282,   283,  1168,  1169,   286,     0,   287,
       0,   288,   289,   290,   291,   292,   293,     0,   294,   295,
     296,     0,     0,   297,   298,  1004,   300,   301,     0,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
     311,  1170,   313,   314,   315,  1171,  1172,   317,     0,   318,
     319,  1173,   321,     0,   322,     0,   323,   790,     0,   791,
     324,   325,   326,     0,   327,  1174,     0,  1175,   330,     0,
     331,   332,   333,   334,   335,   792,   336,   337,   338,   339,
       0,   340,   341,   342,   343,   344,   345,     0,   346,   793,
     347,   348,   349,   350,   351,  1176,  1177,     0,  1178,     0,
     355,   794,   795,   356,   796,   357,   358,   359,   360,   361,
       0,     0,   362,  1179,   797,   364,   798,     0,   365,   366,
     367,  1180,  1181,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,  1182,
     799,  1183,   386,   387,   388,  1184,   389,   390,   800,   391,
    1185,  1186,   393,  1187,   395,   396,   397,     0,   398,     0,
       0,  1188,   400,   401,     0,     0,   402,   403,   801,   404,
     802,  1189,   406,   407,   408,   409,   410,   411,   412,   413,
       0,     0,   414,   415,  1190,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,   426,   427,   428,   429,  1191,
     431,   432,   433,   434,     0,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   446,   447,   803,
     448,   449,   450,  1192,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,   464,  1193,   465,
     466,   467,   468,   469,   804,   470,   471,  1194,   473,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1195,     0,   486,   487,     0,   488,   805,   489,   490,
     491,   492,   493,     0,  1196,  1197,     0,     0,   496,   497,
    1198,   499,  1199,  1200,   501,   502,   503,   504,   505,   506,
     507,     0,  1201,   508,   509,   510,   511,   512,  1202,     0,
     513,   514,   515,   516,   517,   518,  1203,     0,   520,   806,
     521,   522,   523,   524,     0,     0,   525,     0,     0,   526,
     527,   528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,
    1208,  1209,  1210,  1211,   541,   542,   543,  1212,     0,     0,
       0,     0,     0,     0,  1213,  1214,     0,     0,     0,     0,
       0,     0,     0,  1216,  3748,   783,  1146,   601,  1147,  1148,
    1149,   655,  1150,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1151,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,  1152,
     785,  1153,  1154,     0,   247,   248,   249,   250,   251,  1155,
    1156,   252,   253,  1157,  1158,   256,     0,   257,   258,   259,
     260,  1159,     0,  1160,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,   278,   279,   280,   281,   282,   283,  1168,  1169,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,  1170,   313,   314,   315,  1171,  1172,
     317,     0,   318,   319,  1173,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,  1174,     0,
    1175,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,  1176,  1177,
       0,  1178,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,  1179,   797,   364,   798,
       0,   365,   366,   367,  1180,  1181,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1182,   799,  1183,   386,   387,   388,  1184,   389,
     390,   800,   391,  1185,  1186,   393,  1187,   395,   396,   397,
       0,   398,     0,     0,  1188,   400,   401,     0,     0,   402,
     403,   801,   404,   802,  1189,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,  1190,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1191,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,  1192,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,  1193,   465,   466,   467,   468,   469,   804,   470,   471,
    1194,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1195,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1196,  1197,     0,
       0,   496,   497,  1198,   499,  1199,  1200,   501,   502,   503,
     504,   505,   506,   507,     0,  1201,   508,   509,   510,   511,
     512,  1202,     0,   513,   514,   515,   516,   517,   518,  1203,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,   543,
    1212,     0,     0,   223,     0,     0,     0,  1213,  1214,     0,
       0,     0,     0,     0,     0,     0,  1216,  3819,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,  3835,     0,   236,   237,     0,
     238,   239,     0,   240,   241,   242,   243,   244,     0,   245,
     246,     0,   247,   248,   249,   250,   251,     0,     0,   252,
     253,   254,   255,   256,     0,   257,   258,   259,   260,   261,
       0,     0,     0,   262,   263,   264,   265,     0,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0, -1602,
     275,   276,   277,     0,     0,     0,     0,     0,     0,     0,
     278,   279,   280,   281,   282,   283,   284,   285,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,   299,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,   312,   313,   314,   315,   316,     0,   317,     0,
     318,   319,   320,   321,     0,   322,     0,   323,     0,     0,
   -1602,   324,   325,   326,     0,   327,   328,     0,   329,   330,
       0,   331,   332,   333,   334,   335,     0,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
   -1602,   347,   348,   349,   350,   351,   352,   353,     0,   354,
       0,   355,     0,     0,   356, -1602,   357,   358,   359,   360,
     361,     0,     0,   362,   363, -1602,   364,     0,     0,   365,
     366,   367,     0,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384, -1602,   385,   386,   387,   388,     0,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,     0,   398,
       0,     0,   399,   400,   401,     0,     0,   402,   403,     0,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,   416,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
   -1602,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,     0,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,     0,   486,   487,     0,   488,     0,   489,
     490,   491,   492,   493,     0,   494,   495,     0,     0,   496,
     497,   498,   499,   500,     0,   501,   502,   503,   504,   505,
     506,   507,     0,     0,   508,   509,   510,   511,   512,     0,
       0,   513,   514,   515,   516,   517,   518,   519,     0,   520,
       0,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1299,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242,     0,   997,   785,   998,   999,     0,
     247,   248,   249,   250,   251,     0,     0,   252,   253,  1000,
    1001,   256,     0,   257,   258,   259,   260,     0,     0,   786,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
     277,     0,     0,     0,   789,     0,     0,     0,   278,   279,
     280,   281,   282,   283,  1002,  1003,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
       0,   313,   314,   315,     0,     0,   317,     0,   318,   319,
    1005,   321,     0,   322,     0,   323,   790,     0,   791,   324,
     325,   326,     0,   327,     0,     0,     0,   330,     0,   331,
     332,   333,   334,   335,   792,   336,   337,   338,   339,  2015,
     340,   341,   342,   343,   344,   345,     0,   346,   793,  2016,
     348,   349,   350,   351,  1007,  1008,     0,  1009,     0,   355,
     794,   795,   356,   796,   357,   358,   359,   360,   361,     0,
       0,   362,     0,   797,   364,   798,     0,   365,   366,   367,
       0,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1010,   799,
    1011,   386,   387,     0,     0,   389,   390,   800,   391,     0,
       0,   393,  1012,   395,   396,   397,     0,   398,     0,     0,
     399,   400,   401,     0,     0,   402,  2018,   801,   404,   802,
       0,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,     0,   417,     0,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1013,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,     0,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,     0,   465,   466,
    2019,   468,   469,   804,   470,   471,  1015,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1016,  1017,     0,     0,   496,   497,     0,
     499,     0,     0,   501,   502,   503,   504,   505,   506,   507,
       0,     0,   508,   509,   510,   511,   512,     0,     0,   513,
     514,   515,   516,   517,     0,  1018,  2020,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   996,     0,     0,     0,     0,     0,
       0,     0,     0,   541,   542,   543,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,  2126,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   784,   240,   241,   242,     0,   997,   785,
     998,   999,     0,   247,   248,   249,   250,   251,     0,     0,
     252,   253,  1000,  1001,   256,     0,   257,   258,   259,   260,
       0,     0,   786,     0,   262,   263,   264,   265,   787,   266,
     267,   268,     0,   269,   270,   271,   272,   273,   274,     0,
     788,   275,   276,   277,     0,     0,     0,   789,     0,     0,
       0,   278,   279,   280,   281,   282,   283,  1002,  1003,   286,
       0,   287,     0,   288,   289,   290,   291,   292,   293,     0,
     294,   295,   296,     0,     0,   297,   298,  1004,   300,   301,
       0,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,   311,     0,   313,   314,   315,     0,     0,   317,
       0,   318,   319,  1005,   321,     0,   322,     0,   323,   790,
       0,   791,   324,   325,   326,     0,   327,     0,     0,     0,
     330,     0,   331,   332,   333,   334,   335,   792,   336,   337,
     338,   339,  2015,   340,   341,   342,   343,   344,   345,     0,
     346,   793,  2016,   348,   349,   350,   351,  1007,  1008,     0,
    1009,     0,   355,   794,   795,   356,   796,   357,   358,   359,
     360,   361,     0,     0,   362,     0,   797,   364,   798,     0,
     365,   366,   367,     0,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,  1010,   799,  1011,   386,   387,     0,     0,   389,   390,
     800,   391,     0,     0,   393,  1012,   395,   396,   397,     0,
     398,     0,     0,   399,   400,   401,     0,     0,   402,  2018,
     801,   404,   802,     0,   406,   407,   408,   409,   410,   411,
     412,   413,     0,     0,   414,   415,     0,   417,     0,   419,
     420,   421,     0,   422,   423,   424,   425,   426,   427,   428,
     429,  1013,   431,   432,   433,   434,     0,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   446,
     447,   803,   448,   449,   450,     0,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
       0,   465,   466,  2019,   468,   469,   804,   470,   471,  1015,
     473,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,     0,   486,   487,     0,   488,   805,
     489,   490,   491,   492,   493,     0,  1016,  1017,     0,     0,
     496,   497,     0,   499,     0,     0,   501,   502,   503,   504,
     505,   506,   507,     0,     0,   508,   509,   510,   511,   512,
       0,     0,   513,   514,   515,   516,   517,     0,  1018,  2020,
     520,   806,   521,   522,   523,   524,     0,     0,   525,     0,
       0,   526,   527,   528,   529,   530,   531,   783,  1146,   601,
    1147,  1148,  1149,   655,  1150,     0,   541,   542,   543,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,  3075,     0,  1151,     0,
       0,   236,   237,     0,   238,   239,   784,   240,   241,   242,
     243,  1152,   785,  1153,  1154,     0,   247,   248,   249,   250,
     251,  1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,
     258,   259,   260,  1159,     0,  1160,     0,   262,   263,   264,
     265,   787,   266,   267,   268,     0,   269,   270,   271,   272,
     273,   274,     0,   788,   275,   276,   277,  1161,  1162,  1163,
    1164,  1165,  1166,  1167,   278,   279,   280,   281,   282,   283,
    1168,  1169,   286,  1291,   287,     0,   288,   289,   290,   291,
     292,   293,     0,   294,   295,   296,     0,     0,   297,   298,
    1004,   300,   301,     0,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,   311,  1170,   313,   314,   315,
    1171,  1172,   317,     0,   318,   319,  1173,   321,     0,   322,
       0,   323,   790,     0,   791,   324,   325,   326,     0,   327,
    1174,     0,  1175,   330,     0,   331,   332,   333,   334,   335,
     792,   336,   337,   338,   339,     0,   340,   341,   342,   343,
     344,   345,     0,   346,   793,   347,   348,   349,   350,   351,
    1176,  1177,     0,  1178,     0,   355,   794,   795,   356,   796,
     357,   358,   359,   360,   361,     0,     0,   362,  1179,   797,
     364,   798,     0,   365,   366,   367,  1180,  1181,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,  1182,   799,  1183,   386,   387,   388,
    1184,   389,   390,   800,   391,  1185,  1186,   393,  1187,   395,
     396,   397,     0,   398,     0,     0,  1188,   400,   401,     0,
       0,   402,   403,   801,   404,   802,  1189,   406,   407,   408,
     409,   410,   411,   412,   413,     0,     0,   414,   415,  1190,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     426,   427,   428,   429,  1191,   431,   432,   433,   434,     0,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   446,   447,   803,   448,   449,   450,  1192,   452,
     453,   454,   455,   456,   457,   458,   459,    40,   460,   461,
     462,   463,   464,  1193,   465,   466,   467,   468,   469,   804,
     470,   471,  1194,   473,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1195,     0,   486,   487,
      44,   488,   805,   489,   490,   491,   492,   493,     0,  1196,
    1197,     0,     0,   496,   497,  1198,   499,  1199,  1200,   501,
     502,   503,   504,   505,   506,   507,     0,  1201,   508,   509,
     510,   511,   512,  1202,     0,   513,   514,   515,   516,   517,
    1077,  1203,     0,   520,   806,   521,   522,   523,   524,     0,
       0,   525,     0,    49,   526,   527,   528,   529,   530,   531,
     532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,
     542,   543,  1212,     0,    50,     0,     0,     0,     0,  1213,
    1214,     0,     0,     0,     0,     0,     0,     0,  1216,   783,
    1146,   601,  1147,  1148,  1149,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,  1184,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,  1188,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    1192,   452,   453,   454,   455,   456,   457,   458,   459,    40,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,    44,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,  1201,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,  1077,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,    49,   526,   527,   528,   529,
     530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,  1212,     0,    50,     0,     0,     0,
       0,  1213,  1214,     0,     0,     0,     0,     0,     0,     0,
    1216,   783,  1146,   601,  1147,  1148,  1149,   655,  1150,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,  1151,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242,   243,  1152,   785,  1153,  1154,  2560,
     247,   248,   249,   250,   251,  1155,  1156,   252,   253,  1157,
    1158,   256,     0,   257,   258,   259,   260,  1159,     0,  1160,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
     277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,
     280,   281,   282,   283,  1168,  1169,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
    1170,   313,   314,   315,  1171,  1172,   317,     0,   318,   319,
    1173,   321,     0,   322,     0,   323,   790,  2561,   791,   324,
     325,   326,     0,   327,  1174,     0,  1175,   330,     0,   331,
     332,   333,   334,   335,   792,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,   793,   347,
     348,   349,   350,   351,  1176,  1177,     0,  1178,     0,   355,
     794,   795,   356,   796,   357,   358,   359,   360,   361,     0,
    2562,   362,  1179,   797,   364,   798,     0,   365,   366,   367,
    1180,  1181,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1182,   799,
    1183,   386,   387,   388,  1184,   389,   390,   800,   391,  1185,
    1186,   393,  1187,   395,   396,   397,     0,   398,     0,     0,
    1188,   400,   401,     0,     0,   402,   403,   801,   404,   802,
    1189,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,  1190,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1191,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,  1192,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,  1193,   465,   466,
     467,   468,   469,   804,   470,   471,  1194,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1195,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1196,  1197,     0,  2563,   496,   497,  1198,
     499,  1199,  1200,   501,   502,   503,   504,   505,   506,   507,
       0,  1201,   508,   509,   510,   511,   512,  1202,     0,   513,
     514,   515,   516,   517,   518,  1203,     0,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,   541,   542,   543,  1212,     0,     0,     0,
       0,     0,     0,  1213,  1214,     0,     0,     0,     0,     0,
       0,     0,  1216,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,   243,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,   788,
     275,   276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,  1004,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  1175,   330,
       0,   331,   332,   333,   334,   335,   792,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,   794,   795,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,   798,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,  1184,   389,   390,   800,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,   450,  1192,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,   804,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,  1201,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,     0,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,  1212,     0,
       0,     0,     0,     0,     0,  1213,  1214,     0,     0,     0,
       0,     0,  1757,  2515,  1216,   783,  1146,   601,  1147,  1148,
    1149,   655,  1150,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1151,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,  1152,
     785,  1153,  1154,     0,   247,   248,   249,   250,   251,  1155,
    1156,   252,   253,  1157,  1158,   256,     0,   257,   258,   259,
     260,  1159,     0,  1160,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,   278,   279,   280,   281,   282,   283,  1168,  1169,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,  1170,   313,   314,   315,  1171,  1172,
     317,     0,   318,   319,  1173,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,  1174,     0,
    1175,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,  1176,  1177,
       0,  1178,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,  1179,   797,   364,   798,
       0,   365,   366,   367,  1180,  1181,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1182,   799,  1183,   386,   387,   388,  1184,   389,
     390,   800,   391,  1185,  1186,   393,  1187,   395,   396,   397,
       0,   398,     0,     0,  1188,   400,   401,     0,     0,   402,
     403,   801,   404,   802,  1189,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,  1190,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1191,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,  1192,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,  1193,   465,   466,   467,   468,   469,   804,   470,   471,
    1194,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1195,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1196,  1197,     0,
       0,   496,   497,  1198,   499,  1199,  1200,   501,   502,   503,
     504,   505,   506,   507,     0,  1201,   508,   509,   510,   511,
     512,  1202,     0,   513,   514,   515,   516,   517,   518,  1203,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,   543,
    1212,     0,     0,     0,     0,     0,     0,  1213,  1214,  1215,
       0,     0,     0,     0,     0,     0,  1216,   783,  1146,   601,
    1147,  1148,  1149,   655,  1150,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,  1151,     0,
       0,   236,   237,     0,   238,   239,   784,   240,   241,   242,
     243,  1152,   785,  1153,  1154,     0,   247,   248,   249,   250,
     251,  1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,
     258,   259,   260,  1159,     0,  1160,     0,   262,   263,   264,
     265,   787,   266,   267,   268,     0,   269,   270,   271,   272,
     273,   274,     0,   788,   275,   276,   277,  1161,  1162,  1163,
    1164,  1165,  1166,  1167,   278,   279,   280,   281,   282,   283,
    1168,  1169,   286,  1291,   287,     0,   288,   289,   290,   291,
     292,   293,     0,   294,   295,   296,     0,     0,   297,   298,
    1004,   300,   301,     0,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,   311,  1170,   313,   314,   315,
    1171,  1172,   317,     0,   318,   319,  1173,   321,     0,   322,
       0,   323,   790,     0,   791,   324,   325,   326,     0,   327,
    1174,     0,  1175,   330,     0,   331,   332,   333,   334,   335,
     792,   336,   337,   338,   339,     0,   340,   341,   342,   343,
     344,   345,     0,   346,   793,   347,   348,   349,   350,   351,
    1176,  1177,     0,  1178,     0,   355,   794,   795,   356,   796,
     357,   358,   359,   360,   361,     0,     0,   362,  1179,   797,
     364,   798,     0,   365,   366,   367,  1180,  1181,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,  1182,   799,  1183,   386,   387,   388,
    1184,   389,   390,   800,   391,  1185,  1186,   393,  1187,   395,
     396,   397,     0,   398,     0,     0,  1188,   400,   401,     0,
       0,   402,   403,   801,   404,   802,  1189,   406,   407,   408,
     409,   410,   411,   412,   413,     0,     0,   414,   415,  1190,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     426,   427,   428,   429,  1191,   431,   432,   433,   434,     0,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   446,   447,   803,   448,   449,   450,  1192,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,   464,  1193,   465,   466,   467,   468,   469,   804,
     470,   471,  1194,   473,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1195,     0,   486,   487,
       0,   488,   805,   489,   490,   491,   492,   493,     0,  1196,
    1197,     0,     0,   496,   497,  1198,   499,  1199,  1200,   501,
     502,   503,   504,   505,   506,   507,     0,  1201,   508,   509,
     510,   511,   512,  1202,     0,   513,   514,   515,   516,   517,
     518,  1203,     0,   520,   806,   521,   522,   523,   524,     0,
       0,   525,     0,     0,   526,   527,   528,   529,   530,   531,
     532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,
     542,   543,  1212,     0,     0,     0,     0,     0,     0,  1213,
    1214,     0,     0,     0,     0,     0,     0,     0,  1216,   783,
    1146,   601,  1147,  1148,  1149,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,  1990,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,  1184,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,  1188,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    1192,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,  1201,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,   518,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,  1212,     0,     0,     0,     0,     0,
       0,  1213,  1214,     0,     0,     0,     0,     0,     0,     0,
    1216,   783,  1146,   601,  1147,  1148,  1149,   655,  1150,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,  1151,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242,   243,  1152,   785,  1153,  1154,     0,
     247,   248,   249,   250,   251,  1155,  1156,   252,   253,  1157,
    1158,   256,     0,   257,   258,   259,   260,  1159,     0,  1160,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
     277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,
     280,   281,   282,   283,  1168,  1169,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
    1170,   313,   314,   315,  1171,  1172,   317,     0,   318,   319,
    1173,   321,     0,   322,     0,   323,   790,  2561,   791,   324,
     325,   326,     0,   327,  1174,     0,  1175,   330,     0,   331,
     332,   333,   334,   335,   792,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,   793,   347,
     348,   349,   350,   351,  1176,  1177,     0,  1178,     0,   355,
     794,   795,   356,   796,   357,   358,   359,   360,   361,     0,
       0,   362,  1179,   797,   364,   798,     0,   365,   366,   367,
    1180,  1181,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1182,   799,
    1183,   386,   387,   388,  1184,   389,   390,   800,   391,  1185,
    1186,   393,  1187,   395,   396,   397,     0,   398,     0,     0,
    1188,   400,   401,     0,     0,   402,   403,   801,   404,   802,
    1189,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,  1190,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1191,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,  1192,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,  1193,   465,   466,
     467,   468,   469,   804,   470,   471,  1194,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1195,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1196,  1197,     0,     0,   496,   497,  1198,
     499,  1199,  1200,   501,   502,   503,   504,   505,   506,   507,
       0,  1201,   508,   509,   510,   511,   512,  1202,     0,   513,
     514,   515,   516,   517,   518,  1203,     0,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,   541,   542,   543,  1212,     0,     0,     0,
       0,     0,     0,  1213,  1214,     0,     0,     0,     0,     0,
       0,     0,  1216,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,   243,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,   788,
     275,   276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,  1004,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  1175,   330,
       0,   331,   332,   333,   334,   335,   792,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,   794,   795,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,   798,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,  1184,   389,   390,   800,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,   450,  1192,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,   804,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,  1201,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,  3866,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,  1212,     0,
       0,     0,     0,     0,     0,  1213,  1214,     0,     0,     0,
       0,     0,     0,     0,  1216,   783,  1146,   601,  1147,  1148,
    1149,   655,  1150,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1151,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,  1152,
     785,  1153,  1154,     0,   247,   248,   249,   250,   251,  1155,
    1156,   252,   253,  1157,  1158,   256,     0,   257,   258,   259,
     260,  1159,     0,  1160,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,   278,   279,   280,   281,   282,   283,  1168,  1169,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,  1170,   313,   314,   315,  1171,  1172,
     317,     0,   318,   319,  1173,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,  1174,     0,
    1175,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,  1176,  1177,
       0,  1178,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,  1179,   797,   364,   798,
       0,   365,   366,   367,  1180,  1181,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1182,   799,  1183,   386,   387,   388,  1184,   389,
     390,   800,   391,  1185,  1186,   393,  1187,   395,   396,   397,
       0,   398,     0,     0,  1188,   400,   401,     0,     0,   402,
     403,   801,   404,   802,  1189,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,  1190,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1191,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,  1192,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,  1193,   465,   466,   467,   468,   469,   804,   470,   471,
    1194,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1195,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1196,  1197,     0,
       0,   496,   497,  1198,   499,  1199,  1200,   501,   502,   503,
     504,   505,   506,   507,     0,  1201,   508,   509,   510,   511,
     512,  1202,     0,   513,   514,   515,   516,   517,   518,  1203,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,   543,
    1212,     0,     0,     0,     0,     0,     0,  1213,  1214,     0,
       0,     0,     0,     0,     0,     0,  1216,   783,  1146,   601,
    1147,  1148,  1149,   655,  1150,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,  1151,     0,
       0,   236,   237,     0,   238,   239,   784,   240,   241,   242,
     243,  1152,   785,  1153,  1154,     0,   247,   248,   249,   250,
     251,  1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,
     258,   259,   260,  1159,     0,  1160,     0,   262,   263,   264,
     265,   787,   266,   267,   268,     0,   269,   270,   271,   272,
     273,   274,     0,   788,   275,   276,  3879,  1161,  1162,  1163,
    1164,  1165,  1166,  1167,   278,   279,   280,   281,   282,   283,
    1168,  1169,   286,     0,   287,     0,   288,   289,   290,   291,
     292,   293,     0,   294,   295,   296,     0,     0,   297,   298,
    1004,   300,   301,     0,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,   311,  1170,   313,   314,   315,
    1171,  1172,   317,     0,   318,   319,  1173,   321,     0,   322,
       0,   323,   790,     0,   791,   324,   325,   326,     0,   327,
    1174,     0,  1175,   330,     0,   331,   332,   333,   334,   335,
     792,   336,   337,   338,   339,     0,   340,   341,   342,   343,
     344,   345,     0,   346,   793,   347,   348,   349,   350,   351,
    1176,  1177,     0,  1178,     0,   355,   794,   795,   356,   796,
     357,   358,   359,   360,   361,     0,     0,   362,  1179,   797,
     364,   798,     0,   365,   366,   367,  1180,  1181,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,  1182,   799,  1183,   386,   387,   388,
    1184,   389,   390,   800,   391,  1185,  1186,   393,  1187,   395,
     396,   397,     0,   398,     0,     0,  1188,   400,   401,     0,
       0,   402,   403,   801,   404,   802,  1189,   406,   407,   408,
     409,   410,   411,   412,   413,     0,     0,   414,   415,  1190,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     426,   427,   428,   429,  1191,   431,   432,   433,   434,     0,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   446,   447,   803,   448,   449,   450,  1192,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,   464,  1193,   465,   466,   467,   468,   469,   804,
     470,   471,  1194,   473,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1195,     0,   486,   487,
       0,   488,   805,   489,   490,   491,   492,   493,     0,  1196,
    1197,     0,     0,   496,   497,  1198,   499,  1199,  1200,   501,
     502,   503,   504,   505,   506,   507,     0,  1201,   508,   509,
     510,   511,   512,  1202,     0,   513,   514,   515,   516,   517,
     518,  1203,     0,   520,   806,   521,   522,   523,   524,     0,
       0,   525,     0,     0,   526,   527,   528,   529,   530,   531,
     532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,
     542,   543,  1212,     0,     0,     0,     0,     0,     0,  1213,
    1214,     0,     0,     0,     0,     0,     0,     0,  1216,   783,
    1146,   601,  1147,  1148,  1149,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,  1184,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,  1188,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    1192,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,  1201,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,   518,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,  4170,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,  1212,     0,     0,     0,     0,     0,
       0,  1213,  1214,     0,     0,     0,     0,     0,     0,     0,
    1216,   783,  1146,   601,  1147,  1148,  1149,   655,  1150,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,  1151,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242,   243,  1152,   785,  1153,  1154,     0,
     247,   248,   249,   250,   251,  1155,  1156,   252,   253,  1157,
    1158,   256,     0,   257,   258,   259,   260,  1159,     0,  1160,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
     277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,
     280,   281,   282,   283,  1168,  1169,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
    1170,   313,   314,   315,  1171,  1172,   317,     0,   318,   319,
    1173,   321,     0,   322,     0,   323,   790,     0,   791,   324,
     325,   326,     0,   327,  1174,     0,  1175,   330,     0,   331,
     332,   333,   334,   335,   792,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,   793,   347,
     348,   349,   350,   351,  1176,  1177,     0,  1178,     0,   355,
     794,   795,   356,   796,   357,   358,   359,   360,   361,     0,
       0,   362,  1179,   797,   364,   798,     0,   365,   366,   367,
    1180,  1181,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1182,   799,
    1183,   386,  4179,   388,  1184,   389,   390,   800,   391,  1185,
    1186,   393,  1187,   395,   396,   397,     0,   398,     0,     0,
    1188,   400,   401,     0,     0,   402,   403,   801,   404,   802,
    1189,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,  1190,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1191,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,  1192,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,  1193,   465,   466,
     467,   468,   469,   804,   470,   471,  1194,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1195,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1196,  1197,     0,     0,   496,   497,  1198,
     499,  1199,  1200,   501,   502,   503,   504,   505,   506,   507,
       0,  1201,   508,   509,   510,   511,   512,  1202,     0,   513,
     514,   515,   516,   517,   518,  1203,     0,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,   541,   542,   543,  1212,     0,     0,     0,
       0,     0,     0,  1213,  1214,     0,     0,     0,     0,     0,
       0,     0,  1216,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,   243,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,   788,
     275,  4468,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,  1004,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  4469,   330,
       0,   331,   332,   333,   334,   335,   792,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,   794,   795,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,   798,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,  1184,   389,   390,   800,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,  4470,  1192,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,   804,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,  1201,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,     0,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,  1212,     0,
       0,     0,     0,     0,     0,  1213,  1214,     0,     0,     0,
       0,     0,     0,     0,  4471,   783,  1146,   601,  1147,  1148,
    1149,   655,  1150,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1151,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,  4857,  1152,
     785,  1153,  1154,     0,   247,   248,   249,   250,   251,  1155,
    1156,   252,   253,  1157,  1158,   256,     0,   257,   258,   259,
     260,  1159,     0,  1160,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,  4858,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,   278,   279,   280,   281,   282,   283,  1168,  1169,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,  1170,   313,   314,   315,  1171,  1172,
     317,     0,   318,   319,  1173,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,  1174,     0,
    1175,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,  1176,  1177,
       0,  1178,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,  1179,   797,   364,   798,
       0,   365,   366,   367,  1180,  1181,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1182,   799,  1183,   386,   387,   388,  1184,   389,
     390,   800,   391,  1185,  1186,   393,  1187,   395,   396,   397,
       0,   398,     0,     0,  1188,   400,   401,     0,     0,   402,
     403,   801,   404,   802,  1189,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,  1190,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1191,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,  1192,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,  1193,   465,   466,   467,   468,   469,   804,   470,   471,
    1194,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1195,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1196,  1197,     0,
       0,   496,   497,  1198,   499,  1199,  1200,   501,   502,   503,
     504,  4859,   506,   507,     0,  1201,   508,   509,   510,   511,
     512,  1202,     0,   513,   514,   515,   516,   517,   518,  1203,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,   543,
    1212,     0,     0,     0,     0,     0,     0,  1213,  1214,     0,
       0,     0,     0,     0,     0,     0,  1216,   783,  1146,   601,
    1147,  1148,  1149,   655,  1150,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,  1151,     0,
       0,   236,   237,     0,   238,   239,   784,   240,   241,   242,
     243,  1152,   785,  1153,  1154,     0,   247,   248,   249,   250,
     251,  1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,
     258,   259,   260,  1159,     0,  1160,     0,   262,   263,   264,
     265,   787,   266,   267,   268,     0,   269,   270,   271,   272,
     273,   274,     0,   788,   275,   276,  4858,  1161,  1162,  1163,
    1164,  1165,  1166,  1167,   278,   279,   280,   281,   282,   283,
    1168,  1169,   286,     0,   287,     0,   288,   289,   290,   291,
     292,   293,     0,   294,   295,   296,     0,     0,   297,   298,
    1004,   300,   301,     0,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,   311,  1170,   313,   314,   315,
    1171,  1172,   317,     0,   318,   319,  1173,   321,     0,   322,
       0,   323,   790,     0,   791,   324,   325,   326,     0,   327,
    1174,     0,  1175,   330,     0,   331,   332,   333,   334,   335,
     792,   336,   337,   338,   339,     0,   340,   341,   342,   343,
     344,   345,     0,   346,   793,   347,   348,   349,   350,   351,
    1176,  1177,     0,  1178,     0,   355,   794,   795,   356,   796,
     357,   358,   359,   360,   361,     0,     0,   362,  1179,   797,
     364,   798,     0,   365,   366,   367,  1180,  1181,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,  1182,   799,  1183,   386,   387,   388,
    1184,   389,   390,   800,   391,  1185,  1186,   393,  1187,   395,
     396,   397,     0,   398,     0,     0,  1188,   400,   401,     0,
       0,   402,   403,   801,   404,   802,  1189,   406,   407,   408,
     409,   410,   411,   412,   413,     0,     0,   414,   415,  1190,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     426,   427,   428,   429,  1191,   431,   432,   433,   434,     0,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   446,   447,   803,   448,   449,   450,  1192,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,   464,  1193,   465,   466,   467,   468,   469,   804,
     470,   471,  1194,   473,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1195,     0,   486,   487,
       0,   488,   805,   489,   490,   491,   492,   493,     0,  1196,
    1197,     0,     0,   496,   497,  1198,   499,  1199,  1200,   501,
     502,   503,   504,  4859,   506,   507,     0,  1201,   508,   509,
     510,   511,   512,  1202,     0,   513,   514,   515,   516,   517,
     518,  1203,     0,   520,   806,   521,   522,   523,   524,     0,
       0,   525,     0,     0,   526,   527,   528,   529,   530,   531,
     532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,
     542,   543,  1212,     0,     0,     0,     0,     0,     0,  1213,
    1214,     0,     0,     0,     0,     0,     0,     0,  1216,   783,
    1146,   601,  1147,  1148,  1149,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,     0,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,  1188,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    2546,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,     0,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,   518,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,     0,     0,     0,     0,     0,     0,
       0,  2547,  2548,     0,     0,     0,     0,     0,     0,     0,
    2549,   783,  1146,   601,  1147,  1148,  1149,   655,  1150,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,  1151,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242, -2420,  1152,   785,  1153,  1154,     0,
     247,   248,   249,   250,   251,  1155,  1156,   252,   253,  1157,
    1158,   256,     0,   257,   258,   259,   260,  1159,     0,  1160,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
    4858,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,
     280,   281,   282,   283,  1168,  1169,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
    1170,   313,   314,   315,  1171,  1172,   317,     0,   318,   319,
    1173,   321,     0,   322,     0,   323,   790,     0,   791,   324,
     325,   326,     0,   327,  1174,     0,  1175,   330,     0,   331,
     332,   333,   334,   335, -2420,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,   793,   347,
     348,   349,   350,   351,  1176,  1177,     0,  1178,     0,   355,
       0,     0,   356,   796,   357,   358,   359,   360,   361,     0,
       0,   362,  1179,   797,   364, -2420,     0,   365,   366,   367,
    1180,  1181,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1182,   799,
    1183,   386,   387,   388,  1184,   389,   390,     0,   391,  1185,
    1186,   393,  1187,   395,   396,   397,     0,   398,     0,     0,
    1188,   400,   401,     0,     0,   402,   403,   801,   404,   802,
    1189,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,  1190,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1191,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,  1192,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,  1193,   465,   466,
     467,   468,   469, -2420,   470,   471,  1194,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1195,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1196,  1197,     0,     0,   496,   497,  1198,
     499,  1199,  1200,   501,   502,   503,   504,  4859,   506,   507,
       0,  1201,   508,   509,   510,   511,   512,  1202,     0,   513,
     514,   515,   516,   517,   518,  1203,     0,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,   541,   542,   543, -2420,     0,     0,     0,
       0,     0,     0,  1213,  1214,     0,     0,     0,     0,     0,
       0,     0,  1216,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,   243,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,   788,
     275,   276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,  1004,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  1175,   330,
       0,   331,   332,   333,   334,   335,   792,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,     0,   795,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,   798,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,     0,   389,   390,   800,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,   450,  2546,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,   804,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,     0,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,     0,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,     0,     0,
       0,     0,     0,     0,     0,  2547,  2548,     0,     0,   783,
    1146,   601,  1147,  1148,  2549,   655,  1150,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
    1151,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,  1152,   785,  1153,  1154,     0,   247,   248,
     249,   250,   251,  1155,  1156,   252,   253,  1157,  1158,   256,
       0,   257,   258,   259,   260,  1159,     0,  1160,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,  1161,
    1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,
     282,   283,  1168,  1169,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,  1170,   313,
     314,   315,  1171,  1172,   317,     0,   318,   319,  1173,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,  1174,     0,  1175,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,  1176,  1177,     0,  1178,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
    1179,   797,   364,   798,     0,   365,   366,   367,  1180,  1181,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1182,   799,  1183,   386,
     387,   388,     0,   389,   390,   800,   391,  1185,  1186,   393,
    1187,   395,   396,   397,     0,   398,     0,     0,   399,   400,
     401,     0,     0,   402,   403,   801,   404,   802,  1189,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,  1190,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1191,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
    2546,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,  1193,   465,   466,   467,   468,
     469,   804,   470,   471,  1194,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1195,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1196,  1197,     0,     0,   496,   497,  1198,   499,  1199,
    1200,   501,   502,   503,   504,   505,   506,   507,     0,     0,
     508,   509,   510,   511,   512,  1202,     0,   513,   514,   515,
     516,   517,   518,  1203,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,   541,   542,   543,     0,     0,   783,  1146,   601,  1147,
    1148,     0,   655,  1150,     0,     0,     0,     0,     0,     0,
    2549,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1151,     0,     0,
     236,   237,     0,   238,   239,   784,   240,   241,   242,   243,
    1152,   785,  1153,  1154,     0,  3781,   248,   249,   250,   251,
    1155,  1156,   252,   253,  1157,  1158,   256,     0,   257,   258,
     259,   260,  1159,     0,  1160,     0,   262,   263,   264,   265,
     787,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,
    1165,  1166,  1167,   278,   279,   280,   281,   282,   283,  1168,
    1169,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,  1004,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,  1170,   313,   314,   315,  1171,
    1172,   317,     0,   318,   319,  1173,   321,     0,   322,     0,
     323,   790,     0,   791,   324,   325,   326,     0,   327,  1174,
       0,  1175,   330,     0,   331,   332,   333,   334,   335,   792,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,   793,   347,   348,   349,   350,   351,  1176,
    1177,     0,  1178,     0,   355,   794,   795,   356,   796,   357,
     358,   359,   360,   361,     0,     0,   362,  1179,   797,   364,
     798,     0,   365,   366,   367,  1180,  1181,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,  1182,   799,  1183,   386,   387,   388,     0,
     389,   390,   800,   391,  1185,  1186,   393,  1187,   395,   396,
     397,     0,   398,     0,     0,   399,   400,   401,     0,     0,
     402,   403,   801,   404,   802,  1189,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,  1190,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,  1191,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,   803,   448,   449,   450,  2546,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,   464,  1193,   465,   466,   467,   468,   469,   804,   470,
     471,  1194,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1195,     0,   486,   487,     0,
     488,   805,   489,   490,   491,   492,   493,     0,  1196,  1197,
       0,     0,   496,   497,  1198,   499,  1199,  1200,   501,   502,
     503,   504,   505,   506,   507,     0,     0,   508,   509,   510,
     511,   512,  1202,     0,   513,   514,   515,   516,   517,   518,
    1203,     0,   520,   806,   521,   522,   523,   524,     0,     0,
     525,     0,     0,   526,   527,   528,   529,   530,   531,   532,
    1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,
     543,     0,     0,   783,  1146,   601,  1147,  1148,  1149,   655,
    1150,     0,     0,     0,     0,     0,     0,  2549,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1151,     0,     0,   236,   237,     0,
     238,   239,   784,   240,   241,   242,     0,  1152,   785,  1153,
    1154,     0,   247,   248,   249,   250,   251,  1155,  1156,   252,
     253,  1157,  1158,   256,     0,   257,   258,   259,   260,  1159,
       0,  1160,     0,   262,   263,   264,   265,   787,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,   788,
     275,   276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
     278,   279,   280,   281,   282,   283,  1168,  1169,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,  1004,   300,   301,     0,
     302,   303,   304,     0,   305,     0,   307,     0,   308,   309,
     310,   311,  1170,   313,   314,   315,  1171,  1172,   317,     0,
     318,   319,  1173,   321,     0,   322,     0,   323,   790,     0,
     791,   324,   325,   326,     0,   327,  1174,     0,  1175,   330,
       0,   331,   332,   333,   334,   335,     0,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
     793,   347,   348,   349,   350,   351,  1176,  1177,     0,  1178,
       0,   355,     0,     0,   356,   796,   357,   358,   359,   360,
     361,     0,     0,   362,  1179,   797,   364,     0,     0,   365,
     366,   367,  1180,  1181,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
    1182,   799,  1183,   386,   387,   388,  1184,   389,   390,     0,
     391,  1185,  1186,   393,  1187,   395,   396,   397,     0,   398,
       0,     0,  1188,   400,   401,     0,     0,   402,   403,   801,
     404,   802,  1189,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,  1190,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
    1191,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
     803,   448,   449,   450,  1192,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,  1193,
     465,   466,   467,   468,   469,     0,   470,   471,  1194,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1195,     0,   486,   487,     0,   488,   805,   489,
     490,   491,   492,   493,     0,  1196,  1197,     0,     0,   496,
     497,  1198,   499,  1199,  1200,   501,   502,   503,   504,   505,
     506,   507,     0,  1201,   508,   509,   510,   511,   512,  1202,
       0,   513,   514,   515,   516,   517,   518,  1203,     0,   520,
     806,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,  1204,  1205,  1206,
    1207,  1208,  1209,  1210,  1211,   541,   542,   543,     0,     0,
     783,     0,     0,     0,     0,  1213,  1214,     0,     0,     0,
       0,     0,     0,     0,  1216,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,  1156,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,  1159,     0,  1160,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
    1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,  1171,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,  1174,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,  3303,     0,
     362,  1179,   797,   364,   798,     0,   365,   366,   367,  1180,
    1181,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,  1186,
     393,   394,   395,   396,   397,     0,   398,     0,   747,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,  1189,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,  1190,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,  3304,   453,   454,   455,   456,   457,   458,   459,
      40,   460,   461,   462,   463,   464,  1193,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1195,
       0,   486,   487,    44,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,  1198,   499,
    1199,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,  1202,     0,   513,   514,
     515,   516,   517,  1077,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,    49,   526,   527,   528,
     529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,
    1210,  1211,   541,   542,   543,     0,     0,    50,   783,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3305,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   784,   240,   241,
     242,   243,   244,   785,   245,   246,     0,   247,   248,   249,
     250,   251,     0,  1156,   252,   253,   254,   255,   256,     0,
     257,   258,   259,   260,  1159,     0,  1160,     0,   262,   263,
     264,   265,   787,   266,   267,   268,     0,   269,   270,   271,
     272,   273,   274,     0,   788,   275,   276,   277,  1161,  1162,
    1163,  1164,  1165,  1166,  1167,   278,   279,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,   289,   290,
     291,   292,   293,     0,   294,   295,   296,     0,     0,   297,
     298,   299,   300,   301,     0,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,   311,   312,   313,   314,
     315,  1171,     0,   317,     0,   318,   319,   320,   321,     0,
     322,     0,   323,   790,     0,   791,   324,   325,   326,     0,
     327,  1174,     0,   329,   330,     0,   331,   332,   333,   334,
     335,   792,   336,   337,   338,   339,     0,   340,   341,   342,
     343,   344,   345,     0,   346,   793,   347,   348,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   794,   795,   356,
     796,   357,   358,   359,   360,   361,  3303,     0,   362,  1179,
     797,   364,   798,     0,   365,   366,   367,  1180,  1181,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   799,   385,   386,   387,
     388,     0,   389,   390,   800,   391,     0,  1186,   393,   394,
     395,   396,   397,     0,   398,     0,   747,   399,   400,   401,
       0,     0,   402,   403,   801,   404,   802,  1189,   406,   407,
     408,   409,   410,   411,   412,   413,     0,     0,   414,   415,
    1190,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   446,   447,   803,   448,   449,   450,   451,
    3304,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,   464,  1193,   465,   466,   467,   468,   469,
     804,   470,   471,   472,   473,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1195,     0,   486,
     487,     0,   488,   805,   489,   490,   491,   492,   493,     0,
     494,   495,     0,     0,   496,   497,  1198,   499,  1199,     0,
     501,   502,   503,   504,   505,   506,   507,     0,     0,   508,
     509,   510,   511,   512,  1202,     0,   513,   514,   515,   516,
     517,   518,   519,     0,   520,   806,   521,   522,   523,   524,
       0,     0,   525,     0,     0,   526,   527,   528,   529,   530,
     531,   532,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,
     541,   542,   543,     0,     0,   783,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3305,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
    1156,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,  1159,     0,  1160,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,  1171,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,  1174,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,  1179,   797,   364,   798,
       0,   365,   366,   367,  1180,  1181,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,  1186,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,  1189,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,  1190,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,  3304,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,  1193,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1195,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,  1198,   499,  1199,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,  1202,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,   541,   542,   543,
       0,     0,   783,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    51,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   784,   240,   241,   242,   243,   244,   785,   245,   246,
       0,   247,   248,   249,   250,   251,     0,  1156,   252,   253,
     254,   255,   256,     0,   257,   258,   259,   260,  1159,     0,
    1160,     0,   262,   263,   264,   265,   787,   266,   267,   268,
       0,   269,   270,   271,   272,   273,   274,     0,   788,   275,
     276,   277,  1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,
     279,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,   289,   290,   291,   292,   293,     0,   294,   295,
     296,     0,     0,   297,   298,   299,   300,   301,     0,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
     311,   312,   313,   314,   315,  1171,     0,   317,     0,   318,
     319,   320,   321,     0,   322,     0,   323,   790,     0,   791,
     324,   325,   326,     0,   327,  1174,     0,   329,   330,     0,
     331,   332,   333,   334,   335,   792,   336,   337,   338,   339,
       0,   340,   341,   342,   343,   344,   345,     0,   346,   793,
     347,   348,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   794,   795,   356,   796,   357,   358,   359,   360,   361,
       0,     0,   362,  1179,   797,   364,   798,     0,   365,   366,
     367,  1180,  1181,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     799,   385,   386,   387,   388,     0,   389,   390,   800,   391,
       0,  1186,   393,   394,   395,   396,   397,     0,   398,     0,
       0,   399,   400,   401,     0,     0,   402,   403,   801,   404,
     802,  1189,   406,   407,   408,   409,   410,   411,   412,   413,
       0,     0,   414,   415,  1190,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   446,   447,   803,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,   464,  1193,   465,
     466,   467,   468,   469,   804,   470,   471,   472,   473,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1195,     0,   486,   487,     0,   488,   805,   489,   490,
     491,   492,   493,     0,   494,   495,     0,     0,   496,   497,
    1198,   499,  1199,     0,   501,   502,   503,   504,   505,   506,
     507,     0,     0,   508,   509,   510,   511,   512,  1202,     0,
     513,   514,   515,   516,   517,   518,   519,     0,   520,   806,
     521,   522,   523,   524,     0,     0,   525,     0,     0,   526,
     527,   528,   529,   530,   531,   532,  1204,  1205,  1206,  1207,
    1208,  1209,  1210,  1211,   541,   542,   543,     0,     0,   827,
    1421,   601,     0,     0,     0,   655,     0,     0,     0,     0,
       0,     0,     0,  3905,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,   243,   244,   785,   245,   246,     0,   247,   248,
     249,   250,   251,     0,     0,   252,   253,   254,   255,   256,
       0,   257,   258,   259,   260,   261,     0,   786,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,     0,
       0,     0,   789,     0,     0,     0,   278,   279,   280,   281,
     282,   283,   284,   285,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,   299,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,   312,   313,
     314,   315,   316,  1690,   317,     0,   318,   319,   320,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,   328,     0,   329,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,   347,   348,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
     363,   797,   364,   798,     0,   365,   366,   367,     0,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   799,   385,   386,
     387,   388,     0,   389,   390,   800,   391,     0,   392,   393,
     394,   395,   396,   397,     0,   398,  1691,     0,   399,   400,
     401,     0,     0,   402,   403,   801,   404,   802,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,   416,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,     0,   465,   466,   467,   468,
     469,   804,   470,   471,   472,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,   494,   495,     0,     0,   496,   497,   498,   499,   500,
    1692,   501,   502,   503,   504,   505,   506,   507,     0,     0,
     508,   509,   510,   511,   512,     0,     0,   513,   514,   515,
     516,   517,   518,   519,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,     0,     0,   827,     0,     0,     0,
       0,   667,  1422,  4702,     0,     0,     0,     0,     0,     0,
    4703,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     3,     4,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   784,   240,   241,   242,   243,
     244,   785,   245,   246,     0,   247,   248,   249,   250,   251,
       0,     0,   252,   253,   254,   255,   256,     0,   257,   258,
     259,   260,   261,     0,   786,     0,   262,   263,   264,   265,
     787,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,   788,   275,   276,   277,     0,     0,     0,   789,
       0,     0,     0,   278,   279,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,   299,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,   312,   313,   314,   315,   316,
       0,   317,     0,   318,   319,   320,   321,     0,   322,     0,
     323,   790,     0,   791,   324,   325,   326,     0,   327,   328,
       0,   329,   330,     0,   331,   332,   333,   334,   335,   792,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,   793,   347,   348,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   794,   795,   356,   796,   357,
     358,   359,   360,   361,     0,     0,   362,   363,   797,   364,
     798,     0,   365,   366,   367,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   799,   385,   386,   387,   388,     0,
     389,   390,   800,   391,     0,   392,   393,   394,   395,   396,
     397,     0,   398,     0,     0,   399,   400,   401,     0,     0,
     402,   403,   801,   404,   802,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,   416,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,   803,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,    40,   460,   461,   462,
     463,   464,     0,   465,   466,   467,   468,   469,   804,   470,
     471,   472,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,     0,   486,   487,    44,
     488,   805,   489,   490,   491,   492,   493,     0,   494,   495,
       0,     0,   496,   497,   498,   499,   500,     0,   501,   502,
     503,   504,   505,   506,   507,     0,     0,   508,   509,   510,
     511,   512,     0,     0,   513,   514,   515,   516,   517,  1077,
     519,     0,   520,   806,   521,   522,   523,   524,     0,     0,
     525,     0,    49,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,     0,     0,    50,   783,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    51,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   784,   240,   241,   242,   243,   244,   785,
     245,   246,     0,   247,   248,   249,   250,   251,     0,     0,
     252,   253,   254,   255,   256,     0,   257,   258,   259,   260,
     261,     0,   786,     0,   262,   263,   264,   265,   787,   266,
     267,   268,     0,   269,   270,   271,   272,   273,   274,     0,
     788,   275,   276,   277,     0,     0,     0,   789,     0,     0,
       0,   278,   279,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,   289,   290,   291,   292,   293,     0,
     294,   295,   296,     0,     0,   297,   298,   299,   300,   301,
       0,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,   311,   312,   313,   314,   315,   316,     0,   317,
       0,   318,   319,   320,   321,     0,   322,     0,   323,   790,
       0,   791,   324,   325,   326,     0,   327,   328,     0,   329,
     330,     0,   331,   332,   333,   334,   335,   792,   336,   337,
     338,   339,     0,   340,   341,   342,   343,   344,   345,     0,
     346,   793,   347,   348,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   794,   795,   356,   796,   357,   358,   359,
     360,   361,     0,     0,   362,   363,   797,   364,   798,     0,
     365,   366,   367,     0,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   799,   385,   386,   387,   388,     0,   389,   390,
     800,   391,     0,   392,   393,   394,   395,   396,   397,     0,
     398,     0,     0,   399,   400,   401,     0,     0,   402,   403,
     801,   404,   802,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,     0,   414,   415,   416,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   446,
     447,   803,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
       0,   465,   466,   467,   468,   469,   804,   470,   471,   472,
     473,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     0,   486,   487,     0,   488,   805,
     489,   490,   491,   492,   493,     0,   494,   495,     0,     0,
     496,   497,   498,   499,   500,     0,   501,   502,   503,   504,
     505,   506,   507,     0,     0,   508,   509,   510,   511,   512,
       0,     0,   513,   514,   515,   516,   517,   518,   519,     0,
     520,   806,   521,   522,   523,   524,     0,     0,   525,     0,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4519,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
       0,   240,   241,   242,   243,   244,     0,   245,   246,     0,
     247,   248,   249,   250,   251,     0,     0,   252,   253,   254,
     255,   256,     0,   257,   258,   259,   260,   261,     0,     0,
       0,   262,   263,   264,   265,     0,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,     0,   275,   276,
     277,     0,     0,     0,     0,     0,     0,     0,   278,   279,
     280,   281,   282,   283,   284,   285,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,   299,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
     312,   313,   314,   315,   316,     0,   317,     0,   318,   319,
     320,   321,     0,   322,     0,   323,     0,     0,     0,   324,
     325,   326,     0,   327,   328,     0,   329,   330,     0,   331,
     332,   333,   334,   335,     0,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     348,   349,   350,   351,   352,   353,     0,   354,     0,   355,
       0,     0,   356,     0,   357,   358,   359,   360,   361,     0,
       0,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,     0,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,     0,   398,     0,     0,
     399,   400,   401,     0,     0,   402,   403,     0,   404,     0,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,   416,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,    40,   460,   461,   462,   463,   464,     0,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,     0,   486,   487,    44,   488,     0,   489,   490,   491,
     492,   493,     0,   494,   495,     0,     0,   496,   497,   498,
     499,   500,     0,   501,   502,   503,   504,   505,   506,   507,
       0,     0,   508,   509,   510,   511,   512,     0,     0,   513,
     514,   515,   516,   517,  1077,   519,     0,   520,     0,   521,
     522,   523,   524,     0,     0,   525,     0,    49,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,     0,     0,    50,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    51,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,     0,   240,
     241,   242,   243,   244,     0,   245,   246,     0,   247,   248,
     249,   250,   251,     0,     0,   252,   253,   254,   255,   256,
       0,   257,   258,   259,   260,   261,     0,     0,     0,   262,
     263,   264,   265,     0,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,     0,   275,   276,   277,     0,
       0,     0,     0,     0,     0,     0,   278,   279,   280,   281,
     282,   283,   284,   285,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,   299,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,   312,   313,
     314,   315,   316,     0,   317,     0,   318,   319,   320,   321,
       0,   322,     0,   323,     0,     0,     0,   324,   325,   326,
       0,   327,   328,     0,   329,   330,     0,   331,   332,   333,
     334,   335,     0,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,   348,   349,
     350,   351,   352,   353,     0,   354,     0,   355,     0,     0,
     356,     0,   357,   358,   359,   360,   361,     0,     0,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,     0,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,   397,     0,   398,     0,     0,   399,   400,
     401,     0,     0,   402,   403,     0,   404,     0,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,   416,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,     0,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     0,
     486,   487,     0,   488,     0,   489,   490,   491,   492,   493,
       0,   494,   495,     0,     0,   496,   497,   498,   499,   500,
       0,   501,   502,   503,   504,   505,   506,   507,     0,     0,
     508,   509,   510,   511,   512,     0,     0,   513,   514,   515,
     516,   517,   518,   519,     0,   520,     0,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1274,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,     0,   240,   241,   242,   243,
     244,     0,   245,   246,     0,   247,   248,   249,   250,   251,
       0,     0,   252,   253,   254,   255,   256,     0,   257,   258,
     259,   260,   261,     0,     0,     0,   262,   263,   264,   265,
       0,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,     0,   275,   276,   277,     0,     0,     0,     0,
       0,     0,     0,   278,   279,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,   299,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,   312,   313,   314,   315,   316,
       0,   317,     0,   318,   319,   320,   321,     0,   322,     0,
     323,     0,     0,     0,   324,   325,   326,     0,   327,   328,
       0,   329,   330,     0,   331,   332,   333,   334,   335,     0,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,     0,   347,   348,   349,   350,   351,   352,
     353,     0,   354,     0,   355,     0,     0,   356,     0,   357,
     358,   359,   360,   361,     0,     0,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,     0,
     389,   390,     0,   391,     0,   392,   393,   394,   395,   396,
     397,     0,   398,     0,     0,   399,   400,   401,     0,     0,
     402,   403,     0,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,   416,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,   464,     0,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,     0,   486,   487,     0,
     488,     0,   489,   490,   491,   492,   493,     0,   494,   495,
       0,     0,   496,   497,   498,   499,   500,     0,   501,   502,
     503,   504,   505,   506,   507,     0,     0,   508,   509,   510,
     511,   512,     0,     0,   513,   514,   515,   516,   517,   518,
     519,     0,   520,     0,   521,   522,   523,   524,     0,     0,
     525,     0,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,     0,     0,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2703,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,     0,   240,   241,   242,   243,   244,     0,   245,
     246,     0,   247,   248,   249,   250,   251,     0,     0,   252,
     253,   254,   255,   256,     0,   257,   258,   259,   260,   261,
       0,     0,     0,   262,   263,   264,   265,     0,   266,   267,
     268,     0,   269,   270,   271,   272,   273,   274,     0,     0,
     275,   276,   277,     0,     0,     0,     0,     0,     0,     0,
     278,   279,   280,   281,   282,   283,   284,   285,   286,     0,
     287,     0,   288,   289,   290,   291,   292,   293,     0,   294,
     295,   296,     0,     0,   297,   298,   299,   300,   301,     0,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,   311,   312,   313,   314,   315,   316,     0,   317,     0,
     318,   319,   320,   321,     0,   322,     0,   323,     0,     0,
       0,   324,   325,   326,     0,   327,   328,     0,   329,   330,
       0,   331,   332,   333,   334,   335,     0,   336,   337,   338,
     339,     0,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   348,   349,   350,   351,   352,   353,     0,   354,
       0,   355,     0,     0,   356,     0,   357,   358,   359,   360,
     361,     0,     0,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,     0,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,     0,   398,
       0,     0,   399,   400,   401,     0,     0,   402,   403,     0,
     404,     0,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,     0,   414,   415,   416,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,     0,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,   464,     0,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
       0,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,     0,   486,   487,     0,   488,     0,   489,
     490,   491,   492,   493,     0,   494,   495,     0,     0,   496,
     497,   498,   499,   500,     0,   501,   502,   503,   504,   505,
     506,   507,     0,     0,   508,   509,   510,   511,   512,     0,
       0,   513,   514,   515,   516,   517,   518,   519,     0,   520,
       0,   521,   522,   523,   524,     0,     0,   525,     0,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3816,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,     0,     0,     0,     0,     0,
     996,  1421,   601,     0,     0,   841,   655,     0,     0,     0,
       0,  4224,   842,   843,   844,   224,   225,   226,   227,   228,
     229,   230,   231,  1878,   233,   234,   235,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,   236,   237,  1886,   238,   239,   784,
     240,   241,   242,     0,   997,   785,   998,   999,  1887,   247,
     248,   249,   250,   251,  1888,  1889,   252,   253,  1000,  1001,
     256,  1890,   257,   258,   259,   260,     0,  1891,   786,  1892,
     262,   263,   264,   265,   787,   266,   267,   268,  1893,   269,
     270,   271,   272,   273,   274,  1894,   788,   275,   276,   277,
    1895,  1896,  1897,   789,  1898,  1899,  1900,   278,   279,   280,
     281,   282,   283,  1002,  1003,   286,  1901,   287,  1902,   288,
     289,   290,   291,   292,   293,  1903,   294,   295,   296,  1904,
    1905,   297,   298,  1004,   300,   301,  1906,   302,   303,   304,
    1907,   305,   306,   307,  1908,   308,   309,   310,   311,     0,
     313,   314,   315,     0,  1909,   317,  1910,   318,   319,  1005,
     321,  1911,   322,  1912,   323,   790,  1913,   791,   324,   325,
     326,  1914,   327,     0,  1915,     0,   330,  1916,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,  1917,   340,
     341,   342,   343,   344,   345,  1918,   346,   793,     0,   348,
     349,   350,   351,  1007,  1008,  1919,  1009,  1920,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,  1921,  1922,
     362,     0,   797,   364,   798,  1923,   365,   366,   367,  1924,
    1925,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,  1010,   799,  1011,
     386,   387,  4313,  1926,   389,   390,   800,   391,  1927,     0,
     393,  1012,   395,   396,   397,  1928,   398,  1929,  1930,  3567,
     400,   401,  1931,  1932,   402,     0,   801,   404,   802,     0,
     406,   407,   408,   409,   410,   411,   412,   413,     0,  1933,
     414,   415,     0,   417,     0,   419,   420,   421,  1934,   422,
     423,   424,   425,   426,   427,   428,   429,  1013,   431,   432,
     433,   434,  1935,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,  1936,   446,   447,   803,   448,   449,
     450,     0,   452,   453,   454,   455,   456,   457,   458,   459,
    1937,   460,   461,   462,   463,   464,  1938,   465,   466,  2019,
     468,   469,   804,   470,   471,  1015,   473,  1939,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     0,
    1940,   486,   487,  1941,   488,   805,   489,   490,   491,   492,
     493,  1942,  1016,  1017,  1943,  1944,   496,   497,     0,   499,
       0,  1945,   501,   502,   503,   504,   505,   506,   507,  1946,
    1947,   508,   509,   510,   511,   512,  1948,  1949,   513,   514,
     515,   516,   517,     0,  1018,  1950,   520,   806,   521,   522,
     523,   524,  1951,  1952,   525,  1953,  1954,   526,   527,   528,
     529,   530,   531,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   541,   542,   543,     0,     0,     0,   847,   848,
     849,     0,  3568,  3569,   852,   853,   854,   855,   996,  1421,
     601,     0,     0,   841,   655,     0,     0,     0,     0,     0,
     842,   843,   844,   224,   225,   226,   227,   228,   229,   230,
     231,  1878,   233,   234,   235,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,   236,   237,  1886,   238,   239,   784,   240,   241,
     242,     0,   997,   785,   998,   999,  1887,   247,   248,   249,
     250,   251,  1888,  1889,   252,   253,  1000,  1001,   256,  1890,
     257,   258,   259,   260,     0,  1891,   786,  1892,   262,   263,
     264,   265,   787,   266,   267,   268,  1893,   269,   270,   271,
     272,   273,   274,  1894,   788,   275,   276,   277,  1895,  1896,
    1897,   789,  1898,  1899,  1900,   278,   279,   280,   281,   282,
     283,  1002,  1003,   286,  1901,   287,  1902,   288,   289,   290,
     291,   292,   293,  1903,   294,   295,   296,  1904,  1905,   297,
     298,  1004,   300,   301,  1906,   302,   303,   304,  1907,   305,
     306,   307,  1908,   308,   309,   310,   311,     0,   313,   314,
     315,     0,  1909,   317,  1910,   318,   319,  1005,   321,  1911,
     322,  1912,   323,   790,  1913,   791,   324,   325,   326,  1914,
     327,     0,  1915,     0,   330,  1916,   331,   332,   333,   334,
     335,   792,   336,   337,   338,   339,  1917,   340,   341,   342,
     343,   344,   345,  1918,   346,   793,     0,   348,   349,   350,
     351,  1007,  1008,  1919,  1009,  1920,   355,   794,   795,   356,
     796,   357,   358,   359,   360,   361,  1921,  1922,   362,     0,
     797,   364,   798,  1923,   365,   366,   367,  1924,  1925,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,  1010,   799,  1011,   386,   387,
       0,  1926,   389,   390,   800,   391,  1927,     0,   393,  1012,
     395,   396,   397,  1928,   398,  1929,  1930,  3567,   400,   401,
    1931,  1932,   402,     0,   801,   404,   802,     0,   406,   407,
     408,   409,   410,   411,   412,   413,     0,  1933,   414,   415,
       0,   417,     0,   419,   420,   421,  1934,   422,   423,   424,
     425,   426,   427,   428,   429,  1013,   431,   432,   433,   434,
    1935,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,  1936,   446,   447,   803,   448,   449,   450,     0,
     452,   453,   454,   455,   456,   457,   458,   459,  1937,   460,
     461,   462,   463,   464,  1938,   465,   466,  2019,   468,   469,
     804,   470,   471,  1015,   473,  1939,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,  1940,   486,
     487,  1941,   488,   805,   489,   490,   491,   492,   493,  1942,
    1016,  1017,  1943,  1944,   496,   497,     0,   499,     0,  1945,
     501,   502,   503,   504,   505,   506,   507,  1946,  1947,   508,
     509,   510,   511,   512,  1948,  1949,   513,   514,   515,   516,
     517,     0,  1018,  1950,   520,   806,   521,   522,   523,   524,
    1951,  1952,   525,  1953,  1954,   526,   527,   528,   529,   530,
     531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     541,   542,   543,     0,   223,     0,   847,   848,   849,   841,
    3568,  3569,   852,   853,   854,   855,   842,   843,   844,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,     0,   240,   241,   242,   243,   244,     0,
     245,   246,     0,   247,   248,   249,   250,   251,     0,     0,
     252,   253,   254,   255,   256,     0,   257,   845,   259,   260,
     261,     0,     0,     0,   262,   263,   264,   265,     0,   266,
     267,   268,     0,   269,   270,   271,   272,   273,   274,     0,
       0,   275,   276,   277,     0,     0,     0,     0,     0,     0,
       0,   278,   279,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,   289,   290,   291,   292,   293,     0,
     294,   295,   296,     0,     0,   297,   298,   299,   300,   301,
       0,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,   311,   312,   313,   314,   315,   316,     0,   846,
       0,   318,   319,   320,   321,     0,   322,     0,   323,     0,
       0,     0,   324,   325,   326,     0,   327,   328,     0,   329,
     330,     0,   331,   332,   333,   334,   335,     0,   336,   337,
     338,   339,     0,   340,   341,   342,   343,   344,   345,     0,
     346,     0,   347,   348,   349,   350,   351,   352,   353,     0,
     354,     0,   355,     0,     0,   356,     0,   357,   358,   359,
     360,   361,     0,     0,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,     0,   389,   390,
       0,   391,     0,   392,   393,   394,   395,   396,   397,     0,
     398,     0,     0,   399,   400,   401,     0,     0,   402,   403,
       0,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,     0,   414,   415,   416,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
       0,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     0,   486,   487,     0,   488,     0,
     489,   490,   491,   492,   493,     0,   494,   495,     0,     0,
     496,   497,   498,   499,   500,     0,   501,   502,   503,   504,
     505,   506,   507,     0,     0,   508,   509,   510,   511,   512,
       0,     0,   513,   514,   515,   516,   517,   518,   519,     0,
     520,     0,   521,   522,   523,   524,     0,     0,   525,     0,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,     0,
     223,     0,   847,   848,   849,   841,   850,   851,   852,   853,
     854,   855,   842,   843,   844,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   953,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   954,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,     0,   223,     0,   847,   848,
     849,   841,   850,   851,   852,   853,   854,   855,   842,   843,
     844,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,     0,   240,   241,   242,   243,
     244,     0,   245,   246,     0,   247,   248,   249,   250,   251,
       0,     0,   252,   253,   254,   255,   256,     0,   257,  1045,
     259,   260,   261,     0,     0,     0,   262,   263,   264,   265,
       0,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,     0,   275,   276,   277,     0,     0,     0,     0,
       0,     0,     0,   278,   279,   280,   281,   282,   283,   284,
     285,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,   299,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,   312,   313,   314,   315,   316,
       0,  1046,     0,   318,   319,   320,   321,     0,   322,     0,
     323,     0,     0,     0,   324,   325,   326,     0,   327,   328,
       0,   329,   330,     0,   331,   332,   333,   334,  1047,     0,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,     0,   347,   348,   349,   350,   351,   352,
     353,     0,   354,     0,   355,     0,     0,   356,     0,   357,
     358,   359,   360,   361,     0,     0,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,     0,
     389,   390,     0,   391,     0,   392,   393,   394,   395,   396,
     397,     0,   398,     0,     0,   399,   400,   401,     0,     0,
     402,   403,     0,   404,     0,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,   416,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,   464,     0,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,     0,   486,   487,     0,
     488,     0,   489,   490,   491,   492,   493,     0,   494,   495,
       0,     0,   496,   497,   498,   499,   500,     0,   501,   502,
     503,   504,   505,   506,   507,     0,     0,   508,   509,   510,
     511,   512,     0,     0,   513,   514,   515,   516,   517,   518,
     519,     0,   520,     0,   521,   522,   523,   524,     0,     0,
     525,     0,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,     0,   223,     0,   847,   848,   849,   841,   850,   851,
     852,   853,   854,   855,   842,   843,   844,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,     0,   240,   241,   242,   243,   244,     0,   245,   246,
       0,   247,   248,   249,   250,   251,     0,     0,   252,   253,
     254,   255,   256,     0,   257,  1519,   259,   260,   261,     0,
       0,     0,   262,   263,   264,   265,     0,   266,   267,   268,
       0,   269,   270,   271,   272,   273,   274,     0,     0,   275,
     276,   277,     0,     0,     0,     0,     0,     0,     0,   278,
     279,   280,   281,   282,   283,   284,   285,   286,     0,   287,
       0,   288,   289,   290,   291,   292,   293,     0,   294,   295,
     296,     0,     0,   297,   298,   299,   300,   301,     0,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
     311,   312,   313,   314,   315,   316,     0,  1520,     0,   318,
     319,   320,   321,     0,   322,     0,   323,     0,     0,     0,
     324,   325,   326,     0,   327,   328,     0,   329,   330,     0,
     331,   332,   333,   334,   335,     0,   336,   337,   338,   339,
       0,   340,   341,   342,   343,   344,   345,     0,   346,     0,
     347,   348,   349,   350,   351,   352,   353,     0,   354,     0,
     355,     0,     0,   356,     0,   357,   358,   359,   360,   361,
       0,     0,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,     0,   389,   390,     0,   391,
       0,   392,   393,   394,   395,   396,   397,     0,   398,     0,
       0,   399,   400,   401,     0,     0,   402,   403,     0,   404,
       0,   405,   406,   407,   408,   409,   410,   411,   412,   413,
       0,     0,   414,   415,   416,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,     0,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,   464,     0,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     0,   486,   487,     0,   488,     0,   489,   490,
     491,   492,   493,     0,   494,   495,     0,     0,   496,   497,
     498,   499,   500,     0,   501,   502,   503,   504,   505,   506,
     507,     0,     0,   508,   509,   510,   511,   512,     0,     0,
     513,   514,   515,   516,   517,   518,   519,     0,   520,     0,
     521,   522,   523,   524,     0,     0,   525,     0,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,     0,   223,     0,
     847,   848,   849,   841,   850,   851,   852,   853,   854,   855,
     842,   843,   844,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,     0,   240,   241,
     242,   243,   244,     0,   245,   246,     0,   247,   248,   249,
     250,   251,     0,     0,   252,   253,   254,   255,   256,     0,
     257,   258,   259,   260,   261,     0,     0,     0,   262,   263,
     264,   265,     0,   266,   267,   268,     0,   269,   270,   271,
     272,   273,   274,     0,     0,   275,   276,   277,     0,     0,
       0,     0,     0,     0,     0,   278,   279,   280,   281,   282,
     283,   284,   285,   286,     0,   287,     0,   288,   289,   290,
     291,   292,   293,     0,   294,   295,   296,     0,     0,   297,
     298,   299,   300,   301,     0,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,   311,   312,   313,   314,
     315,   316,     0,   317,     0,   318,   319,   320,   321,     0,
     322,     0,   323,     0,     0,     0,   324,   325,   326,     0,
     327,   328,     0,   329,   330,     0,   331,   332,   333,   334,
     335,     0,   336,   337,   338,   339,     0,   340,   341,   342,
     343,   344,   345,     0,   346,     0,   347,   348,   349,   350,
     351,   352,   353,     0,   354,     0,   355,     0,     0,   356,
       0,   357,   358,   359,   360,   361,     0,     0,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,     0,   389,   390,     0,   391,     0,   392,   393,   394,
     395,   396,   397,     0,   398,     0,     0,   399,   400,   401,
       0,     0,   402,   403,     0,   404,     0,   405,   406,   407,
     408,   409,   410,   411,   412,   413,     0,     0,   414,   415,
     416,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
       0,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,   464,     0,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,     0,   486,
     487,     0,   488,     0,   489,   490,   491,   492,   493,     0,
     494,   495,     0,     0,   496,   497,   498,   499,   500,     0,
     501,   502,   503,   504,   505,   506,   507,     0,     0,   508,
     509,   510,   511,   512,     0,     0,   513,   514,   515,   516,
     517,   518,   519,     0,   520,     0,   521,   522,   523,   524,
       0,     0,   525,     0,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,     0,   223,     0,   847,   848,   849,   841,
     850,   851,   852,   853,   854,   855,   842,   843,   844,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,     0,   240,   241,   242,   243,   244,     0,
     245,   246,     0,   247,   248,   249,   250,   251,     0,     0,
     252,   253,   254,   255,   256,     0,   257,  2781,   259,   260,
     261,     0,     0,     0,   262,   263,   264,   265,     0,   266,
     267,   268,     0,   269,   270,   271,   272,   273,   274,     0,
       0,   275,   276,   277,     0,     0,     0,     0,     0,     0,
       0,   278,   279,   280,   281,   282,   283,   284,   285,   286,
       0,   287,     0,   288,   289,   290,   291,   292,   293,     0,
     294,   295,   296,     0,     0,   297,   298,   299,   300,   301,
       0,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,   311,   312,   313,   314,   315,   316,     0,  2782,
       0,   318,   319,   320,   321,     0,   322,     0,   323,     0,
       0,     0,   324,   325,   326,     0,   327,   328,     0,   329,
     330,     0,   331,   332,   333,   334,   335,     0,   336,   337,
     338,   339,     0,   340,   341,   342,   343,   344,   345,     0,
     346,     0,   347,   348,   349,   350,   351,   352,   353,     0,
     354,     0,   355,     0,     0,   356,     0,   357,   358,   359,
     360,   361,     0,     0,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,     0,   389,   390,
       0,   391,     0,   392,   393,   394,   395,   396,   397,     0,
     398,     0,     0,   399,   400,   401,     0,     0,   402,   403,
       0,   404,     0,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,     0,   414,   415,   416,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,     0,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
       0,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     0,   486,   487,     0,   488,     0,
     489,   490,   491,   492,   493,     0,   494,   495,     0,     0,
     496,   497,   498,   499,   500,     0,   501,   502,   503,   504,
     505,   506,   507,     0,     0,   508,   509,   510,   511,   512,
       0,     0,   513,   514,   515,   516,   517,   518,   519,     0,
     520,     0,   521,   522,   523,   524,     0,     0,   525,     0,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,     0,
     223,     0,   847,   848,   849,   841,   850,   851,   852,   853,
     854,   855,   842,   843,   844,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,  4499,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,  1877,     0,     0,   847,   848,
     849,     0,   850,   851,   852,   853,   854,   855,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  1878,   233,
     234,   235,  1879,  1880,  1881,  1882,  1883,  1884,  1885,   236,
     237,  1886,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,  1887,   247,   248,   249,   250,   251,  1888,
    1889,   252,   253,   254,   255,   256,  1890,   257,   258,   259,
     260,   261,  1891,   786,  1892,   262,   263,   264,   265,   787,
     266,   267,   268,  1893,   269,   270,   271,   272,   273,   274,
    1894,   788,   275,   276,   277,  1895,  1896,  1897,   789,  1898,
    1899,  1900,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  1901,   287,  1902,   288,   289,   290,   291,   292,   293,
    1903,   294,   295,   296,  1904,  1905,   297,   298,   299,   300,
     301,  1906,   302,   303,   304,  1907,   305,   306,   307,  1908,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1909,
     317,  1910,   318,   319,   320,   321,  1911,   322,  1912,   323,
     790,  1913,   791,   324,   325,   326,  1914,   327,   328,  1915,
     329,   330,  1916,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  1917,   340,   341,   342,   343,   344,   345,
    1918,   346,   793,   347,   348,   349,   350,   351,   352,   353,
    1919,   354,  1920,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,  1921,  1922,   362,   363,   797,   364,   798,
    1923,   365,   366,   367,  1924,  1925,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,  1926,   389,
     390,   800,   391,  1927,   392,   393,   394,   395,   396,   397,
    1928,   398,  1929,  1930,   399,   400,   401,  1931,  1932,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,  1933,   414,   415,   416,   417,   418,
     419,   420,   421,  1934,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1935,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,  1936,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1937,   460,   461,   462,   463,
     464,  1938,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,  1939,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,  1940,   486,   487,  1941,   488,
     805,   489,   490,   491,   492,   493,  1942,   494,   495,  1943,
    1944,   496,   497,   498,   499,   500,  1945,   501,   502,   503,
     504,   505,   506,   507,  1946,  1947,   508,   509,   510,   511,
     512,  1948,  1949,   513,   514,   515,   516,   517,   518,   519,
    1950,   520,   806,   521,   522,   523,   524,  1951,  1952,   525,
    1953,  1954,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,  1955,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   996,     0,     0,     0,     0,
       0,     0,     0,     0,   752,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,     0,   997,
     785,   998,   999,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,  1000,  1001,   256,     0,   257,   258,   259,
     260,     0,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,  1002,  1003,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,     0,   313,   314,   315,     0,     0,
     317,     0,   318,   319,  1005,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,     0,     0,
       0,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  2015,   340,   341,   342,   343,   344,   345,
       0,   346,   793,  2016,   348,   349,   350,   351,  1007,  1008,
       0,  1009,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,     0,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1010,   799,  1011,   386,   387,     0,     0,   389,
     390,   800,   391,     0,     0,   393,  1012,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,  2017,   402,
    2018,   801,   404,   802,     0,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1013,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,     0,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,  2019,   468,   469,   804,   470,   471,
    1015,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1016,  1017,     0,
       0,   496,   497,     0,   499,     0,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,     0,  1018,
    2020,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,     0,     0,
       0,     0,     0,     0,     0,  2288,     0,   541,   542,   543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2021,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,     0,   997,
     785,   998,   999,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,  1000,  1001,   256,     0,   257,   258,   259,
     260,     0,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,  1002,  1003,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,     0,   313,   314,   315,     0,     0,
     317,     0,   318,   319,  1005,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,     0,     0,
       0,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  2015,   340,   341,   342,   343,   344,   345,
       0,   346,   793,  2016,   348,   349,   350,   351,  1007,  1008,
       0,  1009,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,     0,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1010,   799,  1011,   386,   387,     0,     0,   389,
     390,   800,   391,     0,     0,   393,  1012,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,  2017,   402,
    2018,   801,   404,   802,     0,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1013,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,     0,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,  2019,   468,   469,   804,   470,   471,
    1015,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1016,  1017,     0,
       0,   496,   497,     0,   499,     0,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,     0,  1018,
    2020,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,     0,     0,
       0,     0,     0,     0,     0,   223,     0,   541,   542,   543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2021,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,  1421,   601,     0,     0,     0,   655,     0,     0,  4821,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,  1866,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,  1690,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,  1691,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,  1692,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,  1421,   601,     0,     0,
       0,   655,   667,  1422,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  1871,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1690,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,  1691,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,  1692,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,  1421,   601,     0,     0,     0,   655,   667,  1422,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,  1690,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,  1691,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,  1692,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,   601,     0,     0,
       0,   655,   667,  1422,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  2736,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1690,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,  1691,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,  1692,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,   655,   667,   668,     0,
       0,     0,     0,     0,     0,   224,   656,   226,   227,   228,
     229,   230,   231,   657,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     658,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   659,   320,
     321,     0,   322,     0,   660,     0,   661,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,   662,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   663,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     664,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   665,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   666,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,  1877,  4943,   601,     0,     0,
       0,   655,   667,   668,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  1878,   233,
     234,   235,  1879,  1880,  1881,  1882,  1883,  1884,  1885,   236,
     237,  1886,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,  1887,   247,   248,   249,   250,   251,  1888,
    1889,   252,   253,   254,   255,   256,  1890,   257,   258,   259,
     260,   261,  1891,   786,  1892,   262,   263,   264,   265,   787,
     266,   267,   268,  1893,   269,   270,   271,   272,   273,   274,
    1894,   788,   275,   276,   277,  1895,  1896,  1897,   789,  1898,
    1899,  1900,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  1901,   287,  1902,   288,   289,   290,   291,   292,   293,
    1903,   294,   295,   296,  1904,  1905,   297,   298,   299,   300,
     301,  1906,   302,   303,   304,  1907,   305,   306,   307,  1908,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1909,
     317,  1910,   318,   319,   320,   321,  1911,   322,  1912,   323,
     790,  1913,   791,   324,   325,   326,  1914,   327,   328,  1915,
     329,   330,  1916,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  1917,   340,   341,   342,   343,   344,   345,
    1918,   346,   793,   347,   348,   349,   350,   351,   352,   353,
    1919,   354,  1920,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,  1921,  1922,   362,   363,   797,   364,   798,
    1923,   365,   366,   367,  1924,  1925,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,  1926,   389,
     390,   800,   391,  1927,   392,   393,   394,   395,   396,   397,
    1928,   398,  1929,  1930,   399,   400,   401,  1931,  1932,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,  1933,   414,   415,   416,   417,   418,
     419,   420,   421,  1934,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1935,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,  1936,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1937,   460,   461,   462,   463,
     464,  1938,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,  1939,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,  1940,   486,   487,  1941,   488,
     805,   489,   490,   491,   492,   493,  1942,   494,   495,  1943,
    1944,   496,   497,   498,   499,   500,  1945,   501,   502,   503,
     504,   505,   506,   507,  1946,  1947,   508,   509,   510,   511,
     512,  1948,  1949,   513,   514,   515,   516,   517,   518,   519,
    1950,   520,   806,   521,   522,   523,   524,  1951,  1952,   525,
    1953,  1954,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
    1877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  1878,   233,   234,   235,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,   236,   237,  1886,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,  1887,   247,
     248,   249,   250,   251,  1888,  1889,   252,   253,   254,   255,
     256,  1890,   257,   258,   259,   260,   261,  1891,   786,  1892,
     262,   263,   264,   265,   787,   266,   267,   268,  1893,   269,
     270,   271,   272,   273,   274,  1894,   788,   275,   276,   277,
    1895,  1896,  1897,   789,  1898,  1899,  1900,   278,   279,   280,
     281,   282,   283,   284,   285,   286,  1901,   287,  1902,   288,
     289,   290,   291,   292,   293,  1903,   294,   295,   296,  1904,
    1905,   297,   298,   299,   300,   301,  1906,   302,   303,   304,
    1907,   305,   306,   307,  1908,   308,   309,   310,   311,   312,
     313,   314,   315,   316,  1909,   317,  1910,   318,   319,   320,
     321,  1911,   322,  1912,   323,   790,  1913,   791,   324,   325,
     326,  1914,   327,   328,  1915,   329,   330,  1916,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,  1917,   340,
     341,   342,   343,   344,   345,  1918,   346,   793,   347,   348,
     349,   350,   351,   352,   353,  1919,   354,  1920,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,  1921,  1922,
     362,   363,   797,   364,   798,  1923,   365,   366,   367,  1924,
    1925,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,  1926,   389,   390,   800,   391,  1927,   392,
     393,   394,   395,   396,   397,  1928,   398,  1929,  1930,   399,
     400,   401,  1931,  1932,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,  1933,
     414,   415,   416,   417,   418,   419,   420,   421,  1934,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,  1935,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,  1936,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1937,   460,   461,   462,   463,   464,  1938,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,  1939,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
    1940,   486,   487,  1941,   488,   805,   489,   490,   491,   492,
     493,  1942,   494,   495,  1943,  1944,   496,   497,   498,   499,
     500,  1945,   501,   502,   503,   504,   505,   506,   507,  1946,
    1947,   508,   509,   510,   511,   512,  1948,  1949,   513,   514,
     515,   516,   517,   518,   519,  1950,   520,   806,   521,   522,
     523,   524,  1951,  1952,   525,  1953,  1954,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,  1877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,  2849,   229,   230,   231,  1878,   233,
     234,   235,  1879,  1880,  1881,  1882,  1883,  1884,  1885,   236,
     237,  1886,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,  1887,   247,   248,   249,   250,   251,  1888,
    1889,   252,   253,   254,   255,   256,  1890,   257,   258,   259,
     260,   261,  1891,   786,  1892,   262,   263,   264,   265,   787,
     266,   267,   268,  1893,   269,   270,   271,   272,   273,   274,
    1894,   788,   275,   276,   277,  1895,  1896,  1897,   789,  1898,
    1899,  1900,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  1901,   287,  1902,   288,   289,   290,   291,   292,   293,
    1903,   294,   295,   296,  1904,  1905,   297,   298,   299,  2850,
     301,  1906,   302,   303,   304,  1907,   305,   306,   307,  1908,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1909,
     317,  1910,   318,   319,   320,   321,  1911,   322,  1912,   323,
     790,  1913,   791,   324,   325,   326,  1914,   327,   328,  1915,
     329,   330,  1916,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  1917,   340,   341,   342,   343,   344,   345,
    1918,   346,   793,   347,   348,   349,   350,   351,   352,   353,
    1919,   354,  1920,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,  1921,  1922,   362,   363,   797,   364,   798,
    1923,   365,   366,   367,  1924,  1925,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,  1926,   389,
     390,   800,   391,  1927,   392,   393,   394,   395,   396,   397,
    1928,   398,  1929,  1930,   399,   400,   401,  1931,  1932,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,  1933,   414,   415,   416,   417,   418,
     419,   420,   421,  1934,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1935,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,  1936,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1937,   460,   461,   462,   463,
     464,  1938,  2851,   466,   467,   468,   469,   804,   470,   471,
     472,   473,  1939,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,  1940,   486,   487,  1941,   488,
     805,   489,   490,   491,   492,   493,  1942,   494,   495,  1943,
    1944,   496,   497,   498,   499,   500,  1945,   501,   502,   503,
     504,   505,   506,   507,  1946,  1947,   508,   509,   510,   511,
     512,  1948,  1949,   513,   514,   515,   516,   517,   518,   519,
    1950,   520,   806,   521,   522,   523,   524,  1951,  1952,   525,
    1953,  1954,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     783,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,  1156,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,  1159,     0,  1160,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
    1161,  1162,  1163,  1164,  1165,  1166,  1167,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,  1171,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,  1174,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,  1179,   797,   364,   798,     0,   365,   366,   367,  1180,
    1181,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,  1186,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,  1189,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,  1190,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,  1193,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1195,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,  1198,   499,
    1199,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,  1202,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,  1204,  1205,  1206,  1207,  1208,  1209,
    1210,  1211,   541,   542,   543,   827,     0,   601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,  1690,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,  1691,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,  1692,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   862,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,   828,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,   829,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,   828,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,   829,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,  2244,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,   828,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,  3152,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,   829,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,   828,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,   829,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,   828,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   879,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,   829,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,   828,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     967,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,   829,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,   828,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1040,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,   829,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,   828,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1052,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,   829,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,   828,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1066,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,  1067,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,   829,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,   601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,  1851,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     3,     4,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   827,     0,   601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     827,     0,   601,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1680,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   783,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     783,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   784,
     240,   241,   242,   243,   244,   785,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,   786,     0,
     262,   263,   264,   265,   787,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,   788,   275,   276,   277,
       0,     0,     0,   789,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,   790,     0,   791,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   989,   792,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,   793,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   794,
     795,   356,   796,   357,   358,   359,   360,   361,     0,     0,
     362,   363,   797,   364,   798,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   799,   385,
     386,   387,   388,     0,   389,   390,   800,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,   801,   404,   802,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,   803,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,   804,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,   805,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,   806,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   783,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,   243,   244,
     785,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1038,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,   363,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   799,   385,   386,   387,   388,     0,   389,
     390,   800,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,   801,   404,   802,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,   804,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,  2057,   257,   258,   259,   260,   261,     0,     0,  2133,
     262,   263,   264,   265,     0,   266,   267,   268,  2058,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,  2134,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,  2060,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  2135,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,  2061,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
    2062,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,  2057,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,  2058,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
    2134,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,  2060,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,  3017,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,  2061,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,  2062,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     715,   230,   231,   674,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   675,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,   716,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   676,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     677,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   674,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     675,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,  2743,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   676,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   677,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,  2057,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,  2058,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,  2134,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,  2060,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,  2061,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
    2062,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   674,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     675,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   676,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   677,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  1717,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
    1718,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,  1719,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,  1720,   323,     0,     0,     0,  1721,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,  1722,  1723,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,  1724,   456,   457,   458,   459,
       0,  1725,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,  1726,   488,     0,  1727,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,  1728,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     675,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   676,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   677,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   872,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   873,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,   747,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     3,     4,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  2830,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,  2831,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  2843,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,  2844,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   592,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   593,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   707,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   708,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   709,   495,     0,     0,   710,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   741,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     742,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   743,   495,     0,
       0,   744,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,   747,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   836,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   837,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   981,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   707,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  1120,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  1249,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,  1260,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   727,   253,   254,   255,
    1261,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   730,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   731,   449,
     450,   451,   452,   453,   454,   732,   456,   457,   458,   459,
       0,   460,   461,   462,   463,  1253,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   734,   495,     0,     0,   735,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   736,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1370,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,   747,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  1425,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1426,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,  2633,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,  2634,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,  2635,   488,
       0,   489,  2636,   491,  2637,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,  2638,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,   601,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,  3835,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,  3849,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   693,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   705,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   727,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   728,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   729,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   730,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   731,   449,
     450,   451,   452,   453,   454,   732,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   733,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   734,   495,     0,     0,   735,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   736,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   759,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   860,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   867,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   882,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   943,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   959,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   994,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1050,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1054,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1056,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1058,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1062,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1070,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   727,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   730,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   731,   449,
     450,   451,   452,   453,   454,   732,   456,   457,   458,   459,
       0,   460,   461,   462,   463,  1253,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   734,   495,     0,     0,   735,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   736,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1549,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1579,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1581,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1651,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  1653,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  1655,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,  1751,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,  2012,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,     0,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   727,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   730,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   731,   449,   450,   451,   452,   453,   454,
     732,   456,   457,   458,   459,     0,   460,   461,   462,   463,
    1253,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,  2044,   490,   491,   492,   493,     0,   734,   495,     0,
       0,   735,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   736,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   727,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   730,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   731,   449,
     450,   451,   452,   453,   454,  2118,   456,   457,   458,   459,
       0,   460,   461,   462,   463,  2119,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   734,   495,     0,     0,  2120,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   736,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  2356,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  2360,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  2400,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  2435,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  2754,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   727,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,   335,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   730,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   731,   449,
     450,   451,   452,   453,   454,   732,   456,   457,   458,   459,
       0,   460,   461,   462,   463,  2119,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   734,   495,     0,     0,  2120,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   736,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  2820,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  2833,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,  2835,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  2950,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,     0,   240,   241,   242,   243,   244,
       0,   245,   246,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,   254,   255,   256,     0,   257,   258,   259,
     260,   261,     0,     0,     0,   262,   263,   264,   265,     0,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,     0,   275,   276,   277,     0,     0,     0,     0,     0,
       0,     0,   278,   279,   280,   281,   282,   283,   284,   285,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,  2972,   299,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,   312,   313,   314,   315,   316,     0,
     317,     0,   318,   319,   320,   321,     0,   322,     0,   323,
       0,     0,     0,   324,   325,   326,     0,   327,   328,     0,
     329,   330,     0,   331,   332,   333,   334,   335,     0,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   348,   349,   350,   351,   352,   353,
       0,   354,     0,   355,     0,     0,   356,     0,   357,   358,
     359,   360,   361,     0,     0,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,     0,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
     403,     0,   404,     0,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,   416,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     0,   486,   487,     0,   488,
       0,   489,   490,   491,   492,   493,     0,   494,   495,     0,
       0,   496,   497,   498,   499,   500,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,   518,   519,
       0,   520,     0,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,     0,
     240,   241,   242,   243,   244,     0,   245,   246,     0,   247,
     248,   249,   250,   251,     0,     0,   252,   253,   254,   255,
     256,     0,   257,   258,   259,   260,   261,     0,     0,     0,
     262,   263,   264,   265,     0,   266,   267,   268,     0,   269,
     270,   271,   272,   273,   274,     0,     0,   275,   276,   277,
       0,     0,     0,     0,     0,     0,     0,   278,   279,   280,
     281,   282,   283,   284,   285,   286,     0,   287,     0,   288,
     289,   290,   291,   292,   293,     0,   294,   295,   296,     0,
       0,   297,   298,   299,   300,   301,     0,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   317,     0,   318,   319,   320,
     321,     0,   322,     0,   323,     0,     0,     0,   324,   325,
     326,     0,   327,   328,     0,   329,   330,     0,   331,   332,
     333,   334,  4084,     0,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,   348,
     349,   350,   351,   352,   353,     0,   354,     0,   355,     0,
       0,   356,     0,   357,   358,   359,   360,   361,     0,     0,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,     0,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,     0,   398,     0,     0,   399,
     400,   401,     0,     0,   402,   403,     0,   404,     0,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,     0,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,     0,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,   464,     0,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,     0,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       0,   486,   487,     0,   488,     0,   489,   490,   491,   492,
     493,     0,   494,   495,     0,     0,   496,   497,   498,   499,
     500,     0,   501,   502,   503,   504,   505,   506,   507,     0,
       0,   508,   509,   510,   511,   512,     0,     0,   513,   514,
     515,   516,   517,   518,   519,     0,   520,     0,   521,   522,
     523,   524,     0,     0,   525,     0,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,     0,   997,
     785,   998,   999,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,  1000,  1001,   256,     0,   257,   258,   259,
     260,     0,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,  1002,  1003,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,     0,   313,   314,   315,     0,     0,
     317,     0,   318,   319,  1005,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,     0,     0,
       0,   330,     0,   331,   332,   333,   334,   335,   792,   336,
     337,   338,   339,  2015,   340,   341,   342,   343,   344,   345,
       0,   346,   793,  2016,   348,   349,   350,   351,  1007,  1008,
       0,  1009,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,     0,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1010,   799,  1011,   386,   387,     0,     0,   389,
     390,   800,   391,     0,     0,   393,  1012,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
    2018,   801,   404,   802,     0,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1013,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,     0,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,  2019,   468,   469,   804,   470,   471,
    1015,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1016,  1017,     0,
       0,   496,   497,     0,   499,     0,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,     0,  1018,
    2020,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   996,     0,
       0,     0,     0,     0,     0,     0,     0,   541,   542,   543,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   784,   240,   241,
     242,     0,   997,   785,   998,   999,     0,   247,   248,   249,
     250,   251,     0,     0,   252,   253,  1000,  1001,   256,     0,
     257,   258,   259,   260,     0,     0,   786,     0,   262,   263,
     264,   265,   787,   266,   267,   268,     0,   269,   270,   271,
     272,   273,   274,     0,   788,   275,   276,   277,     0,     0,
       0,   789,     0,     0,     0,   278,   279,   280,   281,   282,
     283,  1002,  1003,   286,     0,   287,     0,   288,   289,   290,
     291,   292,   293,     0,   294,   295,   296,     0,     0,   297,
     298,  1004,   300,   301,     0,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,   311,     0,   313,   314,
     315,     0,     0,   317,     0,   318,   319,  1005,   321,     0,
     322,     0,   323,   790,     0,   791,   324,   325,   326,     0,
     327,     0,     0,     0,   330,     0,   331,   332,   333,   334,
     335,   792,   336,   337,   338,   339,     0,   340,   341,   342,
     343,   344,   345,     0,   346,   793,     0,   348,   349,   350,
     351,  1007,  1008,     0,  1009,     0,   355,   794,   795,   356,
     796,   357,   358,   359,   360,   361,     0,     0,   362,     0,
     797,   364,   798,     0,   365,   366,   367,     0,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,  1010,   799,  1011,   386,   387,
       0,     0,   389,   390,   800,   391,  2114,     0,   393,  1012,
     395,   396,   397,     0,   398,     0,     0,   399,   400,   401,
       0,     0,   402,     0,   801,   404,   802,     0,   406,   407,
     408,   409,   410,   411,   412,   413,     0,     0,   414,   415,
       0,   417,     0,   419,   420,   421,     0,   422,   423,   424,
     425,   426,   427,   428,   429,  1013,   431,   432,   433,   434,
       0,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   446,   447,   803,   448,   449,   450,     0,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,   464,     0,   465,   466,  2019,   468,   469,
     804,   470,   471,  1015,   473,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,     0,   486,
     487,  3668,   488,   805,   489,   490,   491,   492,   493,     0,
    1016,  1017,     0,     0,   496,   497,     0,   499,     0,     0,
     501,   502,   503,   504,   505,   506,   507,     0,     0,   508,
     509,   510,   511,   512,     0,     0,   513,   514,   515,   516,
     517,     0,  1018,     0,   520,   806,   521,   522,   523,   524,
       0,     0,   525,     0,     0,   526,   527,   528,   529,   530,
     531,   223,     0,     0,     0,     0,     0,     0,     0,     0,
     541,   542,   543,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
       0,   240,   241,   242,   243,   244,     0,   245,   246,     0,
     247,   248,   249,   250,   251,     0,     0,   252,   253,   254,
     255,   256,     0,   257,   258,   259,   260,   261,     0,     0,
       0,   262,   263,   264,   265,     0,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,     0,   275,   276,
     277,     0,     0,     0,     0,     0,     0,     0,   278,   279,
     280,   281,   282,   283,   284,   285,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,   299,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
     312,   313,   314,   315,   316,     0,   317,     0,   318,   319,
     320,   321,     0,   322,     0,   323,     0,     0,     0,   324,
     325,   326,     0,   327,   328,     0,   329,   330,     0,   331,
     332,   333,   334,   335,     0,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     348,   349,   350,   351,   352,   353,     0,   354,     0,   355,
       0,     0,   356,     0,   357,   358,   359,   360,   361,     0,
       0,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,     0,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,     0,   398,     0,     0,
     399,   400,   401,     0,     0,   402,   403,     0,   404,     0,
     405,   406,   407,   408,   409,   410,     0,   412,   413,     0,
       0,   414,   415,   416,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,     0,   429,   430,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,   448,
     449,   450,   451,     0,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,     0,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,     0,   486,   487,     0,   488,     0,   489,   490,   491,
     492,   493,     0,   494,   495,     0,     0,   496,   497,   498,
     499,   500,     0,   501,   502,   503,   504,   505,   506,   507,
       0,     0,   508,   509,   510,   511,   512,     0,     0,   513,
     514,   515,   516,   517,   518,   519,     0,   520,     0,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   996,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   784,   240,   241,   242,     0,
     997,   785,   998,   999,     0,   247,   248,   249,   250,   251,
       0,     0,   252,   253,  1000,  1001,   256,     0,   257,   258,
     259,   260,     0,     0,   786,     0,   262,   263,   264,   265,
     787,   266,   267,   268,     0,   269,   270,   271,   272,   273,
     274,     0,   788,   275,   276,   277,     0,     0,     0,   789,
       0,     0,     0,   278,   279,   280,   281,   282,   283,  1002,
    1003,   286,     0,   287,     0,   288,   289,   290,   291,   292,
     293,     0,   294,   295,   296,     0,     0,   297,   298,  1004,
     300,   301,     0,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,   311,     0,   313,   314,   315,     0,
       0,   317,     0,   318,   319,  1005,   321,     0,   322,     0,
     323,   790,     0,   791,   324,   325,   326,     0,   327,     0,
       0,     0,   330,     0,   331,   332,   333,   334,   335,   792,
     336,   337,   338,   339,     0,   340,   341,   342,   343,   344,
     345,     0,   346,   793,     0,   348,   349,   350,   351,  1007,
    1008,     0,  1009,     0,   355,   794,   795,   356,   796,   357,
     358,   359,   360,   361,     0,     0,   362,     0,   797,   364,
     798,     0,   365,   366,   367,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,  1010,   799,  1011,   386,   387,  2184,     0,
     389,   390,   800,   391,     0,     0,   393,  1012,   395,   396,
     397,     0,   398,     0,     0,   399,   400,   401,     0,     0,
     402,     0,   801,   404,   802,     0,   406,   407,   408,   409,
     410,   411,   412,   413,     0,     0,   414,   415,     0,   417,
       0,   419,   420,   421,     0,   422,   423,   424,   425,   426,
     427,   428,   429,  1013,   431,   432,   433,   434,     0,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   446,   447,   803,   448,   449,   450,     0,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,   464,     0,   465,   466,  1014,   468,   469,   804,   470,
     471,  1015,   473,     0,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     0,     0,   486,   487,     0,
     488,   805,   489,   490,   491,   492,   493,     0,  1016,  1017,
       0,     0,   496,   497,     0,   499,     0,     0,   501,   502,
     503,   504,   505,   506,   507,     0,     0,   508,   509,   510,
     511,   512,     0,     0,   513,   514,   515,   516,   517,     0,
    1018,     0,   520,   806,   521,   522,   523,   524,     0,     0,
     525,     0,     0,   526,   527,   528,   529,   530,   531,   996,
       0,     0,     0,     0,     0,     0,     0,     0,   541,   542,
     543,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   784,   240,
     241,   242,     0,   997,   785,   998,   999,     0,   247,   248,
     249,   250,   251,     0,     0,   252,   253,  1000,  1001,   256,
       0,   257,   258,   259,   260,     0,     0,   786,     0,   262,
     263,   264,   265,   787,   266,   267,   268,     0,   269,   270,
     271,   272,   273,   274,     0,   788,   275,   276,   277,     0,
       0,     0,   789,     0,     0,     0,   278,   279,   280,   281,
     282,   283,  1002,  1003,   286,     0,   287,     0,   288,   289,
     290,   291,   292,   293,     0,   294,   295,   296,     0,     0,
     297,   298,  1004,   300,   301,     0,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,   311,     0,   313,
     314,   315,     0,     0,   317,     0,   318,   319,  1005,   321,
       0,   322,     0,   323,   790,     0,   791,   324,   325,   326,
       0,   327,     0,     0,     0,   330,     0,   331,   332,   333,
     334,   335,   792,   336,   337,   338,   339,     0,   340,   341,
     342,   343,   344,   345,     0,   346,   793,     0,   348,   349,
     350,   351,  1007,  1008,     0,  1009,     0,   355,   794,   795,
     356,   796,   357,   358,   359,   360,   361,     0,     0,   362,
       0,   797,   364,   798,     0,   365,   366,   367,     0,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,  1010,   799,  1011,   386,
     387,  3488,     0,   389,   390,   800,   391,     0,     0,   393,
    1012,   395,   396,   397,     0,   398,     0,     0,   399,   400,
     401,     0,     0,   402,     0,   801,   404,   802,     0,   406,
     407,   408,   409,   410,   411,   412,   413,     0,     0,   414,
     415,     0,   417,     0,   419,   420,   421,     0,   422,   423,
     424,   425,   426,   427,   428,   429,  1013,   431,   432,   433,
     434,     0,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,     0,   446,   447,   803,   448,   449,   450,
       0,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,   464,     0,   465,   466,  1014,   468,
     469,   804,   470,   471,  1015,   473,     0,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,     0,
     486,   487,     0,   488,   805,   489,   490,   491,   492,   493,
       0,  1016,  1017,     0,     0,   496,   497,     0,   499,     0,
       0,   501,   502,   503,   504,   505,   506,   507,     0,     0,
     508,   509,   510,   511,   512,     0,     0,   513,   514,   515,
     516,   517,     0,  1018,     0,   520,   806,   521,   522,   523,
     524,     0,     0,   525,     0,     0,   526,   527,   528,   529,
     530,   531,   996,     0,     0,     0,     0,     0,     0,     0,
       0,   541,   542,   543,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   784,   240,   241,   242,     0,   997,   785,   998,   999,
       0,   247,   248,   249,   250,   251,     0,     0,   252,   253,
    1000,  1001,   256,     0,   257,   258,   259,   260,     0,     0,
     786,     0,   262,   263,   264,   265,   787,   266,   267,   268,
       0,   269,   270,   271,   272,   273,   274,     0,   788,   275,
     276,   277,     0,     0,     0,   789,     0,     0,     0,   278,
     279,   280,   281,   282,   283,  1002,  1003,   286,     0,   287,
       0,   288,   289,   290,   291,   292,   293,     0,   294,   295,
     296,     0,     0,   297,   298,  1004,   300,   301,     0,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
     311,     0,   313,   314,   315,     0,     0,   317,     0,   318,
     319,  1005,   321,     0,   322,     0,   323,   790,     0,   791,
     324,   325,   326,     0,   327,     0,     0,     0,   330,     0,
     331,   332,   333,   334,  1006,   792,   336,   337,   338,   339,
       0,   340,   341,   342,   343,   344,   345,     0,   346,   793,
       0,   348,   349,   350,   351,  1007,  1008,     0,  1009,     0,
     355,   794,   795,   356,   796,   357,   358,   359,   360,   361,
       0,     0,   362,     0,   797,   364,   798,     0,   365,   366,
     367,     0,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,  1010,
     799,  1011,   386,   387,     0,     0,   389,   390,   800,   391,
       0,     0,   393,  1012,   395,   396,   397,     0,   398,     0,
       0,   399,   400,   401,     0,     0,   402,     0,   801,   404,
     802,     0,   406,   407,   408,   409,   410,   411,   412,   413,
       0,     0,   414,   415,     0,   417,     0,   419,   420,   421,
       0,   422,   423,   424,   425,   426,   427,   428,   429,  1013,
     431,   432,   433,   434,     0,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   446,   447,   803,
     448,   449,   450,     0,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,   464,     0,   465,
     466,  1014,   468,   469,   804,   470,   471,  1015,   473,     0,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     0,     0,   486,   487,     0,   488,   805,   489,   490,
     491,   492,   493,     0,  1016,  1017,     0,     0,   496,   497,
       0,   499,     0,     0,   501,   502,   503,   504,   505,   506,
     507,     0,     0,   508,   509,   510,   511,   512,     0,     0,
     513,   514,   515,   516,   517,     0,  1018,     0,   520,   806,
     521,   522,   523,   524,     0,     0,   525,     0,     0,   526,
     527,   528,   529,   530,   531,   996,     0,     0,     0,     0,
       0,     0,     0,     0,   541,   542,   543,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   784,   240,   241,   242,     0,   997,
     785,   998,   999,     0,   247,   248,   249,   250,   251,     0,
       0,   252,   253,  1000,  1001,   256,     0,   257,   258,   259,
     260,     0,     0,   786,     0,   262,   263,   264,   265,   787,
     266,   267,   268,     0,   269,   270,   271,   272,   273,   274,
       0,   788,   275,   276,   277,     0,     0,     0,   789,     0,
       0,     0,   278,   279,   280,   281,   282,   283,  1002,  1003,
     286,     0,   287,     0,   288,   289,   290,   291,   292,   293,
       0,   294,   295,   296,     0,     0,   297,   298,  1004,   300,
     301,     0,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,   311,     0,   313,   314,   315,     0,     0,
     317,     0,   318,   319,  1005,   321,     0,   322,     0,   323,
     790,     0,   791,   324,   325,   326,     0,   327,     0,     0,
       0,   330,     0,   331,   332,   333,   334,  1064,   792,   336,
     337,   338,   339,     0,   340,   341,   342,   343,   344,   345,
       0,   346,   793,     0,   348,   349,   350,   351,  1007,  1008,
       0,  1009,     0,   355,   794,   795,   356,   796,   357,   358,
     359,   360,   361,     0,     0,   362,     0,   797,   364,   798,
       0,   365,   366,   367,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  1010,   799,  1011,   386,   387,     0,     0,   389,
     390,   800,   391,     0,     0,   393,  1012,   395,   396,   397,
       0,   398,     0,     0,   399,   400,   401,     0,     0,   402,
       0,   801,   404,   802,     0,   406,   407,   408,   409,   410,
     411,   412,   413,     0,     0,   414,   415,     0,   417,     0,
     419,   420,   421,     0,   422,   423,   424,   425,   426,   427,
     428,   429,  1013,   431,   432,   433,   434,     0,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     446,   447,   803,   448,   449,   450,     0,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
     464,     0,   465,   466,  1014,   468,   469,   804,   470,   471,
    1015,   473,     0,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   486,   487,     0,   488,
     805,   489,   490,   491,   492,   493,     0,  1016,  1017,     0,
       0,   496,   497,     0,   499,     0,     0,   501,   502,   503,
     504,   505,   506,   507,     0,     0,   508,   509,   510,   511,
     512,     0,     0,   513,   514,   515,   516,   517,     0,  1018,
       0,   520,   806,   521,   522,   523,   524,     0,     0,   525,
       0,     0,   526,   527,   528,   529,   530,   531,   996,     0,
       0,     0,     0,     0,     0,     0,     0,   541,   542,   543,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   784,   240,   241,
     242,     0,   997,   785,   998,   999,     0,   247,   248,   249,
     250,   251,     0,     0,   252,   253,  1000,  1001,   256,     0,
     257,   258,   259,   260,     0,     0,   786,     0,   262,   263,
     264,   265,   787,   266,   267,   268,     0,   269,   270,   271,
     272,   273,   274,     0,   788,   275,   276,   277,     0,     0,
       0,   789,     0,     0,     0,   278,   279,   280,   281,   282,
     283,  1002,  1003,   286,     0,   287,     0,   288,   289,   290,
     291,   292,   293,     0,   294,   295,   296,     0,     0,   297,
     298,  1004,   300,   301,     0,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,   311,     0,   313,   314,
     315,     0,     0,   317,     0,   318,   319,  1005,   321,     0,
     322,     0,   323,   790,     0,   791,   324,   325,   326,     0,
     327,     0,     0,     0,   330,     0,   331,   332,   333,   334,
     335,   792,   336,   337,   338,   339,     0,   340,   341,   342,
     343,   344,   345,     0,   346,   793,     0,   348,   349,   350,
     351,  1007,  1008,     0,  1009,     0,   355,   794,   795,   356,
     796,   357,   358,   359,   360,   361,     0,     0,   362,     0,
     797,   364,   798,     0,   365,   366,   367,     0,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,  1010,   799,  1011,   386,   387,
       0,     0,   389,   390,   800,   391,     0,     0,   393,  1012,
     395,   396,   397,     0,   398,     0,     0,   399,   400,   401,
       0,     0,   402,     0,   801,   404,   802,     0,   406,   407,
     408,   409,   410,   411,   412,   413,     0,     0,   414,   415,
       0,   417,     0,   419,   420,   421,     0,   422,   423,   424,
     425,   426,   427,   428,   429,  1013,   431,   432,   433,   434,
       0,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   446,   447,   803,   448,   449,   450,     0,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,   464,     0,   465,   466,  1014,   468,   469,
     804,   470,   471,  1015,   473,     0,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,     0,   486,
     487,     0,   488,   805,   489,   490,   491,   492,   493,     0,
    1016,  1017,     0,     0,   496,   497,     0,   499,     0,     0,
     501,   502,   503,   504,   505,   506,   507,     0,     0,   508,
     509,   510,   511,   512,     0,     0,   513,   514,   515,   516,
     517,     0,  1018,     0,   520,   806,   521,   522,   523,   524,
       0,     0,   525,     0,     0,   526,   527,   528,   529,   530,
     531,   996,     0,     0,     0,     0,     0,     0,     0,     0,
     541,   542,   543,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     784,   240,   241,   242,     0,   997,   785,   998,   999,     0,
     247,   248,   249,   250,   251,     0,     0,   252,   253,  1000,
    1001,   256,     0,   257,   258,   259,   260,     0,     0,   786,
       0,   262,   263,   264,   265,   787,   266,   267,   268,     0,
     269,   270,   271,   272,   273,   274,     0,   788,   275,   276,
     277,     0,     0,     0,   789,     0,     0,     0,   278,   279,
     280,   281,   282,   283,  1002,  1003,   286,     0,   287,     0,
     288,   289,   290,   291,   292,   293,     0,   294,   295,   296,
       0,     0,   297,   298,  1004,   300,   301,     0,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,   311,
       0,   313,   314,   315,     0,     0,   317,     0,   318,   319,
    1005,   321,     0,   322,     0,   323,   790,     0,   791,   324,
     325,   326,     0,   327,     0,     0,     0,   330,     0,   331,
     332,   333,   334,   335,   792,   336,   337,   338,   339,     0,
     340,   341,   342,   343,   344,   345,     0,   346,   793,     0,
     348,   349,   350,   351,  1007,  1008,     0,  1009,     0,   355,
     794,   795,   356,   796,   357,   358,   359,   360,   361,     0,
       0,   362,     0,   797,   364,   798,     0,   365,   366,   367,
       0,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,  1010,   799,
    1011,   386,   387,     0,     0,   389,   390,   800,   391,     0,
       0,   393,  1012,   395,   396,   397,     0,   398,     0,     0,
     399,   400,   401,     0,     0,   402,     0,   801,   404,   802,
       0,   406,   407,   408,   409,   410,   411,   412,   413,     0,
       0,   414,   415,     0,   417,     0,   419,   420,   421,     0,
     422,   423,   424,   425,   426,   427,   428,   429,  1013,   431,
     432,   433,   434,     0,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,     0,   446,   447,   803,   448,
     449,   450,     0,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,   464,     0,   465,   466,
    2019,   468,   469,   804,   470,   471,  1015,   473,     0,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,     0,   486,   487,     0,   488,   805,   489,   490,   491,
     492,   493,     0,  1016,  1017,     0,     0,   496,   497,     0,
     499,     0,     0,   501,   502,   503,   504,   505,   506,   507,
       0,     0,   508,   509,   510,   511,   512,     0,     0,   513,
     514,   515,   516,   517,     0,  1018,     0,   520,   806,   521,
     522,   523,   524,     0,     0,   525,     0,     0,   526,   527,
     528,   529,   530,   531,   996,     0,     0,     0,     0,     0,
       0,     0,     0,   541,   542,   543,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   784,   240,   241,   242,     0,   997,   785,
     998,   999,     0,   247,   248,   249,   250,   251,     0,     0,
     252,   253,  1000,  1001,   256,     0,   257,   258,   259,   260,
       0,     0,   786,     0,   262,   263,   264,   265,   787,   266,
     267,   268,     0,   269,   270,   271,   272,   273,   274,     0,
     788,   275,   276,   277,     0,     0,     0,   789,     0,     0,
       0,   278,   279,   280,   281,   282,   283,  1002,  1003,   286,
       0,   287,     0,   288,   289,   290,   291,   292,   293,     0,
     294,   295,   296,     0,     0,   297,   298,  1004,   300,   301,
       0,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,   311,     0,   313,   314,   315,     0,     0,   317,
       0,   318,   319,  1005,   321,     0,   322,     0,   323,   790,
       0,   791,   324,   325,   326,     0,   327,     0,     0,     0,
     330,     0,   331,   332,   333,   334,   335,   792,   336,   337,
     338,   339,     0,   340,   341,   342,   343,   344,   345,     0,
     346,   793,     0,   348,   349,   350,   351,  1007,  1008,     0,
    1009,     0,   355,   794,   795,   356,   796,   357,   358,   359,
     360,   361,     0,     0,   362,     0,   797,   364,   798,     0,
     365,   366,   367,     0,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,  1010,   799,  1011,   386,   387,     0,     0,   389,   390,
     800,   391,     0,     0,   393,  1012,   395,   396,   397,     0,
     398,     0,     0,   399,   400,   401,     0,     0,   402,     0,
     801,   404,   802,     0,   406,   407,   408,   409,   410,   411,
     412,   413,     0,     0,   414,   415,     0,   417,     0,   419,
     420,   421,     0,   422,   423,   424,   425,   426,   427,   428,
     429,  1013,   431,   432,   433,   434,     0,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   446,
     447,   803,   448,   449,   450,     0,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
       0,   465,   466,     0,   468,   469,   804,   470,   471,  1015,
     473,     0,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,     0,   486,   487,     0,   488,   805,
     489,   490,   491,   492,   493,     0,  1016,  1017,     0,     0,
     496,   497,     0,   499,     0,     0,   501,   502,   503,   504,
     505,   506,   507,     0,     0,   508,   509,   510,   511,   512,
       0,     0,   513,   514,   515,   516,   517,     0,  1018,     0,
     520,   806,   521,   522,   523,   524,     0,     0,   525,     0,
       0,   526,   527,   528,   529,   530,   531,   996,     0,     0,
       0,     0,     0,     0,     0,     0,   541,   542,   543,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   784,   240,   241,   242,
       0,     0,   785,     0,     0,     0,   247,   248,   249,   250,
     251,     0,     0,   252,   253,     0,     0,   256,     0,   257,
     258,   259,   260,     0,     0,   786,     0,   262,   263,   264,
     265,   787,   266,   267,   268,     0,   269,   270,   271,   272,
     273,   274,     0,   788,   275,   276,   277,     0,     0,     0,
     789,     0,     0,     0,   278,   279,   280,   281,   282,   283,
       0,     0,   286,     0,   287,     0,   288,   289,   290,   291,
     292,   293,     0,   294,   295,   296,     0,     0,   297,   298,
     299,   300,   301,     0,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,   311,     0,   313,   314,   315,
       0,     0,   317,     0,   318,   319,     0,   321,     0,   322,
       0,   323,   790,     0,   791,   324,   325,   326,     0,   327,
       0,     0,     0,   330,     0,   331,   332,   333,   334,   335,
     792,   336,   337,   338,   339,     0,   340,   341,   342,   343,
     344,   345,     0,   346,   793,     0,   348,   349,   350,   351,
       0,     0,     0,     0,     0,   355,   794,   795,   356,   796,
     357,   358,   359,   360,   361,     0,     0,   362,     0,   797,
     364,   798,     0,   365,   366,   367,     0,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,   799,     0,   386,   387,     0,
       0,   389,   390,   800,   391,     0,     0,   393,     0,   395,
     396,   397,     0,   398,     0,     0,   399,   400,   401,     0,
       0,   402,     0,   801,   404,   802,     0,   406,   407,   408,
     409,   410,   411,   412,   413,     0,     0,   414,   415,     0,
     417,     0,   419,   420,   421,     0,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   431,   432,   433,   434,     0,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   446,   447,   803,   448,   449,   450,     0,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,   464,     0,   465,   466,     0,   468,   469,   804,
     470,   471,     0,   473,     0,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,     0,   486,   487,
       0,   488,   805,   489,   490,   491,   492,   493,     0,     0,
       0,     0,     0,   496,   497,     0,   499,     0,     0,   501,
     502,   503,   504,   505,   506,   507,     0,     0,   508,   509,
     510,   511,   512,     0,     0,   513,   514,   515,   516,   517,
       0,     0,     0,   520,   806,   521,   522,   523,   524,     0,
       0,   525,     0,     0,   526,   527,   528,   529,   530,   531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
     542,   543
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4498)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2420)))

static const yytype_int16 yycheck[] =
{
      16,     0,     0,     0,     0,     0,     0,    36,    51,    25,
    1039,   205,   572,   602,    21,  1103,  1081,   728,   777,   782,
      27,   839,    20,     7,    20,  1048,   675,   676,   677,    21,
      14,   726,   681,   881,  1043,    27,  1721,  1356,   808,   183,
    1297,   201,  1399,    45,  1014,  1278,   955,   869,   208,  1280,
     890,  2654,  1033,    51,   643,  2306,  1842,   966,  1393,   219,
      12,   621,  1002,  1003,   935,   751,  1505,  2824,  1404,  1139,
      44,   602,  1012,  1017,   735,   208,  2491,  3015,   563,  3042,
    1399,  2315,  2797,    22,  3084,  2849,   219,  2851,  1576,    17,
    1458,  1757,   940,  2235,  3060,  3341,   944,    36,  1329,  1415,
    1333,   949,  3384,    20,  1302,  2023,  2024,  1970,  3071,  3384,
     958,  2467,     0,   868,  2646,  2703,   868,  3004,  3437,   990,
     968,  3277,   874,   642,  2183,  3657,  2273,   612,  2644,  2645,
     170,   883,  3380,  1469,  2281,  1845,  2283,   191,  3646,  3669,
    3660,  3593,   731,  2997,   185,  3647,   200,  3305,  1740,  1588,
    3004,   634,  1801,   185,    35,  2577,     0,     0,  1474,  1475,
       0,    42,     0,  3311,     0,  1385,     0,    50,     0,     0,
    1333,   624,     0,     0,     0,     0,  4104,    41,  2711,  3910,
     825,   881,   635,  4224,  3058,  4226,  3357,   185,  4281,  3310,
    1678,   774,   774,     9,  3240,  1073,  1000,  1001,     9,  4398,
     731,    11,    11,  4262,    84,     0,     5,  1011,     0,    48,
       0,    41,    62,     0,    13,    14,    70,    35,    55,    22,
    4323,  4324,    55,    20,    39,    26,  4319,     5,  1168,  1169,
      40,    29,   103,    55,   109,  2642,    55,  2023,  4587,   154,
     214,    41,     5,     5,   165,     5,     5,  1187,     0,    26,
    2309,   160,     0,  1197,    13,    14,    33,     9,    26,   141,
      70,     9,   200,  1081,     5,    33,    39,    46,     5,    26,
     181,    76,  2547,  2548,    26,     5,    33,  2552,    26,     5,
      55,     5,     5,     5,   933,   192,   193,  2709,  2695,   196,
       5,   198,   159,     5,     5,   169,   162,     5,    13,    14,
      62,   159,   159,   111,   159,   259,  1539,     4,  2642,    55,
     159,   218,     9,   184,  2589,  2590,     5,     5,     9,   160,
      81,   109,    72,  4347,   127,    78,   256,   260,    27,     5,
     293,    81,  4503,  4504,  2799,   247,   129,   159,  1216,   261,
       5,    68,   109,   140,    38,     5,   324,    81,    48,   109,
    2409,   911,  2411,  1157,  1158,   111,     3,   102,   134,   341,
    4857,  2695,   303,    11,   159,   340,   119,   159,   321,   159,
     244,     5,   159,   310,    62,   109,   111,   377,   572,  1183,
     266,   328,   151,    30,    31,   400,   181,   159,   379,   181,
      11,   181,    40,   109,   181,   419,  4745,   176,   410,   159,
     100,  3735,   181,  3737,  2089,   298,    21,   159,    11,   419,
     570,   159,    27,    88,   260,   575,   440,    72,    72,    40,
      26,   113,    70,  4464,  4517,  1265,   586,   621,   156,   181,
     440,   422,   325,   181,   458,   315,   277,   570,   217,   454,
     377,   210,   575,   443,   160,  1263,   399,  1217,   204,    70,
    1268,  1269,    72,   586,  1348,    72,   456,   328,   246,    72,
    4388,  1718,  4959,  3915,    81,  1722,    29,  1724,     4,   335,
    1727,   412,   454,     9,     3,  1245,   454,    11,   116,   316,
    1069,   456,   283,   316,   251,   179,   398,  1516,   102,   164,
     246,   454,  1081,   193,   365,   366,   195,   316,  1521,   244,
     454,   367,   424,   114,   558,   346,   328,   454,   114,   201,
     251,   158,   246,   160,   251,   313,   251,   102,   102,   377,
     458,   454,   298,   276,   454,  1756,   324,   324,   326,   251,
     404,   247,   259,   415,   335,  4559,   552,   458,  1069,   454,
     328,   316,   102,   299,   244,   454,   343,   458,   363,  3014,
    1312,    80,  4901,   607,  1143,  1373,   555,   555,   555,   555,
     555,   555,   251,   617,  1083,  1383,   345,  1798,   443,   370,
     316,   372,   458,   350,   208,   405,  1809,   377,   458,   357,
     358,  3468,   350,   454,   382,   390,   602,   603,   194,   411,
     363,   458,  4695,   350,   402,   398,  1049,  4105,   452,   454,
     643,   458,   456,   132,   454,   377,  1454,   647,  1456,   458,
    4669,  4063,  1143,  1844,  3468,   454,   377,   377,   371,  1371,
    4791,   458,   415,   551,  1712,   458,  1535,   377,  1446,   329,
    3387,  1449,  1450,   777,   445,   446,   454,   453,  1509,   458,
     450,   450,  1464,   454,   642,   643,   642,  3803,  1542,   656,
    4849,   658,  3615,   660,   561,   454,  1109,   186,   565,   666,
     667,   668,   457,  1503,   656,   457,   658,   457,   660,  4121,
     457,  1260,  1125,  1682,   666,  1427,   583,   693,   454,  1268,
    1269,  3839,  3830,   443,   400,  3843,   670,  1140,  2747,   641,
    3656,   454,   454,   445,   446,   454,   456,   445,   446,  1517,
    3638,  3747,   458,   719,  1644,   457,  4799,  1019,  3829,   457,
    1719,   727,   458,   687,   730,   731,   732,   911,  4811,  1728,
    3891,   409,   377,   377,   454,   766,   643,   333,   454,  1260,
     454,   454,  1610,   409,   766,  4776,  1436,  1320,  1320,   454,
     452,  1441,   454,   454,   456,  1057,   454,  1392,   445,   446,
     313,   280,   366,  1065,   445,   446,   421,   377,   102,  1071,
     377,   421,   400,   410,   377,  4496,   454,  2103,   766,   768,
     768,   768,   768,   768,   768,   440,  2133,   751,   454,  4265,
     440,   366,   366,    22,     3,     4,     5,   398,  4881,   454,
       9,   114,   398,  3325,   454,   102,  2714,   169,  2716,   447,
     448,   449,   450,  3037,  2037,  4257,   366,   781,    55,   690,
     691,   692,  4264,  1617,  1618,  4149,   266,   113,  4746,  4153,
    4154,  3578,  4156,  2970,   445,   446,   447,   448,   449,   450,
    2977,  2978,   839,    26,  2981,  3709,  3369,   140,   755,   140,
     159,  2988,   896,  2179,   447,   448,   449,   450,    72,   691,
     824,  3566,   117,   907,     5,  4387,   256,    81,  2644,  2645,
    2646,     3,   391,     5,   366,   729,    78,  4353,   256,   733,
     399,   194,  1432,   402,  2037,   154,   759,  1755,    78,  1757,
     768,    74,   167,   419,   109,  1763,   256,    32,   127,    82,
     109,  1769,  1770,  1771,    22,   340,  3303,   244,  3305,    64,
      28,  1779,  1780,  2123,   440,   201,  1784,   119,   690,   445,
     446,   445,   446,   447,   448,   449,   450,   110,  4846,   119,
    2979,  2980,   976,   114,   768,   768,  4208,   815,   768,   233,
     768,  2164,   768,  3355,   768,  1584,   768,   768,   845,   846,
     768,   768,   768,   768,  3219,  3220,  3221,  3222,   104,   260,
    3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,  3234,
     109,   114,   104,  4245,     3,   102,     3,  3682,   274,  3303,
      64,  3305,   109,   138,   127,   266,  4258,  3384,   137,   419,
     199,  2349,    78,  4258,   244,  2050,    23,    81,   230,   870,
     871,   156,   185,   881,  2704,   153,   141,   244,   114,   127,
      22,   163,   221,   194,   310,   455,  3281,  3282,   458,  2658,
     333,  4497,  4168,   458,  1725,  1726,  1778,   173,   458,   926,
    4506,   246,   366,   119,  1786,  1795,   111,   331,  2363,   871,
     337,   173,   404,   312,   103,   274,   321,    22,   141,   198,
     343,    80,   343,    80,   138,   310,   953,   954,  2029,  2019,
    3384,   273,   980,  1069,   454,  4213,    34,   404,   377,   221,
    4218,  4209,   156,  4221,   276,  1081,   454,   974,  2301,   316,
    4602,   310,  4574,    64,  1081,   398,   276,   233,   194,  2997,
     236,  2673,    78,  4613,   454,  1083,  3004,  1083,   870,  4597,
    4610,   233,   131,   340,   236,   132,  4598,  1657,   161,  1115,
    1689,   340,  1086,  3990,  1088,   127,  1090,   266,  1092,   246,
    1094,  1095,  1096,   379,   161,   184,  4398,  1101,   109,   204,
    1605,  4121,   104,   119,   443,   161,   291,  1143,   286,   400,
    4093,   109,  4098,  1616,   273,   288,  3990,   456,  1045,  1046,
      88,   452,   127,   250,   181,   456,   274,  3904,   162,   186,
     658,   659,   660,  1151,    56,   663,   664,   665,   324,   371,
     108,   246,    64,  3081,   403,   673,   359,   458,   154,  1688,
     274,   371,  1170,  1216,   273,   331,   436,   264,   164,   151,
     276,  3945,   310,   454,   333,   224,   122,   274,   124,   331,
     419,   173,  1675,   141,   385,   181,  1649,   291,  2455,   262,
     207,   340,  1218,  1201,    83,   340,   127,   398,   370,  1662,
     372,  1227,   340,    36,   299,   262,  1776,   366,  1216,   356,
      30,    31,   359,   310,  1677,  1241,   445,   446,   393,   458,
     333,   169,   398,   392,   396,   274,   340,   613,  1432,  4747,
     347,   340,   340,   280,  1260,   124,  4494,  1263,  1264,   274,
    1290,   233,  1268,  1269,   236,   246,  1263,   406,   634,   328,
     251,  1268,  1269,   366,  1305,  1306,   111,  1308,    26,   149,
     419,   243,  4428,  1305,  1306,   371,  1308,   454,    88,   435,
     276,  4600,   398,    26,   321,   310,    22,  1599,   266,   274,
     326,   440,    28,   435,  2005,   118,   365,   366,   108,   393,
     291,  3889,  4460,   406,  4756,   454,   244,  1305,  1306,   290,
    1308,  3586,   359,  4845,   305,   340,   419,   454,  4850,   221,
     256,   335,  2231,   458,   411,   310,   264,   364,  3860,  1489,
     369,   141,   371,   319,  3866,  2568,  1648,   440,   218,  3855,
    1652,  2574,   149,   264,   380,   206,  1658,  1659,  1322,   331,
     386,   454,     0,   367,   391,   340,  4638,   416,   306,   204,
     458,   290,   399,  4519,   122,   402,  1373,  4523,  4524,  1681,
     137,  3727,  4904,  2402,   388,   371,  1383,   139,   258,   122,
    2132,  4663,   149,   244,  2202,   333,   181,   154,  4663,  2412,
     273,   127,  2210,   314,  2212,   112,   173,  2406,   379,   458,
    1560,   246,   393,  3550,  1564,  4292,   266,   377,   169,  3556,
    3557,   218,  3559,   312,  4380,  1422,  1576,    24,   366,   340,
     182,  2330,  2331,  2332,  2333,   457,  4672,  4673,   122,   454,
     124,   198,  3839,  2342,  4966,  4373,  3843,    44,  4292,  1446,
    1368,   422,  1449,  1450,  2199,   120,  1462,  2199,   274,   163,
     379,   218,   112,   435,   299,   130,   233,   340,   406,   137,
     177,  2050,   377,  1657,  3149,   443,   404,   400,  2666,  2221,
     330,   419,   454,   206,   452,   101,   454,   455,   456,  2814,
     458,   101,   343,   244,   310,  2742,   281,   111,   458,   443,
    1650,   258,   440,   422,  1468,  3637,   306,  2249,  2376,   266,
    3363,  2372,   456,  1410,   349,  3839,   454,   221,   112,  3843,
    1517,   244,   159,   274,   340,   310,   230,   177,  1678,   314,
     419,   454,   326,   333,   155,     8,  3192,   903,    11,   155,
     154,  2091,   274,    81,   181,   160,   227,   398,   274,  3325,
     218,   440,  2910,   458,  1598,   340,  1562,   923,  1436,   310,
    3468,   111,   246,  1441,   331,   186,   366,    40,  2043,   458,
     186,   937,   256,    46,   188,   190,   299,  4849,   310,  1476,
    1477,  1478,  1479,   177,   310,   324,  1084,   326,   382,  1087,
     205,  1089,  1776,  1091,  2920,  1093,   458,    70,   195,  1097,
     215,   274,  4349,  1647,   326,    22,   406,  2194,   340,   274,
     410,    28,    61,    62,   340,   231,   333,  1614,   234,   419,
     343,   231,  1519,  1520,   234,   163,    11,  1624,   202,  1626,
     244,  1528,   246,  4586,   419,   392,  1633,   310,   188,  4875,
     440,  1538,    53,   382,  1641,   310,   184,   328,  3697,   366,
    3699,  2459,  4608,   404,   454,   440,  4584,   293,   281,  3137,
     382,  2248,   135,  1965,   382,  2888,   370,   340,   372,  1566,
    1567,  1568,  1569,   274,  2752,   398,   122,  1721,   124,  4289,
     370,  2549,   372,   221,   274,    70,   260,  2130,   369,   406,
     101,   314,   396,  2561,   244,   452,   246,  4625,   455,   456,
    1688,   147,  1688,   176,   324,   320,  4411,   255,   181,   310,
     127,   299,   421,   314,    24,   396,  2191,   340,   303,  2358,
     310,  4331,   330,   311,  1698,  2593,  1700,   265,  1702,  1748,
    1704,   440,  1706,   163,    44,   355,  1710,   454,   419,   340,
     421,  2712,   274,  4148,   217,   454,   421,  2718,   336,   334,
     340,  1740,  1740,  1740,  1740,  1740,  1740,  1123,  3064,  4513,
    4507,  3067,  1768,  2631,  1661,   440,  4756,  1664,  1765,  1766,
    2783,  1735,   183,   454,   421,  1772,  1773,  1674,   310,   454,
    3003,   366,  1689,    11,   412,    72,  1683,   314,  2367,   262,
    3212,   221,  2722,   440,    81,  2547,  2548,    89,    64,   208,
    2552,   246,  4755,  1800,    70,   251,   251,   154,   454,   310,
     256,  4208,    40,   340,  4407,    81,  4213,   344,  1747,  3241,
     231,  4218,   232,   234,  4221,   227,  1814,   412,   175,   122,
    4071,   124,   370,   244,   372,   310,  1754,  2589,  2590,   340,
     314,   161,    70,   109,   382,   111,  2367,  4252,  4245,  4254,
    2429,  2659,   297,  1859,   147,   393,  4097,   281,   396,  4083,
      42,  4258,   273,   452,   154,   340,   340,   456,   160,   382,
     137,   191,   345,   303,   419,   149,  3925,  3926,    13,    14,
     154,    63,   149,  2033,  4208,   175,   310,   154,  2038,  4213,
     314,   149,  2042,   382,  4218,   440,   154,  4221,   190,  4164,
    3147,  1558,  2651,  4040,   315,  4042,  4043,  2091,  2429,  4046,
    2771,   324,   325,   205,     4,  1812,   340,  4622,  2068,     9,
    1577,  4245,   188,   215,   455,   449,   328,   458,  4675,   137,
     454,   198,   456,   303,  4258,   452,   312,   454,   384,   456,
     370,   149,   372,   354,   218,   449,   154,   230,   394,   241,
     454,   218,   456,   246,  2560,    89,  2562,  2563,   251,  3388,
     218,  2111,   227,   256,   334,   438,   396,   369,   260,  3047,
     330,  4899,   445,   446,   447,   448,   449,   450,  3056,  2129,
     246,   260,   412,   230,   258,   251,   265,  1984,  2800,   455,
     198,   258,   458,   453,   396,   419,   366,  4950,   458,   266,
     258,  4398,  1984,   453,   260,  2656,  2129,    85,   458,   265,
     218,  2161,  4547,  2825,  4549,   184,   440,   419,  4553,   421,
    4555,  2010,  2010,   232,   137,   291,   160,   455,   320,   455,
     458,  3254,   458,  2052,   455,  2054,   149,   458,  2082,   305,
    3261,   154,   412,  2193,  2050,  2089,  4793,  2197,   455,   175,
     258,   458,   454,  2050,   455,  2605,   190,   458,   266,  2801,
    1967,   382,   227,  4460,  1430,  2215,   227,    77,  2050,  4662,
    2193,   205,   455,   412,  4398,   458,  2226,  2379,   227,  3855,
    2659,   215,  3990,   455,  3860,   198,   458,     5,  3435,  2239,
    3866,   384,    10,   455,    52,  3421,   458,  2247,   330,  2401,
      18,   394,   208,   455,   369,   218,   458,   241,   400,   370,
       8,   372,  2118,    11,  2416,  3175,   454,  2419,  2420,    37,
     324,   325,  2424,  2425,  2247,   392,   454,   393,   456,  2431,
     454,   396,   227,  2875,  3440,  3441,  4460,   455,  2102,   452,
     458,   454,    40,  3364,  1510,   258,  3472,     9,    46,   455,
     333,   260,   458,   266,   419,   455,   421,   328,   458,  1525,
     227,   458,  4427,   328,  3183,   454,    52,   328,  3102,  3103,
    3008,   455,    70,   455,   458,   410,   458,   455,  1544,   328,
     458,    42,   412,   366,   392,  4932,   320,  2084,  2085,   454,
    2769,  2493,     8,   204,   437,    11,  2093,  4334,  2095,    15,
      16,    17,  2099,   227,   369,  2202,   455,   263,   369,   458,
     248,   455,   260,  2210,   458,  2212,   455,   263,   455,   458,
     369,   458,   456,   406,   455,  1591,   455,   458,   154,   458,
    3659,   396,   419,   328,   421,   396,   419,   135,  1604,   455,
     455,  4638,   458,   458,  3467,   377,  3469,   396,  2769,   455,
    1616,   454,   458,   456,   419,   260,   421,   440,   419,  2265,
     421,   328,  1628,   263,    42,   455,  4663,  2273,   458,   204,
     419,   454,   421,  1788,   369,  2281,  1791,  2283,   176,   392,
    4873,   455,   455,   181,   458,   458,   437,   455,   455,   454,
     458,   458,   419,   454,   421,   333,  2739,  2740,   437,   447,
     455,   396,   369,   458,   328,   454,  1672,  3385,  3386,  1675,
     370,  2208,   372,  4906,  4638,  2465,   158,  4366,  3179,   217,
     458,    52,   455,  2329,   419,   458,   421,   455,   366,   396,
     458,   455,   455,  2483,   458,   458,  3645,  3662,   454,  4663,
     455,  2491,   159,   458,  4120,   369,  3214,   455,   455,   200,
     458,   458,   419,  2359,   421,   455,   455,   455,   458,   454,
     458,  2367,  2351,  2351,   262,   181,   455,  2264,   406,   458,
     455,   455,   396,   458,  2316,  2272,  3184,  2274,   454,   456,
    3248,   419,  4975,  2280,  4292,  4790,   202,   454,   423,  2393,
    2394,  2395,  2389,  2390,  3033,   419,   340,   421,   455,  2396,
     455,   458,   440,   458,   455,   455,   455,   458,   458,   458,
     455,   455,   455,   458,   458,   458,   454,   455,   454,   457,
     370,  2605,   372,  2429,   455,  3293,   455,   458,   310,   458,
     454,  3010,   455,  3012,   455,   458,  3366,   458,  1804,   181,
     142,   455,  3413,     0,   458,   227,   262,   345,  2891,   247,
     248,  2495,  4849,  2755,   456,  2352,   455,  2501,  2901,   458,
     454,   142,  2459,  3710,  3711,  3712,   260,  3219,  3220,  3221,
    3222,   181,   310,  3225,  3226,  3227,  3228,  3229,  3230,  3231,
    3232,  3233,  3234,  3159,   455,   455,   260,   458,   458,  3010,
     142,  3012,  4400,  2677,   455,   455,   181,   458,   458,  3329,
    3252,  3080,   455,   455,   455,   458,   458,   458,   227,   455,
     142,  2408,   458,  2410,     8,   455,  2549,    11,   458,   260,
     154,    15,    16,    17,   455,  4849,   455,   458,   457,  3281,
    3282,    88,  2834,   455,  2836,   333,   458,   310,    32,   455,
     438,   455,   458,   419,   458,   421,   328,   445,   446,   447,
     448,   449,   450,   142,   455,   455,  3316,   458,   458,  3080,
    2593,  2549,   455,   455,   455,   458,   458,   458,   366,   216,
    3319,  3320,  3321,  2723,   455,   455,   455,   458,   458,   458,
     137,  3024,   455,  3026,   455,   458,   457,   369,  3844,   111,
    3846,   771,   149,   773,   400,   260,  3943,   154,  2642,   232,
    4841,   454,   159,   382,   255,  2593,   330,   164,   406,   328,
     167,   412,   154,   170,   396,  2512,  2766,   208,   455,   454,
      64,   419,  2610,    35,   246,   441,   442,   443,   423,   445,
     446,   447,   448,   449,   450,  3856,   454,   419,  2626,   421,
     260,   198,   440,  2945,  2636,  2637,  2638,   246,    42,  2951,
     369,  2695,    42,  2659,  2642,   387,   454,   274,   154,   412,
    2657,   218,  2659,   412,  3885,  2698,    77,   154,   294,   142,
    4345,   142,   454,     0,   454,   142,   409,   396,   454,   287,
       8,   142,   454,    11,  2673,  2673,  2673,  2673,  2673,  2673,
      34,   142,   142,   423,   458,   142,   142,   260,   260,   142,
     419,   258,   421,   260,   142,   142,   142,  2695,   202,   266,
    2698,   142,    40,   154,   260,   142,   142,   142,    46,     8,
    2086,   366,    11,  2873,    35,  3563,    15,    16,    17,   454,
    3542,  3174,  2098,   216,   154,   454,  2886,   154,   454,   260,
       5,     5,    70,    32,   154,   454,   454,   454,   454,   454,
     454,    40,     5,   454,   454,     5,   454,    46,   454,   454,
     317,    88,   454,  2769,  4011,  4012,  3989,  4014,   262,     5,
     454,   454,  2138,     5,  3673,   454,   454,   454,   454,   454,
     454,    70,   454,   454,   454,   454,   454,   454,   454,   420,
     271,  3093,   200,    35,   458,   458,    92,   216,    35,   154,
     258,   154,   256,   340,   377,   377,   456,   135,   328,   366,
     137,   377,   377,  2997,   328,  2965,   218,   377,  3120,  3121,
    3004,  3123,   149,  3125,  3126,   314,   377,   154,   443,   377,
      81,   328,   159,  3793,  3586,   392,  3138,   164,  4614,   142,
     167,     8,   260,   170,    11,   260,   332,   213,   176,  2855,
     377,   377,   251,   181,   377,   399,   369,   260,   324,   416,
     260,   418,   419,   256,   454,   377,   377,   174,   454,    81,
     458,   198,   181,    40,  3176,   142,   274,   103,   377,    46,
      52,  2778,     0,  2780,  2781,  2782,   377,   176,    52,   217,
     400,   218,   181,  2899,   400,   452,   264,   377,   455,   456,
     457,   377,   377,    70,   369,   377,    41,  3715,     8,   377,
      41,    11,  3780,   202,   203,    15,    16,    17,   377,   328,
     377,   377,   458,   260,   377,   202,   260,  2293,   217,   260,
     423,   258,   202,   260,   262,   377,   202,   419,   387,   266,
      35,    24,  2948,   260,   142,   454,   246,   441,   442,   443,
     454,   445,   446,   447,   448,   449,   450,   109,   142,   411,
     249,   400,   224,   256,  2970,   246,   246,    35,   135,   154,
      88,  2977,  2978,   262,    35,  2981,   265,   454,   208,   329,
     454,    34,  2988,   375,   375,  2991,   340,  3137,   452,   452,
     317,  2997,   377,   377,   377,   377,   142,   142,  3004,   454,
    2997,  4079,  3152,   400,  3010,   142,  3012,  3004,   142,   176,
     142,   400,   255,   377,   181,     8,   250,   345,    11,   137,
     159,   454,    15,    16,    17,   238,    11,  3177,   415,   238,
    3027,   149,   375,   454,   458,   377,   154,   167,   454,   366,
     150,   159,   159,   379,  3050,   458,   164,    40,   455,   167,
     217,   174,   170,    46,     3,   459,   345,   198,   174,   454,
     343,   261,   458,   206,    35,   392,   268,   400,    52,   455,
     458,   377,   377,  3079,  3080,  2972,  4385,    70,   454,   328,
     198,  3070,  3070,   328,   400,   206,   206,   377,   251,   416,
       8,   418,   419,   251,   454,   262,   382,    15,    16,    17,
     218,   377,  3099,  3092,  3092,  3149,   377,   330,   412,   154,
     438,   208,   144,   251,    42,  2481,  4339,   445,   446,   447,
     448,   449,   450,   144,   260,   452,   216,   349,   455,   456,
     457,    80,  2498,   246,   216,   216,   324,   259,   377,   458,
     258,   369,   260,  2509,   377,   260,   260,   175,   266,   438,
    3910,   310,   441,   442,   443,  3289,   445,   446,   447,   448,
     449,   450,   262,   337,   202,    35,  3609,  3610,   202,   458,
     377,   377,   299,   202,   259,   400,   400,   202,   345,  3622,
    4855,  4856,   131,   176,   208,   202,   184,  3184,   181,   296,
     142,   443,   154,   412,   154,  3159,  3881,   443,   156,   317,
     256,   142,   142,   419,   337,   246,  4453,   454,    35,   202,
     203,   246,   260,   454,   260,   172,   208,  4464,   172,   154,
      35,   452,   437,   437,   217,   331,   455,   236,   455,   142,
    3127,   208,  3129,   260,   455,   455,  3133,   455,   260,   337,
     260,   246,   154,   181,   181,   181,   423,   458,   366,    23,
     458,   165,   377,   458,  3287,   454,   249,  3263,   159,  3303,
     235,  3305,   419,   260,   458,    52,  3416,   366,   255,   262,
     382,   438,  3305,   455,   392,   224,   208,   455,   445,   446,
     447,   448,   449,   450,  3468,   455,   412,   159,   271,   455,
    3187,   279,  4539,   455,   455,   455,   159,   437,   416,  3287,
     418,   419,   455,  3295,  3296,  3297,  3298,   454,   458,   270,
    4985,  4986,   377,   455,   416,  3303,   226,  3305,   398,   406,
      52,   260,   416,  3873,   184,   274,   455,   455,   439,   260,
     454,   260,   281,   263,   452,   454,   142,   455,   456,   457,
    3384,   441,   442,   443,   262,   445,   446,   447,   448,   449,
     450,   454,   345,   454,   443,   192,   423,   251,   454,   377,
     246,   310,   455,   454,   377,   314,   454,   377,   264,   377,
     142,  3521,   142,   332,  3524,     8,   142,   332,    11,   332,
     216,   184,    15,    16,    17,   144,   377,   218,   400,   280,
     280,   340,  3694,   397,   228,   377,   377,  4644,   377,    32,
    3702,  3703,  3704,  3705,   377,   228,  2772,    40,   228,   377,
     377,   328,  4164,    46,   377,   260,   246,   328,   340,   328,
     369,  4173,   371,  2789,   328,  4064,   377,   377,     8,   377,
     377,    11,   142,   377,    41,   377,   169,    70,   202,    48,
     202,   202,   202,     3,   455,   438,    42,   312,   441,   442,
     443,   458,   445,   446,   447,   448,   449,   450,   377,   455,
      40,   387,  3468,   102,   458,   455,    46,   259,   454,   260,
     419,  3468,    35,   142,  3624,   455,   142,   377,  4701,  4228,
     154,    90,   169,   453,   453,    62,  4235,   142,   328,  4544,
      70,   455,   400,   400,  4247,  3501,   328,  3940,  3504,   328,
    3506,  4520,   458,  3500,   337,  4343,   115,   263,  4521,  3406,
    3407,  3408,  3409,   140,   140,   133,   202,  2883,  3500,  2885,
     202,   202,   131,   441,   442,   443,   135,   445,   446,   447,
     448,   449,   450,    11,   159,   458,  4535,   452,  4537,   154,
     271,   266,   411,   176,  3550,   159,   155,   159,   181,   158,
    3556,  3557,   455,  3559,   416,   135,   455,   455,   455,  3565,
    4003,   454,   171,   455,  4432,   440,   454,   167,  3718,   202,
     203,  3568,  3569,   458,   458,   455,   455,   453,   455,   317,
    2946,   454,   261,    79,   217,   387,   154,    35,   400,   400,
     192,   208,   377,    52,   369,   142,   176,   454,   387,   377,
     377,   181,   332,  4471,   377,  2971,   328,   328,   377,   377,
     310,   455,   455,   455,   419,   443,   249,    52,   369,  3921,
     154,   144,   142,    70,   387,   102,   202,   202,   454,   262,
     455,   202,   265,  4711,  4712,   202,   454,   217,   419,   295,
     206,   454,   251,   187,   454,   154,    35,   423,  4703,   458,
     259,   455,  3658,  3955,  3956,    75,   369,   458,   458,   454,
     387,   458,   377,  4364,   454,  3654,  3654,   455,   102,   453,
     337,   164,   159,   202,   202,  4427,   202,   202,   159,  4902,
     304,    52,   262,   417,   455,   271,   205,  3584,   297,  3873,
     455,   417,   205,   368,   267,   269,   454,  3063,  4447,    52,
     455,   458,   455,   455,   454,   454,   454,   170,   455,  4259,
     455,   455,   345,   256,   443,   387,     8,   377,  3715,    11,
     159,   419,    70,   443,   186,    52,  3732,   251,  3094,  3735,
     251,  3737,  4034,  4035,   369,   458,  4544,   377,    64,   458,
     377,  4819,  4965,   377,    22,   142,    24,   202,    40,   454,
      28,   161,   159,  4303,    46,   400,    34,    35,    36,   181,
      38,  4984,   454,    41,    42,   345,    44,  4635,    46,   400,
      35,   246,   337,   128,   415,   419,   419,    35,    70,  4647,
     159,   260,   154,   454,  4652,   189,  4654,   263,   200,   159,
     454,   454,   304,   455,   405,  3839,   353,   455,   278,  3843,
     454,   454,   205,   455,    81,   438,  3990,   123,   441,   442,
     443,   260,   445,   446,   447,   448,   449,   450,   454,   418,
    3970,   305,   377,   455,   377,   458,  4128,   116,    35,  4131,
    4132,  3197,  3982,  4888,   454,   454,   154,   251,   454,   229,
     184,   454,   295,   135,   454,  4147,   142,   455,   454,    35,
    4293,  3839,  3218,   141,   455,  3843,   264,   325,   438,   325,
     387,   351,  3868,  4882,  3870,   445,   446,   447,   448,   449,
     450,   455,    52,    52,    35,   454,   454,  3243,     0,   351,
     369,   369,   454,  3902,   176,   455,   455,   244,     5,   181,
     454,   260,   454,   400,  3883,  3883,    18,   458,   369,   455,
     148,   295,    64,   263,    64,   123,    28,   404,    30,    31,
     405,  3277,    25,   191,   192,   193,   194,   419,   196,   419,
     198,   304,   200,    45,   202,   217,   458,   205,    35,   340,
     159,   416,   454,   211,   302,   154,   214,   454,   369,   251,
     218,   128,   220,    65,   186,    67,    68,   260,   454,   260,
     337,    73,    35,    75,  3951,    35,   263,   263,   161,    72,
     454,   161,    52,   455,    86,  4544,    88,   114,   454,  3951,
     262,   454,   324,   455,   398,     5,  3973,  3974,   324,   311,
     454,  3978,  3979,   105,  3990,   455,   108,    21,    32,   458,
     103,   458,   141,  3990,   454,   377,   159,   295,  4148,   121,
     351,   123,   351,   419,   419,   127,   161,   161,   454,   864,
     831,   133,   125,  1492,   768,  2314,  2659,  2173,  2825,   141,
    3467,   143,  4066,   136,  2243,  4031,  4032,   149,  2995,  1269,
    3565,  4557,  4701,  4888,  4040,  4674,  4042,  4043,  4381,  3607,
    4046,  4385,   164,   156,  4057,  4363,  2746,  2447,   161,  4797,
    4258,  4879,  4729,   345,  4728,  4828,  2750,  3655,   180,  3640,
    3599,  3462,  2304,  2304,  2850,  1563,  3623,  4082,  4890,  3049,
    4984,  2298,  4965,  4358,  3003,  4259,  4839,  2999,  4305,  4689,
    4807,    27,  1552,  4308,  4090,  3718,  4493,  1110,  2024,  1126,
    3662,  2721,  4614,   603,   632,  1743,   209,   219,   220,  1743,
    2949,  1744,  4252,   225,  4254,  3989,  4095,  4095,  4292,  4968,
    4854,  1967,  1689,  4119,  1352,   237,  4013,   230,  4420,  4303,
    1968,  4671,  3643,   746,  4703,  4789,   248,  3361,  3884,  1315,
    2674,  4028,  2685,  2008,  1314,  3328,  4782,  1246,  2680,  4656,
    1296,  3869,  2007,  4149,  1317,  3305,   438,  4153,  4154,  2695,
    4156,  3845,  4461,   445,   446,   447,   448,   449,   450,   281,
    3830,  3303,  4638,  4637,  4208,  3362,  3108,   289,  1322,  4213,
    4430,  3256,  4237,  1621,  4218,  4786,  4785,  4221,  4222,   301,
    4772,   294,  1837,  2677,   306,   307,  2520,   309,  2610,  2608,
    2662,  1840,   314,  4495,    -1,    -1,    -1,   319,    -1,  4096,
     322,  4245,    -1,    -1,    -1,   327,    -1,    -1,   321,    -1,
     332,   333,    -1,    -1,  4258,   328,    -1,    -1,   340,    -1,
      -1,   334,   344,    -1,    -1,  4213,    -1,    -1,    -1,    -1,
    4218,    -1,   354,  4221,    -1,    -1,    -1,    -1,  4540,    -1,
      -1,    -1,    -1,    -1,   366,    -1,    -1,  3613,    -1,    -1,
      -1,    -1,    -1,   366,    -1,    -1,   369,    -1,  4302,  4247,
      -1,    -1,    -1,   385,    -1,    -1,  4240,    -1,    -1,    -1,
      -1,    -1,   550,   395,   387,    -1,    -1,    -1,   556,   401,
     558,    -1,    -1,   561,   406,   563,  4292,   565,    -1,    -1,
      -1,    -1,    -1,    -1,   572,  4292,    -1,   419,   576,   412,
      -1,  4345,    -1,    -1,    -1,   583,    -1,    -1,    -1,  4888,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,   440,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,  4334,   607,
      -1,    -1,   454,    -1,   612,   457,    32,    -1,    -1,   617,
      -1,    -1,    -1,   621,    40,    -1,    -1,    -1,    -1,     8,
      46,    -1,    11,    -1,  4398,    -1,    15,    16,    17,    -1,
     638,    -1,    -1,  4260,  4261,  4262,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    70,    -1,    -1,    -1,    -1,  4368,
    4368,    40,     8,    -1,    -1,    11,    -1,    46,    -1,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4395,  4395,    -1,   687,
      -1,    70,   690,   691,   692,    -1,  4460,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   703,    -1,   705,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,  4471,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   725,   726,    -1,
     728,   729,    -1,    -1,    -1,   733,    -1,  4490,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,   747,
      -1,    -1,  4460,   751,    -1,    -1,    -1,    -1,    -1,   757,
     176,    -1,    -1,  4471,    -1,   181,    -1,  4671,    -1,    -1,
      -1,   769,    -1,    -1,    40,    -1,    -1,    -1,    -1,  4396,
      46,    -1,  4490,   781,    -1,    -1,   202,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,
      -1,   217,   181,    -1,    70,    -1,    -1,    -1,  4572,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4544,    -1,
      -1,    -1,  4548,   202,   203,    -1,   824,  4544,    -1,    -1,
      -1,    -1,  4558,   249,    -1,    -1,    -1,  3923,   217,    -1,
      -1,    -1,   840,    -1,    -1,    -1,   262,   845,   846,   265,
      -1,    -1,  4874,    -1,    -1,     8,   202,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,  3954,    -1,
     249,    -1,   870,   871,  4638,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,   262,    -1,    -1,  4595,  4595,    -1,  3975,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   896,  4663,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   907,
     176,    -1,    -1,   911,    -1,   181,   262,    -1,    -1,  4536,
    4790,  4538,    -1,     8,    -1,    -1,    11,    -1,   926,   345,
      15,    16,    17,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,  4033,   946,    -1,
      -1,   217,    -1,    -1,    -1,   953,   954,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   345,    -1,    -1,    -1,
      -1,    -1,   970,   971,   972,    -1,   974,  4703,   976,    -1,
    4744,  4707,    -1,  4709,    -1,    -1,    -1,  4713,  4714,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,    -1,  4122,    -1,  4802,   455,
      -1,    -1,    -1,    -1,    -1,  1043,    -1,  1045,  1046,   202,
      -1,    -1,  4669,    -1,    -1,    -1,    -1,    -1,    -1,   438,
      -1,    -1,   441,   442,   443,    -1,   445,   446,   447,   448,
     449,   450,    -1,    -1,    -1,  1073,    -1,    -1,    -1,   345,
      -1,    -1,  4168,    -1,    -1,  4849,    -1,    -1,    -1,    -1,
      -1,  4855,  4856,    -1,    -1,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,  1103,  1104,    -1,    -1,   262,
    1108,    -1,  1110,    -1,    -1,    -1,    -1,   202,    -1,    -1,
      -1,  4738,    -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,
      -1,  4840,  4840,    -1,    -1,    -1,    -1,    -1,  1136,    -1,
      -1,  1139,    -1,    -1,  1142,  4854,  4854,  4854,  4854,  4854,
    4854,    -1,    -1,    -1,    -1,  4908,    -1,  1155,    -1,    -1,
      -1,    -1,  4888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   438,    -1,    -1,    -1,  4902,   262,    -1,   445,
     446,   447,   448,   449,   450,  4902,  1184,   262,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4812,    -1,    -1,    -1,  4908,
    4908,  4908,  4908,  4908,  4908,    -1,    -1,    -1,    -1,  4973,
      -1,    -1,    -1,    -1,  1212,  1213,  1214,    -1,  1216,    -1,
      -1,  4985,  4986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1236,  4965,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4965,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4984,  4968,
    4968,  4968,  4968,  4968,  4968,    -1,  4883,  4984,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,  1274,    -1,     8,  1277,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,  1307,
      40,    -1,    -1,  1311,  1312,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1322,  1323,  1324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,  4428,    -1,    -1,    -1,    -1,  1345,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
    4466,    -1,  1380,    -1,    -1,    -1,    -1,  1385,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1398,  1399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1407,
      -1,    -1,  1410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4519,  1432,    -1,  1434,  4523,  4524,    -1,
      -1,    -1,    -1,    -1,  1442,    -1,   176,  1445,    -1,    -1,
      -1,   181,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1468,    -1,   202,   203,    -1,    -1,    -1,    32,  1476,  1477,
    1478,  1479,  1480,    -1,    -1,    40,    -1,   217,    -1,    -1,
      -1,    46,    -1,  1491,    -1,    -1,  1494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1505,    -1,  1507,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,   249,
      -1,  1519,  1520,    -1,    -1,    -1,    -1,    -1,    -1,  4615,
    1528,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,
    1538,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1557,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,  1566,  1567,
    1568,  1569,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1578,    -1,    -1,    -1,    -1,    -1,    -1,  1585,    -1,    -1,
    1588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1598,    -1,     8,    -1,    -1,    11,    -1,  1605,    -1,    15,
      16,    17,  1610,    -1,    -1,   345,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,  1647,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1657,
      -1,    -1,   217,  1661,    70,    -1,  1664,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1674,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1682,  1683,    -1,    -1,    -1,  1687,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,   438,    -1,
     265,   441,   442,   443,  1712,   445,   446,   447,   448,   449,
     450,  1719,    -1,  1721,    -1,    -1,    -1,  1725,  1726,    -1,
    1728,     8,    -1,    -1,    11,   202,    -1,  1735,    15,    16,
      17,    -1,    -1,    -1,  1742,    -1,    -1,    -1,    -1,  1747,
    1748,    -1,    -1,  1751,    -1,    -1,    -1,  1755,    -1,  1757,
      -1,    -1,    -1,    40,  1762,  1763,    -1,    -1,    -1,    46,
     176,  1769,  1770,  1771,    -1,   181,    -1,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,    -1,  1784,    -1,  1786,  1787,
     345,    -1,  1790,    70,    -1,   262,   202,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1805,  1806,  1807,
    1808,   217,    -1,    -1,  1812,  1813,    -1,    -1,    -1,  1817,
      -1,    -1,  1820,    -1,    -1,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,    54,  1833,    -1,    -1,    -1,    -1,
      -1,  1839,  1840,   249,  1842,    -1,    -1,    -1,    -1,    -1,
      -1,  1849,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    87,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,    -1,    -1,   441,   442,   443,    32,
     445,   446,   447,   448,   449,   450,    -1,    40,    -1,   176,
     455,    -1,    -1,    46,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,   145,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,   345,
     217,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,    32,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    40,  1966,    -1,
    1968,    -1,  1970,    46,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,   262,    -1,     8,    -1,    -1,
      11,    -1,    -1,   213,    15,    16,    17,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2005,    -1,    -1,
     117,    32,    -1,   120,  2012,    -1,  2014,    -1,    -1,    40,
     127,    -1,    -1,   130,    -1,    46,   246,    -1,    -1,    -1,
      -1,    -1,   438,   176,    -1,   441,   442,   443,   181,   445,
     446,   447,   448,   449,   450,  2043,    -1,    -1,   155,    70,
      -1,    -1,    -1,    -1,  2052,   275,  2054,    -1,    -1,   202,
     203,   281,    -1,    -1,    -1,    -1,    -1,    -1,   345,    -1,
      -1,    -1,    -1,  2071,   217,    -1,    -1,    -1,    -1,   186,
      -1,    -1,    -1,    -1,  2082,    -1,  2084,  2085,    -1,    -1,
      -1,  2089,    -1,  2091,   314,  2093,   316,  2095,   318,    -1,
      -1,  2099,    -1,   176,  2102,   325,   249,    -1,   181,    -1,
      -1,    -1,   332,    -1,    -1,    -1,    -1,    -1,    -1,   262,
     340,    -1,   265,    -1,    -1,  2123,    -1,    -1,    -1,   202,
     203,    -1,   352,    -1,    -1,  2133,    -1,   244,    -1,   246,
     360,    -1,    -1,  2141,   217,    -1,    -1,    -1,    -1,   256,
    2148,    -1,    -1,    -1,    -1,   176,    -1,   264,    -1,  2157,
     181,   438,    -1,    -1,   441,   442,   443,   274,   445,   446,
     447,   448,   449,   450,    -1,    -1,   249,    -1,    -1,  2177,
      -1,   202,   203,    -1,  2182,  2183,    -1,    -1,    -1,   262,
      -1,    -1,   265,  2191,   414,    -1,   217,    -1,    -1,    -1,
      -1,    -1,   345,   310,    -1,    -1,   313,   314,    -1,    -1,
    2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,   249,    -1,
      28,    -1,    -1,   340,    -1,    -1,    -1,  2235,    -1,  2237,
    2238,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2264,    -1,    -1,    -1,
      68,    -1,   345,    -1,  2272,    -1,  2274,     8,    -1,    -1,
      11,    -1,  2280,    -1,    15,    16,    17,    25,    -1,    -1,
      -1,    -1,    -1,    -1,  2292,   438,   403,    -1,   441,   442,
     443,    32,   445,   446,   447,   448,   449,   450,  2306,    40,
      -1,  2309,   455,  2311,    -1,    46,  2314,    -1,    -1,  2317,
      58,    -1,   120,    -1,   345,    -1,    -1,    -1,     8,   127,
      -1,    11,   130,    71,    -1,    15,    16,    17,    -1,    70,
      -1,    -1,    -1,    -1,    -1,  2343,    -1,    85,    -1,    -1,
      -1,    -1,    32,    -1,  2352,  2353,    -1,   155,    -1,    -1,
      40,    -1,    -1,    -1,    -1,   438,    46,    -1,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,  2376,    -1,
      -1,    -1,   455,    -1,    -1,    -1,    -1,   125,   186,    -1,
      70,    -1,    -1,  2391,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2406,    -1,
    2408,  2409,  2410,  2411,    -1,    -1,    -1,   438,   156,    -1,
     441,   442,   443,   161,   445,   446,   447,   448,   449,   450,
      -1,    -1,    -1,    -1,   455,    -1,  2434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   244,    -1,   246,  2447,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   202,   203,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,  2485,    -1,    -1,
      -1,    -1,   230,    -1,    -1,    -1,   176,  2495,    -1,    -1,
      -1,   181,    -1,  2501,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,  2512,   313,   314,    -1,   249,    -1,
      -1,  2519,   202,   203,   262,    -1,  2524,    -1,    -1,    -1,
      -1,   262,    -1,    -1,   265,    -1,    -1,   217,    -1,    -1,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,  2547,
    2548,  2549,    -1,    -1,  2552,    -1,   294,    -1,    -1,    -1,
      -1,    -1,  2560,  2561,  2562,  2563,    -1,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    -1,  2573,    -1,    -1,  2576,    -1,
    2578,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,
     328,  2589,  2590,    -1,    -1,  2593,   334,    -1,    -1,   337,
      -1,    -1,    -1,    -1,    -1,   403,    -1,  2605,    -1,  2607,
      -1,  2609,    -1,  2611,   345,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,    -1,
      -1,     8,    -1,  2631,    11,   373,    -1,  2635,    15,    16,
      17,    -1,   380,    -1,  2642,    -1,  2644,  2645,  2646,   387,
      -1,     8,    -1,    -1,    11,    32,    -1,    54,    15,    16,
      17,    -1,    -1,    40,  2662,   345,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,   412,    32,  2674,    -1,    -1,    -1,
      -1,  2679,    -1,    40,    -1,    -1,    -1,  2685,    -1,    46,
      87,    -1,    -1,    70,    -1,    -1,    -1,  2695,    22,    -1,
    2698,    -1,    -1,  2701,    28,  2703,    -1,   438,    -1,    -1,
     441,   442,   443,    70,   445,   446,   447,   448,   449,   450,
     117,    -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,  2745,   145,  2747,
      -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,   438,    -1,
      -1,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,    -1,    -1,    -1,    -1,   455,    -1,   101,    -1,    -1,
    2778,   178,  2780,  2781,  2782,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,   176,
      -1,    -1,    -1,   127,   181,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,   176,
      -1,    -1,    -1,    -1,   181,   202,   203,    -1,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,
     217,    -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,   274,   275,    -1,
      -1,    -1,    -1,    -1,   281,   262,    -1,    -1,   265,    -1,
      -1,  2889,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,    -1,   231,   265,    -1,
     234,    -1,    -1,   310,    -1,    -1,    -1,   314,    -1,    -1,
     244,   318,   246,    -1,   202,    -1,    -1,    -1,   325,    -1,
      -1,    -1,   256,   211,    -1,   332,    -1,    -1,    -1,    -1,
     264,    -1,   220,   340,    -1,    -1,    -1,    -1,    -1,   273,
     274,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   360,    -1,    -1,    -1,    -1,   345,    -1,
      -1,    -1,    -1,    -1,  2972,    -1,    -1,    -1,    -1,    -1,
      -1,  2979,  2980,    -1,    -1,    -1,   310,    -1,   345,   313,
     314,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,   340,   414,  3016,  3017,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
     354,    -1,    -1,    -1,  3032,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,  3047,
    3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,  3057,
    3058,   438,    -1,    -1,   441,   442,   443,    70,   445,   446,
     447,   448,   449,   450,    -1,    -1,  3074,    -1,   455,   403,
      -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,   455,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3127,
      -1,  3129,    -1,    -1,    -1,  3133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,    -1,    -1,    -1,  3175,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3187,
      -1,    -1,    -1,    -1,    -1,    -1,  3194,    -1,    -1,   202,
     203,    -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,
      -1,  3209,    -1,  3211,   217,    -1,  3214,    -1,    -1,    -1,
      -1,  3219,  3220,  3221,  3222,    -1,    -1,  3225,  3226,  3227,
    3228,  3229,  3230,  3231,  3232,  3233,  3234,    -1,    -1,    -1,
    3238,  3239,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
    3248,    -1,    -1,    -1,  3252,    -1,    -1,    -1,  3256,   262,
      -1,    -1,   265,    -1,    -1,    -1,  3264,    -1,    -1,  3267,
      -1,  3269,   550,    -1,    -1,    -1,    -1,    -1,   556,    -1,
    3278,    -1,    -1,  3281,  3282,    -1,    -1,    -1,  3286,  3287,
      -1,     8,    -1,  3291,    11,  3293,    -1,    -1,    15,    16,
      17,    -1,  3300,  3301,  3302,  3303,    -1,  3305,  3306,    -1,
      -1,    -1,  3310,  3311,    -1,    32,    22,    -1,    -1,  3317,
      -1,    -1,    28,    40,    -1,  3323,  3324,  3325,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3350,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,  3361,    -1,  3363,    -1,    -1,    13,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,  3384,  3385,  3386,    -1,
    3388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,  3406,  3407,
    3408,  3409,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,   703,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   438,    -1,  3435,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,    -1,   155,
     728,  3449,   455,    -1,    -1,    -1,    -1,    -1,    -1,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,   747,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    40,    -1,    -1,    -1,    -1,   244,    46,
     246,  3539,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,
     256,    -1,    -1,   198,    -1,    -1,    -1,    -1,   264,    -1,
      -1,   206,   840,    70,   209,   210,    -1,   212,   274,    -1,
     215,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3582,    -1,  3584,    -1,  3586,    -1,
      -1,    -1,    -1,    -1,  3592,    -1,    -1,    -1,    -1,    -1,
    3598,    -1,    -1,    -1,   310,    -1,    -1,   313,   314,  3607,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,   345,  3627,
      -1,    -1,    -1,    -1,   340,    -1,    -1,    32,    -1,  3637,
      -1,    -1,    -1,    -1,    -1,    40,    -1,  3645,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,  3655,    -1,    -1,
      -1,  3659,    -1,    -1,    -1,  3663,  3664,    -1,   946,   176,
      -1,    -1,    -1,    -1,   181,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   970,   971,   972,   202,   203,   403,    -1,  3697,
      -1,  3699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,  3709,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,   455,    -1,
      -1,  3739,   249,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    28,  3750,    -1,    -1,   262,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,  3780,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    68,  3790,  3791,    -1,    -1,    -1,    -1,    -1,  3797,
    3798,    -1,    -1,    -1,  3802,    -1,    -1,   202,   203,  3807,
      -1,    -1,  3810,  3811,    -1,    -1,    -1,  3815,  3816,    -1,
      -1,    -1,   217,  3821,  3822,  3823,  3824,  3825,    -1,    -1,
    1108,  3829,  3830,    -1,  3832,    -1,    -1,  3835,   345,    -1,
     117,  3839,    -1,   120,    -1,  3843,    -1,    -1,    -1,    -1,
     127,  3849,    -1,   130,   249,    -1,    -1,  3855,    -1,    -1,
      -1,  1139,  3860,    -1,    -1,    -1,    -1,   262,  3866,    -1,
     265,    -1,    -1,    -1,    -1,  3873,    -1,    -1,   155,    -1,
      -1,    -1,    -1,  3881,    -1,    -1,  3884,    -1,    -1,    -1,
      -1,  3889,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3902,    -1,    -1,  3905,    -1,   186,
      -1,    -1,    -1,    -1,   559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   567,    -1,    -1,    -1,    -1,  3925,  3926,   574,
      -1,   438,   577,   578,   441,   442,   443,   582,   445,   446,
     447,   448,   449,   450,    -1,  3943,   453,    -1,   593,    -1,
     345,    -1,    -1,    -1,  3952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   608,    -1,    -1,    -1,   244,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   623,   256,
     625,    -1,    -1,   628,    -1,   630,    -1,   264,   633,    -1,
      -1,    -1,    -1,    -1,    -1,  3993,  1274,   274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4013,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4028,    -1,    -1,   310,    -1,    -1,   313,   314,    -1,    -1,
      -1,    -1,    -1,   438,    -1,  1323,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,    -1,  4055,    -1,   704,
     455,    -1,    -1,   340,    -1,    -1,    -1,    -1,  4066,   613,
      -1,    -1,    -1,  4071,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4079,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
     634,    -1,    -1,    15,    16,    17,    -1,    -1,  4096,  4097,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,   759,    -1,    -1,    -1,    40,    -1,
    1398,    -1,    -1,    -1,    46,    -1,   403,  4125,    -1,  1407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1442,    -1,  4164,  1445,    -1,    -1,
      -1,    -1,    -1,    -1,   819,  4173,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,  4190,  4191,    -1,    -1,  4194,    -1,    -1,    -1,
      32,    -1,  1480,    -1,    -1,    -1,    -1,    -1,    40,    -1,
    4208,  4209,    -1,    -1,    46,  4213,  1494,    -1,    -1,    -1,
    4218,    -1,    -1,  4221,  4222,    -1,  4224,    -1,  4226,  1507,
      -1,  4229,  4230,    -1,    -1,    -1,    -1,    -1,    70,   884,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4245,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   900,    -1,    -1,    -1,   181,
    4258,  4259,  4260,  4261,  4262,    -1,    -1,   912,    -1,   914,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   922,    -1,  1557,
     202,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   934,
      -1,    -1,    -1,    -1,   939,   217,    -1,   942,    -1,    -1,
    1578,    -1,    -1,    -1,  4302,  4303,    -1,  1585,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,   977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     262,    -1,    -1,   265,   176,    -1,    -1,  4345,    -1,   181,
    4348,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,   903,
    4358,    -1,    -1,    -1,    -1,    -1,  4364,    -1,  4366,    -1,
     202,   203,    -1,    -1,  4372,    -1,    -1,    -1,    -1,   923,
      -1,    -1,    -1,    -1,    -1,   217,    -1,  4385,    -1,    -1,
      -1,    -1,    -1,   937,    -1,    -1,    -1,    68,  4396,  4397,
    4398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1687,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,    -1,   345,    -1,    -1,    -1,    -1,    -1,  4427,
     262,    -1,  4430,   265,  4432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1725,  1726,   120,
      -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,  4456,   130,
      -1,    -1,  4460,    -1,  1742,    -1,  4464,  1112,    -1,    -1,
    1014,    -1,    -1,  4471,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,  4480,    11,   155,    -1,    -1,    15,    16,    17,
      -1,    -1,  4490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,  4505,    -1,    -1,
      -1,    -1,    40,   345,    -1,   186,   438,    -1,    46,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,    -1,
    4528,    -1,    -1,   455,    -1,    -1,    -1,  4535,  4536,  4537,
    4538,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      -1,  1849,    -1,   244,  4572,   246,    -1,    -1,    -1,  1123,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,
    4588,    -1,    -1,   264,    -1,  4593,    -1,    -1,    -1,    -1,
      -1,    -1,    87,   274,    -1,    -1,   438,    -1,    -1,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,    -1,
      -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4635,    -1,   310,
    4638,    -1,   313,   314,    -1,    -1,    -1,    -1,   176,  4647,
      -1,  1296,  1297,   181,  4652,    -1,  4654,    -1,  4656,    -1,
     145,    -1,    -1,    -1,    -1,  4663,    -1,    -1,    -1,   340,
      -1,  4669,    -1,  4671,   202,   203,    -1,    -1,    -1,    -1,
      -1,    -1,  4680,    -1,    -1,    -1,    -1,    -1,  1966,   217,
    1968,    -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4711,  4712,    -1,    -1,    -1,    -1,  1263,
      -1,   249,    -1,   208,  1369,    -1,    -1,  2005,   213,    -1,
      -1,    -1,   403,    -1,   262,    -1,    -1,   265,    -1,    -1,
    4738,    -1,    -1,    -1,    -1,    -1,  4744,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,   246,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,  4771,  4772,    -1,    -1,    54,  4776,    -1,
      -1,    -1,    -1,  1327,  4782,    -1,    32,  4785,  1433,    -1,
     275,  4789,    -1,    -1,    40,    -1,   281,    -1,    -1,     8,
      46,    -1,    11,    -1,  4802,    -1,    15,    16,    17,    -1,
      87,    -1,    -1,    -1,  4812,    -1,    -1,   345,    -1,    -1,
      -1,  4819,    -1,    32,    70,    -1,    -1,    -1,    -1,   314,
      -1,    40,    -1,   318,    -1,    -1,    -1,    46,    -1,    -1,
     325,    -1,    -1,  4841,    -1,    -1,    -1,   332,    -1,  1393,
      -1,  4849,    -1,    -1,    -1,   340,    -1,  4855,  4856,  4857,
      -1,    70,    -1,    -1,    -1,    -1,    -1,   352,   145,    -1,
      -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,  4876,  2157,
      -1,    -1,    -1,    -1,    -1,  4883,  1430,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,  2177,
      -1,   178,    -1,  1548,    -1,    -1,    -1,    -1,    -1,    -1,
     438,    -1,    -1,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,    -1,    -1,    -1,    -1,   455,    -1,   414,
     176,   208,    -1,   418,   419,   181,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,
      -1,  4959,  4960,    -1,    -1,    -1,  1510,   176,    -1,   246,
      -1,   217,   181,    -1,    -1,  4973,    -1,    -1,    -1,    -1,
      -1,  1525,    -1,    -1,    -1,    -1,    -1,  4985,  4986,  1533,
      -1,    -1,    -1,   202,   203,    -1,    -1,    -1,   275,    -1,
    1544,  1646,    -1,   249,   281,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,    -1,  1660,   262,    -1,  1663,   265,
    1665,    -1,  1667,    -1,    -1,    -1,    -1,    -1,  1673,    -1,
      -1,    -1,    -1,  2311,    -1,    -1,    -1,   314,    -1,    -1,
     249,   318,    -1,    -1,    -1,    -1,    -1,  1591,   325,    -1,
      -1,    -1,    -1,   262,    -1,   332,   265,    -1,    -1,    -1,
    1604,    -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,  1616,  1718,    -1,   352,    -1,  1722,    -1,  1724,
      -1,    -1,  1727,   360,  1628,    -1,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   345,
      -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,  1672,    -1,
      -1,  1675,    -1,    -1,    -1,    -1,   345,   414,    -1,    -1,
      -1,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      22,   145,    -1,    40,    -1,    -1,    28,    -1,    -1,    46,
      -1,    -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,    -1,    -1,  2485,    -1,   455,
      -1,    -1,    -1,    70,   178,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,   438,
      -1,    -1,   441,   442,   443,    -1,   445,   446,   447,   448,
     449,   450,    -1,    -1,   208,    -1,   455,    -1,    -1,   213,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,   120,    15,
      16,    17,   246,    -1,    -1,   127,    -1,    -1,   130,    -1,
       8,    -1,    -1,    11,    -1,    -1,    32,    15,    16,    17,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,   275,    -1,   155,    32,    -1,    -1,   281,    36,   176,
      -1,    -1,    40,    -1,   181,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,   202,   203,    -1,    -1,    -1,
     314,    -1,    70,    -1,   318,    -1,    -1,  2635,    -1,    -1,
     217,   325,    -1,    -1,    -1,    -1,    -1,    -1,   332,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,  2034,
    2035,    -1,   249,    -1,  2039,  2040,   360,    -1,    -1,  2044,
     118,    -1,   244,    -1,   246,   262,    -1,    -1,   265,    -1,
      -1,    -1,    -1,  2058,   256,    -1,   380,    -1,    -1,    -1,
    2065,    -1,   264,    -1,  2069,  2070,    -1,    -1,  2073,  2074,
      -1,    -1,   274,    -1,    -1,  2080,    -1,    -1,    -1,    -1,
     176,    -1,    -1,    -1,    -1,   181,    -1,  2092,    -1,  2094,
     414,    -1,    -1,    -1,   418,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,   181,    -1,    -1,   202,   203,  2113,    -1,
      -1,   313,   314,  2118,    -1,  2019,    -1,    -1,    -1,  2023,
    2024,   217,    -1,    -1,   202,   203,  2131,    -1,   345,    -1,
      -1,    -1,    -1,    -1,    -1,  2140,    -1,  2142,   340,   217,
    2145,  2146,  2147,    -1,    -1,    -1,    -1,  2152,  2153,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,  2162,    -1,    -1,
      -1,    -1,  2167,    -1,    -1,    -1,   262,  2172,    -1,   265,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2086,    -1,   262,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,  2198,  2098,    -1,    -1,    -1,    -1,    -1,
      -1,   403,    -1,    -1,  2209,    -1,  2211,    -1,    -1,    -1,
      -1,  2216,    -1,    -1,    -1,  2220,    -1,  2222,  2223,  2224,
    2225,   438,  2227,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,  2138,  2240,  2241,  2242,   455,    -1,
      -1,    -1,    -1,    -1,    -1,  2250,  2251,    -1,    -1,   345,
      -1,  2889,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,   345,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    32,    15,    16,
      17,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    46,    22,    -1,    -1,    32,    -1,  2302,    28,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    22,    68,    -1,
      -1,    -1,   438,    28,    -1,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,   455,
     438,    -1,    -1,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,    -1,    -1,    -1,    -1,    -1,  3016,  3017,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,  2293,
     120,    -1,    -1,    -1,  3032,    -1,    -1,   127,    -1,   154,
     130,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,    -1,
    3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3057,
    3058,   176,    -1,    -1,    -1,   155,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,  3074,    -1,    -1,   176,
      -1,    -1,   127,    -1,   181,   130,    -1,   202,   203,    -1,
    2455,    -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,  2363,
      -1,    -1,   217,    -1,    -1,   202,   203,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,  2486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,
      -1,   186,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,
     265,    -1,   249,    -1,   244,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,   256,    -1,   265,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,  3175,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    22,    -1,    -1,    -1,    -1,    -1,    28,   244,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,  2481,    -1,   264,
     310,    -1,    -1,   313,   314,    -1,    -1,    -1,    -1,   274,
     345,    -1,    -1,    -1,  2498,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,  2509,    -1,    -1,   345,    -1,
     340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   361,   310,    -1,    -1,   313,   314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,    -1,    -1,    -1,   340,    -1,   127,    -1,    -1,
     130,    -1,  3300,  3301,  3302,    -1,    -1,  2672,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,    -1,   155,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
      -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,    -1,   186,    -1,   403,  2724,
    2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,  2742,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,  2767,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,  2776,    -1,    -1,   244,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   256,  2792,  2793,    -1,
      -1,    -1,  2797,    70,   264,    -1,    -1,  2802,  2803,  2804,
      -1,  2806,    -1,    -1,   274,    -1,    -1,  2711,    -1,    -1,
    2714,    -1,  2716,    -1,    -1,    -1,    -1,  2721,     8,    -1,
      -1,    11,  2827,    -1,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,  2837,  2838,  2839,  2840,    -1,    -1,    -1,    -1,
     310,    -1,    32,   313,   314,    35,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    46,    22,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,  2772,  2874,
     340,    -1,  2877,  2878,  2879,    -1,   153,    -1,    -1,    -1,
      70,    -1,  2887,     8,    -1,  2789,    11,    -1,    53,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,   176,
      -1,    -1,    -1,    68,   181,    -1,    -1,    32,    -1,    -1,
    2814,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,   101,    -1,    -1,    -1,
     217,    -1,    -1,    -1,  3582,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2958,  3592,   120,    -1,    -1,    -1,    -1,
      -1,  2966,   127,    -1,    -1,   130,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,  2883,
    2985,  2885,    -1,    -1,    -1,   262,   176,    -1,   265,  3627,
     155,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3011,    -1,    -1,   286,
      -1,    -1,   202,   203,    -1,    -1,    -1,  3655,   183,    -1,
      -1,   186,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3055,   176,    -1,    -1,  3059,    -1,   181,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    -1,    -1,   231,  2971,   345,   234,
      -1,  3709,   262,    -1,    -1,   265,    -1,   202,   203,   244,
      -1,   246,    -1,  3088,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,   217,  2997,    -1,    -1,    -1,    -1,    -1,   264,
    3004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
      -1,    -1,    -1,  3118,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    28,    -1,   249,    -1,    -1,  3132,    -1,    -1,
      -1,  3136,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,
     265,    -1,  3147,    -1,    -1,   310,    -1,    -1,   313,   314,
     315,    -1,    -1,    -1,    -1,   345,    -1,   282,    -1,  3063,
      -1,   438,    68,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,   340,    -1,  3081,    -1,    -1,
      -1,    -1,    -1,    -1,  3822,  3823,  3824,  3825,   191,   354,
    3094,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,    -1,
      -1,    -1,    -1,    -1,     8,   208,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,   120,    -1,   219,    -1,    -1,    -1,
     345,   127,    -1,    -1,   130,    -1,    -1,    -1,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    40,    -1,   403,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,   438,   155,
      -1,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3197,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,  3218,    -1,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,  3243,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,   176,  3277,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3391,    -1,  3393,    -1,
      -1,    -1,    -1,    -1,    -1,  3400,    -1,    -1,   202,   203,
      -1,    -1,    -1,    -1,   310,    -1,    -1,   313,   314,    -1,
      -1,     8,  3417,   217,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3433,    -1,
      -1,    -1,    -1,    -1,   340,    32,    -1,    -1,    -1,    -1,
      -1,    -1,  3447,    40,    -1,   249,    -1,    -1,    22,    46,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,   262,    -1,
    3465,   265,    -1,    -1,    -1,  3369,    -1,    -1,    -1,    -1,
    3475,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4125,    -1,    -1,
      -1,  3496,    -1,    -1,    68,    -1,    -1,   403,    -1,    -1,
      -1,    -1,  3507,  3508,  3509,    -1,    -1,  3512,  3513,  3514,
    3515,  3516,  3517,    -1,    -1,    -1,    -1,  3522,  3523,    -1,
    3525,  3526,  3527,  3528,  3529,  3530,    -1,  3532,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3541,    -1,  3543,  3544,
      -1,   345,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,   558,   130,    -1,    -1,    -1,
      -1,  3566,   159,    -1,  3468,    -1,    -1,   570,    -1,    -1,
      -1,    -1,   575,    -1,    -1,    -1,    -1,    -1,    -1,   176,
    3585,   155,    -1,   586,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   602,
      -1,    -1,    -1,    -1,   607,   202,   203,    -1,    -1,    -1,
     613,    -1,   186,    -1,   617,   618,    -1,    -1,    -1,    -1,
     217,   624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   634,   635,    -1,   438,    -1,    -1,   441,   442,   443,
     643,   445,   446,   447,   448,   449,   450,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,
     244,    -1,   246,    -1,    -1,    -1,    -1,  3682,    -1,    -1,
      -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,  3710,  3711,  3712,    -1,  3613,
    4348,    -1,    -1,    -1,    -1,    -1,    -1,  3722,    -1,    -1,
      -1,    -1,   725,   726,    -1,    -1,  4364,    -1,   731,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,
     314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   345,    -1,
      -1,    -1,    -1,    -1,   757,    -1,    -1,    -1,  3662,  4397,
      -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,   403,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,   438,    -1,    -1,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,  4505,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3793,
      -1,    -1,    -1,   896,    -1,    -1,    -1,    -1,    -1,  3803,
     903,    -1,    -1,    -1,   907,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
     923,    15,    16,    17,    -1,    -1,  3931,    -1,    -1,    -1,
    3935,  3936,  3937,  3938,   937,    -1,  3941,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
    4588,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3965,  3966,  3967,    -1,  3969,    -1,  3971,  3972,    -1,   176,
      -1,    -1,    -1,   976,   181,    -1,    70,    -1,  3983,  3984,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,  4004,
      -1,    -1,    -1,    -1,    -1,     8,  4011,  4012,    11,  4014,
     217,  1014,    15,    16,    17,    -1,    -1,    25,    -1,  3923,
      -1,  4026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,   249,    46,    -1,    -1,  1049,    -1,    -1,    -1,
    3954,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    71,    -1,    -1,  1069,    70,    -1,    -1,
    1073,  3975,    -1,    -1,    -1,    -1,    -1,    85,  1081,    -1,
      -1,  4086,   176,    -1,    -1,    -1,  3990,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,
      -1,   109,  4107,    -1,    -1,    -1,  1109,    -1,   202,   203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,
    1123,    -1,  1125,   217,    -1,    -1,    -1,    -1,   136,  4033,
      -1,    -1,  4137,    -1,    -1,    -1,   144,  1140,   345,    -1,
    1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,    -1,
      -1,    -1,  1155,   161,    -1,   249,    -1,    -1,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,   176,    -1,    -1,   184,    -1,   181,    -1,
      -1,  1184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,   209,    -1,    -1,    -1,    -1,  4211,    -1,    -1,  1212,
    1213,  1214,    -1,  1216,   217,    -1,    -1,    -1,  4122,    -1,
      -1,  4226,   230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   438,    -1,  1236,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,    -1,    -1,   249,    -1,    -1,    -1,
      -1,   345,    -1,    -1,   262,    -1,    -1,  1260,    -1,   262,
       8,    -1,   265,    11,  4168,  1268,  1269,    15,    16,    17,
      -1,    -1,    -1,    -1,  1277,  1278,   284,    -1,    -1,    -1,
     374,    -1,    -1,    -1,    32,    -1,   294,    -1,    -1,  4294,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,  1307,    -1,    -1,    -1,  1311,  1312,
    4315,    -1,    -1,   321,    -1,  4320,  4321,    -1,   326,    -1,
     328,    -1,    70,    -1,  1327,    -1,   334,    -1,    -1,   337,
    1333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   345,    -1,   438,    -1,    -1,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   365,   366,    -1,
    4365,   369,    -1,    -1,    -1,   373,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,   387,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4292,    -1,
    1393,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,    -1,  4411,    -1,    -1,    -1,
      -1,    -1,    -1,  4418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1430,   176,    -1,
      -1,    -1,    -1,   181,    -1,   438,    -1,    -1,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,  4453,    -1,
      -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,  4464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4486,    -1,    -1,    -1,    -1,  1489,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4400,    -1,    -1,    -1,
      -1,   249,    -1,    -1,  4509,    -1,    -1,  1510,    -1,    -1,
      -1,    -1,    -1,  4518,   262,    -1,    -1,   265,    -1,    -1,
      -1,    -1,  1525,    -1,  4428,    -1,    -1,    -1,    -1,    -1,
    1533,    -1,    -1,    -1,  4539,    -1,  1539,    -1,    -1,    -1,
      -1,  1544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1560,    -1,    -1,
      -1,  1564,  4466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1576,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1591,    -1,
      -1,    -1,    -1,    -1,    -1,  1598,    -1,   345,    -1,    -1,
      -1,  1604,    -1,    -1,    -1,    -1,    -1,  1610,    -1,    -1,
      -1,    -1,    -1,  1616,    -1,  4519,    -1,  4622,    -1,  4523,
    4524,    -1,    -1,    -1,    -1,  1628,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4644,
      -1,    -1,    -1,    -1,  1647,    -1,  1649,  1650,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1662,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1672,
      -1,    -1,  1675,  4678,  1677,  1678,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1689,    -1,  4693,    -1,
     438,    -1,    -1,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4615,    -1,    -1,    -1,    -1,    -1,    -1,  1721,    -1,
      -1,    -1,    -1,    -1,    -1,  4730,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1755,    -1,  1757,    -1,    -1,    -1,    -1,  1762,
    1763,    -1,    -1,    -1,    -1,    -1,  1769,  1770,  1771,    -1,
      -1,    -1,  1775,    -1,  1777,  1778,  1779,  1780,  1781,  1782,
      -1,  1784,    -1,  1786,  1787,    -1,    -1,  1790,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4801,    -1,    -1,    -1,
      -1,  1804,  1805,  1806,  1807,  1808,  1809,    -1,    -1,    -1,
    1813,    -1,    -1,    -1,  1817,    -1,    -1,  1820,    -1,    -1,
    1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,    -1,
    1833,    -1,  4837,    -1,    -1,    20,    -1,  1840,    -1,  1842,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   136,    -1,    -1,    -1,    -1,    -1,    20,    -1,   144,
      -1,    -1,    25,    -1,    -1,    -1,    -1,  1970,    -1,    -1,
      -1,   156,    -1,    -1,    37,    -1,    -1,    -1,   163,    -1,
      -1,    -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,   184,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2019,    -1,    -1,    -1,
    2023,  2024,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2033,    -1,    -1,    -1,  2037,  2038,   221,    -1,    -1,  2042,
     103,    -1,    -1,    -1,    -1,   230,    -1,  2050,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   125,    -1,    -1,  2068,    -1,    -1,  2071,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,   262,    -1,  2082,
     265,   144,    -1,  2086,    -1,    -1,  2089,    -1,    -1,    -1,
      -1,    -1,    -1,   156,    -1,  2098,    -1,    -1,   161,   284,
      -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,  2111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,
      -1,   184,    -1,    -1,    -1,    -1,  2129,  2130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2138,   321,    -1,    -1,    -1,
      -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,    -1,   334,
      -1,    -1,   337,    -1,    -1,    -1,    -1,  2160,  2161,    -1,
      -1,  2164,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   366,    -1,    -1,   369,   370,    -1,   372,   373,    -1,
    2193,    -1,    -1,    -1,  2197,    -1,    -1,   382,    -1,   262,
      -1,    -1,   387,    -1,    -1,    -1,    -1,    -1,   393,    -1,
     273,   396,  2215,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,   284,    -1,  2226,    -1,    -1,    -1,   412,    -1,    -1,
      -1,   294,    -1,    -1,    -1,    -1,  2239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,
      -1,    -1,    -1,   326,    -1,   328,    -1,    -1,    -1,    -1,
      -1,   334,    -1,    -1,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2292,
    2293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2301,    -1,
      -1,    -1,    -1,   366,    -1,    -1,   369,    -1,    -1,    -1,
     373,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,   382,
      -1,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2363,    -1,    -1,    -1,  2367,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2429,    -1,    -1,    -1,
      -1,  2434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2481,    -1,
    2483,    -1,    -1,    -1,    -1,    -1,    58,    -1,  2491,    -1,
      -1,    -1,  2495,    -1,    -1,  2498,    -1,    -1,  2501,    71,
      72,    -1,    -1,    -1,    -1,    -1,  2509,    -1,    -1,    81,
      -1,    -1,    -1,    85,    -1,    -1,  2519,    -1,    -1,    -1,
      -1,  2524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,
      -1,    -1,    -1,   208,  2547,  2548,  2549,    -1,    -1,  2552,
      -1,    -1,    -1,   125,   219,    -1,    -1,  2560,  2561,  2562,
    2563,    -1,    -1,    -1,   136,  2568,    -1,    -1,    -1,    -1,
    2573,  2574,   144,  2576,    -1,  2578,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   156,    -1,  2589,  2590,    -1,   161,
    2593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2607,    -1,  2609,    -1,  2611,    -1,
      -1,    -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2631,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,  2642,
      -1,  2644,  2645,  2646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2659,    -1,   230,  2662,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2674,    -1,    -1,    -1,    -1,  2679,    -1,    -1,    -1,
      -1,    -1,  2685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     262,    -1,  2695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2711,    -1,
      -1,  2714,   284,  2716,    -1,    -1,    -1,    -1,  2721,    -1,
    2723,    -1,   294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2739,  2740,    -1,    -1,
      -1,    -1,  2745,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,    -1,    -1,    -1,   326,    -1,   328,    -1,    -1,    -1,
      -1,    -1,   334,  2766,    -1,   337,  2769,    -1,    -1,  2772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2789,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   366,    -1,    -1,   369,    -1,    -1,
      -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,
     382,  2814,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     412,    -1,    -1,    -1,    -1,    -1,  2849,  2850,  2851,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2883,    -1,  2885,  2886,    -1,  2888,    -1,    -1,  2891,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2901,    -1,
      -1,    -1,    -1,    -1,    -1,   570,    -1,    -1,    -1,    -1,
     575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   602,    -1,    -1,
      -1,    -1,    -1,  2946,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   618,    -1,    -1,    -1,    -1,    -1,   624,
      -1,    -1,  2965,    -1,    -1,    -1,    -1,    -1,  2971,    -1,
     635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,    -1,    -1,
    3003,  3004,    -1,    -1,    -1,    -1,    -1,  3010,    -1,  3012,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3024,    -1,  3026,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3063,    -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3080,  3081,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3149,    -1,    -1,  3152,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3174,    -1,    -1,  3177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3194,    -1,    -1,  3197,    -1,    -1,    -1,    -1,    -1,
    3203,    -1,    -1,    -1,    -1,    -1,  3209,    -1,  3211,    -1,
      -1,  3214,    -1,    -1,    -1,  3218,  3219,  3220,  3221,  3222,
      -1,    -1,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,    -1,    -1,    -1,  3238,  3239,    -1,    -1,    -1,
    3243,    -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,  3252,
      -1,  3254,    -1,  3256,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3264,    -1,    -1,  3267,    -1,  3269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3277,  3278,    -1,    -1,  3281,  3282,
      -1,    -1,    -1,  3286,  3287,    -1,    -1,    -1,    -1,    -1,
    3293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3303,    -1,  3305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3317,    -1,    -1,    -1,    -1,    -1,
    3323,  3324,  3325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   613,    -1,    -1,    -1,
    3363,    -1,    -1,    -1,    -1,    -1,  3369,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   634,    -1,    -1,
      -1,  3384,    -1,    -1,  1049,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1069,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3416,    -1,    -1,  1081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3462,
    1125,    -1,    -1,    -1,  3467,  3468,  3469,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1140,    -1,    -1,  1143,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3521,    -1,
      -1,  3524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3586,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1260,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1268,  1269,    -1,  3609,  3610,    -1,    -1,
    3613,    -1,    -1,  1278,    -1,    -1,    -1,    -1,    -1,  3622,
      -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   903,    -1,    -1,   201,
      -1,    -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,  3662,
    3663,  3664,    -1,    -1,    -1,    -1,   923,   219,  1333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3739,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3750,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1014,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3780,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,  3791,    -1,
    3793,    -1,    -1,    -1,  3797,  3798,    -1,    -1,    -1,  3802,
    3803,    -1,    -1,    -1,  3807,    -1,    -1,  3810,  3811,    -1,
      -1,    -1,  3815,    -1,    -1,    -1,    -1,    -1,  3821,    -1,
      -1,    -1,    -1,    -1,  1489,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3839,    -1,    -1,    -1,
    3843,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3855,    -1,    -1,    -1,    -1,  3860,    -1,    -1,
      -1,    -1,    -1,  3866,    -1,    -1,  1123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1539,    -1,    -1,    -1,  3881,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1560,    -1,    -1,    -1,  1564,
      -1,    -1,  3905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3940,    -1,    -1,
      -1,    -1,  3945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3970,    -1,    -1,
      -1,    -1,  3975,    -1,    -1,    -1,    -1,    -1,    -1,  3982,
      -1,    -1,    -1,    -1,  1649,  1650,  3989,  3990,    -1,    -1,
    3993,    -1,    -1,    -1,    -1,    -1,    -1,  1662,    -1,    -1,
    4003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1677,  1678,    -1,    -1,    -1,    -1,   570,    -1,
      -1,    -1,    -1,   575,  1689,    -1,    -1,    -1,    -1,    -1,
    4033,    -1,    -1,    -1,   586,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     602,    -1,  4055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4066,    -1,    -1,   618,    -1,    -1,    -1,
    1327,    -1,   624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   635,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4120,    -1,  4122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1809,  4148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4164,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,
    4173,    -1,    -1,  1430,    -1,    -1,    -1,    -1,    -1,   731,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4190,  4191,    -1,
      -1,  4194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   725,   726,  4208,    -1,    -1,    -1,    -1,
    4213,    -1,    -1,    -1,    -1,  4218,    -1,    -1,  4221,  4222,
      -1,    -1,    -1,    -1,    -1,    -1,  4229,  4230,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   757,    -1,    -1,    -1,    -1,
      -1,    -1,  4245,    -1,    -1,    -1,    -1,    -1,    -1,  4252,
      -1,  4254,    -1,  1510,    -1,  4258,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1533,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1544,    -1,  4292,
    4293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1591,    -1,  4339,    -1,    -1,    -1,
      -1,    -1,  4345,    -1,    -1,    -1,    -1,  1604,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1616,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2033,    -1,
      -1,  1628,  2037,  2038,    -1,    -1,    -1,  2042,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2050,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4398,    -1,  4400,    -1,    -1,
      -1,    -1,    -1,  2068,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,  1675,    -1,
      -1,    -1,    -1,    -1,  4427,  4428,    -1,  4430,    -1,  4432,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2111,    -1,    -1,    -1,
      -1,    -1,    -1,  4456,    -1,    -1,    -1,  4460,    -1,    -1,
      -1,    -1,    -1,  4466,  2129,  2130,    -1,    -1,  4471,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2160,  2161,  1049,    -1,  2164,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4513,    -1,    -1,    -1,    -1,    -1,  4519,  1069,    -1,    -1,
    4523,  4524,    -1,    -1,    -1,  4528,    -1,    -1,  2193,  1081,
      -1,    -1,  2197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4544,    -1,    -1,    -1,    -1,    -1,  1804,    -1,    -1,
    2215,    -1,    -1,    -1,    -1,    -1,    -1,  1109,    -1,    -1,
      -1,  2226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4572,
      -1,    -1,    -1,  1125,  2239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2247,    -1,    -1,  1842,    -1,    -1,  1140,    -1,
    4593,  1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4614,  4615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4635,  1155,    -1,  4638,  2301,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4647,    -1,    -1,    -1,    -1,  4652,
      -1,  4654,    -1,  4656,    -1,    -1,    -1,    -1,    -1,    -1,
    4663,    -1,  1184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4680,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1212,  1213,  1214,    -1,  1216,    -1,    -1,    -1,  4701,    -1,
    4703,    -1,  2367,    -1,    -1,    -1,    -1,    -1,  1260,    -1,
      -1,    -1,    -1,    -1,  1236,    -1,  1268,  1269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1277,    -1,    -1,    -1,    -1,
      -1,    -1,  2019,    -1,  2429,    -1,  2023,  2024,  4771,  4772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4782,
      -1,  1333,    -1,    -1,    -1,  1307,    -1,  4790,    -1,  1311,
    1312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4802,
    2465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2491,    -1,    -1,  2086,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2098,   613,    -1,    -1,    -1,  4849,    -1,    -1,    -1,
      -1,    -1,  4855,  4856,  4857,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   634,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4876,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2138,    -1,    -1,    -1,  4888,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4902,
      -1,    -1,    -1,  2568,    -1,    -1,    -1,    -1,    -1,  2574,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1489,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4959,  4960,    -1,    -1,
      -1,    -1,  4965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4973,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4984,  4985,  4986,    -1,    -1,    -1,  1539,    -1,    -1,
      -1,    -1,    -1,    -1,  2659,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1560,    -1,
      -1,    -1,  1564,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1576,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2723,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2739,  2740,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1649,  1650,    -1,
      -1,  2766,    -1,    -1,  2769,    -1,  2363,    -1,    -1,    -1,
    1662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1677,  1678,    -1,    -1,    -1,
      -1,    -1,   903,    -1,    -1,    -1,    -1,  1689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   937,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2849,  2850,  2851,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2873,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2886,    -1,  2888,  2481,    -1,  2891,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2901,    -1,    -1,    -1,
    1762,  2498,    -1,  1014,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2509,  1775,    -1,  1777,    -1,  1809,  1780,  1781,
    1782,    -1,    -1,    -1,    -1,  1787,    -1,    -1,  1790,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1805,  1806,  1807,  1808,    -1,    -1,    -1,
      -1,  1813,    -1,    -1,    -1,  1817,    -1,    -1,  1820,    -1,
    2965,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
      -1,  1833,    -1,    -1,    -1,    -1,    -1,    -1,  1840,    -1,
    1842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,
      -1,    -1,    -1,    -1,    -1,  3010,    -1,  3012,    -1,    -1,
      -1,    -1,  1123,    -1,    -1,    -1,    -1,    -1,    -1,  3024,
      -1,  3026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2644,  2645,  2646,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1970,    -1,
      -1,    -1,    -1,    -1,  2711,    -1,    -1,  2714,    -1,  2716,
      -1,    -1,    -1,    -1,  2721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3137,    -1,    -1,    -1,    -1,    -1,    -1,   613,
      -1,  2033,    -1,    -1,    -1,  2037,  2038,  3152,    -1,    -1,
    2042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2050,    -1,
     634,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3174,
      -1,    -1,  3177,    -1,    -1,  2772,  2068,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2071,
      -1,    -1,    -1,    -1,    -1,    -1,  1327,  2814,    -1,  2111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2129,  2130,    -1,
      -1,   613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   634,    -1,    -1,    -1,    -1,    -1,  2160,  2161,
      -1,    -1,  2164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1393,    -1,    -1,    -1,  2883,    -1,  2885,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2193,    -1,    -1,    -1,  2197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1430,
      -1,    -1,    -1,  2215,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2239,    -1,  2946,
      -1,    -1,    -1,    -1,    -1,  2247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2971,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1510,
    2997,    -1,    -1,    -1,    -1,    -1,    -1,  3004,    -1,  2301,
      -1,  3416,    -1,    -1,  1525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1533,    -1,    -1,    -1,    -1,    -1,    -1,   903,
    2292,    -1,    -1,  1544,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3462,    -1,    -1,
      -1,    -1,  3467,   937,  3469,    -1,  3063,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2367,    -1,    -1,    -1,    -1,
    1591,    -1,    -1,    -1,  3081,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1604,    -1,    -1,    -1,  3094,    -1,    -1,
      -1,    -1,    -1,   613,    -1,  1616,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3521,  1628,    -1,  3524,
      -1,    -1,    -1,    -1,   634,    -1,    -1,    -1,    -1,    -1,
      -1,   903,    -1,    -1,    -1,    -1,    -1,  2429,    -1,    -1,
    1014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1672,    -1,    -1,  1675,   937,    -1,    -1,    -1,    -1,
      -1,    -1,  2434,  2465,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2491,
    3197,    -1,    -1,    -1,  3609,  3610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3622,    -1,  3624,
      -1,  3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1014,    -1,    -1,    -1,  3243,    -1,    -1,  1123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2519,    -1,    -1,
      -1,    -1,  2524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2568,    -1,    -1,    -1,
    3277,    -1,  2574,    -1,    -1,    -1,    -1,  2549,    -1,    -1,
      -1,    -1,    -1,  1804,    -1,    -1,    -1,    -1,  2560,    -1,
    2562,  2563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2573,    -1,  3718,  2576,    -1,  2578,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2607,    -1,  2609,    -1,  2611,
      -1,  1123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2659,    -1,    -1,
      -1,    -1,  3369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2644,  2645,  2646,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   903,    -1,    -1,    -1,    -1,    -1,    -1,
    2662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2674,   923,    -1,    -1,    -1,  2679,    -1,    -1,
      -1,    -1,    -1,  2685,    -1,    -1,    -1,   937,    -1,    -1,
      -1,  2723,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2739,  2740,    -1,
      -1,    -1,    -1,  1327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3468,    -1,    -1,  2766,    -1,    -1,  2769,    -1,    -1,
      -1,    -1,    -1,  2745,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1014,    -1,    -1,    -1,  2019,    -1,
      -1,    -1,  2023,  2024,    -1,    -1,    -1,    -1,    -1,  1393,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3940,    -1,    -1,    -1,    -1,
    3945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1327,  1430,  2849,  2850,  2851,
      -1,    -1,    -1,    -1,    -1,  3970,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2086,    -1,  3982,    -1,    -1,
      -1,  2873,    -1,    -1,  3989,    -1,    -1,  2098,    -1,    -1,
      -1,    -1,    -1,    -1,  2886,    -1,  2888,    -1,  4003,  2891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2901,
      -1,    -1,    -1,  1123,    -1,    -1,  3613,    -1,    -1,    -1,
      -1,  1393,    -1,    -1,    -1,    -1,    -1,  2138,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1510,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1525,    -1,    -1,    -1,    -1,    -1,    -1,  1430,  1533,
      -1,    -1,    -1,    -1,    -1,  3662,    -1,    -1,    -1,    -1,
    1544,    -1,    -1,  2965,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,    -1,    -1,  1591,  3010,    -1,
    3012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1604,    -1,  3024,    -1,  3026,    -1,    -1,    -1,  1510,    -1,
      -1,    -1,  1616,  4148,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1525,  1628,    -1,    -1,    -1,    -1,    -1,
      -1,  1533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2293,    -1,    -1,    -1,    -1,    -1,  3080,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3793,    -1,  1672,    -1,
      -1,  1675,    -1,    -1,    -1,    -1,  3803,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1327,    -1,  1591,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1616,  3137,    -1,  4252,    -1,  4254,
      -1,    -1,  2363,    -1,    -1,    -1,  1628,    -1,  3855,    -1,
    3152,    -1,    -1,  3860,    -1,    -1,    -1,    -1,    -1,  3866,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3174,  1393,    -1,  3177,    -1,    -1,  4293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1672,    -1,    -1,  1675,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1430,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,
    1804,    -1,  3194,    -1,  4339,    -1,    -1,    -1,    -1,    -1,
      -1,  3203,    -1,    -1,    -1,    -1,    -1,  3209,    -1,  3211,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3954,    -1,    -1,
      -1,    -1,  3254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2481,    -1,    -1,    -1,    -1,    -1,  3238,  3239,  3975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,    -1,
      -1,    -1,    -1,  3990,  3256,    -1,    -1,    -1,  2509,    -1,
    1510,    -1,  3264,    -1,    -1,  3267,    -1,  3269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1525,  3278,    -1,    -1,    -1,
      -1,    -1,    -1,  1533,  3286,  3287,    -1,    -1,    -1,    -1,
      -1,    -1,  1804,    -1,  1544,    -1,  4033,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3317,    -1,    -1,    -1,    -1,
      -1,  3323,  3324,  3325,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1591,    -1,    -1,    -1,    -1,    -1,    -1,  3350,    -1,
      -1,    -1,    -1,    -1,  1604,    -1,    -1,    -1,    -1,    -1,
      -1,  3363,    -1,    -1,    -1,    -1,  1616,    -1,  4513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1628,    -1,
      -1,    -1,    -1,  4120,  3416,  4122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4544,
      -1,    -1,    -1,    -1,    -1,  2019,    -1,    -1,    -1,  2023,
    2024,    -1,    -1,    -1,    -1,   613,    -1,    -1,    -1,    -1,
      -1,    -1,  1672,    -1,    -1,  1675,    -1,    -1,    -1,    -1,
    3462,  4168,    -1,    -1,    -1,  3467,   634,  3469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2711,    -1,    -1,  2714,    -1,  2716,    -1,    -1,    -1,    -1,
    2721,    -1,  2086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2098,    -1,    -1,    -1,    -1,  3521,
      -1,    -1,  3524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2019,    -1,    -1,
      -1,  2023,  2024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2772,    -1,    -1,  2138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2789,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1804,  4292,  4701,    -1,  4703,    -1,
      -1,    -1,    -1,  2814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2086,    -1,    -1,  3609,  3610,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2098,    -1,    -1,    -1,
    3622,    -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,   613,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     634,    -1,    -1,    -1,    -1,    -1,  2138,    -1,    -1,    -1,
      -1,    -1,  2883,    -1,  2885,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4790,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3663,  3664,  4400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2293,
      -1,    -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,    -1,
      -1,  4428,    -1,    -1,    -1,  2946,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   903,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2971,    -1,    -1,    -1,    -1,   923,    -1,    -1,    -1,  4466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3739,    -1,   937,
      -1,    -1,    -1,  4888,    -1,    -1,  2997,    -1,  3750,  2363,
      -1,    -1,    -1,  3004,    -1,    -1,    -1,  4902,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2019,
      -1,    -1,    -1,  2023,  2024,    -1,    -1,    -1,    -1,    -1,
      -1,  2293,  4519,    -1,    -1,    -1,  4523,  4524,  3790,  3791,
      -1,    -1,    -1,    -1,    -1,  3797,  3798,    -1,    -1,    -1,
    3802,    -1,    -1,    -1,    -1,  3807,    -1,    -1,  3810,  3811,
      -1,    -1,  3063,  3815,    -1,    -1,  1014,    -1,    -1,  3821,
    4965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3081,    -1,    -1,    -1,    -1,    -1,  2086,    -1,    -1,  4984,
      -1,    -1,    -1,  3094,    -1,    -1,    -1,    -1,  2098,    -1,
      -1,  2363,    -1,  3855,    -1,    -1,    -1,    -1,  3860,    -1,
      -1,    -1,    -1,    -1,  3866,    -1,    -1,  2481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4614,  4615,  3881,
      -1,    -1,    -1,    -1,  2498,    -1,    -1,    -1,  2138,   903,
      -1,    -1,    -1,    -1,    -1,  2509,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3905,    -1,    -1,    -1,    -1,  3940,   923,
      -1,    -1,    -1,  3945,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   937,    -1,  1123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3197,    -1,    -1,    -1,
    3982,    -1,    -1,    -1,    -1,    -1,    -1,  3989,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3218,    -1,  2481,
      -1,  4003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,    -1,    -1,
      -1,  3993,  3243,    -1,    -1,    -1,    -1,  2509,    -1,    -1,
    1014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4055,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2711,    -1,    -1,
    2714,    -1,  2716,    -1,    -1,    -1,    -1,  2721,    -1,  1123,
      -1,    -1,    -1,  2363,    -1,    -1,  4148,    -1,  3369,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1327,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2789,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4190,  4191,
      -1,    -1,  4194,    -1,    -1,  1393,    -1,    -1,    -1,  2711,
    2814,    -1,  2714,    -1,  2716,    -1,    -1,    -1,    -1,  2721,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3468,    -1,    -1,
    4252,    -1,  4254,    -1,    -1,    -1,    -1,  4229,  4230,    -1,
      -1,  2481,  1430,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2509,
    2772,  4293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,
      -1,  2885,    -1,    -1,    -1,    -1,    -1,  2789,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2814,    -1,    -1,    -1,    -1,  4339,    -1,    -1,
      -1,    -1,  1510,  1327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1525,    -1,    -1,
      -1,    -1,  2946,    -1,    -1,  1533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1544,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2971,    -1,    -1,
      -1,    -1,  3613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2883,    -1,  2885,    -1,    -1,    -1,    -1,    -1,  1393,
      -1,    -1,    -1,  2997,    -1,    -1,    -1,    -1,    -1,    -1,
    3004,    -1,    -1,  1591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1604,    -1,    -1,    -1,
      -1,  3662,    -1,    -1,    -1,    -1,  1430,    -1,  1616,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4430,    -1,
    1628,    -1,    -1,    -1,  2946,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3063,
      -1,    -1,    -1,    -1,  4456,    -1,    -1,    -1,    -1,  2971,
      -1,  2711,    -1,    -1,  2714,    -1,  2716,  3081,    -1,  4471,
      -1,  2721,    -1,    -1,  1672,    -1,    -1,  1675,    -1,    -1,
    3094,  4513,    -1,    -1,    -1,  2997,    -1,    -1,  4490,    -1,
      -1,    -1,  3004,    -1,    -1,    -1,  1510,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1525,  4544,    -1,    -1,    -1,    -1,    -1,    -1,  1533,
      -1,    -1,  2772,    -1,    -1,    -1,  4528,    -1,    -1,    -1,
    1544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2789,
      -1,    -1,  3793,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3063,  3803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2814,    -1,    -1,    -1,    -1,  3081,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1591,    -1,    -1,
      -1,    -1,  3094,  3197,    -1,    -1,    -1,    -1,    -1,    -1,
    1604,  4593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1616,    -1,  3218,    -1,  1804,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1628,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3243,
      -1,    -1,    -1,  2883,    -1,  2885,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4656,    -1,    -1,    -1,  1672,    -1,
      -1,  1675,    -1,  3277,    -1,    -1,    -1,    -1,    -1,  4701,
      -1,  4703,  3923,    -1,    -1,    -1,    -1,    -1,  4680,    -1,
      -1,    -1,    -1,    -1,    -1,  3197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2946,    -1,    -1,    -1,
      -1,    -1,    -1,  3954,    -1,    -1,  3218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2971,    -1,    -1,  3975,    -1,    -1,    -1,    -1,    -1,
      -1,  3243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,
      -1,    -1,    -1,    -1,  3004,  3369,    -1,    -1,  4790,    -1,
      -1,    -1,    -1,    -1,    -1,  3277,    -1,    -1,    -1,  4771,
    4772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4782,    -1,  4033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1804,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3063,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2019,    -1,    -1,    -1,  2023,  2024,    -1,    -1,    -1,
      -1,  3081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3094,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3468,  4857,  4888,  3369,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4902,  4122,    -1,    -1,  4876,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2086,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4965,    -1,    -1,    -1,    -1,    -1,    -1,
    2138,    -1,    -1,    -1,    -1,    -1,    -1,  3197,    -1,    -1,
      -1,    -1,  4984,    -1,    -1,    -1,  3468,  4959,  4960,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3218,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3243,    -1,  1228,    -1,    -1,    -1,  3613,
      -1,    -1,    -1,    -1,    -1,  2019,    -1,    -1,    -1,  2023,
    2024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4292,    -1,    -1,    -1,    -1,    -1,    -1,  3662,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2098,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2293,    -1,    -1,    -1,    -1,
      -1,  3613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3369,
      -1,    -1,    -1,    -1,  2138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4400,
    3662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2363,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4428,    -1,  3793,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4466,    -1,    -1,  3468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4519,    -1,
      -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,  2293,
      -1,  3793,    -1,  2481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,
      -1,  2509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2363,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3975,    -1,  3613,  4615,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,  3662,    -1,    -1,    -1,    -1,    -1,    -1,  4033,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3975,    -1,    -1,    -1,  2481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3990,    -1,
      -1,    -1,    -1,    -1,  2498,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2509,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4122,    -1,
      -1,    -1,    -1,  2711,    -1,    -1,  2714,    -1,  2716,    -1,
      -1,  4033,    -1,  2721,    -1,    -1,    -1,  1760,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1774,    -1,  3793,    -1,  1778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3803,  4168,    -1,    -1,    -1,    -1,  1792,
    1793,  1794,    -1,  1796,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2772,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1838,    -1,    -1,    -1,    -1,
    4122,    -1,    -1,    -1,    -1,    -1,  2814,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,  4292,    -1,
      -1,    -1,    -1,    -1,    -1,  2883,    -1,  2885,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2711,    -1,    -1,
    2714,    -1,  2716,    -1,  3954,    -1,    -1,  2721,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3975,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3990,    -1,    -1,    -1,    -1,    -1,    -1,  1980,  2946,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,  1992,
      -1,    -1,  1995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2971,    -1,  2789,    -1,    -1,    -1,    -1,
    4292,    -1,    -1,  4033,    -1,    -1,  4400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2997,
    2814,    -1,    -1,    -1,    -1,    -1,  3004,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4428,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3063,    -1,    -1,    -1,  2883,
      -1,  2885,  4122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3081,    -1,    -1,    -1,    -1,  4400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3094,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4519,    -1,    -1,    -1,  4523,
    4524,    -1,    -1,    -1,    -1,    -1,  4428,    -1,  4168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4466,    -1,    -1,  2971,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2997,    -1,    -1,    -1,    -1,    -1,    -1,
    3004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3197,
      -1,  4615,    -1,    -1,    -1,    -1,    -1,  4519,    -1,    -1,
      -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4292,    -1,    -1,  3243,    -1,    -1,    -1,  3063,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3081,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3277,
    3094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4615,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3369,    -1,    -1,    -1,    -1,    -1,    -1,  4428,    -1,
      -1,    -1,    -1,  3197,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3218,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3277,    -1,    -1,    -1,    -1,    -1,  4519,
    3468,    -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2522,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2542,
      -1,  2544,    -1,    -1,  2547,  2548,    -1,  2550,    -1,  2552,
      -1,    -1,    -1,  2556,    -1,    -1,  2559,    -1,    -1,    -1,
      -1,  2564,    -1,    -1,    -1,    -1,    -1,  2570,    -1,    -1,
      -1,    -1,  2575,    -1,    -1,    -1,    -1,    -1,    -1,  2582,
    2583,  2584,  2585,    -1,    -1,  3369,  2589,  2590,    -1,  2592,
      -1,    -1,    -1,    -1,    -1,  4615,    -1,    -1,    -1,    -1,
      -1,  2604,    -1,  2606,    -1,    -1,    -1,    -1,    -1,    -1,
    2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3613,    -1,  2650,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3662,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2760,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3793,    -1,    -1,    -1,  3613,
      -1,    -1,    -1,    -1,    -1,  3803,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3662,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3954,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3000,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3975,    -1,  3793,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,
      -1,    -1,  3990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4033,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3140,    -1,  3923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3193,  3975,    -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,
    4168,    -1,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,
      -1,    -1,  3215,  3216,    -1,    -1,  3219,  3220,  3221,  3222,
      -1,    -1,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4033,
      -1,    -1,    -1,    -1,  3257,    -1,    -1,  3260,    -1,  3262,
      -1,    -1,  3265,  3266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3280,  3281,  3282,
    3283,    -1,  3285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4292,    -1,    -1,    -1,    -1,    -1,
    3333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4122,    -1,
      -1,  3344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3381,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4519,    -1,    -1,    -1,  4523,  4524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3586,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4428,    -1,    -1,  4615,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4519,    -1,  3740,    -1,  4523,
    4524,  3744,  3745,  3746,    -1,    -1,    -1,    -1,    -1,  3752,
    3753,  3754,  3755,    -1,    -1,    -1,    -1,  3760,  3761,  3762,
    3763,  3764,  3765,  3766,  3767,  3768,  3769,  3770,  3771,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3796,    -1,    -1,  3799,    -1,  3801,    -1,
      -1,    -1,  3805,    -1,    -1,  3808,  3809,    -1,    -1,  3812,
    3813,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3857,    -1,    -1,    -1,    -1,    -1,
      -1,  3864,  3865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3880,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4058,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4117,  4118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4158,    -1,    -1,    -1,    -1,
    4163,  4164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4178,    -1,  4180,    -1,    -1,
      -1,  4184,  4185,  4186,    -1,    -1,  4189,    -1,    -1,  4192,
    4193,    -1,    -1,    -1,  4197,    -1,    -1,    -1,  4201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4256,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4316,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4426,  4427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4442,
    4443,  4444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4478,  4479,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4627,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4692,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4800,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,  4860,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,  4931,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,  4972,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,    -1,    -1,
      -1,    -1,    -1,    -1,   454,   455,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,    -1,   440,    -1,    -1,    -1,    -1,   445,   446,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,   455,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,   455,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,    -1,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   454,   455,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,    -1,    -1,     3,    -1,    -1,    -1,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,   455,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,    -1,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,    -1,    -1,   394,   395,   396,   397,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
      -1,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   455,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,    -1,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,    -1,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,    -1,
     382,    -1,    -1,   385,   386,   387,   388,   389,   390,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,   437,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,   455,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,    -1,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,    -1,   382,    -1,    -1,   385,   386,   387,   388,
     389,   390,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,   417,    -1,
      -1,   420,   421,   422,   423,   424,   425,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,   435,   436,   437,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,   455,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,    -1,   440,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,    -1,   440,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,
      -1,    -1,   452,   453,   454,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
      -1,    -1,    -1,    -1,    -1,    -1,   454,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,    -1,
      -1,   417,    -1,    -1,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   454,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,    -1,
      -1,   417,    -1,    -1,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   454,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,    -1,
      -1,   417,    -1,    -1,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,     3,
       4,     5,     6,     7,   454,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,     3,     4,     5,     6,
       7,    -1,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,   414,    -1,    -1,
     417,    -1,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,   454,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,    -1,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
       3,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   454,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,   440,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   454,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,    -1,   283,   284,
     285,   286,   287,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,    -1,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,   414,
      -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,    -1,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   454,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,     3,    -1,    -1,    -1,
      -1,   445,   446,   447,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,   440,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,    -1,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,   414,    -1,    -1,   417,    -1,
      -1,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   454,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,    -1,   411,
     412,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,    -1,   440,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,    -1,   367,    -1,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,    -1,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,    -1,   216,
      -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,    -1,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,    -1,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,
     417,    -1,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,    -1,   367,    -1,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,    -1,    -1,   394,   395,   396,   397,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
      -1,   411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   454,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,
      -1,   454,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    -1,   167,    -1,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,    -1,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,    -1,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   435,   436,   437,    -1,    -1,    -1,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,     3,     4,
       5,    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
      -1,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,    -1,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,   437,    -1,     3,    -1,   441,   442,   443,     8,
     445,   446,   447,   448,   449,   450,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,    -1,   364,   365,    -1,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,    -1,   411,   412,   413,   414,    -1,    -1,   417,    -1,
      -1,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
       3,    -1,   441,   442,   443,     8,   445,   446,   447,   448,
     449,   450,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,     3,    -1,   441,   442,
     443,     8,   445,   446,   447,   448,   449,   450,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,    -1,   216,
      -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,    -1,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,    -1,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,
     417,    -1,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,     3,    -1,   441,   442,   443,     8,   445,   446,
     447,   448,   449,   450,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,    -1,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,    -1,    -1,   204,    -1,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,
     221,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,    -1,   247,   248,    -1,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,    -1,   364,   365,    -1,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,    -1,
     411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,     3,    -1,
     441,   442,   443,     8,   445,   446,   447,   448,   449,   450,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,
      -1,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
      -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,    -1,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,    -1,   283,   284,
     285,   286,   287,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,    -1,   364,
     365,    -1,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,    -1,   411,   412,   413,   414,
      -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,     3,    -1,   441,   442,   443,     8,
     445,   446,   447,   448,   449,   450,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,    -1,   364,   365,    -1,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,    -1,   411,   412,   413,   414,    -1,    -1,   417,    -1,
      -1,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
       3,    -1,   441,   442,   443,     8,   445,   446,   447,   448,
     449,   450,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,    -1,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,    -1,   382,    -1,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,    -1,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,    -1,   382,    -1,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,   447,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,     4,     5,    -1,    -1,
      -1,     9,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,     4,     5,    -1,    -1,    -1,     9,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,     5,    -1,    -1,
      -1,     9,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,     9,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,   159,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,     4,     5,    -1,    -1,
      -1,     9,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    -1,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,   164,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,   164,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,   261,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,   261,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,   261,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,    -1,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,    -1,   367,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,    -1,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,    -1,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,    -1,   411,   412,
     413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,    -1,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,    -1,   382,    -1,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,   437,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,    -1,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,    -1,   283,   284,
      -1,   286,    -1,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,    -1,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,    -1,   382,    -1,    -1,
     385,   386,   387,   388,   389,   390,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,   401,   402,   403,   404,
     405,    -1,   407,    -1,   409,   410,   411,   412,   413,   414,
      -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,   424,
     425,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,   437,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,    -1,   367,    -1,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,    -1,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    -1,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,    -1,
      -1,    -1,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,    -1,   215,   216,
     217,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,    -1,   283,   284,    -1,   286,
      -1,   288,   289,   290,    -1,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,    -1,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,    -1,   382,    -1,    -1,   385,   386,
     387,   388,   389,   390,   391,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,   401,   402,   403,   404,   405,    -1,
     407,    -1,   409,   410,   411,   412,   413,   414,    -1,    -1,
     417,    -1,    -1,   420,   421,   422,   423,   424,   425,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
     437,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
      -1,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,    -1,   283,
     284,    -1,   286,    -1,   288,   289,   290,    -1,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
      -1,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,    -1,   382,    -1,
      -1,   385,   386,   387,   388,   389,   390,   391,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,   401,   402,   403,
     404,   405,    -1,   407,    -1,   409,   410,   411,   412,   413,
     414,    -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,
     424,   425,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,   437,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,    -1,   215,   216,   217,    -1,   219,   220,
     221,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,    -1,   283,   284,    -1,   286,    -1,   288,   289,   290,
      -1,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,    -1,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
      -1,   382,    -1,    -1,   385,   386,   387,   388,   389,   390,
     391,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
     401,   402,   403,   404,   405,    -1,   407,    -1,   409,   410,
     411,   412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,
     421,   422,   423,   424,   425,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,   436,   437,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,    -1,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,    -1,   382,    -1,    -1,   385,   386,   387,
     388,   389,   390,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,   401,   402,   403,   404,   405,    -1,   407,
      -1,   409,   410,   411,   412,   413,   414,    -1,    -1,   417,
      -1,    -1,   420,   421,   422,   423,   424,   425,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,   437,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,    -1,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,    -1,   283,   284,
      -1,   286,    -1,   288,   289,   290,    -1,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,    -1,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,    -1,   382,    -1,    -1,
     385,   386,   387,   388,   389,   390,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,   401,   402,   403,   404,
     405,    -1,   407,    -1,   409,   410,   411,   412,   413,   414,
      -1,    -1,   417,    -1,    -1,   420,   421,   422,   423,   424,
     425,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,   436,   437,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
      -1,   283,   284,    -1,   286,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,    -1,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,    -1,
     382,    -1,    -1,   385,   386,   387,   388,   389,   390,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,   401,
     402,   403,   404,   405,    -1,   407,    -1,   409,   410,   411,
     412,   413,   414,    -1,    -1,   417,    -1,    -1,   420,   421,
     422,   423,   424,   425,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   435,   436,   437,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,   283,   284,    -1,   286,    -1,   288,
     289,   290,    -1,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,    -1,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,    -1,   382,    -1,    -1,   385,   386,   387,   388,
     389,   390,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   401,   402,   403,   404,   405,    -1,   407,    -1,
     409,   410,   411,   412,   413,   414,    -1,    -1,   417,    -1,
      -1,   420,   421,   422,   423,   424,   425,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   435,   436,   437,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    -1,    -1,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
      -1,    -1,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,    -1,   148,    -1,   150,   151,    -1,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
      -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,    -1,   192,   193,   194,   195,
      -1,    -1,    -1,    -1,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,    -1,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,    -1,   243,   244,    -1,
      -1,   247,   248,   249,   250,    -1,    -1,   253,    -1,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,    -1,   283,   284,    -1,
     286,    -1,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,    -1,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,    -1,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
      -1,    -1,    -1,   379,   380,    -1,   382,    -1,    -1,   385,
     386,   387,   388,   389,   390,   391,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,   409,   410,   411,   412,   413,   414,    -1,
      -1,   417,    -1,    -1,   420,   421,   422,   423,   424,   425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,
     436,   437
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    18,    28,    30,    31,    45,    65,    67,    68,    73,
      75,    86,    88,   105,   108,   121,   123,   127,   133,   141,
     143,   149,   164,   180,   219,   220,   225,   237,   248,   281,
     289,   301,   306,   307,   309,   314,   319,   322,   327,   332,
     333,   340,   344,   354,   366,   385,   395,   401,   406,   419,
     440,   454,   461,   462,   463,   464,   470,   471,   473,   474,
     475,   476,   477,   478,   479,   481,   482,   486,   498,   503,
     504,   507,   508,   509,   521,   524,   525,   541,   578,   581,
     584,   585,   586,   593,   599,   601,   603,   604,   607,   610,
     611,   615,   616,   625,   629,   630,   631,   632,   633,   636,
     638,   639,   640,   641,   642,   649,   650,   663,   664,   668,
     670,   671,   672,   682,   684,   691,   692,   695,   696,   697,
     698,   699,   705,   707,   710,   714,   718,   719,   729,   730,
     733,   738,   749,   772,   775,   776,   777,   780,   783,   785,
     787,   789,   790,   795,   796,   799,   800,   801,   804,   805,
     812,   813,   815,   816,   817,   822,   824,   825,   831,   832,
     833,   834,   835,   836,   838,   839,   841,   842,   844,   847,
     848,   853,   859,   862,   864,   865,   873,   875,   880,   887,
     891,   892,   893,   894,   895,   896,   899,   934,   379,   422,
     818,    25,    71,    85,   103,   109,   125,   136,   144,   156,
     161,   167,   184,   209,   230,   262,   284,   294,   321,   326,
     328,   334,   337,   365,   366,   369,   373,   382,   387,   399,
     412,   600,   818,     3,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    37,    38,    40,    41,
      43,    44,    45,    46,    47,    49,    50,    52,    53,    54,
      55,    56,    59,    60,    61,    62,    63,    65,    66,    67,
      68,    69,    73,    74,    75,    76,    78,    79,    80,    82,
      83,    84,    85,    86,    87,    90,    91,    92,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   110,   112,   113,
     114,   115,   116,   117,   119,   120,   121,   124,   125,   126,
     127,   128,   130,   131,   132,   134,   135,   136,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   148,   150,   151,
     152,   153,   155,   157,   161,   162,   163,   165,   166,   168,
     169,   171,   172,   173,   174,   175,   177,   178,   179,   180,
     182,   183,   184,   185,   186,   187,   189,   191,   192,   193,
     194,   195,   196,   197,   199,   201,   204,   206,   207,   208,
     209,   210,   213,   214,   216,   219,   220,   221,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   242,   243,   244,   245,   247,
     248,   250,   252,   253,   254,   255,   256,   257,   259,   262,
     263,   264,   267,   268,   270,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   283,   284,   285,   286,   287,   288,
     289,   290,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   318,   319,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     334,   335,   336,   337,   338,   340,   341,   342,   343,   344,
     346,   347,   348,   349,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   364,   365,   367,   369,
     370,   371,   372,   373,   375,   376,   379,   380,   381,   382,
     383,   385,   386,   387,   388,   389,   390,   391,   394,   395,
     396,   397,   398,   401,   402,   403,   404,   405,   406,   407,
     409,   411,   412,   413,   414,   417,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   888,  1056,  1070,  1074,  1075,   410,
     849,   260,   290,   818,    48,   454,   532,    20,    25,    37,
      58,    71,    81,   103,   109,   125,   136,   144,   156,   163,
     167,   221,   262,   265,   284,   321,   328,   337,   369,   370,
     372,   373,   382,   387,   393,   396,   399,   542,   583,   687,
     739,   750,    26,   289,  1056,   888,    26,   283,   335,   370,
     372,     5,   208,   781,   782,  1065,    20,    25,    37,    58,
      71,    85,   103,   125,   136,   144,   156,   161,   167,   184,
     230,   262,   273,   284,   321,   326,   328,   334,   337,   366,
     369,   373,   380,   382,   387,   399,   412,   600,   700,   818,
    1056,    88,   410,   454,   578,   581,   584,   848,   854,   862,
     865,   873,   880,   887,   891,     9,    19,    26,    43,   151,
     157,   159,   181,   210,   243,   292,   308,   445,   446,   715,
     716,   888,  1064,  1066,    26,    88,   305,   333,   720,   721,
     722,  1070,   156,  1070,  1061,  1065,   366,   902,   715,  1070,
     314,   340,   344,   379,  1056,   273,   230,   103,   184,   328,
     365,   366,   454,   791,   792,   327,  1070,    26,   338,   375,
     379,   490,   499,   500,  1070,    23,   164,   720,   721,   290,
     818,  1070,   207,    26,   122,   904,   905,    59,    82,   221,
     239,   321,   328,   338,   375,   379,   425,   487,   488,   489,
     490,    26,   338,   375,   379,   490,   379,   261,   945,  1054,
    1070,   902,   447,  1070,   160,   454,   850,   454,  1049,   303,
     897,   898,  1056,   897,   892,   893,   896,     0,   457,   849,
     137,   198,   266,   392,   906,   907,   892,   894,   895,   114,
     194,   398,   458,     3,    42,    48,    71,    77,    89,    96,
     158,   160,   176,   190,   202,   203,   205,   215,   217,   241,
     249,   269,   271,   320,   345,   368,   410,  1062,  1070,  1071,
    1074,  1076,   702,  1070,   702,  1057,  1070,   293,   702,   382,
     702,  1056,  1070,   102,   366,   728,  1062,     3,    99,   339,
    1067,  1068,  1072,  1074,  1075,  1076,    26,   175,  1054,   255,
     412,     8,    15,    16,    17,    66,   148,   441,   442,   443,
     445,   446,   447,   448,   449,   450,   779,  1015,  1016,  1070,
     175,  1056,    26,  1067,  1068,  1056,  1056,   175,  1054,  1056,
     314,   340,    26,   175,   945,  1056,   330,  1056,   702,   228,
    1067,  1068,   175,  1054,   208,   111,   204,   246,   299,   819,
     820,   821,  1054,  1060,  1070,    20,    25,    58,    71,    72,
      81,    85,   103,   125,   136,   144,   156,   161,   184,   209,
     230,   262,   284,   321,   326,   328,   334,   337,   366,   369,
     373,   380,   382,   387,   412,   600,   708,  1065,   861,   865,
     873,   880,   891,  1054,   232,  1062,  1056,   454,   702,   382,
    1057,   702,   382,   175,  1056,   102,   366,   370,   372,  1067,
    1068,   370,   372,    66,   148,   779,   312,  1056,  1067,   175,
     483,  1070,  1056,  1056,   330,  1056,   702,   228,  1067,   303,
     334,   366,   412,   230,    85,   184,   161,   326,   380,   386,
     594,    26,  1056,   889,   497,  1065,  1072,   782,   232,   175,
    1062,  1056,   175,   786,   175,  1057,     3,    47,    49,    50,
      61,    62,   106,   107,   126,   152,   175,   196,   197,   199,
     240,   242,   254,   300,   342,   348,   375,   376,   407,   704,
     960,   962,   964,   966,   968,   970,   971,   972,   974,   975,
     976,   979,   980,  1071,  1074,   382,   102,   366,   175,  1062,
     175,  1068,  1069,    77,   412,    66,   148,   175,   779,    52,
     175,  1056,   175,  1069,   175,  1056,   175,  1056,   175,  1056,
     330,   786,   175,  1056,   175,   704,   175,   228,  1069,   208,
     175,   701,   702,   454,   863,   542,   854,   406,   848,   855,
     856,   857,  1072,   849,  1066,   716,   717,    26,   717,  1066,
     717,    26,   717,  1066,   717,   717,   717,  1066,  1064,  1064,
     888,   717,   293,   454,   454,   561,   561,   561,   260,   377,
     458,   561,   328,   945,   946,   458,   814,   500,   488,   490,
      26,   490,  1065,   454,   860,    52,   412,   410,   793,   794,
    1054,  1056,  1070,    42,   437,   204,   456,   263,   263,   260,
     159,  1065,   377,   154,   711,   260,     4,     6,     7,     8,
      10,    34,    47,    49,    50,    57,    58,    61,    62,    69,
      71,    93,    94,    95,    96,    97,    98,    99,   106,   107,
     142,   146,   147,   152,   166,   168,   196,   197,   199,   214,
     222,   223,   240,   242,   246,   251,   252,   254,   262,   272,
     285,   300,   324,   339,   348,   362,   375,   376,   381,   383,
     384,   393,   399,   407,   427,   428,   429,   430,   431,   432,
     433,   434,   438,   445,   446,   447,   454,   892,   963,   966,
     969,   970,   971,   973,   974,   975,   979,   980,   984,   986,
     987,   988,   990,  1011,  1012,  1013,  1017,  1036,  1041,  1051,
    1052,  1062,  1063,  1064,  1065,  1070,  1050,  1051,  1065,    26,
     505,  1053,  1054,   338,   487,   109,   496,  1065,   497,  1065,
      42,    63,   487,   437,   349,   820,   263,   159,   377,   443,
      42,   437,   204,   821,   454,  1054,   447,   452,   456,  1042,
    1044,   946,     3,   158,   160,   410,   845,   846,   848,   158,
     851,   109,   984,  1047,  1048,   897,   458,   454,   852,   455,
     455,   463,  1054,    26,   122,   903,   903,    52,   903,   149,
     154,   218,   258,   910,   912,   913,   928,   930,   931,   932,
     906,   907,   159,   200,   945,   947,  1049,   454,   762,  1044,
     274,   310,   340,   456,   703,   274,   310,   340,     3,    80,
     131,   224,   274,   281,   310,   340,   369,   371,   419,   498,
     501,   826,   827,   828,   829,   734,    22,   127,   274,   310,
     340,   403,   512,  1056,   340,    22,   127,   398,   480,   423,
     175,   945,    54,    87,   117,   145,   178,   213,   246,   274,
     275,   310,   318,   325,   332,   340,   352,   360,   414,   498,
     502,   765,   773,   454,   751,   310,   480,   181,   142,    22,
      28,    68,   117,   120,   127,   130,   155,   186,   244,   246,
     256,   264,   274,   310,   313,   314,   340,   403,   510,   511,
     619,     4,   446,   591,  1066,    26,   175,  1054,   702,   702,
     454,   778,   456,   142,   260,   181,   472,   310,   419,   440,
     465,   472,   260,   274,   310,   142,    53,   101,   183,   231,
     234,   244,   273,   310,   315,   340,   354,   510,   588,   589,
     274,   310,   411,   619,   627,   500,   488,   181,   142,   310,
     340,   510,   274,   310,   314,   340,    78,   119,   276,   371,
     260,    22,    28,   127,   274,   310,   340,   522,   523,   154,
     310,   340,   465,   501,   142,   310,   340,   510,  1056,   216,
     111,   261,   424,   458,   819,   400,   843,   260,   232,  1062,
     454,  1056,   960,   382,   102,   366,  1062,   255,   412,    66,
     148,   779,  1056,  1056,   330,   154,  1056,   960,   208,   702,
     455,   561,  1056,   454,   677,   762,    64,   960,   159,   454,
     673,  1056,   465,    35,   837,  1056,   246,   465,   423,   175,
    1054,   465,   702,   702,   673,   396,   542,   260,   465,   246,
      42,   484,   387,   626,   274,   602,    78,   119,   276,   371,
      24,    44,   195,   651,    35,   673,   154,   465,   412,   175,
    1054,   175,   579,  1054,  1054,   412,   702,    77,   740,  1062,
    1056,   154,   600,    48,   100,   193,   244,   329,   142,   762,
      55,   316,   513,   142,   454,   142,   409,   977,   977,   977,
     454,   965,   965,   287,   454,   967,   142,    61,    62,   977,
     965,   962,   421,   440,   454,   981,   454,   981,   458,   513,
      34,   961,    62,   454,   978,   104,   173,   233,   236,   331,
     435,   454,   982,   983,   703,   965,   423,   142,   751,   142,
     458,   175,   701,   175,   702,   175,   702,   142,   778,  1069,
     142,   260,   142,   142,   260,   142,   513,   142,    78,   119,
     276,   371,   154,   142,   260,   142,   513,   142,   154,   175,
     175,   497,   142,   458,   513,   984,  1020,   366,   455,   458,
     147,   260,   384,   494,   497,   591,   858,   854,   717,   888,
     717,   888,   717,   888,   717,   888,   717,   888,   888,   888,
     717,   888,   454,   562,   563,  1070,   562,    26,   103,   125,
     156,   161,   208,   209,   328,   334,   366,   369,   387,   723,
    1053,  1069,   722,  1056,   181,   458,   876,  1065,   960,  1023,
      35,  1069,   740,   455,   458,   216,  1070,   154,   154,   723,
    1069,   327,  1070,   497,   260,   454,  1045,   452,   892,  1024,
     984,  1040,   454,   454,   154,   454,   454,   892,   454,   454,
     454,   454,   454,   454,   984,   454,   454,   454,   454,   454,
     454,   454,   454,   892,   454,   454,   454,   454,   454,   454,
     454,   454,   984,   984,   984,   892,   984,  1020,  1044,  1065,
     454,  1065,     3,     8,    11,    15,    16,    17,    32,    35,
      40,    46,    70,   176,   181,   202,   203,   217,   249,   262,
     265,   345,   438,   441,   442,   443,   445,   446,   447,   448,
     449,   450,  1015,  1017,  1019,   420,   999,   271,   984,   200,
     458,   900,   454,  1065,  1044,   900,   112,   177,   506,   458,
      63,   109,   497,    35,     3,   109,   221,   495,   591,   980,
    1065,  1065,    83,   124,   996,    92,   109,   491,   492,   494,
     591,   109,   491,   216,  1054,   984,  1043,     3,    26,    30,
      31,    32,    33,    34,    35,    36,    39,    51,    57,    58,
      64,    70,    72,    81,    88,    93,    94,    95,    97,    98,
      99,   109,   111,   118,   122,   123,   129,   133,   137,   147,
     149,   154,   156,   159,   164,   167,   170,   181,   188,   198,
     200,   211,   212,   218,   222,   223,   246,   251,   258,   260,
     261,   265,   266,   282,   291,   305,   317,   333,   339,   350,
     363,   366,   374,   377,   378,   384,   392,   393,   399,   400,
     408,   415,   416,   418,   419,   447,  1059,  1073,  1074,  1075,
    1076,  1077,  1042,    84,   315,   706,   455,   458,   849,   455,
     458,   898,  1055,  1056,    35,   852,   894,   894,   908,   909,
     984,   894,   151,   243,   919,   206,   244,   299,   343,   398,
      26,   914,   984,   915,   917,   984,   986,   928,   929,   913,
     912,   910,   911,   154,   931,   256,   933,   910,   928,   947,
     866,  1054,    35,  1070,   340,   181,   191,   266,   268,   342,
     408,   447,   755,   756,   757,   759,   761,   763,   960,  1071,
     274,   310,   340,   377,   377,   328,  1059,   456,   377,   377,
     328,   218,   377,   377,   369,   487,   274,   826,   828,   443,
     830,   154,   164,   181,   319,   735,   736,    64,    81,   138,
     156,   291,   393,   558,   559,    81,   109,   246,   377,    81,
     377,   109,   246,   328,    81,   120,   130,   274,   310,   669,
     328,   608,    25,    58,    71,    85,   125,   136,   156,   161,
     230,   262,   328,   334,   337,   366,   373,   380,   387,   412,
     600,  1056,   142,   310,   340,   510,   260,   591,   260,   332,
     213,   377,  1070,   377,   251,   591,   113,   201,   328,   338,
     379,   489,   316,   340,   765,   774,   455,   752,   755,   377,
     399,   369,  1054,    72,   138,   175,   549,   558,  1070,    72,
      81,   797,   260,   260,   324,   326,   382,    81,   797,    29,
     313,   324,   326,   382,   324,  1054,   155,   186,   256,   702,
     454,   377,   377,   174,   454,   517,   227,   369,   396,   419,
     421,   517,    81,   458,     4,   274,   181,   142,   117,   310,
     340,   510,   400,   400,   245,   960,   274,   340,   779,  1056,
    1054,   103,   501,   377,   467,   501,  1054,   377,   377,  1054,
     591,    52,   590,   591,   591,   101,   231,   234,    52,   377,
     465,   328,   465,   244,   589,   377,   377,   251,  1065,   619,
     369,   945,    81,   377,   797,   328,   377,   377,   517,   517,
     702,   702,   702,   702,  1054,    41,   405,    41,    41,   377,
      41,   377,   328,   458,   399,   637,  1068,   377,   467,  1054,
     377,   328,   274,   310,   299,   311,   336,   493,   819,  1060,
    1070,  1054,   762,   960,   260,   202,   423,   751,   591,   702,
     702,   778,   260,   202,   260,    78,   119,   276,   371,   960,
     260,   202,   702,   202,   377,   419,   533,   387,     3,   678,
     679,   673,   454,    35,   702,   674,   675,  1073,    24,   826,
     960,   260,   142,   605,  1056,   246,   454,   466,   687,   400,
     303,   412,  1054,   466,   142,  1068,    88,   164,   485,   541,
     585,   650,   718,   738,   822,  1065,   627,   628,  1068,   224,
     702,   702,   702,   702,   256,   114,   194,   385,   398,   652,
     653,   134,   298,   454,   637,   466,  1054,   246,   587,   588,
     246,    35,   256,   454,   561,   561,   175,   582,  1054,   154,
     175,   741,  1060,   454,   753,    35,   960,   208,   419,   421,
     890,   329,  1062,   513,   960,  1057,   454,  1020,  1064,   704,
     977,   977,    34,   961,   375,   375,  1064,  1064,   960,   452,
     452,   340,  1064,   377,   377,   377,   454,   377,  1064,   965,
     175,  1056,  1062,   513,  1069,  1068,   142,   513,   142,   400,
     142,   400,   779,   513,   513,  1056,   702,  1069,  1056,   702,
    1056,  1056,   960,  1056,   702,   704,  1069,   637,   142,   142,
     513,   701,   702,   455,   458,   175,  1054,   854,   856,   888,
     888,   888,   888,   888,   888,   562,   455,   458,   455,   162,
     335,   367,  1055,   701,   102,   337,   727,   728,  1055,   255,
    1055,  1053,  1053,  1055,   701,   377,   419,   731,   137,   218,
     634,   635,    20,   140,   324,   343,   877,   945,   250,   878,
     455,   458,   861,   377,  1054,   791,   792,   794,   721,   720,
     721,   159,   165,   732,  1070,    25,    72,   103,   125,   136,
     156,   161,   209,   230,   321,   328,   334,   366,   369,   387,
     412,   600,   712,  1020,  1042,   453,  1020,  1024,  1025,   415,
    1037,  1038,   984,  1020,   454,  1064,  1064,     3,   104,   173,
     233,   236,   331,   435,  1026,  1027,  1065,  1020,  1020,  1020,
    1064,  1064,   984,   779,   984,  1028,   324,   445,   446,   454,
     985,   986,  1017,  1030,   455,  1020,   984,  1020,  1031,   984,
      51,   159,   212,   378,   984,  1020,  1034,  1020,   238,   986,
     984,   994,   995,   996,   238,   984,   996,   455,   458,  1064,
     982,   960,   984,   984,   984,   984,  1073,   375,    39,   363,
    1046,   702,   984,   454,   892,  1035,   122,   124,   147,   246,
     251,   256,   384,   394,   984,   454,   984,   377,    46,   176,
     181,   217,   345,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,    26,    33,   350,  1014,   167,   150,  1000,
     324,   454,  1011,   163,   221,   366,   370,   372,   396,   901,
    1054,  1052,   159,   935,    26,   122,   408,   447,   455,   757,
     984,  1021,  1022,  1071,   935,  1054,   379,   454,  1065,   458,
     455,   453,   459,   174,   174,   513,  1054,   846,   847,  1054,
    1047,   455,   458,   454,   458,    36,   118,   400,   747,   454,
     916,  1066,   343,   206,   261,   458,   324,   325,   918,  1053,
     250,   347,   879,   929,   911,   400,   874,   109,   454,   867,
     891,    35,  1070,   454,   881,   882,   883,   884,   885,  1070,
     268,    52,  1071,   455,   757,   759,   756,   759,  1071,   266,
     455,   458,   703,   377,   377,   328,  1068,  1056,  1056,  1059,
    1068,  1056,  1056,  1068,  1057,  1056,   109,   494,  1066,   321,
     399,   720,   328,   164,   720,   454,  1056,   400,   742,   206,
     206,   400,   454,   577,   175,  1056,   251,  1068,  1056,  1056,
     984,   251,  1056,  1056,    29,   313,   377,   377,  1056,   377,
     609,  1062,   454,   702,   702,   960,   382,   102,   366,   728,
     412,    66,   148,   779,  1056,   702,  1056,   702,   330,   154,
     960,   702,   208,   169,   244,   274,   310,   404,   612,   613,
     614,   945,   377,   797,   328,   251,   144,   113,   201,  1068,
    1056,   260,  1056,   455,   458,  1067,  1069,  1056,   310,   510,
     175,   549,   246,   960,  1056,  1070,  1056,   144,   216,  1056,
      26,   399,  1056,   175,  1056,   175,  1070,   326,   382,   326,
     382,   216,  1056,    26,   399,  1056,   216,   324,  1054,    22,
     127,   340,   620,   621,   622,   623,  1073,  1068,  1056,   109,
     160,   247,   400,   516,   519,   520,  1073,  1056,   259,    68,
     259,  1056,   511,   377,   369,  1054,   260,   377,   797,   328,
    1058,  1070,  1058,   458,   455,   458,   377,   328,   454,   260,
     310,   377,   646,  1057,  1067,     3,    80,   132,   186,   280,
     391,   399,   402,   468,   310,  1068,  1056,   310,   340,   510,
     588,   591,   702,  1056,   591,  1056,   591,  1068,  1056,  1056,
     310,   340,   510,  1056,  1056,  1056,  1056,  1068,  1056,    22,
      28,   127,   274,   310,   340,   274,   310,   340,   673,   310,
     340,   310,   340,   117,   310,   959,  1070,   175,   683,  1070,
     175,  1070,  1068,  1056,  1056,  1056,    22,   523,   337,  1067,
     310,   340,   510,  1056,  1056,   377,   377,    76,   390,   299,
     202,    35,   125,   702,   251,   709,  1065,   202,   202,   400,
     400,   202,   702,   709,   702,   208,   702,   709,   202,   709,
     296,   527,   259,   159,   377,   526,   184,   443,   455,   458,
     984,   960,   455,   458,   443,   652,   551,  1073,  1056,    55,
     159,   328,   411,   606,   613,   614,   142,   217,   543,   545,
     547,   549,   555,   558,    23,   181,   321,   364,   468,   469,
     154,  1058,   412,  1054,   154,   647,   483,  1070,   484,   265,
     542,   156,  1065,   673,   673,   673,   673,   256,   260,   265,
     454,   673,   957,   958,   959,   337,   454,   142,   142,   141,
     891,   702,   543,  1070,   419,   421,   573,   419,   518,   246,
      35,   561,  1065,   246,   260,   455,   754,   755,   760,    35,
     208,   318,   380,   418,   764,   765,   766,   260,   208,   497,
     172,   172,   154,   762,    35,  1020,   455,   455,   513,   452,
     437,   437,   455,   455,  1064,   453,  1064,  1070,   455,   173,
     233,   983,   233,   983,   983,  1064,   236,   455,   142,   513,
     751,   701,   702,  1058,   702,  1058,   778,   260,   513,   260,
     513,   513,   208,   260,   513,   513,   337,   154,   497,   513,
     984,   246,   455,   563,   181,   181,   181,   423,  1055,   458,
     591,   592,   167,   724,   725,  1068,    23,   732,   377,   454,
     159,   140,   343,   140,   343,   324,   398,   235,   960,  1068,
     419,   580,  1054,  1056,   159,   260,   724,    52,   513,  1062,
     960,   382,   366,  1062,   255,   412,   960,   208,   702,   455,
     453,   453,   458,   984,   129,  1038,  1039,    35,   455,   984,
     455,   455,   455,   159,   455,   455,   455,   455,   455,   458,
     455,   282,  1029,   455,   454,   985,   985,  1020,    11,    15,
      16,    17,   181,   202,   262,   441,   442,   443,   445,   446,
     447,   448,   449,   450,  1017,   985,   455,   455,   154,   159,
    1032,  1033,   455,    35,  1034,  1020,  1034,  1034,   159,   455,
     455,  1073,   279,   998,    35,   455,   458,   984,  1073,   458,
     984,  1045,   984,   455,   437,   985,   985,   135,  1020,   159,
     122,   124,   147,   251,   256,   384,   394,   454,   135,   779,
     984,   363,  1046,   984,  1035,   984,   377,   454,   892,   454,
     454,   270,  1004,   454,  1020,   370,   372,   370,   372,  1054,
     902,   902,   902,   211,   325,   454,   892,   936,   937,   938,
     945,   950,   987,   989,   990,  1062,  1070,   416,   955,  1021,
    1021,  1022,   455,    13,    14,   458,   906,   907,   955,   820,
    1064,   982,   492,   984,  1043,   852,  1056,   861,   909,   262,
    1015,  1018,   439,   748,   984,   918,   398,   915,   226,   936,
     416,   956,   406,   868,   869,  1070,   260,   870,  1070,   885,
     886,   458,   935,   443,  1045,   763,   703,   759,   759,    52,
     761,   449,  1068,  1056,  1056,  1069,  1069,   260,  1055,   263,
     260,   984,   559,  1058,   454,   454,   454,   577,   184,   562,
     661,   142,   513,   377,  1068,  1056,   497,   762,   960,  1056,
     423,   702,   702,   702,   702,   778,    78,   119,   276,   371,
     960,  1056,   595,  1056,   169,   404,   377,   377,   595,   612,
     619,   310,   340,   510,  1056,  1056,  1056,   192,  1056,   251,
     755,   273,   340,   377,   246,   142,   264,   617,   661,   127,
     314,   340,   512,   619,   798,  1056,   332,   142,   513,   142,
     513,  1056,  1056,  1056,  1056,   332,   332,   216,   622,   623,
     622,   455,   458,   624,  1065,   184,   455,   458,   443,   456,
    1068,  1056,   310,   340,   510,   144,  1056,  1056,  1056,   274,
     310,   340,    22,   127,   274,   310,   340,   960,   245,   960,
    1068,  1056,   802,   803,  1073,  1054,   377,  1069,   400,   643,
     218,   280,   251,  1065,   280,  1069,   397,   377,   377,   328,
     273,   340,    81,   377,   797,   328,   377,   377,   228,   228,
     228,   377,   377,   328,   377,   377,   328,   377,   328,   377,
     328,   260,   377,   513,   960,   246,  1065,   340,   798,   142,
     513,   377,  1056,   377,   328,  1068,  1056,   709,   960,   702,
     202,   709,   709,  1058,  1058,   709,   202,   202,  1056,   202,
     709,   357,   358,   528,  1065,   527,   169,   262,   445,   446,
     591,   676,   759,  1018,  1065,  1077,     3,   679,   455,   455,
     675,   676,   260,    64,    70,    81,   109,   111,   188,   246,
     251,   291,   305,   393,   552,   553,   554,   141,   415,   465,
     497,  1056,   497,   617,  1054,  1054,   455,   458,  1069,   167,
     321,  1069,  1064,   387,  1054,   561,    26,   114,   194,   333,
     398,   648,   377,   645,    42,   484,   312,   366,   102,   518,
     562,  1054,   653,   680,   681,  1065,   455,   458,  1056,   562,
    1054,   579,  1054,  1056,   580,   454,   544,   455,   259,   517,
     259,   260,   574,   517,    35,   142,   891,   518,   377,   142,
    1054,   455,   458,   109,   443,   767,  1065,   497,   366,   758,
     759,   154,   768,   419,   766,   769,   114,   194,   333,   398,
     810,  1056,   169,   891,   513,   960,   455,  1064,   981,   981,
     453,   453,   978,   455,  1056,   513,   513,   400,   513,   400,
     513,   513,   702,   702,  1056,   702,  1056,   637,   513,   142,
     328,   328,   328,  1055,   728,   458,  1068,   419,   458,   726,
     263,   946,   337,   140,   140,   102,   244,  1069,   723,   513,
    1068,   762,   202,   751,   591,   202,   702,   202,  1024,   374,
     984,   133,   960,   455,   984,   984,   984,  1032,   455,  1020,
     458,   960,   985,   985,   985,   985,   122,   124,   246,   256,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   985,
     984,   984,  1033,  1032,   960,   455,   455,   455,  1020,   455,
     458,    52,   986,   455,  1073,   995,   288,   361,   997,   455,
     458,   411,   991,    35,   455,  1065,   984,    32,    32,   984,
     455,   984,   159,   454,  1023,   984,   455,   135,   985,   985,
     135,   135,   984,   984,   907,   416,   454,  1005,  1070,   455,
    1020,   458,   902,   902,   902,   902,  1054,  1054,  1054,   892,
     950,   159,   892,   937,   938,    35,   939,   940,  1070,   458,
      89,   160,   190,   205,   215,   241,   320,   942,   940,    35,
     939,   941,  1070,   440,   954,   454,  1044,   984,   167,   920,
     458,   906,   906,   906,   984,   984,   408,  1022,   455,   920,
     455,   453,   455,   454,   748,   151,   210,   455,   261,    92,
     984,   317,   872,   455,   458,  1045,    79,   872,   455,   458,
     882,   956,  1047,   455,   449,   763,   387,   162,   335,   367,
     388,   737,   154,   737,   455,   454,   565,   566,   744,   989,
    1070,   562,   562,   661,  1060,   455,   111,   188,   244,   246,
     662,  1056,  1056,    35,  1056,   400,   400,   702,   702,   702,
     702,   208,   703,  1068,  1056,   377,   797,   328,   377,   192,
      52,   369,  1056,   142,   549,   454,   551,   246,   517,   102,
     246,   356,   359,   517,   387,  1056,  1070,   332,   621,  1056,
     520,   676,  1073,   273,   340,   377,   797,   328,  1056,   377,
     377,   377,   328,   161,   262,   359,   685,   686,   161,   262,
     693,   694,   377,   377,   328,   455,   455,   455,   455,   458,
     443,   310,  1056,   454,   419,   644,  1066,  1065,  1065,  1065,
    1056,  1056,  1056,    52,   369,  1056,  1056,  1056,  1056,  1056,
    1056,   154,   154,   312,   154,   175,  1068,  1056,  1056,  1068,
    1056,  1056,  1056,  1056,  1056,  1056,   144,  1056,    70,   514,
     142,    24,    44,   387,  1070,  1056,   619,  1056,  1056,   455,
     202,   709,   202,   202,   709,   709,   202,   709,   465,   528,
     595,   661,   419,   421,  1054,   454,   702,  1056,   985,   112,
     177,   111,   251,   206,  1054,   769,   295,   665,   666,  1070,
     605,   454,   556,   187,   572,   547,  1069,  1069,   960,   454,
     518,  1069,   643,  1068,   175,  1054,   423,   154,   654,   455,
     458,   959,   617,   455,   587,    35,   256,   454,   863,   546,
     548,   550,   558,  1070,   573,   572,    75,   369,   575,   891,
     582,   580,   575,  1065,  1060,   742,   760,   984,   984,   458,
     454,   764,   387,   458,   673,   377,   454,   595,   455,   453,
     513,  1058,  1058,   513,   513,   513,   513,   337,  1055,  1055,
    1055,   591,   164,   725,   455,  1056,   102,   732,   159,   202,
     251,   713,  1065,   202,   202,   713,   202,   713,   984,   455,
     455,  1033,   455,   984,   159,   122,   124,   256,   454,   455,
     426,   993,  1020,   304,    52,   417,   417,   455,   984,   244,
     984,   458,   992,   962,   984,   984,   984,  1023,   455,   984,
      32,    32,   984,   984,   135,   455,   455,   984,  1006,  1070,
     455,   984,  1054,  1054,  1054,  1054,   940,   941,   454,   455,
    1070,   454,   937,   205,   269,   943,   937,   943,   205,   942,
     943,   205,   368,   948,   454,  1070,   454,   267,  1021,    52,
     170,   927,   455,   455,   455,  1022,  1065,   927,  1065,   779,
     256,  1051,   891,   869,   260,   454,   871,   443,   885,   872,
     387,   455,   377,   720,   159,   661,   984,   455,   458,   419,
      70,   745,   745,   455,   455,   769,   112,   177,   186,   111,
     402,   513,   960,  1058,  1058,  1056,  1056,  1056,  1056,  1056,
    1069,  1056,   549,   618,   622,   251,   251,  1066,  1070,   960,
     513,   513,   443,    52,   369,  1056,  1056,  1056,  1056,  1068,
    1056,  1056,  1064,  1064,   960,   458,  1064,  1064,   458,  1068,
    1056,  1056,   803,   245,   676,   377,   984,    64,  1069,  1056,
     377,   377,  1055,  1055,   702,  1055,   142,  1056,   702,  1065,
    1065,   960,   513,   513,   202,   709,   709,   709,   709,   454,
     529,   530,   400,   534,   535,   161,   191,   161,   159,   660,
     984,   246,   553,   769,   561,   400,   576,  1062,    32,   141,
     181,   543,   139,   182,   454,   337,   400,   562,    35,   644,
     484,   246,   454,  1056,   128,   655,   415,   657,  1065,   518,
     891,   702,   543,   580,   455,   458,   419,   574,   573,   114,
     127,   288,  1056,   419,   823,    35,   159,   260,   454,  1065,
     757,   770,   771,  1071,   769,   960,   154,  1054,   159,   377,
     788,   189,   596,   513,   513,   513,  1056,   263,   200,   513,
     724,   713,   713,   713,   713,   455,   985,   159,   454,  1023,
     454,   455,   458,   455,   986,   304,   455,   405,   353,   455,
     455,   455,   984,   984,   984,   455,   278,  1007,   455,   951,
     952,   989,   939,   454,  1055,   937,   260,   400,   944,   937,
     205,   937,  1062,   958,   454,   958,  1070,   906,    91,   168,
     323,   454,   921,   922,   923,   924,   925,   926,   984,   984,
     418,  1001,   906,  1001,   455,   888,    81,   743,   744,   123,
     454,   892,  1049,   724,   260,   724,   455,   769,   566,   262,
     779,   702,   702,   746,   746,   305,   769,   576,   455,   377,
     340,   878,   455,   458,   514,   676,  1069,  1056,   377,   454,
    1062,   779,   686,   454,   454,   694,  1056,   455,   454,   340,
     878,  1056,  1056,   419,   440,   840,   312,   840,   840,   154,
     514,   709,   536,   537,  1073,    48,    90,   115,   131,   135,
     155,   158,   171,   251,   259,   297,   531,   465,   116,   728,
      35,   784,   784,  1054,   661,   455,   576,   229,   564,   184,
     454,   666,   295,   454,   455,    26,    74,    82,   110,   185,
     359,   557,   557,  1053,  1056,  1058,   455,   891,   142,   617,
     324,   355,   656,   454,   141,    35,   580,   544,   455,   548,
     264,   575,   574,   325,   325,    56,    64,   221,   891,   702,
    1054,   743,   759,   455,   458,   387,   955,   351,   351,   455,
     595,   244,   404,   597,   598,  1056,   513,   985,  1023,   455,
     994,  1020,    52,   244,   436,    52,   906,   455,   458,    35,
     953,  1055,   455,   984,   454,   937,   944,   454,   455,   958,
     455,   455,   454,   341,   454,   455,   458,  1002,  1003,  1070,
     455,  1056,   455,   458,   247,   398,   726,   737,   513,   745,
     576,   454,   747,   747,  1054,   576,   661,  1056,   369,   622,
     400,   515,   340,   878,  1056,  1023,   751,   154,   689,   778,
    1023,  1023,   984,   369,   701,   702,   701,   702,  1055,   513,
     455,   458,   447,   454,   494,   538,   591,   837,  1065,   837,
     246,   251,   297,   837,   837,   529,  1065,   784,    38,   179,
     154,   244,   560,   160,   277,   346,   260,   568,   569,   570,
     369,   455,  1062,     5,   667,   572,   455,   617,   148,   688,
     518,   823,  1054,   984,   295,   891,   573,   572,   551,   575,
      64,   263,    64,   580,   742,   455,   764,   770,   960,   123,
     419,   419,   404,   595,   617,   455,   455,   455,   304,   405,
    1020,   298,   325,  1008,   954,   951,   454,   455,  1055,  1020,
     455,  1020,   454,  1020,   922,   458,    35,   955,   744,   340,
     159,   746,   416,   567,   779,   748,   748,   561,   661,  1056,
     984,   369,   455,   266,   330,   302,   690,   689,   455,   455,
     455,  1056,   840,   537,   494,   539,   540,  1065,  1065,   251,
     562,   447,   562,  1065,  1065,   128,   186,   114,   398,   260,
     570,   260,   569,  1056,   454,   455,   458,   337,   702,    35,
      35,   454,   455,  1062,   823,   574,   573,   263,   263,   454,
     518,   769,    27,   195,   811,   161,   161,    46,    92,   389,
     984,  1009,  1010,  1009,   455,   958,   455,   455,   455,   921,
     455,  1003,  1005,   881,   724,   747,   454,   661,   455,   564,
     878,  1056,  1062,    52,   690,   878,   702,   455,   458,   562,
     324,    55,   244,   316,   340,   571,   571,   455,     5,  1056,
     685,   891,   454,   575,   574,   743,   575,   247,   454,   806,
     808,   813,   865,   873,   880,   891,   728,   728,  1010,   324,
     153,   286,   153,   286,   455,   311,   949,   455,   955,   513,
     748,   984,   568,   878,   751,   702,   540,   657,    21,   109,
     251,   617,   823,     4,   658,   659,  1064,  1065,  1073,   575,
     455,   955,   807,   808,   809,   892,   893,   458,   458,    32,
     454,   455,   661,   141,   455,   458,   518,   455,   457,   377,
     159,  1010,   984,   295,   659,   575,   809,   351,   351,   455,
    1062,   955,   419,   419,   454,   161,   161,   658,   728,   728,
     455
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 770 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 777 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 784 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 919 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 930 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 940 "gram.y"
    {}
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 941 "gram.y"
    {}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 942 "gram.y"
    {}
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 951 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 952 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 956 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 957 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 962 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 967 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 971 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 976 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 981 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 985 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 989 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 994 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 998 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1045 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1048 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1052 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1056 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1060 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1064 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1078 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1096 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1106 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1107 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1112 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1120 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1138 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1150 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].node);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1171 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1178 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1197 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1204 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1221 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1239 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].node);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1249 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1250 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1263 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1270 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1287 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[(3) - (6)].str);
					n->authrole = (yyvsp[(5) - (6)].node);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1297 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1307 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[(6) - (9)].str);
					n->authrole = (yyvsp[(8) - (9)].node);
					if ((yyvsp[(9) - (9)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(9) - (9)]))));
					n->schemaElts = (yyvsp[(9) - (9)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1322 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[(6) - (7)].str);
					n->authrole = NULL;
					if ((yyvsp[(7) - (7)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(7) - (7)]))));
					n->schemaElts = (yyvsp[(7) - (7)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1339 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1340 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1345 "gram.y"
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[(2) - (2)]);
					(yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node));
				}
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1351 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1379 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minumum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1386 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1392 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1398 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1407 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1415 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1427 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1435 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1443 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1450 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1458 "gram.y"
    {(yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt);}
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1460 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1468 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1479 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1487 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1495 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1506 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1514 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1522 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1529 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1538 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1547 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1549 "gram.y"
    { (yyval.str) = psprintf("%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str)); }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1552 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1553 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1557 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1559 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1562 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1563 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1564 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1565 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1569 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1570 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1571 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1577 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1590 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1594 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1598 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1613 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (5)].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1619 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1620 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1621 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1625 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1626 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1627 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1631 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1632 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1636 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1638 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minumum */
					(yyval.node) = (Node *) n;
				}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1646 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt); }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1648 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1655 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1662 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1672 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(1) - (1)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1679 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1688 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1689 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1694 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1695 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1702 "gram.y"
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[(3) - (3)].str);
				(yyval.node) = (Node *) n;
			}
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1708 "gram.y"
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1714 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1720 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1726 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1732 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1738 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1748 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1757 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1758 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1762 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1763 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1772 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1787 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1793 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1799 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1805 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1811 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1830 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1839 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1848 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1859 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1870 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1879 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1888 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1899 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1910 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1919 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1928 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1937 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1946 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1955 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1964 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (11)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(10) - (11)].str);
					n->nowait = (yyvsp[(11) - (11)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1975 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (14)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[(10) - (14)].list);
					n->new_tablespacename = (yyvsp[(13) - (14)].str);
					n->nowait = (yyvsp[(14) - (14)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1988 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1989 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1995 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 2004 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(5) - (5)].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 2013 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 2022 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(6) - (6)].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 2031 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 2040 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 2048 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 2056 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 2065 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 2074 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 2083 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 2092 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 2102 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 2115 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 2130 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 2139 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 2148 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[(3) - (4)].str);
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 2163 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 2171 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 2181 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 2191 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 2198 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 2205 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 2213 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 2221 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 2228 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 2235 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 2243 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 2251 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 2259 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 2266 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 2273 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 2281 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 2288 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 2295 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 2303 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 2311 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 2319 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 2327 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 2335 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 2343 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 2353 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 2360 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 2368 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 2376 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 2384 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 2392 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 2400 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 2407 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 2414 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 2421 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 2427 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 2436 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 2437 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 2441 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 2442 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 2443 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 2448 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 2455 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 2459 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2460 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2465 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2472 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2479 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2486 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 2495 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2499 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2504 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2510 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2514 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2518 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2523 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2538 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2550 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2551 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2557 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2566 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2576 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2586 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2612 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2618 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2652 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (11)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (11)].list);
					n->is_from = (yyvsp[(6) - (11)].boolean);
					n->is_program = (yyvsp[(7) - (11)].boolean);
					n->filename = (yyvsp[(8) - (11)].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(8) - (11)]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (11)].defelt));
					if ((yyvsp[(5) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (11)].defelt));
					if ((yyvsp[(9) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(9) - (11)].defelt));
					if ((yyvsp[(11) - (11)].list))
						n->options = list_concat(n->options, (yyvsp[(11) - (11)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2680 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(3) - (9)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[(6) - (9)].boolean);
					n->filename = (yyvsp[(7) - (9)].str);
					n->options = (yyvsp[(9) - (9)].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(5) - (9)]))));

					(yyval.node) = (Node *)n;
				}
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2701 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2702 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2706 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2707 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2716 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2717 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2718 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 2721 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2722 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2727 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2728 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2733 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2737 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2741 "gram.y"
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2745 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2749 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2753 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2757 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2761 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2765 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2769 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2773 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2777 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2781 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2785 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2794 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2797 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2802 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2805 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2810 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2813 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2817 "gram.y"
    {}
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2818 "gram.y"
    {}
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2824 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2828 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2835 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2841 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2842 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2843 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2844 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2845 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2850 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2854 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2861 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2874 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2891 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2907 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2924 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2952 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2953 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2954 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2955 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2957 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2964 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2970 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2971 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2975 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2976 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2980 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2981 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2986 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2990 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2997 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 3001 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 3007 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 3008 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 3009 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 3013 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 3014 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 3018 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 3039 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 3059 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 3060 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 3065 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 3072 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 3073 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 3075 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 3106 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 3113 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 3120 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 3131 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 3142 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 3154 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 3165 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 3198 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 3205 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 3212 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 3219 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 3230 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 3239 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 3240 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 3241 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 3245 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 3246 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 3247 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 3248 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 3249 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 3250 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 3260 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 3267 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 3272 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 3286 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 3300 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 3315 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 3329 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 3345 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 3362 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 3381 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 3382 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 3386 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 3387 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 3391 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 3392 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 3396 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 3402 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 3406 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 3414 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 3418 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 3424 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 3426 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 3430 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 3435 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 3441 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 3442 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 3453 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 3455 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 3457 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 3459 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 3461 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 3464 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 3467 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 3471 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 3472 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 3473 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 3474 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 3475 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 3478 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 3479 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 3484 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 3485 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 3486 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 3487 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 3490 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 3491 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 3492 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 3493 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 3496 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 3497 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 3500 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 3501 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 3504 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 3520 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 3533 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(9) - (10)].node);
					ctas->into = (yyvsp[(7) - (10)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[(7) - (10)].into)->rel->relpersistence = (yyvsp[(2) - (10)].ival);
					(yyvsp[(7) - (10)].into)->skipData = !((yyvsp[(10) - (10)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 3549 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 3562 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 3563 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 3564 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 3577 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(7) - (8)].node);
					ctas->into = (yyvsp[(5) - (8)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(5) - (8)].into)->rel->relpersistence = (yyvsp[(2) - (8)].ival);
					(yyvsp[(5) - (8)].into)->skipData = !((yyvsp[(8) - (8)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 3590 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(10) - (11)].node);
					ctas->into = (yyvsp[(8) - (11)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[(8) - (11)].into)->rel->relpersistence = (yyvsp[(2) - (11)].ival);
					(yyvsp[(8) - (11)].into)->skipData = !((yyvsp[(11) - (11)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 3606 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (4)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (4)].list);
					(yyval.into)->options = (yyvsp[(3) - (4)].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[(4) - (4)].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 3618 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 3619 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 3632 "gram.y"
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[(4) - (6)].boolean);
					n->relation = (yyvsp[(5) - (6)].range);
					n->skipData = !((yyvsp[(6) - (6)].boolean));
					(yyval.node) = (Node *) n;
				}
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 3652 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 3662 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(7) - (8)].range)->relpersistence = (yyvsp[(2) - (8)].ival);
					n->sequence = (yyvsp[(7) - (8)].range);
					n->options = (yyvsp[(8) - (8)].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 3675 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 3683 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 3693 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 3694 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 3697 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 3698 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 3702 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 3706 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 3710 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 3714 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 3718 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 3722 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 3726 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 3730 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 3734 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 3738 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 3742 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 3746 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 3751 "gram.y"
    {}
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 3752 "gram.y"
    {}
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 3756 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 3758 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 3762 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 3765 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 3766 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 3779 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 3792 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 3805 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 3806 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 3814 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 3815 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 3819 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 3820 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 3824 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 3825 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 3829 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 3830 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 3835 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 3846 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 3858 "gram.y"
    {}
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 3859 "gram.y"
    {}
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 3870 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (7)].str);
					n->owner = (yyvsp[(4) - (7)].node);
					n->location = (yyvsp[(6) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 3880 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 3881 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 3895 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 3902 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 3919 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 3927 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 3938 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 3940 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 3945 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 3949 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 3953 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 3957 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(TRUE));
				}
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 3969 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 3979 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 3981 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 3986 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 3999 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (7)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 4009 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 4019 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 4028 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 4037 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[(6) - (6)].typnam));
					(yyval.node) = (Node *)n;
				}
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 4046 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 4056 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 4065 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 4075 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[(9) - (9)].str)), (yyvsp[(7) - (9)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 4084 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[(9) - (9)].str)), (yyvsp[(7) - (9)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 4093 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 4102 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 4111 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 4120 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 4129 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 4138 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 4147 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 4156 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 4165 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 4174 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 4183 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 4192 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 4201 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 4210 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[(7) - (9)].typnam));
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 4220 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (6)].typnam));
					(yyval.node) = (Node *)n;
				}
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 4238 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 4248 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 4249 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 4250 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 4251 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 4255 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 4256 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 4260 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 4261 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 4272 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 4283 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 4303 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 4311 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 4322 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 4323 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 4328 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 4332 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 4339 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 4344 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 4348 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 4355 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 4359 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 4364 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 4369 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 4376 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 4382 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 4387 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 4399 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 4411 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 4412 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 4417 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 4418 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 4422 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 4423 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 4434 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 4445 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 4465 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 4474 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 4482 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 4501 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (11)].range);
					n->base.tableElts = (yyvsp[(6) - (11)].list);
					n->base.inhRelations = (yyvsp[(8) - (11)].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(10) - (11)].str);
					n->options = (yyvsp[(11) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 4521 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (14)].range);
					n->base.tableElts = (yyvsp[(9) - (14)].list);
					n->base.inhRelations = (yyvsp[(11) - (14)].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(13) - (14)].str);
					n->options = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 4549 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 4558 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 4580 "gram.y"
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[(8) - (11)].str);
				n->remote_schema = (yyvsp[(4) - (11)].str);
				n->local_schema = (yyvsp[(10) - (11)].str);
				n->list_type = (yyvsp[(5) - (11)].importqual)->type;
				n->table_list = (yyvsp[(5) - (11)].importqual)->table_names;
				n->options = (yyvsp[(11) - (11)].list);
				(yyval.node) = (Node *) n;
			}
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 4593 "gram.y"
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 4594 "gram.y"
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 4599 "gram.y"
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[(1) - (4)].ival);
				n->table_names = (yyvsp[(3) - (4)].list);
				(yyval.importqual) = n;
			}
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 4606 "gram.y"
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 4622 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[(5) - (8)].node);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 4632 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 4633 "gram.y"
    { (yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[(1) - (1)])); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 4644 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[(5) - (7)].node);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 4652 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[(7) - (9)].node);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 4669 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[(5) - (8)].node);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 4693 "gram.y"
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[(3) - (9)].str);
					n->table = (yyvsp[(5) - (9)].range);
					n->cmd_name = (yyvsp[(6) - (9)].str);
					n->roles = (yyvsp[(7) - (9)].list);
					n->qual = (yyvsp[(8) - (9)].node);
					n->with_check = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 4708 "gram.y"
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[(3) - (8)].str);
					n->table = (yyvsp[(5) - (8)].range);
					n->roles = (yyvsp[(6) - (8)].list);
					n->qual = (yyvsp[(7) - (8)].node);
					n->with_check = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 4721 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 4732 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 4745 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 4746 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 4750 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 4751 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 4755 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 4756 "gram.y"
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 4760 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 4761 "gram.y"
    { (yyval.list) = NULL; }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 4765 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 4766 "gram.y"
    { (yyval.str) = "all"; }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 4770 "gram.y"
    { (yyval.str) = "all"; }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 4771 "gram.y"
    { (yyval.str) = "select"; }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 4772 "gram.y"
    { (yyval.str) = "insert"; }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 4773 "gram.y"
    { (yyval.str) = "update"; }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 4774 "gram.y"
    { (yyval.str) = "delete"; }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 4785 "gram.y"
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[(4) - (8)].str);
					n->handler_name = (yyvsp[(8) - (8)].list);
					n->amtype = AMTYPE_INDEX;
					(yyval.node) = (Node *) n;
				}
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 4806 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 4827 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 4848 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 4849 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 4850 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 4855 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 4857 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 4879 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 4881 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 4883 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 4885 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 4887 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 4892 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 4896 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 4906 "gram.y"
    {}
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 4907 "gram.y"
    {}
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 4911 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 4912 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 4916 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 4917 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 4921 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 4922 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 4923 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 4928 "gram.y"
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[(1) - (1)].ival)));
				}
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 4931 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 4932 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 4933 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 4937 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 4938 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 4943 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 4945 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 4971 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 4972 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 4973 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 4974 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 4975 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 4976 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 4982 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 4993 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 5017 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (11)].str);
					n->eventname = (yyvsp[(6) - (11)].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 5028 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (13)].str);
					n->eventname = (yyvsp[(6) - (13)].str);
					n->whenclause = (yyvsp[(8) - (13)].list);
					n->funcname = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 5040 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 5042 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 5047 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (5)].str), (Node *) (yyvsp[(4) - (5)].list)); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 5052 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 5054 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 5059 "gram.y"
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[(4) - (5)].str);
					n->tgenabled = (yyvsp[(5) - (5)].chr);
					(yyval.node) = (Node *) n;
				}
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 5068 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 5069 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 5070 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 5071 "gram.y"
    { (yyval.chr) = TRIGGER_DISABLED; }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 5085 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 5104 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 742:
/* Line 1792 of yacc.c  */
#line 5127 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 743:
/* Line 1792 of yacc.c  */
#line 5137 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 5148 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 5158 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 5168 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 5179 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 5188 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 5195 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 5202 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 5211 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 5220 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 5229 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 5238 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 5247 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 5257 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 5260 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 5261 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 5265 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 5269 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 5275 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 5276 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 5277 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 5278 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 5279 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 5282 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 5285 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 5286 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 5295 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 5301 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 5302 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 5306 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 5308 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 5319 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (7)].list);
				n->newVal = (yyvsp[(7) - (7)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (7)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 5329 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 5339 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 5350 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 5351 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 5369 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 5382 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 781:
/* Line 1792 of yacc.c  */
#line 5383 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 5388 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 5399 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 5409 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 5418 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 5428 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 787:
/* Line 1792 of yacc.c  */
#line 5436 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 5437 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 5440 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 5441 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 5444 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 5445 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 5446 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 5450 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 795:
/* Line 1792 of yacc.c  */
#line 5463 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 796:
/* Line 1792 of yacc.c  */
#line 5469 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 5479 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 5488 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 799:
/* Line 1792 of yacc.c  */
#line 5499 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 5500 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 5505 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 5513 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 5525 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(6) - (7)].str)), (yyvsp[(4) - (7)].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 5535 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(8) - (9)].str)), (yyvsp[(6) - (9)].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 5548 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(6) - (7)].str)), (yyvsp[(4) - (7)].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 806:
/* Line 1792 of yacc.c  */
#line 5558 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(8) - (9)].str)), (yyvsp[(6) - (9)].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 5580 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 808:
/* Line 1792 of yacc.c  */
#line 5590 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 809:
/* Line 1792 of yacc.c  */
#line 5608 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 5619 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 5630 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 812:
/* Line 1792 of yacc.c  */
#line 5640 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 813:
/* Line 1792 of yacc.c  */
#line 5650 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 5660 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 815:
/* Line 1792 of yacc.c  */
#line 5670 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 5681 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 5694 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 818:
/* Line 1792 of yacc.c  */
#line 5695 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 819:
/* Line 1792 of yacc.c  */
#line 5696 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 820:
/* Line 1792 of yacc.c  */
#line 5697 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 5698 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 5699 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 5700 "gram.y"
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 5701 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 5702 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 826:
/* Line 1792 of yacc.c  */
#line 5703 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 5704 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 5705 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 829:
/* Line 1792 of yacc.c  */
#line 5706 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 830:
/* Line 1792 of yacc.c  */
#line 5707 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 5708 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 5709 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 5713 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 5714 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 5717 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 5718 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 5722 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 5724 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 839:
/* Line 1792 of yacc.c  */
#line 5728 "gram.y"
    { (yyval.list) = list_make1(list_make1((yyvsp[(1) - (1)].typnam))); }
    break;

  case 840:
/* Line 1792 of yacc.c  */
#line 5729 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), list_make1((yyvsp[(3) - (3)].typnam))); }
    break;

  case 841:
/* Line 1792 of yacc.c  */
#line 5740 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 842:
/* Line 1792 of yacc.c  */
#line 5750 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 5751 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 5752 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 5787 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 846:
/* Line 1792 of yacc.c  */
#line 5796 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(4) - (6)].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 847:
/* Line 1792 of yacc.c  */
#line 5805 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[(4) - (6)].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 848:
/* Line 1792 of yacc.c  */
#line 5814 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 849:
/* Line 1792 of yacc.c  */
#line 5823 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 850:
/* Line 1792 of yacc.c  */
#line 5832 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 851:
/* Line 1792 of yacc.c  */
#line 5841 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 852:
/* Line 1792 of yacc.c  */
#line 5850 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->objname = list_make1(makeTypeNameFromNameList((yyvsp[(7) - (9)].list)));
					n->objargs = list_make1(makeString((yyvsp[(4) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 853:
/* Line 1792 of yacc.c  */
#line 5864 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 854:
/* Line 1792 of yacc.c  */
#line 5873 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 855:
/* Line 1792 of yacc.c  */
#line 5882 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 856:
/* Line 1792 of yacc.c  */
#line 5892 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[(5) - (9)].typnam));
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 857:
/* Line 1792 of yacc.c  */
#line 5901 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 858:
/* Line 1792 of yacc.c  */
#line 5910 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[(7) - (9)].str)), (yyvsp[(5) - (9)].list));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 859:
/* Line 1792 of yacc.c  */
#line 5918 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[(7) - (9)].str)), (yyvsp[(5) - (9)].list));
					n->objargs = NIL;
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 860:
/* Line 1792 of yacc.c  */
#line 5927 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 861:
/* Line 1792 of yacc.c  */
#line 5936 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 862:
/* Line 1792 of yacc.c  */
#line 5945 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 863:
/* Line 1792 of yacc.c  */
#line 5956 "gram.y"
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
    break;

  case 864:
/* Line 1792 of yacc.c  */
#line 5957 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 865:
/* Line 1792 of yacc.c  */
#line 5958 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 866:
/* Line 1792 of yacc.c  */
#line 5959 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 867:
/* Line 1792 of yacc.c  */
#line 5960 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 868:
/* Line 1792 of yacc.c  */
#line 5961 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 5962 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 870:
/* Line 1792 of yacc.c  */
#line 5963 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 871:
/* Line 1792 of yacc.c  */
#line 5964 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 872:
/* Line 1792 of yacc.c  */
#line 5965 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 873:
/* Line 1792 of yacc.c  */
#line 5966 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 874:
/* Line 1792 of yacc.c  */
#line 5967 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 875:
/* Line 1792 of yacc.c  */
#line 5968 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 876:
/* Line 1792 of yacc.c  */
#line 5969 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 877:
/* Line 1792 of yacc.c  */
#line 5970 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 878:
/* Line 1792 of yacc.c  */
#line 5971 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 879:
/* Line 1792 of yacc.c  */
#line 5972 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 5973 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 5974 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 5975 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 5976 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 5977 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 5981 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 5982 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 887:
/* Line 1792 of yacc.c  */
#line 5998 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 888:
/* Line 1792 of yacc.c  */
#line 6009 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (8)].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 889:
/* Line 1792 of yacc.c  */
#line 6020 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (8)].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 890:
/* Line 1792 of yacc.c  */
#line 6031 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 891:
/* Line 1792 of yacc.c  */
#line 6042 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 892:
/* Line 1792 of yacc.c  */
#line 6053 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 6064 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 894:
/* Line 1792 of yacc.c  */
#line 6075 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 895:
/* Line 1792 of yacc.c  */
#line 6076 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 896:
/* Line 1792 of yacc.c  */
#line 6080 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 897:
/* Line 1792 of yacc.c  */
#line 6081 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 6082 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 6083 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 900:
/* Line 1792 of yacc.c  */
#line 6084 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 901:
/* Line 1792 of yacc.c  */
#line 6085 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 902:
/* Line 1792 of yacc.c  */
#line 6086 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 903:
/* Line 1792 of yacc.c  */
#line 6087 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 904:
/* Line 1792 of yacc.c  */
#line 6088 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 905:
/* Line 1792 of yacc.c  */
#line 6089 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 906:
/* Line 1792 of yacc.c  */
#line 6090 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 907:
/* Line 1792 of yacc.c  */
#line 6093 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 908:
/* Line 1792 of yacc.c  */
#line 6094 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 909:
/* Line 1792 of yacc.c  */
#line 6105 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 910:
/* Line 1792 of yacc.c  */
#line 6111 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 911:
/* Line 1792 of yacc.c  */
#line 6119 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 912:
/* Line 1792 of yacc.c  */
#line 6127 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 913:
/* Line 1792 of yacc.c  */
#line 6135 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 914:
/* Line 1792 of yacc.c  */
#line 6143 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 915:
/* Line 1792 of yacc.c  */
#line 6151 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 916:
/* Line 1792 of yacc.c  */
#line 6159 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 917:
/* Line 1792 of yacc.c  */
#line 6167 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 918:
/* Line 1792 of yacc.c  */
#line 6175 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 919:
/* Line 1792 of yacc.c  */
#line 6183 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 920:
/* Line 1792 of yacc.c  */
#line 6191 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 921:
/* Line 1792 of yacc.c  */
#line 6199 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 922:
/* Line 1792 of yacc.c  */
#line 6207 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 923:
/* Line 1792 of yacc.c  */
#line 6215 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 924:
/* Line 1792 of yacc.c  */
#line 6223 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 925:
/* Line 1792 of yacc.c  */
#line 6231 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 926:
/* Line 1792 of yacc.c  */
#line 6239 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 927:
/* Line 1792 of yacc.c  */
#line 6248 "gram.y"
    {}
    break;

  case 928:
/* Line 1792 of yacc.c  */
#line 6249 "gram.y"
    {}
    break;

  case 929:
/* Line 1792 of yacc.c  */
#line 6252 "gram.y"
    {}
    break;

  case 930:
/* Line 1792 of yacc.c  */
#line 6253 "gram.y"
    {}
    break;

  case 931:
/* Line 1792 of yacc.c  */
#line 6265 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 932:
/* Line 1792 of yacc.c  */
#line 6281 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 933:
/* Line 1792 of yacc.c  */
#line 6295 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 934:
/* Line 1792 of yacc.c  */
#line 6320 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 935:
/* Line 1792 of yacc.c  */
#line 6322 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 936:
/* Line 1792 of yacc.c  */
#line 6324 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 937:
/* Line 1792 of yacc.c  */
#line 6326 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 938:
/* Line 1792 of yacc.c  */
#line 6333 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 939:
/* Line 1792 of yacc.c  */
#line 6341 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 940:
/* Line 1792 of yacc.c  */
#line 6342 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 941:
/* Line 1792 of yacc.c  */
#line 6346 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 942:
/* Line 1792 of yacc.c  */
#line 6353 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 943:
/* Line 1792 of yacc.c  */
#line 6360 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 944:
/* Line 1792 of yacc.c  */
#line 6367 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 945:
/* Line 1792 of yacc.c  */
#line 6381 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 946:
/* Line 1792 of yacc.c  */
#line 6389 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 947:
/* Line 1792 of yacc.c  */
#line 6397 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 948:
/* Line 1792 of yacc.c  */
#line 6405 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 949:
/* Line 1792 of yacc.c  */
#line 6413 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 950:
/* Line 1792 of yacc.c  */
#line 6421 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 951:
/* Line 1792 of yacc.c  */
#line 6429 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 952:
/* Line 1792 of yacc.c  */
#line 6437 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 953:
/* Line 1792 of yacc.c  */
#line 6445 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 954:
/* Line 1792 of yacc.c  */
#line 6453 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 955:
/* Line 1792 of yacc.c  */
#line 6461 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 956:
/* Line 1792 of yacc.c  */
#line 6469 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 957:
/* Line 1792 of yacc.c  */
#line 6477 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 958:
/* Line 1792 of yacc.c  */
#line 6485 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 959:
/* Line 1792 of yacc.c  */
#line 6493 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 960:
/* Line 1792 of yacc.c  */
#line 6501 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 961:
/* Line 1792 of yacc.c  */
#line 6512 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 962:
/* Line 1792 of yacc.c  */
#line 6513 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 963:
/* Line 1792 of yacc.c  */
#line 6517 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 964:
/* Line 1792 of yacc.c  */
#line 6518 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 965:
/* Line 1792 of yacc.c  */
#line 6523 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 966:
/* Line 1792 of yacc.c  */
#line 6524 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 967:
/* Line 1792 of yacc.c  */
#line 6528 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 968:
/* Line 1792 of yacc.c  */
#line 6530 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 969:
/* Line 1792 of yacc.c  */
#line 6535 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 970:
/* Line 1792 of yacc.c  */
#line 6551 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 971:
/* Line 1792 of yacc.c  */
#line 6564 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 972:
/* Line 1792 of yacc.c  */
#line 6574 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 973:
/* Line 1792 of yacc.c  */
#line 6585 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 974:
/* Line 1792 of yacc.c  */
#line 6586 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 975:
/* Line 1792 of yacc.c  */
#line 6589 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 976:
/* Line 1792 of yacc.c  */
#line 6590 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 977:
/* Line 1792 of yacc.c  */
#line 6601 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 978:
/* Line 1792 of yacc.c  */
#line 6610 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 979:
/* Line 1792 of yacc.c  */
#line 6611 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 980:
/* Line 1792 of yacc.c  */
#line 6616 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 981:
/* Line 1792 of yacc.c  */
#line 6620 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 982:
/* Line 1792 of yacc.c  */
#line 6624 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 983:
/* Line 1792 of yacc.c  */
#line 6636 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 984:
/* Line 1792 of yacc.c  */
#line 6649 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 985:
/* Line 1792 of yacc.c  */
#line 6663 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 986:
/* Line 1792 of yacc.c  */
#line 6678 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 987:
/* Line 1792 of yacc.c  */
#line 6679 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 988:
/* Line 1792 of yacc.c  */
#line 6680 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 989:
/* Line 1792 of yacc.c  */
#line 6681 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 990:
/* Line 1792 of yacc.c  */
#line 6696 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 991:
/* Line 1792 of yacc.c  */
#line 6722 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (17)].boolean);
					n->concurrent = (yyvsp[(4) - (17)].boolean);
					n->idxname = (yyvsp[(8) - (17)].str);
					n->relation = (yyvsp[(10) - (17)].range);
					n->accessMethod = (yyvsp[(11) - (17)].str);
					n->indexParams = (yyvsp[(13) - (17)].list);
					n->options = (yyvsp[(15) - (17)].list);
					n->tableSpace = (yyvsp[(16) - (17)].str);
					n->whereClause = (yyvsp[(17) - (17)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 992:
/* Line 1792 of yacc.c  */
#line 6748 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 993:
/* Line 1792 of yacc.c  */
#line 6749 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 994:
/* Line 1792 of yacc.c  */
#line 6753 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 995:
/* Line 1792 of yacc.c  */
#line 6754 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 996:
/* Line 1792 of yacc.c  */
#line 6758 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 997:
/* Line 1792 of yacc.c  */
#line 6759 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 998:
/* Line 1792 of yacc.c  */
#line 6763 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 999:
/* Line 1792 of yacc.c  */
#line 6764 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 1000:
/* Line 1792 of yacc.c  */
#line 6767 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 1001:
/* Line 1792 of yacc.c  */
#line 6768 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 1002:
/* Line 1792 of yacc.c  */
#line 6777 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 1003:
/* Line 1792 of yacc.c  */
#line 6788 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 1004:
/* Line 1792 of yacc.c  */
#line 6799 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 1005:
/* Line 1792 of yacc.c  */
#line 6811 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1006:
/* Line 1792 of yacc.c  */
#line 6812 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1007:
/* Line 1792 of yacc.c  */
#line 6815 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1008:
/* Line 1792 of yacc.c  */
#line 6816 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1009:
/* Line 1792 of yacc.c  */
#line 6819 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 1010:
/* Line 1792 of yacc.c  */
#line 6820 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 1011:
/* Line 1792 of yacc.c  */
#line 6821 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 1012:
/* Line 1792 of yacc.c  */
#line 6824 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 1013:
/* Line 1792 of yacc.c  */
#line 6825 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 1014:
/* Line 1792 of yacc.c  */
#line 6826 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 1015:
/* Line 1792 of yacc.c  */
#line 6844 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1016:
/* Line 1792 of yacc.c  */
#line 6856 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1017:
/* Line 1792 of yacc.c  */
#line 6869 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1018:
/* Line 1792 of yacc.c  */
#line 6882 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1019:
/* Line 1792 of yacc.c  */
#line 6883 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1020:
/* Line 1792 of yacc.c  */
#line 6886 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1021:
/* Line 1792 of yacc.c  */
#line 6887 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1022:
/* Line 1792 of yacc.c  */
#line 6891 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1023:
/* Line 1792 of yacc.c  */
#line 6892 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1024:
/* Line 1792 of yacc.c  */
#line 6900 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1025:
/* Line 1792 of yacc.c  */
#line 6901 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1026:
/* Line 1792 of yacc.c  */
#line 6905 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1027:
/* Line 1792 of yacc.c  */
#line 6907 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1028:
/* Line 1792 of yacc.c  */
#line 6922 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1029:
/* Line 1792 of yacc.c  */
#line 6931 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1030:
/* Line 1792 of yacc.c  */
#line 6940 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1031:
/* Line 1792 of yacc.c  */
#line 6949 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1032:
/* Line 1792 of yacc.c  */
#line 6958 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1033:
/* Line 1792 of yacc.c  */
#line 6969 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 1034:
/* Line 1792 of yacc.c  */
#line 6970 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 1035:
/* Line 1792 of yacc.c  */
#line 6971 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 1036:
/* Line 1792 of yacc.c  */
#line 6972 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 1037:
/* Line 1792 of yacc.c  */
#line 6973 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 1039:
/* Line 1792 of yacc.c  */
#line 6984 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1040:
/* Line 1792 of yacc.c  */
#line 6998 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1041:
/* Line 1792 of yacc.c  */
#line 7000 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 1042:
/* Line 1792 of yacc.c  */
#line 7006 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 1043:
/* Line 1792 of yacc.c  */
#line 7016 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 1044:
/* Line 1792 of yacc.c  */
#line 7020 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 1045:
/* Line 1792 of yacc.c  */
#line 7025 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 1046:
/* Line 1792 of yacc.c  */
#line 7033 "gram.y"
    {
					if (!((yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 1047:
/* Line 1792 of yacc.c  */
#line 7074 "gram.y"
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
    break;

  case 1048:
/* Line 1792 of yacc.c  */
#line 7078 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(2) - (3)].list), makeInteger(-1));
				}
    break;

  case 1049:
/* Line 1792 of yacc.c  */
#line 7082 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(4) - (5)].list), makeInteger(0));
				}
    break;

  case 1050:
/* Line 1792 of yacc.c  */
#line 7086 "gram.y"
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[(2) - (6)].list), (yyvsp[(5) - (6)].list), yyscanner);
				}
    break;

  case 1051:
/* Line 1792 of yacc.c  */
#line 7093 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1052:
/* Line 1792 of yacc.c  */
#line 7094 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1053:
/* Line 1792 of yacc.c  */
#line 7099 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1054:
/* Line 1792 of yacc.c  */
#line 7100 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1055:
/* Line 1792 of yacc.c  */
#line 7108 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 1056:
/* Line 1792 of yacc.c  */
#line 7112 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 1057:
/* Line 1792 of yacc.c  */
#line 7116 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 1058:
/* Line 1792 of yacc.c  */
#line 7120 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 1059:
/* Line 1792 of yacc.c  */
#line 7124 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 1060:
/* Line 1792 of yacc.c  */
#line 7128 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 1061:
/* Line 1792 of yacc.c  */
#line 7132 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1062:
/* Line 1792 of yacc.c  */
#line 7136 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1063:
/* Line 1792 of yacc.c  */
#line 7140 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1064:
/* Line 1792 of yacc.c  */
#line 7144 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1065:
/* Line 1792 of yacc.c  */
#line 7148 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 1066:
/* Line 1792 of yacc.c  */
#line 7152 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 1067:
/* Line 1792 of yacc.c  */
#line 7156 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1068:
/* Line 1792 of yacc.c  */
#line 7160 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1069:
/* Line 1792 of yacc.c  */
#line 7164 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 1070:
/* Line 1792 of yacc.c  */
#line 7169 "gram.y"
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1071:
/* Line 1792 of yacc.c  */
#line 7176 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1072:
/* Line 1792 of yacc.c  */
#line 7180 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1073:
/* Line 1792 of yacc.c  */
#line 7184 "gram.y"
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1074:
/* Line 1792 of yacc.c  */
#line 7188 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 1075:
/* Line 1792 of yacc.c  */
#line 7192 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 1076:
/* Line 1792 of yacc.c  */
#line 7197 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1077:
/* Line 1792 of yacc.c  */
#line 7199 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1078:
/* Line 1792 of yacc.c  */
#line 7205 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(3) - (3)].typnam)); }
    break;

  case 1079:
/* Line 1792 of yacc.c  */
#line 7206 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (5)].list), (yyvsp[(5) - (5)].typnam)); }
    break;

  case 1080:
/* Line 1792 of yacc.c  */
#line 7210 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1081:
/* Line 1792 of yacc.c  */
#line 7211 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1082:
/* Line 1792 of yacc.c  */
#line 7215 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1083:
/* Line 1792 of yacc.c  */
#line 7227 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 1084:
/* Line 1792 of yacc.c  */
#line 7231 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 1085:
/* Line 1792 of yacc.c  */
#line 7246 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1086:
/* Line 1792 of yacc.c  */
#line 7256 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1087:
/* Line 1792 of yacc.c  */
#line 7257 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1090:
/* Line 1792 of yacc.c  */
#line 7279 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1091:
/* Line 1792 of yacc.c  */
#line 7290 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1092:
/* Line 1792 of yacc.c  */
#line 7304 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1093:
/* Line 1792 of yacc.c  */
#line 7315 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1094:
/* Line 1792 of yacc.c  */
#line 7329 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1095:
/* Line 1792 of yacc.c  */
#line 7340 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1096:
/* Line 1792 of yacc.c  */
#line 7354 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 1097:
/* Line 1792 of yacc.c  */
#line 7362 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1098:
/* Line 1792 of yacc.c  */
#line 7364 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1099:
/* Line 1792 of yacc.c  */
#line 7366 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 1100:
/* Line 1792 of yacc.c  */
#line 7371 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1101:
/* Line 1792 of yacc.c  */
#line 7373 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 1102:
/* Line 1792 of yacc.c  */
#line 7386 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1103:
/* Line 1792 of yacc.c  */
#line 7394 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1104:
/* Line 1792 of yacc.c  */
#line 7395 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1105:
/* Line 1792 of yacc.c  */
#line 7400 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 1106:
/* Line 1792 of yacc.c  */
#line 7404 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1107:
/* Line 1792 of yacc.c  */
#line 7417 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1108:
/* Line 1792 of yacc.c  */
#line 7428 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1109:
/* Line 1792 of yacc.c  */
#line 7439 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1110:
/* Line 1792 of yacc.c  */
#line 7450 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 1111:
/* Line 1792 of yacc.c  */
#line 7451 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 1112:
/* Line 1792 of yacc.c  */
#line 7452 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 1113:
/* Line 1792 of yacc.c  */
#line 7457 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1114:
/* Line 1792 of yacc.c  */
#line 7469 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1115:
/* Line 1792 of yacc.c  */
#line 7470 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1116:
/* Line 1792 of yacc.c  */
#line 7481 "gram.y"
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[(2) - (10)].boolean);
					n->type_name = (yyvsp[(5) - (10)].typnam);
					n->lang = (yyvsp[(7) - (10)].str);
					n->fromsql = linitial((yyvsp[(9) - (10)].list));
					n->tosql = lsecond((yyvsp[(9) - (10)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1117:
/* Line 1792 of yacc.c  */
#line 7493 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(5) - (11)].funwithargs), (yyvsp[(11) - (11)].funwithargs));
				}
    break;

  case 1118:
/* Line 1792 of yacc.c  */
#line 7497 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(11) - (11)].funwithargs), (yyvsp[(5) - (11)].funwithargs));
				}
    break;

  case 1119:
/* Line 1792 of yacc.c  */
#line 7501 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(5) - (5)].funwithargs), NULL);
				}
    break;

  case 1120:
/* Line 1792 of yacc.c  */
#line 7505 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(5) - (5)].funwithargs));
				}
    break;

  case 1121:
/* Line 1792 of yacc.c  */
#line 7512 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make1((yyvsp[(5) - (8)].typnam)));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (8)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:
/* Line 1792 of yacc.c  */
#line 7533 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (3)].ival);
					n->relation = (yyvsp[(3) - (3)].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:
/* Line 1792 of yacc.c  */
#line 7542 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (3)].ival);
					n->name = (yyvsp[(3) - (3)].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:
/* Line 1792 of yacc.c  */
#line 7551 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(5) - (6)].ival);
					n->relation = (yyvsp[(6) - (6)].range);
					n->name = NULL;
					n->options = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:
/* Line 1792 of yacc.c  */
#line 7560 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(5) - (6)].ival);
					n->name = (yyvsp[(6) - (6)].str);
					n->relation = NULL;
					n->options = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:
/* Line 1792 of yacc.c  */
#line 7570 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
    break;

  case 1127:
/* Line 1792 of yacc.c  */
#line 7571 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
    break;

  case 1128:
/* Line 1792 of yacc.c  */
#line 7574 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
    break;

  case 1129:
/* Line 1792 of yacc.c  */
#line 7575 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
    break;

  case 1130:
/* Line 1792 of yacc.c  */
#line 7576 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
    break;

  case 1131:
/* Line 1792 of yacc.c  */
#line 7579 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1132:
/* Line 1792 of yacc.c  */
#line 7580 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1133:
/* Line 1792 of yacc.c  */
#line 7583 "gram.y"
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
    break;

  case 1134:
/* Line 1792 of yacc.c  */
#line 7594 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1135:
/* Line 1792 of yacc.c  */
#line 7603 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1136:
/* Line 1792 of yacc.c  */
#line 7620 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1137:
/* Line 1792 of yacc.c  */
#line 7630 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1138:
/* Line 1792 of yacc.c  */
#line 7639 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1139:
/* Line 1792 of yacc.c  */
#line 7648 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1140:
/* Line 1792 of yacc.c  */
#line 7657 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1141:
/* Line 1792 of yacc.c  */
#line 7666 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1142:
/* Line 1792 of yacc.c  */
#line 7675 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1143:
/* Line 1792 of yacc.c  */
#line 7684 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1144:
/* Line 1792 of yacc.c  */
#line 7694 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1145:
/* Line 1792 of yacc.c  */
#line 7703 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1146:
/* Line 1792 of yacc.c  */
#line 7712 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1147:
/* Line 1792 of yacc.c  */
#line 7721 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1148:
/* Line 1792 of yacc.c  */
#line 7730 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1149:
/* Line 1792 of yacc.c  */
#line 7740 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[(7) - (10)].range);
					n->subname = (yyvsp[(5) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1150:
/* Line 1792 of yacc.c  */
#line 7750 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1151:
/* Line 1792 of yacc.c  */
#line 7759 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1152:
/* Line 1792 of yacc.c  */
#line 7768 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1153:
/* Line 1792 of yacc.c  */
#line 7778 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1154:
/* Line 1792 of yacc.c  */
#line 7788 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1155:
/* Line 1792 of yacc.c  */
#line 7798 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1156:
/* Line 1792 of yacc.c  */
#line 7808 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1157:
/* Line 1792 of yacc.c  */
#line 7818 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1158:
/* Line 1792 of yacc.c  */
#line 7828 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1159:
/* Line 1792 of yacc.c  */
#line 7838 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1160:
/* Line 1792 of yacc.c  */
#line 7848 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1161:
/* Line 1792 of yacc.c  */
#line 7858 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1162:
/* Line 1792 of yacc.c  */
#line 7868 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1163:
/* Line 1792 of yacc.c  */
#line 7878 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1164:
/* Line 1792 of yacc.c  */
#line 7888 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1165:
/* Line 1792 of yacc.c  */
#line 7899 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1166:
/* Line 1792 of yacc.c  */
#line 7910 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1167:
/* Line 1792 of yacc.c  */
#line 7921 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1168:
/* Line 1792 of yacc.c  */
#line 7932 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1169:
/* Line 1792 of yacc.c  */
#line 7942 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1170:
/* Line 1792 of yacc.c  */
#line 7952 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1171:
/* Line 1792 of yacc.c  */
#line 7963 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1172:
/* Line 1792 of yacc.c  */
#line 7974 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1173:
/* Line 1792 of yacc.c  */
#line 7984 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1174:
/* Line 1792 of yacc.c  */
#line 7994 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1175:
/* Line 1792 of yacc.c  */
#line 8002 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1176:
/* Line 1792 of yacc.c  */
#line 8011 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1177:
/* Line 1792 of yacc.c  */
#line 8020 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1178:
/* Line 1792 of yacc.c  */
#line 8029 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1179:
/* Line 1792 of yacc.c  */
#line 8038 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1180:
/* Line 1792 of yacc.c  */
#line 8047 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1181:
/* Line 1792 of yacc.c  */
#line 8056 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1182:
/* Line 1792 of yacc.c  */
#line 8065 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1183:
/* Line 1792 of yacc.c  */
#line 8074 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:
/* Line 1792 of yacc.c  */
#line 8087 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1185:
/* Line 1792 of yacc.c  */
#line 8088 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1186:
/* Line 1792 of yacc.c  */
#line 8091 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1187:
/* Line 1792 of yacc.c  */
#line 8092 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1188:
/* Line 1792 of yacc.c  */
#line 8103 "gram.y"
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->relation = NULL;
					n->objname = (yyvsp[(3) - (7)].funwithargs)->funcname;
					n->objargs = (yyvsp[(3) - (7)].funwithargs)->funcargs;
					n->extname = makeString((yyvsp[(7) - (7)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1189:
/* Line 1792 of yacc.c  */
#line 8113 "gram.y"
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (9)].range);
					n->objname = list_make1(makeString((yyvsp[(3) - (9)].str)));
					n->objargs = NIL;
					n->extname = makeString((yyvsp[(9) - (9)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1190:
/* Line 1792 of yacc.c  */
#line 8123 "gram.y"
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (8)].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[(8) - (8)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1191:
/* Line 1792 of yacc.c  */
#line 8133 "gram.y"
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (7)].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[(7) - (7)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1192:
/* Line 1792 of yacc.c  */
#line 8152 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1193:
/* Line 1792 of yacc.c  */
#line 8162 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1194:
/* Line 1792 of yacc.c  */
#line 8171 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1195:
/* Line 1792 of yacc.c  */
#line 8180 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1196:
/* Line 1792 of yacc.c  */
#line 8189 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1197:
/* Line 1792 of yacc.c  */
#line 8198 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1198:
/* Line 1792 of yacc.c  */
#line 8208 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1199:
/* Line 1792 of yacc.c  */
#line 8218 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1200:
/* Line 1792 of yacc.c  */
#line 8227 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1201:
/* Line 1792 of yacc.c  */
#line 8236 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1202:
/* Line 1792 of yacc.c  */
#line 8245 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1203:
/* Line 1792 of yacc.c  */
#line 8254 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1204:
/* Line 1792 of yacc.c  */
#line 8263 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1205:
/* Line 1792 of yacc.c  */
#line 8272 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1206:
/* Line 1792 of yacc.c  */
#line 8281 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1207:
/* Line 1792 of yacc.c  */
#line 8290 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1208:
/* Line 1792 of yacc.c  */
#line 8299 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1209:
/* Line 1792 of yacc.c  */
#line 8308 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1210:
/* Line 1792 of yacc.c  */
#line 8317 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1211:
/* Line 1792 of yacc.c  */
#line 8326 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1212:
/* Line 1792 of yacc.c  */
#line 8335 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1213:
/* Line 1792 of yacc.c  */
#line 8344 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1214:
/* Line 1792 of yacc.c  */
#line 8353 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1215:
/* Line 1792 of yacc.c  */
#line 8362 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1216:
/* Line 1792 of yacc.c  */
#line 8380 "gram.y"
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[(3) - (8)].list);
					n->operargs = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1217:
/* Line 1792 of yacc.c  */
#line 8389 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1218:
/* Line 1792 of yacc.c  */
#line 8390 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1219:
/* Line 1792 of yacc.c  */
#line 8394 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), NULL); }
    break;

  case 1220:
/* Line 1792 of yacc.c  */
#line 8396 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node)); }
    break;

  case 1221:
/* Line 1792 of yacc.c  */
#line 8406 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1222:
/* Line 1792 of yacc.c  */
#line 8415 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1223:
/* Line 1792 of yacc.c  */
#line 8423 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1224:
/* Line 1792 of yacc.c  */
#line 8431 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1225:
/* Line 1792 of yacc.c  */
#line 8439 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1226:
/* Line 1792 of yacc.c  */
#line 8447 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1227:
/* Line 1792 of yacc.c  */
#line 8456 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1228:
/* Line 1792 of yacc.c  */
#line 8464 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1229:
/* Line 1792 of yacc.c  */
#line 8472 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1230:
/* Line 1792 of yacc.c  */
#line 8481 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newowner = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1231:
/* Line 1792 of yacc.c  */
#line 8489 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newowner = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1232:
/* Line 1792 of yacc.c  */
#line 8497 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1233:
/* Line 1792 of yacc.c  */
#line 8505 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1234:
/* Line 1792 of yacc.c  */
#line 8513 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1235:
/* Line 1792 of yacc.c  */
#line 8521 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1236:
/* Line 1792 of yacc.c  */
#line 8529 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1237:
/* Line 1792 of yacc.c  */
#line 8537 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1238:
/* Line 1792 of yacc.c  */
#line 8545 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1239:
/* Line 1792 of yacc.c  */
#line 8553 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1240:
/* Line 1792 of yacc.c  */
#line 8572 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1241:
/* Line 1792 of yacc.c  */
#line 8586 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1242:
/* Line 1792 of yacc.c  */
#line 8587 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1243:
/* Line 1792 of yacc.c  */
#line 8588 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1244:
/* Line 1792 of yacc.c  */
#line 8594 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1245:
/* Line 1792 of yacc.c  */
#line 8600 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1251:
/* Line 1792 of yacc.c  */
#line 8616 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1252:
/* Line 1792 of yacc.c  */
#line 8617 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1253:
/* Line 1792 of yacc.c  */
#line 8620 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1254:
/* Line 1792 of yacc.c  */
#line 8621 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1255:
/* Line 1792 of yacc.c  */
#line 8622 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1256:
/* Line 1792 of yacc.c  */
#line 8623 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1257:
/* Line 1792 of yacc.c  */
#line 8627 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1258:
/* Line 1792 of yacc.c  */
#line 8628 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1259:
/* Line 1792 of yacc.c  */
#line 8629 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1260:
/* Line 1792 of yacc.c  */
#line 8635 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1261:
/* Line 1792 of yacc.c  */
#line 8646 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1262:
/* Line 1792 of yacc.c  */
#line 8668 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1263:
/* Line 1792 of yacc.c  */
#line 8677 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1264:
/* Line 1792 of yacc.c  */
#line 8678 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1265:
/* Line 1792 of yacc.c  */
#line 8682 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1266:
/* Line 1792 of yacc.c  */
#line 8691 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1267:
/* Line 1792 of yacc.c  */
#line 8697 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1268:
/* Line 1792 of yacc.c  */
#line 8716 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1269:
/* Line 1792 of yacc.c  */
#line 8723 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1270:
/* Line 1792 of yacc.c  */
#line 8730 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1271:
/* Line 1792 of yacc.c  */
#line 8737 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1272:
/* Line 1792 of yacc.c  */
#line 8744 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1273:
/* Line 1792 of yacc.c  */
#line 8751 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1274:
/* Line 1792 of yacc.c  */
#line 8758 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1275:
/* Line 1792 of yacc.c  */
#line 8766 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1276:
/* Line 1792 of yacc.c  */
#line 8774 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1277:
/* Line 1792 of yacc.c  */
#line 8782 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1278:
/* Line 1792 of yacc.c  */
#line 8790 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1279:
/* Line 1792 of yacc.c  */
#line 8798 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1280:
/* Line 1792 of yacc.c  */
#line 8805 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1281:
/* Line 1792 of yacc.c  */
#line 8812 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1282:
/* Line 1792 of yacc.c  */
#line 8820 "gram.y"
    {}
    break;

  case 1283:
/* Line 1792 of yacc.c  */
#line 8821 "gram.y"
    {}
    break;

  case 1284:
/* Line 1792 of yacc.c  */
#line 8822 "gram.y"
    {}
    break;

  case 1285:
/* Line 1792 of yacc.c  */
#line 8827 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1286:
/* Line 1792 of yacc.c  */
#line 8830 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1287:
/* Line 1792 of yacc.c  */
#line 8833 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1288:
/* Line 1792 of yacc.c  */
#line 8836 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1289:
/* Line 1792 of yacc.c  */
#line 8839 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1290:
/* Line 1792 of yacc.c  */
#line 8846 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1291:
/* Line 1792 of yacc.c  */
#line 8848 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1292:
/* Line 1792 of yacc.c  */
#line 8850 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1294:
/* Line 1792 of yacc.c  */
#line 8856 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1295:
/* Line 1792 of yacc.c  */
#line 8870 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					n->withCheckOption = (yyvsp[(9) - (9)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1296:
/* Line 1792 of yacc.c  */
#line 8883 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					n->withCheckOption = (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1297:
/* Line 1792 of yacc.c  */
#line 8896 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(5) - (12)].range);
					n->view->relpersistence = (yyvsp[(2) - (12)].ival);
					n->aliases = (yyvsp[(7) - (12)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(11) - (12)].node));
					n->replace = false;
					n->options = (yyvsp[(9) - (12)].list);
					n->withCheckOption = (yyvsp[(12) - (12)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(12) - (12)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1298:
/* Line 1792 of yacc.c  */
#line 8914 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(7) - (14)].range);
					n->view->relpersistence = (yyvsp[(4) - (14)].ival);
					n->aliases = (yyvsp[(9) - (14)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(13) - (14)].node));
					n->replace = true;
					n->options = (yyvsp[(11) - (14)].list);
					n->withCheckOption = (yyvsp[(14) - (14)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(14) - (14)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1299:
/* Line 1792 of yacc.c  */
#line 8933 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1300:
/* Line 1792 of yacc.c  */
#line 8934 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1301:
/* Line 1792 of yacc.c  */
#line 8935 "gram.y"
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
    break;

  case 1302:
/* Line 1792 of yacc.c  */
#line 8936 "gram.y"
    { (yyval.ival) = NO_CHECK_OPTION; }
    break;

  case 1303:
/* Line 1792 of yacc.c  */
#line 8947 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1304:
/* Line 1792 of yacc.c  */
#line 8963 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1305:
/* Line 1792 of yacc.c  */
#line 8972 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1306:
/* Line 1792 of yacc.c  */
#line 8973 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1307:
/* Line 1792 of yacc.c  */
#line 8977 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1308:
/* Line 1792 of yacc.c  */
#line 8978 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1309:
/* Line 1792 of yacc.c  */
#line 8983 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1310:
/* Line 1792 of yacc.c  */
#line 8987 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1311:
/* Line 1792 of yacc.c  */
#line 8991 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), NULL);
				}
    break;

  case 1312:
/* Line 1792 of yacc.c  */
#line 9008 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1313:
/* Line 1792 of yacc.c  */
#line 9009 "gram.y"
    { (yyval.str) = pstrdup("connection_limit"); }
    break;

  case 1314:
/* Line 1792 of yacc.c  */
#line 9010 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1315:
/* Line 1792 of yacc.c  */
#line 9011 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1316:
/* Line 1792 of yacc.c  */
#line 9012 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1317:
/* Line 1792 of yacc.c  */
#line 9013 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1318:
/* Line 1792 of yacc.c  */
#line 9014 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1319:
/* Line 1792 of yacc.c  */
#line 9021 "gram.y"
    {}
    break;

  case 1320:
/* Line 1792 of yacc.c  */
#line 9022 "gram.y"
    {}
    break;

  case 1321:
/* Line 1792 of yacc.c  */
#line 9034 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1322:
/* Line 1792 of yacc.c  */
#line 9041 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1323:
/* Line 1792 of yacc.c  */
#line 9048 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1324:
/* Line 1792 of yacc.c  */
#line 9059 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1325:
/* Line 1792 of yacc.c  */
#line 9076 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1326:
/* Line 1792 of yacc.c  */
#line 9083 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1327:
/* Line 1792 of yacc.c  */
#line 9101 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1328:
/* Line 1792 of yacc.c  */
#line 9107 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1329:
/* Line 1792 of yacc.c  */
#line 9123 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1330:
/* Line 1792 of yacc.c  */
#line 9136 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1331:
/* Line 1792 of yacc.c  */
#line 9145 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1332:
/* Line 1792 of yacc.c  */
#line 9153 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1333:
/* Line 1792 of yacc.c  */
#line 9161 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1334:
/* Line 1792 of yacc.c  */
#line 9170 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1335:
/* Line 1792 of yacc.c  */
#line 9181 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1336:
/* Line 1792 of yacc.c  */
#line 9192 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1337:
/* Line 1792 of yacc.c  */
#line 9201 "gram.y"
    {}
    break;

  case 1338:
/* Line 1792 of yacc.c  */
#line 9202 "gram.y"
    {}
    break;

  case 1339:
/* Line 1792 of yacc.c  */
#line 9214 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1340:
/* Line 1792 of yacc.c  */
#line 9224 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1341:
/* Line 1792 of yacc.c  */
#line 9235 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1342:
/* Line 1792 of yacc.c  */
#line 9246 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1343:
/* Line 1792 of yacc.c  */
#line 9257 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1344:
/* Line 1792 of yacc.c  */
#line 9268 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1345:
/* Line 1792 of yacc.c  */
#line 9277 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1346:
/* Line 1792 of yacc.c  */
#line 9288 "gram.y"
    {}
    break;

  case 1347:
/* Line 1792 of yacc.c  */
#line 9289 "gram.y"
    {}
    break;

  case 1348:
/* Line 1792 of yacc.c  */
#line 9305 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1349:
/* Line 1792 of yacc.c  */
#line 9327 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1350:
/* Line 1792 of yacc.c  */
#line 9335 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1351:
/* Line 1792 of yacc.c  */
#line 9344 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1352:
/* Line 1792 of yacc.c  */
#line 9354 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1353:
/* Line 1792 of yacc.c  */
#line 9355 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1354:
/* Line 1792 of yacc.c  */
#line 9368 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (4)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1355:
/* Line 1792 of yacc.c  */
#line 9382 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (5)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1356:
/* Line 1792 of yacc.c  */
#line 9396 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (5)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1357:
/* Line 1792 of yacc.c  */
#line 9408 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1358:
/* Line 1792 of yacc.c  */
#line 9416 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1359:
/* Line 1792 of yacc.c  */
#line 9428 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1360:
/* Line 1792 of yacc.c  */
#line 9429 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1361:
/* Line 1792 of yacc.c  */
#line 9433 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1362:
/* Line 1792 of yacc.c  */
#line 9434 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1363:
/* Line 1792 of yacc.c  */
#line 9435 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1364:
/* Line 1792 of yacc.c  */
#line 9436 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1365:
/* Line 1792 of yacc.c  */
#line 9438 "gram.y"
    {
					if (strcmp((yyvsp[(1) - (1)].str), "disable_page_skipping") == 0)
						(yyval.ival) = VACOPT_DISABLE_PAGE_SKIPPING;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized VACUUM option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 1366:
/* Line 1792 of yacc.c  */
#line 9451 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1367:
/* Line 1792 of yacc.c  */
#line 9461 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1368:
/* Line 1792 of yacc.c  */
#line 9473 "gram.y"
    {}
    break;

  case 1369:
/* Line 1792 of yacc.c  */
#line 9474 "gram.y"
    {}
    break;

  case 1370:
/* Line 1792 of yacc.c  */
#line 9478 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1371:
/* Line 1792 of yacc.c  */
#line 9479 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1372:
/* Line 1792 of yacc.c  */
#line 9482 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1373:
/* Line 1792 of yacc.c  */
#line 9483 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1374:
/* Line 1792 of yacc.c  */
#line 9486 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1375:
/* Line 1792 of yacc.c  */
#line 9487 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1376:
/* Line 1792 of yacc.c  */
#line 9491 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1377:
/* Line 1792 of yacc.c  */
#line 9492 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1378:
/* Line 1792 of yacc.c  */
#line 9506 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1379:
/* Line 1792 of yacc.c  */
#line 9513 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1380:
/* Line 1792 of yacc.c  */
#line 9523 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1381:
/* Line 1792 of yacc.c  */
#line 9530 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1391:
/* Line 1792 of yacc.c  */
#line 9552 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1392:
/* Line 1792 of yacc.c  */
#line 9556 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1393:
/* Line 1792 of yacc.c  */
#line 9563 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1394:
/* Line 1792 of yacc.c  */
#line 9569 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1395:
/* Line 1792 of yacc.c  */
#line 9570 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1396:
/* Line 1792 of yacc.c  */
#line 9574 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1397:
/* Line 1792 of yacc.c  */
#line 9575 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1398:
/* Line 1792 of yacc.c  */
#line 9576 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1399:
/* Line 1792 of yacc.c  */
#line 9587 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1400:
/* Line 1792 of yacc.c  */
#line 9596 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1401:
/* Line 1792 of yacc.c  */
#line 9597 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1406:
/* Line 1792 of yacc.c  */
#line 9615 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1407:
/* Line 1792 of yacc.c  */
#line 9623 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1408:
/* Line 1792 of yacc.c  */
#line 9639 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1409:
/* Line 1792 of yacc.c  */
#line 9640 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1410:
/* Line 1792 of yacc.c  */
#line 9651 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1411:
/* Line 1792 of yacc.c  */
#line 9657 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1412:
/* Line 1792 of yacc.c  */
#line 9663 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1413:
/* Line 1792 of yacc.c  */
#line 9669 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1414:
/* Line 1792 of yacc.c  */
#line 9686 "gram.y"
    {
					(yyvsp[(5) - (7)].istmt)->relation = (yyvsp[(4) - (7)].range);
					(yyvsp[(5) - (7)].istmt)->onConflictClause = (yyvsp[(6) - (7)].onconflict);
					(yyvsp[(5) - (7)].istmt)->returningList = (yyvsp[(7) - (7)].list);
					(yyvsp[(5) - (7)].istmt)->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (7)].istmt);
				}
    break;

  case 1415:
/* Line 1792 of yacc.c  */
#line 9703 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1416:
/* Line 1792 of yacc.c  */
#line 9707 "gram.y"
    {
					(yyvsp[(1) - (3)].range)->alias = makeAlias((yyvsp[(3) - (3)].str), NIL);
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1417:
/* Line 1792 of yacc.c  */
#line 9715 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1418:
/* Line 1792 of yacc.c  */
#line 9721 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1419:
/* Line 1792 of yacc.c  */
#line 9727 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1420:
/* Line 1792 of yacc.c  */
#line 9736 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1421:
/* Line 1792 of yacc.c  */
#line 9738 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1422:
/* Line 1792 of yacc.c  */
#line 9743 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1423:
/* Line 1792 of yacc.c  */
#line 9754 "gram.y"
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[(3) - (8)].infer);
					(yyval.onconflict)->targetList = (yyvsp[(7) - (8)].list);
					(yyval.onconflict)->whereClause = (yyvsp[(8) - (8)].node);
					(yyval.onconflict)->location = (yylsp[(1) - (8)]);
				}
    break;

  case 1424:
/* Line 1792 of yacc.c  */
#line 9764 "gram.y"
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[(3) - (5)].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1425:
/* Line 1792 of yacc.c  */
#line 9773 "gram.y"
    {
					(yyval.onconflict) = NULL;
				}
    break;

  case 1426:
/* Line 1792 of yacc.c  */
#line 9780 "gram.y"
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[(2) - (4)].list);
					(yyval.infer)->whereClause = (yyvsp[(4) - (4)].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 1427:
/* Line 1792 of yacc.c  */
#line 9789 "gram.y"
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[(3) - (3)].str);
					(yyval.infer)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1428:
/* Line 1792 of yacc.c  */
#line 9797 "gram.y"
    {
					(yyval.infer) = NULL;
				}
    break;

  case 1429:
/* Line 1792 of yacc.c  */
#line 9803 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1430:
/* Line 1792 of yacc.c  */
#line 9804 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1431:
/* Line 1792 of yacc.c  */
#line 9817 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1432:
/* Line 1792 of yacc.c  */
#line 9829 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1433:
/* Line 1792 of yacc.c  */
#line 9830 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1434:
/* Line 1792 of yacc.c  */
#line 9842 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1435:
/* Line 1792 of yacc.c  */
#line 9852 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1436:
/* Line 1792 of yacc.c  */
#line 9853 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1437:
/* Line 1792 of yacc.c  */
#line 9856 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1438:
/* Line 1792 of yacc.c  */
#line 9857 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1439:
/* Line 1792 of yacc.c  */
#line 9858 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1440:
/* Line 1792 of yacc.c  */
#line 9859 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1441:
/* Line 1792 of yacc.c  */
#line 9860 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1442:
/* Line 1792 of yacc.c  */
#line 9861 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1443:
/* Line 1792 of yacc.c  */
#line 9862 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1444:
/* Line 1792 of yacc.c  */
#line 9863 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1445:
/* Line 1792 of yacc.c  */
#line 9866 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1446:
/* Line 1792 of yacc.c  */
#line 9867 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1447:
/* Line 1792 of yacc.c  */
#line 9871 "gram.y"
    { (yyval.ival) = LockWaitError; }
    break;

  case 1448:
/* Line 1792 of yacc.c  */
#line 9872 "gram.y"
    { (yyval.ival) = LockWaitSkip; }
    break;

  case 1449:
/* Line 1792 of yacc.c  */
#line 9873 "gram.y"
    { (yyval.ival) = LockWaitBlock; }
    break;

  case 1450:
/* Line 1792 of yacc.c  */
#line 9889 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1451:
/* Line 1792 of yacc.c  */
#line 9902 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1452:
/* Line 1792 of yacc.c  */
#line 9903 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1453:
/* Line 1792 of yacc.c  */
#line 9907 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1454:
/* Line 1792 of yacc.c  */
#line 9908 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1455:
/* Line 1792 of yacc.c  */
#line 9913 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1456:
/* Line 1792 of yacc.c  */
#line 9929 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  This is semantically
					 * equivalent to, and much cheaper to process than, the
					 * general case.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(5) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1457:
/* Line 1792 of yacc.c  */
#line 9955 "gram.y"
    {
					SubLink *sl = makeNode(SubLink);
					int ncolumns = list_length((yyvsp[(2) - (5)].list));
					int i = 1;
					ListCell *col_cell;

					/* First, convert bare SelectStmt into a SubLink */
					sl->subLinkType = MULTIEXPR_SUBLINK;
					sl->subLinkId = 0;		/* will be assigned later */
					sl->testexpr = NULL;
					sl->operName = NIL;
					sl->subselect = (yyvsp[(5) - (5)].node);
					sl->location = (yylsp[(5) - (5)]);

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[(2) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) sl;
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1458:
/* Line 1792 of yacc.c  */
#line 9988 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1459:
/* Line 1792 of yacc.c  */
#line 9998 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1460:
/* Line 1792 of yacc.c  */
#line 9999 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1461:
/* Line 1792 of yacc.c  */
#line 10010 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1462:
/* Line 1792 of yacc.c  */
#line 10020 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1463:
/* Line 1792 of yacc.c  */
#line 10023 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1464:
/* Line 1792 of yacc.c  */
#line 10024 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1465:
/* Line 1792 of yacc.c  */
#line 10025 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1466:
/* Line 1792 of yacc.c  */
#line 10026 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1467:
/* Line 1792 of yacc.c  */
#line 10027 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1468:
/* Line 1792 of yacc.c  */
#line 10030 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1469:
/* Line 1792 of yacc.c  */
#line 10031 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1470:
/* Line 1792 of yacc.c  */
#line 10032 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1473:
/* Line 1792 of yacc.c  */
#line 10085 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1474:
/* Line 1792 of yacc.c  */
#line 10086 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1475:
/* Line 1792 of yacc.c  */
#line 10101 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1476:
/* Line 1792 of yacc.c  */
#line 10103 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1477:
/* Line 1792 of yacc.c  */
#line 10110 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1478:
/* Line 1792 of yacc.c  */
#line 10118 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1479:
/* Line 1792 of yacc.c  */
#line 10126 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1480:
/* Line 1792 of yacc.c  */
#line 10134 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1481:
/* Line 1792 of yacc.c  */
#line 10142 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1482:
/* Line 1792 of yacc.c  */
#line 10150 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1483:
/* Line 1792 of yacc.c  */
#line 10160 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1484:
/* Line 1792 of yacc.c  */
#line 10161 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1485:
/* Line 1792 of yacc.c  */
#line 10191 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1486:
/* Line 1792 of yacc.c  */
#line 10205 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1487:
/* Line 1792 of yacc.c  */
#line 10217 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1488:
/* Line 1792 of yacc.c  */
#line 10219 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1489:
/* Line 1792 of yacc.c  */
#line 10238 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1490:
/* Line 1792 of yacc.c  */
#line 10242 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1491:
/* Line 1792 of yacc.c  */
#line 10246 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1492:
/* Line 1792 of yacc.c  */
#line 10263 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1493:
/* Line 1792 of yacc.c  */
#line 10270 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1494:
/* Line 1792 of yacc.c  */
#line 10277 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1495:
/* Line 1792 of yacc.c  */
#line 10286 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1496:
/* Line 1792 of yacc.c  */
#line 10287 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1497:
/* Line 1792 of yacc.c  */
#line 10291 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1498:
/* Line 1792 of yacc.c  */
#line 10302 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1499:
/* Line 1792 of yacc.c  */
#line 10303 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1500:
/* Line 1792 of yacc.c  */
#line 10308 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1501:
/* Line 1792 of yacc.c  */
#line 10319 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1502:
/* Line 1792 of yacc.c  */
#line 10328 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1503:
/* Line 1792 of yacc.c  */
#line 10333 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1504:
/* Line 1792 of yacc.c  */
#line 10338 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1505:
/* Line 1792 of yacc.c  */
#line 10343 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1506:
/* Line 1792 of yacc.c  */
#line 10348 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1507:
/* Line 1792 of yacc.c  */
#line 10356 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1508:
/* Line 1792 of yacc.c  */
#line 10364 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1509:
/* Line 1792 of yacc.c  */
#line 10369 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1510:
/* Line 1792 of yacc.c  */
#line 10374 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1511:
/* Line 1792 of yacc.c  */
#line 10380 "gram.y"
    {}
    break;

  case 1512:
/* Line 1792 of yacc.c  */
#line 10381 "gram.y"
    {}
    break;

  case 1513:
/* Line 1792 of yacc.c  */
#line 10385 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1514:
/* Line 1792 of yacc.c  */
#line 10386 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1515:
/* Line 1792 of yacc.c  */
#line 10387 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1516:
/* Line 1792 of yacc.c  */
#line 10394 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1517:
/* Line 1792 of yacc.c  */
#line 10395 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1518:
/* Line 1792 of yacc.c  */
#line 10399 "gram.y"
    { (yyval.list) = NIL;}
    break;

  case 1519:
/* Line 1792 of yacc.c  */
#line 10400 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1520:
/* Line 1792 of yacc.c  */
#line 10404 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1521:
/* Line 1792 of yacc.c  */
#line 10405 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1522:
/* Line 1792 of yacc.c  */
#line 10409 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1523:
/* Line 1792 of yacc.c  */
#line 10413 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1524:
/* Line 1792 of yacc.c  */
#line 10414 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1525:
/* Line 1792 of yacc.c  */
#line 10418 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1526:
/* Line 1792 of yacc.c  */
#line 10427 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1527:
/* Line 1792 of yacc.c  */
#line 10439 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1528:
/* Line 1792 of yacc.c  */
#line 10440 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1529:
/* Line 1792 of yacc.c  */
#line 10441 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1530:
/* Line 1792 of yacc.c  */
#line 10442 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1531:
/* Line 1792 of yacc.c  */
#line 10446 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1532:
/* Line 1792 of yacc.c  */
#line 10447 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1533:
/* Line 1792 of yacc.c  */
#line 10452 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1534:
/* Line 1792 of yacc.c  */
#line 10454 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1535:
/* Line 1792 of yacc.c  */
#line 10464 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1536:
/* Line 1792 of yacc.c  */
#line 10469 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1537:
/* Line 1792 of yacc.c  */
#line 10472 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1538:
/* Line 1792 of yacc.c  */
#line 10476 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1539:
/* Line 1792 of yacc.c  */
#line 10478 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1540:
/* Line 1792 of yacc.c  */
#line 10485 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1541:
/* Line 1792 of yacc.c  */
#line 10495 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1542:
/* Line 1792 of yacc.c  */
#line 10496 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1543:
/* Line 1792 of yacc.c  */
#line 10497 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1544:
/* Line 1792 of yacc.c  */
#line 10505 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1545:
/* Line 1792 of yacc.c  */
#line 10509 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1546:
/* Line 1792 of yacc.c  */
#line 10510 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1547:
/* Line 1792 of yacc.c  */
#line 10513 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1548:
/* Line 1792 of yacc.c  */
#line 10514 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1549:
/* Line 1792 of yacc.c  */
#line 10539 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1550:
/* Line 1792 of yacc.c  */
#line 10540 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1551:
/* Line 1792 of yacc.c  */
#line 10544 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1552:
/* Line 1792 of yacc.c  */
#line 10545 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].node)); }
    break;

  case 1553:
/* Line 1792 of yacc.c  */
#line 10549 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1554:
/* Line 1792 of yacc.c  */
#line 10550 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1555:
/* Line 1792 of yacc.c  */
#line 10551 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1556:
/* Line 1792 of yacc.c  */
#line 10552 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1557:
/* Line 1792 of yacc.c  */
#line 10553 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1558:
/* Line 1792 of yacc.c  */
#line 10558 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1559:
/* Line 1792 of yacc.c  */
#line 10571 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1560:
/* Line 1792 of yacc.c  */
#line 10578 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1561:
/* Line 1792 of yacc.c  */
#line 10585 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1562:
/* Line 1792 of yacc.c  */
#line 10591 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1563:
/* Line 1792 of yacc.c  */
#line 10592 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1564:
/* Line 1792 of yacc.c  */
#line 10596 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1565:
/* Line 1792 of yacc.c  */
#line 10597 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1566:
/* Line 1792 of yacc.c  */
#line 10601 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1567:
/* Line 1792 of yacc.c  */
#line 10602 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1568:
/* Line 1792 of yacc.c  */
#line 10606 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1569:
/* Line 1792 of yacc.c  */
#line 10607 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1570:
/* Line 1792 of yacc.c  */
#line 10612 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(2) - (3)].list);
					n->strength = (yyvsp[(1) - (3)].ival);
					n->waitPolicy = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1571:
/* Line 1792 of yacc.c  */
#line 10622 "gram.y"
    { (yyval.ival) = LCS_FORUPDATE; }
    break;

  case 1572:
/* Line 1792 of yacc.c  */
#line 10623 "gram.y"
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
    break;

  case 1573:
/* Line 1792 of yacc.c  */
#line 10624 "gram.y"
    { (yyval.ival) = LCS_FORSHARE; }
    break;

  case 1574:
/* Line 1792 of yacc.c  */
#line 10625 "gram.y"
    { (yyval.ival) = LCS_FORKEYSHARE; }
    break;

  case 1575:
/* Line 1792 of yacc.c  */
#line 10629 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1576:
/* Line 1792 of yacc.c  */
#line 10630 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1577:
/* Line 1792 of yacc.c  */
#line 10636 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1578:
/* Line 1792 of yacc.c  */
#line 10642 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1579:
/* Line 1792 of yacc.c  */
#line 10659 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1580:
/* Line 1792 of yacc.c  */
#line 10660 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1581:
/* Line 1792 of yacc.c  */
#line 10664 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1582:
/* Line 1792 of yacc.c  */
#line 10665 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1583:
/* Line 1792 of yacc.c  */
#line 10672 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1584:
/* Line 1792 of yacc.c  */
#line 10677 "gram.y"
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[(3) - (3)].node);
					(yyvsp[(1) - (3)].range)->alias = (yyvsp[(2) - (3)].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[(1) - (3)].range);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1585:
/* Line 1792 of yacc.c  */
#line 10685 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(1) - (2)].node);
					n->alias = linitial((yyvsp[(2) - (2)].list));
					n->coldeflist = lsecond((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1586:
/* Line 1792 of yacc.c  */
#line 10692 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(2) - (3)].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[(3) - (3)].list));
					n->coldeflist = lsecond((yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1587:
/* Line 1792 of yacc.c  */
#line 10700 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[(2) - (2)].alias) == NULL)
					{
						if (IsA((yyvsp[(1) - (2)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(1) - (2)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1588:
/* Line 1792 of yacc.c  */
#line 10735 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[(2) - (3)].node);
					n->alias = (yyvsp[(3) - (3)].alias);
					/* same coment as above */
					if ((yyvsp[(3) - (3)].alias) == NULL)
					{
						if (IsA((yyvsp[(2) - (3)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(2) - (3)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1589:
/* Line 1792 of yacc.c  */
#line 10760 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1590:
/* Line 1792 of yacc.c  */
#line 10764 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1591:
/* Line 1792 of yacc.c  */
#line 10790 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1592:
/* Line 1792 of yacc.c  */
#line 10794 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1593:
/* Line 1792 of yacc.c  */
#line 10806 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1594:
/* Line 1792 of yacc.c  */
#line 10819 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1595:
/* Line 1792 of yacc.c  */
#line 10833 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1596:
/* Line 1792 of yacc.c  */
#line 10844 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1597:
/* Line 1792 of yacc.c  */
#line 10859 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1598:
/* Line 1792 of yacc.c  */
#line 10865 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1599:
/* Line 1792 of yacc.c  */
#line 10870 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1600:
/* Line 1792 of yacc.c  */
#line 10876 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1601:
/* Line 1792 of yacc.c  */
#line 10882 "gram.y"
    { (yyval.alias) = (yyvsp[(1) - (1)].alias); }
    break;

  case 1602:
/* Line 1792 of yacc.c  */
#line 10883 "gram.y"
    { (yyval.alias) = NULL; }
    break;

  case 1603:
/* Line 1792 of yacc.c  */
#line 10892 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (1)].alias), NIL);
				}
    break;

  case 1604:
/* Line 1792 of yacc.c  */
#line 10896 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1605:
/* Line 1792 of yacc.c  */
#line 10900 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.list) = list_make2(a, (yyvsp[(4) - (5)].list));
				}
    break;

  case 1606:
/* Line 1792 of yacc.c  */
#line 10906 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.list) = list_make2(a, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1607:
/* Line 1792 of yacc.c  */
#line 10912 "gram.y"
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
    break;

  case 1608:
/* Line 1792 of yacc.c  */
#line 10917 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1609:
/* Line 1792 of yacc.c  */
#line 10918 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1610:
/* Line 1792 of yacc.c  */
#line 10919 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1611:
/* Line 1792 of yacc.c  */
#line 10920 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1612:
/* Line 1792 of yacc.c  */
#line 10924 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1613:
/* Line 1792 of yacc.c  */
#line 10925 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1614:
/* Line 1792 of yacc.c  */
#line 10937 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1615:
/* Line 1792 of yacc.c  */
#line 10938 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1616:
/* Line 1792 of yacc.c  */
#line 10944 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1617:
/* Line 1792 of yacc.c  */
#line 10951 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1618:
/* Line 1792 of yacc.c  */
#line 10958 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1619:
/* Line 1792 of yacc.c  */
#line 10965 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1620:
/* Line 1792 of yacc.c  */
#line 10975 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1621:
/* Line 1792 of yacc.c  */
#line 10976 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1622:
/* Line 1792 of yacc.c  */
#line 10990 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1623:
/* Line 1792 of yacc.c  */
#line 10994 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1624:
/* Line 1792 of yacc.c  */
#line 11001 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1625:
/* Line 1792 of yacc.c  */
#line 11014 "gram.y"
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[(2) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->repeatable = (yyvsp[(6) - (6)].node);
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1626:
/* Line 1792 of yacc.c  */
#line 11026 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].node); }
    break;

  case 1627:
/* Line 1792 of yacc.c  */
#line 11027 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1628:
/* Line 1792 of yacc.c  */
#line 11043 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(2) - (2)].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[(1) - (2)].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1629:
/* Line 1792 of yacc.c  */
#line 11053 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(6) - (6)].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[(4) - (6)].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1630:
/* Line 1792 of yacc.c  */
#line 11065 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list)); }
    break;

  case 1631:
/* Line 1792 of yacc.c  */
#line 11069 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 1632:
/* Line 1792 of yacc.c  */
#line 11070 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 1633:
/* Line 1792 of yacc.c  */
#line 11073 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1634:
/* Line 1792 of yacc.c  */
#line 11074 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1635:
/* Line 1792 of yacc.c  */
#line 11077 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 1636:
/* Line 1792 of yacc.c  */
#line 11078 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 1637:
/* Line 1792 of yacc.c  */
#line 11083 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1638:
/* Line 1792 of yacc.c  */
#line 11084 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1639:
/* Line 1792 of yacc.c  */
#line 11089 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1640:
/* Line 1792 of yacc.c  */
#line 11091 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1641:
/* Line 1792 of yacc.c  */
#line 11098 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1642:
/* Line 1792 of yacc.c  */
#line 11103 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1643:
/* Line 1792 of yacc.c  */
#line 11104 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1644:
/* Line 1792 of yacc.c  */
#line 11109 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1645:
/* Line 1792 of yacc.c  */
#line 11113 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1646:
/* Line 1792 of yacc.c  */
#line 11119 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1647:
/* Line 1792 of yacc.c  */
#line 11149 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1648:
/* Line 1792 of yacc.c  */
#line 11154 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1649:
/* Line 1792 of yacc.c  */
#line 11161 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1650:
/* Line 1792 of yacc.c  */
#line 11166 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1651:
/* Line 1792 of yacc.c  */
#line 11172 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1652:
/* Line 1792 of yacc.c  */
#line 11177 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1653:
/* Line 1792 of yacc.c  */
#line 11186 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1654:
/* Line 1792 of yacc.c  */
#line 11188 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1655:
/* Line 1792 of yacc.c  */
#line 11190 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1656:
/* Line 1792 of yacc.c  */
#line 11194 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1657:
/* Line 1792 of yacc.c  */
#line 11195 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1658:
/* Line 1792 of yacc.c  */
#line 11196 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1659:
/* Line 1792 of yacc.c  */
#line 11197 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1660:
/* Line 1792 of yacc.c  */
#line 11198 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1661:
/* Line 1792 of yacc.c  */
#line 11200 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1662:
/* Line 1792 of yacc.c  */
#line 11205 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (4)].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1663:
/* Line 1792 of yacc.c  */
#line 11224 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1664:
/* Line 1792 of yacc.c  */
#line 11225 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1665:
/* Line 1792 of yacc.c  */
#line 11226 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1666:
/* Line 1792 of yacc.c  */
#line 11227 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1667:
/* Line 1792 of yacc.c  */
#line 11239 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1668:
/* Line 1792 of yacc.c  */
#line 11245 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1669:
/* Line 1792 of yacc.c  */
#line 11252 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1670:
/* Line 1792 of yacc.c  */
#line 11253 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1671:
/* Line 1792 of yacc.c  */
#line 11260 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1672:
/* Line 1792 of yacc.c  */
#line 11265 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1673:
/* Line 1792 of yacc.c  */
#line 11270 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1674:
/* Line 1792 of yacc.c  */
#line 11275 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1675:
/* Line 1792 of yacc.c  */
#line 11280 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1676:
/* Line 1792 of yacc.c  */
#line 11285 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1677:
/* Line 1792 of yacc.c  */
#line 11290 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1678:
/* Line 1792 of yacc.c  */
#line 11295 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1679:
/* Line 1792 of yacc.c  */
#line 11301 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1680:
/* Line 1792 of yacc.c  */
#line 11307 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1681:
/* Line 1792 of yacc.c  */
#line 11313 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1682:
/* Line 1792 of yacc.c  */
#line 11320 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1683:
/* Line 1792 of yacc.c  */
#line 11341 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1684:
/* Line 1792 of yacc.c  */
#line 11351 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1685:
/* Line 1792 of yacc.c  */
#line 11355 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1686:
/* Line 1792 of yacc.c  */
#line 11363 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1687:
/* Line 1792 of yacc.c  */
#line 11367 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1688:
/* Line 1792 of yacc.c  */
#line 11375 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1689:
/* Line 1792 of yacc.c  */
#line 11387 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1690:
/* Line 1792 of yacc.c  */
#line 11408 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1691:
/* Line 1792 of yacc.c  */
#line 11412 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1692:
/* Line 1792 of yacc.c  */
#line 11418 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1693:
/* Line 1792 of yacc.c  */
#line 11422 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1694:
/* Line 1792 of yacc.c  */
#line 11435 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
						(yyvsp[(1) - (5)].str) = psprintf("%s_%s", (yyvsp[(1) - (5)].str), (yyvsp[(5) - (5)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1695:
/* Line 1792 of yacc.c  */
#line 11446 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
						(yyvsp[(1) - (2)].str) = psprintf("%s_%s", (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1696:
/* Line 1792 of yacc.c  */
#line 11461 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1697:
/* Line 1792 of yacc.c  */
#line 11463 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1698:
/* Line 1792 of yacc.c  */
#line 11465 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1699:
/* Line 1792 of yacc.c  */
#line 11467 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1700:
/* Line 1792 of yacc.c  */
#line 11469 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1701:
/* Line 1792 of yacc.c  */
#line 11471 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1702:
/* Line 1792 of yacc.c  */
#line 11475 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1703:
/* Line 1792 of yacc.c  */
#line 11476 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1704:
/* Line 1792 of yacc.c  */
#line 11480 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1705:
/* Line 1792 of yacc.c  */
#line 11481 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1706:
/* Line 1792 of yacc.c  */
#line 11489 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1707:
/* Line 1792 of yacc.c  */
#line 11498 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1708:
/* Line 1792 of yacc.c  */
#line 11506 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1709:
/* Line 1792 of yacc.c  */
#line 11515 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1710:
/* Line 1792 of yacc.c  */
#line 11526 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1711:
/* Line 1792 of yacc.c  */
#line 11533 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1712:
/* Line 1792 of yacc.c  */
#line 11534 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1713:
/* Line 1792 of yacc.c  */
#line 11535 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1714:
/* Line 1792 of yacc.c  */
#line 11540 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1715:
/* Line 1792 of yacc.c  */
#line 11542 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1716:
/* Line 1792 of yacc.c  */
#line 11544 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1717:
/* Line 1792 of yacc.c  */
#line 11546 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1718:
/* Line 1792 of yacc.c  */
#line 11548 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1719:
/* Line 1792 of yacc.c  */
#line 11550 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1720:
/* Line 1792 of yacc.c  */
#line 11552 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1721:
/* Line 1792 of yacc.c  */
#line 11557 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1722:
/* Line 1792 of yacc.c  */
#line 11562 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1723:
/* Line 1792 of yacc.c  */
#line 11568 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1724:
/* Line 1792 of yacc.c  */
#line 11576 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1725:
/* Line 1792 of yacc.c  */
#line 11581 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1726:
/* Line 1792 of yacc.c  */
#line 11588 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1727:
/* Line 1792 of yacc.c  */
#line 11594 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1728:
/* Line 1792 of yacc.c  */
#line 11599 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1729:
/* Line 1792 of yacc.c  */
#line 11603 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1730:
/* Line 1792 of yacc.c  */
#line 11638 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1731:
/* Line 1792 of yacc.c  */
#line 11640 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1732:
/* Line 1792 of yacc.c  */
#line 11642 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1733:
/* Line 1792 of yacc.c  */
#line 11650 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node)),
											   (yylsp[(2) - (5)]));
				}
    break;

  case 1734:
/* Line 1792 of yacc.c  */
#line 11665 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1735:
/* Line 1792 of yacc.c  */
#line 11667 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1736:
/* Line 1792 of yacc.c  */
#line 11669 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1737:
/* Line 1792 of yacc.c  */
#line 11671 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1738:
/* Line 1792 of yacc.c  */
#line 11673 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1739:
/* Line 1792 of yacc.c  */
#line 11675 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1740:
/* Line 1792 of yacc.c  */
#line 11677 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1741:
/* Line 1792 of yacc.c  */
#line 11679 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1742:
/* Line 1792 of yacc.c  */
#line 11681 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1743:
/* Line 1792 of yacc.c  */
#line 11683 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1744:
/* Line 1792 of yacc.c  */
#line 11685 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1745:
/* Line 1792 of yacc.c  */
#line 11687 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1746:
/* Line 1792 of yacc.c  */
#line 11689 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1747:
/* Line 1792 of yacc.c  */
#line 11691 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1748:
/* Line 1792 of yacc.c  */
#line 11694 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1749:
/* Line 1792 of yacc.c  */
#line 11696 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1750:
/* Line 1792 of yacc.c  */
#line 11698 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1751:
/* Line 1792 of yacc.c  */
#line 11701 "gram.y"
    { (yyval.node) = makeAndExpr((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1752:
/* Line 1792 of yacc.c  */
#line 11703 "gram.y"
    { (yyval.node) = makeOrExpr((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1753:
/* Line 1792 of yacc.c  */
#line 11705 "gram.y"
    { (yyval.node) = makeNotExpr((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1754:
/* Line 1792 of yacc.c  */
#line 11707 "gram.y"
    { (yyval.node) = makeNotExpr((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1755:
/* Line 1792 of yacc.c  */
#line 11710 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
				}
    break;

  case 1756:
/* Line 1792 of yacc.c  */
#line 11715 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1757:
/* Line 1792 of yacc.c  */
#line 11723 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
				}
    break;

  case 1758:
/* Line 1792 of yacc.c  */
#line 11728 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1759:
/* Line 1792 of yacc.c  */
#line 11736 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
				}
    break;

  case 1760:
/* Line 1792 of yacc.c  */
#line 11741 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1761:
/* Line 1792 of yacc.c  */
#line 11749 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
				}
    break;

  case 1762:
/* Line 1792 of yacc.c  */
#line 11754 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1763:
/* Line 1792 of yacc.c  */
#line 11763 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (4)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1764:
/* Line 1792 of yacc.c  */
#line 11771 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1765:
/* Line 1792 of yacc.c  */
#line 11779 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1766:
/* Line 1792 of yacc.c  */
#line 11787 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
											   (yylsp[(2) - (7)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1767:
/* Line 1792 of yacc.c  */
#line 11805 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1768:
/* Line 1792 of yacc.c  */
#line 11813 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1769:
/* Line 1792 of yacc.c  */
#line 11821 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1770:
/* Line 1792 of yacc.c  */
#line 11829 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1771:
/* Line 1792 of yacc.c  */
#line 11837 "gram.y"
    {
					if (list_length((yyvsp[(1) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[(1) - (3)]))));
					if (list_length((yyvsp[(3) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[(3) - (3)]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)),
											   (yylsp[(2) - (3)]));
				}
    break;

  case 1772:
/* Line 1792 of yacc.c  */
#line 11853 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1773:
/* Line 1792 of yacc.c  */
#line 11861 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1774:
/* Line 1792 of yacc.c  */
#line 11869 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1775:
/* Line 1792 of yacc.c  */
#line 11877 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1776:
/* Line 1792 of yacc.c  */
#line 11885 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1777:
/* Line 1792 of yacc.c  */
#line 11893 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1778:
/* Line 1792 of yacc.c  */
#line 11901 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1779:
/* Line 1792 of yacc.c  */
#line 11905 "gram.y"
    {
					(yyval.node) = makeNotExpr((Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															   "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
									 (yylsp[(2) - (6)]));
				}
    break;

  case 1780:
/* Line 1792 of yacc.c  */
#line 11911 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1781:
/* Line 1792 of yacc.c  */
#line 11915 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1782:
/* Line 1792 of yacc.c  */
#line 11919 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[(1) - (6)].node),
												   (Node *) list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
												   (yylsp[(2) - (6)]));
				}
    break;

  case 1783:
/* Line 1792 of yacc.c  */
#line 11927 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[(1) - (7)].node),
												   (Node *) list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
												   (yylsp[(2) - (7)]));
				}
    break;

  case 1784:
/* Line 1792 of yacc.c  */
#line 11935 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[(1) - (6)].node),
												   (Node *) list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
												   (yylsp[(2) - (6)]));
				}
    break;

  case 1785:
/* Line 1792 of yacc.c  */
#line 11943 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[(1) - (7)].node),
												   (Node *) list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
												   (yylsp[(2) - (7)]));
				}
    break;

  case 1786:
/* Line 1792 of yacc.c  */
#line 11951 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1787:
/* Line 1792 of yacc.c  */
#line 11971 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[(2) - (4)]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1788:
/* Line 1792 of yacc.c  */
#line 11993 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1789:
/* Line 1792 of yacc.c  */
#line 12004 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1790:
/* Line 1792 of yacc.c  */
#line 12011 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1791:
/* Line 1792 of yacc.c  */
#line 12027 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1792:
/* Line 1792 of yacc.c  */
#line 12032 "gram.y"
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
									 (yylsp[(2) - (4)]));
				}
    break;

  case 1793:
/* Line 1792 of yacc.c  */
#line 12049 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1794:
/* Line 1792 of yacc.c  */
#line 12051 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1795:
/* Line 1792 of yacc.c  */
#line 12053 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1796:
/* Line 1792 of yacc.c  */
#line 12055 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1797:
/* Line 1792 of yacc.c  */
#line 12057 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1798:
/* Line 1792 of yacc.c  */
#line 12059 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1799:
/* Line 1792 of yacc.c  */
#line 12061 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1800:
/* Line 1792 of yacc.c  */
#line 12063 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1801:
/* Line 1792 of yacc.c  */
#line 12065 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1802:
/* Line 1792 of yacc.c  */
#line 12067 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1803:
/* Line 1792 of yacc.c  */
#line 12069 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1804:
/* Line 1792 of yacc.c  */
#line 12071 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1805:
/* Line 1792 of yacc.c  */
#line 12073 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1806:
/* Line 1792 of yacc.c  */
#line 12075 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1807:
/* Line 1792 of yacc.c  */
#line 12077 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1808:
/* Line 1792 of yacc.c  */
#line 12079 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1809:
/* Line 1792 of yacc.c  */
#line 12081 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1810:
/* Line 1792 of yacc.c  */
#line 12083 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1811:
/* Line 1792 of yacc.c  */
#line 12085 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1812:
/* Line 1792 of yacc.c  */
#line 12087 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1813:
/* Line 1792 of yacc.c  */
#line 12091 "gram.y"
    {
					(yyval.node) = makeNotExpr((Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															   "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
									 (yylsp[(2) - (6)]));
				}
    break;

  case 1814:
/* Line 1792 of yacc.c  */
#line 12097 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1815:
/* Line 1792 of yacc.c  */
#line 12101 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1816:
/* Line 1792 of yacc.c  */
#line 12105 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1817:
/* Line 1792 of yacc.c  */
#line 12110 "gram.y"
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
									 (yylsp[(2) - (4)]));
				}
    break;

  case 1818:
/* Line 1792 of yacc.c  */
#line 12125 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1819:
/* Line 1792 of yacc.c  */
#line 12126 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1820:
/* Line 1792 of yacc.c  */
#line 12128 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1821:
/* Line 1792 of yacc.c  */
#line 12143 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[(2) - (4)].node), NULL, (yylsp[(1) - (4)]));
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1822:
/* Line 1792 of yacc.c  */
#line 12173 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1823:
/* Line 1792 of yacc.c  */
#line 12175 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1824:
/* Line 1792 of yacc.c  */
#line 12177 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1825:
/* Line 1792 of yacc.c  */
#line 12188 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1826:
/* Line 1792 of yacc.c  */
#line 12212 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1827:
/* Line 1792 of yacc.c  */
#line 12223 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1828:
/* Line 1792 of yacc.c  */
#line 12234 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1829:
/* Line 1792 of yacc.c  */
#line 12242 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1830:
/* Line 1792 of yacc.c  */
#line 12252 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1831:
/* Line 1792 of yacc.c  */
#line 12262 "gram.y"
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[(3) - (4)].list);
				  g->location = (yylsp[(1) - (4)]);
				  (yyval.node) = (Node *)g;
			  }
    break;

  case 1832:
/* Line 1792 of yacc.c  */
#line 12271 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[(1) - (3)].list), NIL, (yylsp[(1) - (3)]));
				}
    break;

  case 1833:
/* Line 1792 of yacc.c  */
#line 12275 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (5)].list), (yyvsp[(3) - (5)].list), (yylsp[(1) - (5)]));
					n->agg_order = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1834:
/* Line 1792 of yacc.c  */
#line 12281 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), list_make1((yyvsp[(4) - (6)].node)), (yylsp[(1) - (6)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1835:
/* Line 1792 of yacc.c  */
#line 12288 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (8)].list), lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node)), (yylsp[(1) - (8)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1836:
/* Line 1792 of yacc.c  */
#line 12295 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1837:
/* Line 1792 of yacc.c  */
#line 12305 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1838:
/* Line 1792 of yacc.c  */
#line 12312 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[(1) - (4)].list), NIL, (yylsp[(1) - (4)]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1839:
/* Line 1792 of yacc.c  */
#line 12340 "gram.y"
    {
					FuncCall *n = (FuncCall *) (yyvsp[(1) - (4)].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[(2) - (4)].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						n->agg_order = (yyvsp[(2) - (4)].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[(3) - (4)].node);
					n->over = (yyvsp[(4) - (4)].windef);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1840:
/* Line 1792 of yacc.c  */
#line 12375 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1841:
/* Line 1792 of yacc.c  */
#line 12385 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1842:
/* Line 1792 of yacc.c  */
#line 12386 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1843:
/* Line 1792 of yacc.c  */
#line 12394 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[(4) - (5)].node)),
											   (yylsp[(1) - (5)]));
				}
    break;

  case 1844:
/* Line 1792 of yacc.c  */
#line 12400 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1845:
/* Line 1792 of yacc.c  */
#line 12426 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1846:
/* Line 1792 of yacc.c  */
#line 12436 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1847:
/* Line 1792 of yacc.c  */
#line 12449 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1848:
/* Line 1792 of yacc.c  */
#line 12457 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1849:
/* Line 1792 of yacc.c  */
#line 12470 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1850:
/* Line 1792 of yacc.c  */
#line 12480 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1851:
/* Line 1792 of yacc.c  */
#line 12493 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1852:
/* Line 1792 of yacc.c  */
#line 12503 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1853:
/* Line 1792 of yacc.c  */
#line 12516 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1854:
/* Line 1792 of yacc.c  */
#line 12520 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1855:
/* Line 1792 of yacc.c  */
#line 12524 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1856:
/* Line 1792 of yacc.c  */
#line 12528 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1857:
/* Line 1792 of yacc.c  */
#line 12532 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1858:
/* Line 1792 of yacc.c  */
#line 12536 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1859:
/* Line 1792 of yacc.c  */
#line 12540 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1860:
/* Line 1792 of yacc.c  */
#line 12542 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1861:
/* Line 1792 of yacc.c  */
#line 12546 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1862:
/* Line 1792 of yacc.c  */
#line 12555 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1863:
/* Line 1792 of yacc.c  */
#line 12560 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1864:
/* Line 1792 of yacc.c  */
#line 12567 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str),
												list_make1((yyvsp[(3) - (6)].node)),
												(yylsp[(1) - (6)]));
				}
    break;

  case 1865:
/* Line 1792 of yacc.c  */
#line 12582 "gram.y"
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1866:
/* Line 1792 of yacc.c  */
#line 12589 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1867:
/* Line 1792 of yacc.c  */
#line 12593 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1868:
/* Line 1792 of yacc.c  */
#line 12597 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1869:
/* Line 1792 of yacc.c  */
#line 12601 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1870:
/* Line 1792 of yacc.c  */
#line 12605 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1871:
/* Line 1792 of yacc.c  */
#line 12612 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1872:
/* Line 1792 of yacc.c  */
#line 12620 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1873:
/* Line 1792 of yacc.c  */
#line 12628 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1874:
/* Line 1792 of yacc.c  */
#line 12632 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1875:
/* Line 1792 of yacc.c  */
#line 12636 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1876:
/* Line 1792 of yacc.c  */
#line 12640 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1877:
/* Line 1792 of yacc.c  */
#line 12644 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1878:
/* Line 1792 of yacc.c  */
#line 12648 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node)), (yylsp[(1) - (5)]));
				}
    break;

  case 1879:
/* Line 1792 of yacc.c  */
#line 12654 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1880:
/* Line 1792 of yacc.c  */
#line 12658 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1881:
/* Line 1792 of yacc.c  */
#line 12667 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1882:
/* Line 1792 of yacc.c  */
#line 12671 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1883:
/* Line 1792 of yacc.c  */
#line 12675 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1884:
/* Line 1792 of yacc.c  */
#line 12680 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1885:
/* Line 1792 of yacc.c  */
#line 12694 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1886:
/* Line 1792 of yacc.c  */
#line 12696 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1887:
/* Line 1792 of yacc.c  */
#line 12700 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1888:
/* Line 1792 of yacc.c  */
#line 12702 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1889:
/* Line 1792 of yacc.c  */
#line 12704 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1890:
/* Line 1792 of yacc.c  */
#line 12706 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1891:
/* Line 1792 of yacc.c  */
#line 12709 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1892:
/* Line 1792 of yacc.c  */
#line 12712 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1893:
/* Line 1792 of yacc.c  */
#line 12713 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1894:
/* Line 1792 of yacc.c  */
#line 12717 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1895:
/* Line 1792 of yacc.c  */
#line 12725 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1896:
/* Line 1792 of yacc.c  */
#line 12734 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1897:
/* Line 1792 of yacc.c  */
#line 12735 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1898:
/* Line 1792 of yacc.c  */
#line 12738 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1899:
/* Line 1792 of yacc.c  */
#line 12739 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1900:
/* Line 1792 of yacc.c  */
#line 12740 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1901:
/* Line 1792 of yacc.c  */
#line 12746 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1902:
/* Line 1792 of yacc.c  */
#line 12750 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1903:
/* Line 1792 of yacc.c  */
#line 12754 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1904:
/* Line 1792 of yacc.c  */
#line 12758 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1905:
/* Line 1792 of yacc.c  */
#line 12768 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1906:
/* Line 1792 of yacc.c  */
#line 12769 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1907:
/* Line 1792 of yacc.c  */
#line 12773 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 1908:
/* Line 1792 of yacc.c  */
#line 12774 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1909:
/* Line 1792 of yacc.c  */
#line 12782 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1910:
/* Line 1792 of yacc.c  */
#line 12783 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1911:
/* Line 1792 of yacc.c  */
#line 12787 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1912:
/* Line 1792 of yacc.c  */
#line 12789 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1913:
/* Line 1792 of yacc.c  */
#line 12794 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1914:
/* Line 1792 of yacc.c  */
#line 12802 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1915:
/* Line 1792 of yacc.c  */
#line 12804 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1916:
/* Line 1792 of yacc.c  */
#line 12817 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1917:
/* Line 1792 of yacc.c  */
#line 12822 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1918:
/* Line 1792 of yacc.c  */
#line 12847 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1919:
/* Line 1792 of yacc.c  */
#line 12848 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1920:
/* Line 1792 of yacc.c  */
#line 12851 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1921:
/* Line 1792 of yacc.c  */
#line 12852 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1922:
/* Line 1792 of yacc.c  */
#line 12864 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1923:
/* Line 1792 of yacc.c  */
#line 12882 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1924:
/* Line 1792 of yacc.c  */
#line 12888 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1925:
/* Line 1792 of yacc.c  */
#line 12898 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1926:
/* Line 1792 of yacc.c  */
#line 12915 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1927:
/* Line 1792 of yacc.c  */
#line 12960 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1928:
/* Line 1792 of yacc.c  */
#line 12968 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1929:
/* Line 1792 of yacc.c  */
#line 12976 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1930:
/* Line 1792 of yacc.c  */
#line 12984 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1931:
/* Line 1792 of yacc.c  */
#line 12992 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1932:
/* Line 1792 of yacc.c  */
#line 13012 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1933:
/* Line 1792 of yacc.c  */
#line 13013 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1934:
/* Line 1792 of yacc.c  */
#line 13014 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1935:
/* Line 1792 of yacc.c  */
#line 13017 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1936:
/* Line 1792 of yacc.c  */
#line 13018 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1937:
/* Line 1792 of yacc.c  */
#line 13021 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1938:
/* Line 1792 of yacc.c  */
#line 13024 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1939:
/* Line 1792 of yacc.c  */
#line 13025 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1940:
/* Line 1792 of yacc.c  */
#line 13026 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1941:
/* Line 1792 of yacc.c  */
#line 13029 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1942:
/* Line 1792 of yacc.c  */
#line 13030 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1943:
/* Line 1792 of yacc.c  */
#line 13033 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1944:
/* Line 1792 of yacc.c  */
#line 13034 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1945:
/* Line 1792 of yacc.c  */
#line 13035 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1946:
/* Line 1792 of yacc.c  */
#line 13036 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1947:
/* Line 1792 of yacc.c  */
#line 13037 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1948:
/* Line 1792 of yacc.c  */
#line 13038 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1949:
/* Line 1792 of yacc.c  */
#line 13039 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1950:
/* Line 1792 of yacc.c  */
#line 13040 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1951:
/* Line 1792 of yacc.c  */
#line 13041 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1952:
/* Line 1792 of yacc.c  */
#line 13042 "gram.y"
    { (yyval.str) = "<="; }
    break;

  case 1953:
/* Line 1792 of yacc.c  */
#line 13043 "gram.y"
    { (yyval.str) = ">="; }
    break;

  case 1954:
/* Line 1792 of yacc.c  */
#line 13044 "gram.y"
    { (yyval.str) = "<>"; }
    break;

  case 1955:
/* Line 1792 of yacc.c  */
#line 13048 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1956:
/* Line 1792 of yacc.c  */
#line 13050 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1957:
/* Line 1792 of yacc.c  */
#line 13055 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1958:
/* Line 1792 of yacc.c  */
#line 13057 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1959:
/* Line 1792 of yacc.c  */
#line 13062 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1960:
/* Line 1792 of yacc.c  */
#line 13064 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1961:
/* Line 1792 of yacc.c  */
#line 13066 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1962:
/* Line 1792 of yacc.c  */
#line 13068 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1963:
/* Line 1792 of yacc.c  */
#line 13070 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1964:
/* Line 1792 of yacc.c  */
#line 13072 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1965:
/* Line 1792 of yacc.c  */
#line 13084 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1966:
/* Line 1792 of yacc.c  */
#line 13088 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1967:
/* Line 1792 of yacc.c  */
#line 13095 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1968:
/* Line 1792 of yacc.c  */
#line 13099 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1969:
/* Line 1792 of yacc.c  */
#line 13105 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1970:
/* Line 1792 of yacc.c  */
#line 13109 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1971:
/* Line 1792 of yacc.c  */
#line 13118 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1972:
/* Line 1792 of yacc.c  */
#line 13128 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1973:
/* Line 1792 of yacc.c  */
#line 13129 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1974:
/* Line 1792 of yacc.c  */
#line 13133 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1975:
/* Line 1792 of yacc.c  */
#line 13137 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1976:
/* Line 1792 of yacc.c  */
#line 13141 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1977:
/* Line 1792 of yacc.c  */
#line 13146 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1978:
/* Line 1792 of yacc.c  */
#line 13147 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1979:
/* Line 1792 of yacc.c  */
#line 13153 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1980:
/* Line 1792 of yacc.c  */
#line 13156 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1981:
/* Line 1792 of yacc.c  */
#line 13163 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1982:
/* Line 1792 of yacc.c  */
#line 13164 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1983:
/* Line 1792 of yacc.c  */
#line 13165 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1984:
/* Line 1792 of yacc.c  */
#line 13166 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1985:
/* Line 1792 of yacc.c  */
#line 13167 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1986:
/* Line 1792 of yacc.c  */
#line 13168 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1987:
/* Line 1792 of yacc.c  */
#line 13169 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1988:
/* Line 1792 of yacc.c  */
#line 13170 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1989:
/* Line 1792 of yacc.c  */
#line 13181 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1990:
/* Line 1792 of yacc.c  */
#line 13185 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1991:
/* Line 1792 of yacc.c  */
#line 13192 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1992:
/* Line 1792 of yacc.c  */
#line 13198 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1993:
/* Line 1792 of yacc.c  */
#line 13199 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1994:
/* Line 1792 of yacc.c  */
#line 13216 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1995:
/* Line 1792 of yacc.c  */
#line 13220 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1996:
/* Line 1792 of yacc.c  */
#line 13225 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1997:
/* Line 1792 of yacc.c  */
#line 13229 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1998:
/* Line 1792 of yacc.c  */
#line 13244 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1999:
/* Line 1792 of yacc.c  */
#line 13248 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 2000:
/* Line 1792 of yacc.c  */
#line 13252 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 2001:
/* Line 1792 of yacc.c  */
#line 13255 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 2002:
/* Line 1792 of yacc.c  */
#line 13258 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 2003:
/* Line 1792 of yacc.c  */
#line 13259 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 2004:
/* Line 1792 of yacc.c  */
#line 13260 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 2005:
/* Line 1792 of yacc.c  */
#line 13264 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 2006:
/* Line 1792 of yacc.c  */
#line 13270 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 2007:
/* Line 1792 of yacc.c  */
#line 13281 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 2008:
/* Line 1792 of yacc.c  */
#line 13294 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2009:
/* Line 1792 of yacc.c  */
#line 13295 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 2010:
/* Line 1792 of yacc.c  */
#line 13300 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 2011:
/* Line 1792 of yacc.c  */
#line 13310 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 2012:
/* Line 1792 of yacc.c  */
#line 13311 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 2013:
/* Line 1792 of yacc.c  */
#line 13314 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 2014:
/* Line 1792 of yacc.c  */
#line 13315 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 2015:
/* Line 1792 of yacc.c  */
#line 13319 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 2016:
/* Line 1792 of yacc.c  */
#line 13323 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 2017:
/* Line 1792 of yacc.c  */
#line 13330 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 2018:
/* Line 1792 of yacc.c  */
#line 13334 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 2019:
/* Line 1792 of yacc.c  */
#line 13338 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 2020:
/* Line 1792 of yacc.c  */
#line 13346 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 2021:
/* Line 1792 of yacc.c  */
#line 13356 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 2022:
/* Line 1792 of yacc.c  */
#line 13357 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 2023:
/* Line 1792 of yacc.c  */
#line 13361 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2024:
/* Line 1792 of yacc.c  */
#line 13362 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 2025:
/* Line 1792 of yacc.c  */
#line 13366 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 2026:
/* Line 1792 of yacc.c  */
#line 13367 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 2029:
/* Line 1792 of yacc.c  */
#line 13382 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 2030:
/* Line 1792 of yacc.c  */
#line 13384 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 2031:
/* Line 1792 of yacc.c  */
#line 13392 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2032:
/* Line 1792 of yacc.c  */
#line 13393 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 2033:
/* Line 1792 of yacc.c  */
#line 13401 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 2034:
/* Line 1792 of yacc.c  */
#line 13411 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 2035:
/* Line 1792 of yacc.c  */
#line 13412 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 2036:
/* Line 1792 of yacc.c  */
#line 13416 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 2037:
/* Line 1792 of yacc.c  */
#line 13417 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 2038:
/* Line 1792 of yacc.c  */
#line 13421 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 2039:
/* Line 1792 of yacc.c  */
#line 13437 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 2040:
/* Line 1792 of yacc.c  */
#line 13445 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 2041:
/* Line 1792 of yacc.c  */
#line 13453 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 2042:
/* Line 1792 of yacc.c  */
#line 13474 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 2043:
/* Line 1792 of yacc.c  */
#line 13475 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 2044:
/* Line 1792 of yacc.c  */
#line 13487 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2045:
/* Line 1792 of yacc.c  */
#line 13491 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 2046:
/* Line 1792 of yacc.c  */
#line 13518 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 2047:
/* Line 1792 of yacc.c  */
#line 13520 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 2048:
/* Line 1792 of yacc.c  */
#line 13524 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2049:
/* Line 1792 of yacc.c  */
#line 13527 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2050:
/* Line 1792 of yacc.c  */
#line 13530 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2051:
/* Line 1792 of yacc.c  */
#line 13532 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2052:
/* Line 1792 of yacc.c  */
#line 13534 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2053:
/* Line 1792 of yacc.c  */
#line 13536 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2054:
/* Line 1792 of yacc.c  */
#line 13547 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 2055:
/* Line 1792 of yacc.c  */
#line 13549 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 2056:
/* Line 1792 of yacc.c  */
#line 13560 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 2057:
/* Line 1792 of yacc.c  */
#line 13564 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2058:
/* Line 1792 of yacc.c  */
#line 13568 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2059:
/* Line 1792 of yacc.c  */
#line 13572 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2060:
/* Line 1792 of yacc.c  */
#line 13576 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2061:
/* Line 1792 of yacc.c  */
#line 13585 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 2062:
/* Line 1792 of yacc.c  */
#line 13592 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (6)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[(3) - (6)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[(4) - (6)].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[(4) - (6)]))));

					t->typmods = (yyvsp[(3) - (6)].list);
					t->location = (yylsp[(1) - (6)]);
					(yyval.node) = makeStringConstCast((yyvsp[(6) - (6)].str), (yylsp[(6) - (6)]), t);
				}
    break;

  case 2063:
/* Line 1792 of yacc.c  */
#line 13624 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 2064:
/* Line 1792 of yacc.c  */
#line 13628 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 2065:
/* Line 1792 of yacc.c  */
#line 13634 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (5)].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 2066:
/* Line 1792 of yacc.c  */
#line 13641 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 2067:
/* Line 1792 of yacc.c  */
#line 13645 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 2068:
/* Line 1792 of yacc.c  */
#line 13649 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 2069:
/* Line 1792 of yacc.c  */
#line 13654 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 2070:
/* Line 1792 of yacc.c  */
#line 13655 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2071:
/* Line 1792 of yacc.c  */
#line 13657 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 2072:
/* Line 1792 of yacc.c  */
#line 13658 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 2073:
/* Line 1792 of yacc.c  */
#line 13659 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 2074:
/* Line 1792 of yacc.c  */
#line 13664 "gram.y"
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[(1) - (1)].node);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[(1) - (1)]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[(1) - (1)]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[(1) - (1)]))));
					}
				}
    break;

  case 2075:
/* Line 1792 of yacc.c  */
#line 13694 "gram.y"
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[(1) - (1)]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[(1) - (1)].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[(1) - (1)]))));
						}
						else
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_CSTRING, (yylsp[(1) - (1)]));
							n->rolename = pstrdup((yyvsp[(1) - (1)].str));
						}
						(yyval.node) = (Node *) n;
					}
    break;

  case 2076:
/* Line 1792 of yacc.c  */
#line 13721 "gram.y"
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[(1) - (1)]));
					}
    break;

  case 2077:
/* Line 1792 of yacc.c  */
#line 13725 "gram.y"
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[(1) - (1)]));
					}
    break;

  case 2078:
/* Line 1792 of yacc.c  */
#line 13731 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2079:
/* Line 1792 of yacc.c  */
#line 13733 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 2080:
/* Line 1792 of yacc.c  */
#line 13749 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2081:
/* Line 1792 of yacc.c  */
#line 13750 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2082:
/* Line 1792 of yacc.c  */
#line 13751 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2083:
/* Line 1792 of yacc.c  */
#line 13756 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2084:
/* Line 1792 of yacc.c  */
#line 13757 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2085:
/* Line 1792 of yacc.c  */
#line 13758 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2086:
/* Line 1792 of yacc.c  */
#line 13763 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2087:
/* Line 1792 of yacc.c  */
#line 13764 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2088:
/* Line 1792 of yacc.c  */
#line 13765 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2089:
/* Line 1792 of yacc.c  */
#line 13766 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2090:
/* Line 1792 of yacc.c  */
#line 13772 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2091:
/* Line 1792 of yacc.c  */
#line 13773 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2092:
/* Line 1792 of yacc.c  */
#line 13774 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2093:
/* Line 1792 of yacc.c  */
#line 13775 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2094:
/* Line 1792 of yacc.c  */
#line 13776 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;


/* Line 1792 of yacc.c  */
#line 43132 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 14252 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static Node *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return (Node *) spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Create a DefElem setting "oids" to the specified value.
 */
static DefElem *
defWithOids(bool value)
{
	DefElem    *f = makeNode(DefElem);

	f->defname = "oids";
	f->arg = (Node *) makeInteger(value);
	return f;
}
